<?php
	session_start();
	
	include("php/settings.php");
	include("php/public_settings.php");
	include("php/localization.php");
	include('php/phpmailer/class.phpmailer.php');
	include('php/phpmailer/class.smtp.php');
	include("php/utils.php");
	include("php/bd.php");
	
	if(!isset($action))
		$action=$argv[1];
	
	if($action=='check_notif')
	{
		$user_language=array();
		$user_actif=array();
		$requete=requeteSql("select * from worker");
		while($ligne = fetchRequest($requete['result']))
		{
			$id_worker=$ligne['id'];
			$language=$ligne['language'];
			$actif=$ligne['actif'];
			$user_language[$id_worker]=$language;
			$user_actif[$id_worker]=$actif;
		}
		$requete=requeteSql("select * from notification where checked_notif=0 order by date_notif");
		$people=array();
		while($ligne = fetchRequest($requete['result']))
		{
			$id_notification=$ligne['id'];
			$id_destinataire=$ligne['id_destinataire'];
			if($user_actif[$id_destinataire]==WORKER_ACTIF)
			{
				$_SESSION['language_worker']=$user_language[$id_destinataire];
				$mode=MODE_NOTIF_SIMPLE;
				$type=$ligne['type_notif'];
				$param1=$ligne['param1'];
				$param2=$ligne['param2'];
				$param3=$ligne['param3'];
				$param4=$ligne['param4'];
				$texte_notif=stripslashes(translateNotification($mode,$type,$param1,$param2,$param3,$param4));
				$people[$id_destinataire][$param2][]=array('id_notification'=>$id_notification,'texte_notification'=>$texte_notif);
			}
		}
		
		foreach($people as $id_worker=>$tasks)
		{

			$email_worker=getWorkerEmail($id_worker);
			$_SESSION['language_worker']=$user_language[$id_worker];
			foreach($tasks as $id_tache=>$news)
			{
				$message='';
				if($id_tache!=0)
				{
					$requete=requeteSql("select * from tache where id=$id_tache");
					$ligne=$requete['first_line'];
					$nom_tache=$ligne['nom_tache'];
					$auteur_tache=getWorkerName($ligne['id_auteur']);
					$description=$ligne['description'];
					$message.=str_replace('[X]','<a href="'.WEBSITE_ADDRESS.'#taches/display/tache'.$id_tache.'">'.$nom_tache.'</a>',getLocText('ltext_new_notif')).'<br><br>';
				}
				foreach($news as $key=>$val)
					$message.='<b>'.$val['texte_notification'].'</b><br><br>';
				if($id_tache!=0)
				{
					$message.=str_replace('[X]',$auteur_tache,getLocText('ltext_new_notif_author')).'<br><br>';
					$message.=getLocText('ltext_new_notif_description').'<br><br>'.$description;
				}
				$params=array('to'=>array($email_worker),'subject'=>getLocText('ltext_new_notif_subject'),'message'=>$message);
				$mail_sent=sendMail($params);
				if($mail_sent)
				{
					writeInLog("Mail sent to $email_worker");
					foreach($news as $key=>$val)
						requeteSql("update notification set checked_notif=1 where id=".$val['id_notification']);
					/*if($id_worker!=1)
					{
						$params=array('to'=>array('xmarot@magicpockets.com'),'subject'=>'[TASK] Nouvelle notification','message'=>"Mail envoyé à $email_worker <br><br>".$message);
						$mail_sent=sendMail($params);
					}*/
				}
				else
					writeInLog("Error during the email sending to $email_worker (id worker : $id_worker)");
			}
		}
	}
	elseif($action=='backup_bdd')
	{
		if(!(is_dir("backup/")))
			mkdir("backup/");
		set_time_limit(0);
		$today=@date("j_m_y");
		$full_path=BACKUP_PATH."backup/backup_bases_$today.txt";
		$fp = fopen($full_path, 'w');
		fwrite($fp, getBackupBase(NOM_BASE_COMMON));
		fclose($fp);
		writeInLog("Backup done!");
	}
	elseif($action=='clean_notif')
	{
		$requete=requeteSql("delete from notification where DATEDIFF( CURDATE( ) , date_notif ) >30");
		$nb_notif_deleted=$requete['affected_lines'];
		writeInLog("$nb_notif_deleted notifications deleted.");
	}
	elseif($action=='clean_chat')
	{
		$requete=requeteSql("delete from chat_message");
		$nb_chat_deleted=$requete['affected_lines'];
		$folder=BACKUP_PATH.'uploaded/agora/';
		$nb_file_deleted=0;
		if (is_dir($folder)) 
		{
			if ($dh = opendir($folder)) 
			{
				while (($file = readdir($dh)) !== false) 
				{
					if($file!="." && $file!=".." && is_file($folder.$file))
					{
						$file_deleted=unlink($folder.$file);
						if($file_deleted)
							$nb_file_deleted++;
					}
				}
				closedir($dh);
			}
		}
		writeInLog("$nb_chat_deleted messages deleted.");
		writeInLog("$nb_file_deleted files deleted.");
	}
	elseif($action=='check_current_task')
	{
		$requete=getWorkers(WORKER_ACTIF);
		while($ligne = fetchRequest($requete['result']))
		{
			$id_worker=$ligne['id'];
			$nom_worker=$ligne['nom_worker'];
			$vacs=requeteSql("select * from vacances where CURDATE()>=vac_date_start and CURDATE()<=vac_date_end and id_worker=$id_worker");
			if($vacs['nb_lines']==0)
			{
				$current_tasks=requeteSql("select * from etape where id_worker=$id_worker and sleeping=0 and statut=".STAGE_WIP);
				$todo_tasks=requeteSql("select * from etape where id_worker=$id_worker and sleeping=0 and statut=".STAGE_TODO);
				if($current_tasks['nb_lines']==0 && $todo_tasks['nb_lines']>0 && $nom_worker!='xmarot' && $nom_worker!='ezmiro' && $nom_worker!='jponset' && $nom_worker!='lcornet' && $nom_worker!='mhauuy')
				{
					addNotification($id_worker,NOTIF_NO_CURRENT_TASK);
					writeInLog("Notification sent to $nom_worker");
				}
			}
		}
	}
	elseif($action=='check_delays')
	{
		$workers=getWorkers(WORKER_ACTIF);

		while($worker = fetchRequest($workers['result']))
		{
			$id_auteur=$worker['id'];
			$nom_auteur=getWorkerName($id_auteur);
			$requete=requeteSql("select t.id as id_tache,nom_tache from tache t,projet p where p.statut_projet=".PROJECT_RUNNING." and p.id=t.id_projet and id_auteur=$id_auteur");
			$nb_notif=0;
			while($ligne = fetchRequest($requete['result']))
			{
				$id_tache=$ligne['id_tache'];
				$nom_tache=$ligne['nom_tache'];
				if(ENGINE_V2)
					$current_stages=@getTaskCurrentStage($id_tache);
				else
				{
					$current_stage=getTaskCurrentStage($id_tache);
					$current_stages[]=$current_stage;
				}
				foreach($current_stages as $key=>$current_stage)
				{
					if($current_stage['id_worker']!=$id_auteur)
					{
						if($current_stage['statut']==STAGE_TODO || $current_stage['statut']==STAGE_WIP)
						{
							if($current_stage['duree']>$current_stage['estimation_duree']*1.25)
							{
								$retard=($current_stage['duree']-$current_stage['estimation_duree']);	
								if($retard>1)
								{
									$id_etape=$current_stage['id_etape'];
									$retard_afx=@formatWorkDuration($retard);
									$nom_worker=getWorkerName($current_stage['id_worker']);
									addNotification($id_auteur,NOTIF_DELAY,$current_stage['id_worker'],$id_tache,$id_etape,round($retard));
									$nb_notif++;
									
								}
							}
						}
					}
				}
			}
			if($nb_notif>0)
				writeInLog("$nb_notif notification(s) sent to $nom_auteur");
		}
	}
	elseif($action=='get_coming_vacations')
	{
		$next_vacs=requeteSql("select * from vacances v, worker w where v.id_worker=w.id and w.actif=".WORKER_ACTIF." and vac_date_start<DATE_ADD(NOW(),INTERVAL 7 DAY) and vac_date_start>NOW()");
		$rapport=array();
		if($next_vacs['nb_lines']>0)
		{
			$languages=getLanguageSelector();
			foreach($languages as $key=>$val)
			{
				$id_language=$val['option_value'];
				$_SESSION['language_worker']=$id_language;
				$rapport[$id_language]='<table border="1">
						<thead>
							<tr>
								<th>'.getLocText('ltext_task_member').'</th>
								<th>'.getLocText('ltext_team_start').'</th>
								<th>'.getLocText('ltext_team_end').'</th>
								<th>'.getLocText('ltext_team_holidays_type').'</th>
								<th>'.getLocText('ltext_team_holidays_duration').'</th>
								<th>'.getLocText('ltext_team_holidays_due').'</th>
							</tr>
						</thead>
						<tbody>';
				while($vac = fetchRequest($next_vacs['result']))
				{
					$type_vac=getHolidayType($vac['type_vac']);
					$worker_name=$vac['nom_worker'];
					$vac_date_start=@dateHtml($vac['vac_date_start']);
					$vac_date_end=@dateHtml($vac['vac_date_end']);
					$echeance=round((@getTimeStamp($vac_date_start)-time())/(60*60*24),1);
					$duree=round((@getTimeStamp($vac_date_end)-@getTimeStamp($vac_date_start))/(60*60*24),1)+1;
					$rapport[$id_language].='
							<tr>
								<td>'.$worker_name.'</a></td>
								<td>'.$vac_date_start.'</a></td>
								<td>'.$vac_date_end.'</td>
								<td>'.$type_vac.'</td>
								<td>'.$duree.'</td>
								<td>'.$echeance.'</td>
							</tr>';
				}
				$rapport[$id_language].='		</tbody>
					</table>';
				mysqli_data_seek($next_vacs['result'],0);
				
			}
		}
		if(sizeof($rapport)>0)
		{
			$requete=getWorkers(WORKER_ACTIF);
			while($ligne = fetchRequest($requete['result']))
			{
				$id_worker=$ligne['id'];
				$language=$ligne['language'];
				$can_get_vacation_report=workerHasRight($id_worker,DROIT_GET_HOLIDAYS);
				if($can_get_vacation_report)
				{
					$email_worker=getWorkerEmail($id_worker);
					if(isset($rapport[$language]))
					{
						$_SESSION['language_worker']=$language;
						$params=array('to'=>array($email_worker),'subject'=>getLocText('ltext_new_vacation_report_subject'),'message'=>$rapport[$language]);
						$mail_sent=sendMail($params);
						if($mail_sent)
						{
							writeInLog("Weekly vacation report sent to $email_worker");
						}
					}
				}
			}
		}
	}
	
	function writeInLog($msg)
	{
		global $action;
		$today = @date("Y-m-d H:i:s"); 
		echo "$today $action : $msg\r\n";
	}
	
	
	
	



?>