<?php
	if(!isset($_COOKIE['login']))
	{
		setcookie('login', '', time() + 365*24*3600, null, null, false, true); // On écrit un cookie
		setcookie('mdp', '', time() + 365*24*3600, null, null, false, true); // On écrit un autre cookie...
		setcookie('remember', 0, time() + 365*24*3600, null, null, false, true); // On écrit un autre cookie...
		setcookie('restored_lines', 0, time() + 365*24*3600, null, null, false, true); // On écrit un autre cookie...
	}
	
	session_start();
	
	date_default_timezone_set ( 'Europe/Paris' );
	
	include("php/settings.php");
	include("php/public_settings.php");
	include("php/localization.php");
	include('php/phpmailer/class.phpmailer.php');
	include('php/phpmailer/class.smtp.php');
	include("php/utils.php");
	include("php/ExcelWriterXML/ExcelWriterXML.php");
	include("php/bd.php");
	include("php/cryptojs-aes.php");
	//header('Content-type: text/html');
	
	
	
	if(isset($_GET['init_translation_table']))
	{	
		header('Connection: close');
		session_write_close();

		initTranslationTable();
		
		if($_SESSION['language_worker']==LANG_FR)
		{
			echo "
				$.datepicker.regional[''] = {
				closeText: 'Fermer',
				prevText: 'Précédent',
				nextText: 'Suivant',
				currentText: 'Aujourd\'hui',
				monthNames: ['Janvier','Février','Mars','Avril','Mai','Juin',
				'Juillet','Août','Septembre','Octobre','Novembre','Décembre'],
				monthNamesShort: ['Janv.','Févr.','Mars','Avril','Mai','Juin',
				'Juil.','Août','Sept.','Oct.','Nov.','Déc.'],
				dayNames: ['Dimanche','Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi'],
				dayNamesShort: ['Dim.','Lun.','Mar.','Mer.','Jeu.','Ven.','Sam.'],
				dayNamesMin: ['D','L','M','M','J','V','S'],
				weekHeader: 'Sem.',
				firstDay: 1,
				isRTL: false,
				showMonthAfterYear: false,
				yearSuffix: ''};
			$.datepicker.setDefaults($.datepicker.regional['']);";
		}
		if(DATE_FORMAT==DATE_MDY)
		{
			echo "
			$.datepicker.regional[''] = {
			dateFormat: 'mm/dd/yy'
			};
			$.datepicker.setDefaults($.datepicker.regional['']);";
		}
		else
		{
			echo "
			$.datepicker.regional[''] = {
			dateFormat: 'dd/mm/yy'
			};
			$.datepicker.setDefaults($.datepicker.regional['']);";
		}
		exit(0);
	}
	
	
	$check_user=checkSession();
	//$check_user=0;
	if($check_user!=SESSION_OK && $check_user!=SESSION_TEMP)
	{
		$fields=array();
		$options=array('submit_text'=>"");
		if($check_user==SESSION_WRONG)
			$options['title_form']='<div class="ui-widget"><div style="padding: 0 .7em;" class="ui-state-error ui-corner-all"><p><span style="float: left; margin-right: .3em;" class="ui-icon ui-icon-alert"></span>'.getLocText('ltext_team_session_wrong').'</p></div></div>';
		else
			$options['title_form']='<div style="margin-top: 20px; padding: 0 .7em;" class="ui-state-highlight ui-corner-all"><p><span style="float: left; margin-right: .3em;" class="ui-icon ui-icon-info"></span>'.getLocText('ltext_team_session_expired').'</p></div>';
		$pre_login='';
		$pre_pwd='';
		$pre_remember='';
		if(isset($_COOKIE['login']))
			$pre_login=$_COOKIE['login'];
		if(isset($_COOKIE['mdp']))
			$pre_pwd=magicDecrypt($_COOKIE['mdp']);
		if(isset($_COOKIE['remember']))
			$pre_remember=$_COOKIE['remember'];
		
		if($pre_login=='')
		{
			$pre_login='visitor';
			$pre_pwd='visitor';
			$pre_remember=true;
		}
		
		$title_login='';
		$title_password='';
		if(USE_WINDOWS_LDAP)
		{
			$title_login=getLocText('ltext_team_login_help');
			$title_password=getLocText('ltext_team_password_help');
		}
		
		$fields[]=array("id_field"=>"login","label"=>getLocText('ltext_team_login'),"type"=>"text","title"=>$title_login,"validation"=>"not_empty",'value'=>$pre_login);
		$fields[]=array("id_field"=>"password","label"=>getLocText('ltext_team_password'),"type"=>"password","title"=>$title_password,"validation"=>"not_empty",'value'=>$pre_pwd);
		$fields[]=array("id_field"=>"remember_me","label"=>getLocText('ltext_team_remember'),"type"=>"checkbox",'value'=>$pre_remember);
		if(sizeof($_POST)>2 || isset($_POST['posting_form']))
			$fields[]=array("id_field"=>"posting_form","type"=>"hidden");
		$form=getBasicForm("identify_user",$fields,$options);
		$form['js'].='execOnEnter("login","$(\'#identify_user\').submit();");';
		$form['js'].='execOnEnter("password","$(\'#identify_user\').submit();");';
		updatePage($form['html'],$form['js'].'getDialog("identify_user");setAjaxForm("identify_user","post","identify_user","Vérification du compte");check_notification=1;','dialog-message');		
	}
	elseif(isset($_GET['get_add_project_form']))
	{
		$fields=array();
		$fields[]=array("id_field"=>"nom_projet","label"=>getLocText('ltext_project_name'),"type"=>"text","validation"=>"not_empty");
		$fields[]=array("id_field"=>"alias_projet","label"=>getLocText('ltext_project_alias'),"type"=>"text","validation"=>"not_empty");
		$fields[]=array("id_field"=>"budget_projet","label"=>getLocText('ltext_project_budget'),"type"=>"text","validation"=>"is_numeric");
		$fields[]=array("id_field"=>"date_start","label"=>getLocText('ltext_project_start'),"type"=>"date","validation"=>"valid_date");
		$fields[]=array("id_field"=>"date_end","label"=>getLocText('ltext_project_end'),"type"=>"date","validation"=>"valid_date");
		//$fields[]=array("id_field"=>"add_project_docs","label"=>"Fichier","type"=>"file");
		$options=array('submit_text'=>getLocText('ltext_project_add'));
		$form=getBasicForm("add_project",$fields,$options);
		updatePage($form['html'],$form['js'].'setAjaxForm("add_project","post","add_project","Ajout de projet");');		
	}
	elseif(isset($_GET['get_add_task_form']))
	{
		$fields=array();
		
		if(!isset($_SESSION['last_task_project']))
			$_SESSION['last_task_project']=0;
		if(!isset($_SESSION['expert_mode']))
			$_SESSION['expert_mode']=false;
		
		$id_projet=$_SESSION['last_task_project'];
		$nom_tache='';
		$description='';
		$priorite=0;
		$nb_etapes_ref=0;
		$id_echeance=0;
		$id_milestone=0;
		$etapes=array();
		$etapes[0]['objectif']='';
		$etapes[0]['id_worker']=$_SESSION['id_worker'];
		$etapes[0]['estimation_duree']=0;
		$etapes[0]['id_tag']=0;
		$etapes[0]['etape_priorite']=0;
		$observers=array();
		$observers[0]=0;
		$etapes[0]['objectif']='';
		$move_stages='';
		if(isset($_GET['copy_task']))
		{
			$id_tache_ref=$_GET['copy_task'];
			$requete=requeteSql("select e.id as id_etape,id_projet,nom_tache,description,position,priorite,estimation_duree,e.id_tag,objectif,id_worker,id_echeance,id_milestone,is_blocking from tache t, etape e where t.id=e.id_tache and t.id=$id_tache_ref order by position");
			$ligne=$requete['first_line'];
			$id_projet=$ligne['id_projet'];
			$nom_tache=$ligne['nom_tache'];
			$description=$ligne['description'];
			$id_echeance=$ligne['id_echeance'];
			$id_milestone=$ligne['id_milestone'];
			
			$etapes=array();
			$id_flow=0;
			while($ligne = fetchRequest($requete['result']))
			{
				$id_flow++;
				$id_etape=$ligne['id_etape'];
				$etapes[$id_etape]['objectif']=$ligne['objectif'];
				$etapes[$id_etape]['id_worker']=$ligne['id_worker'];
				$etapes[$id_etape]['etape_priorite']=$ligne['priorite'];
				$priorite+=$ligne['priorite'];
				$etapes[$id_etape]['estimation_duree']=$ligne['estimation_duree'];
				$etapes[$id_etape]['id_tag']=$ligne['id_tag'];
				$position=$ligne['position'];
				$is_blocking=$ligne['is_blocking'];
				$move_stages.='moveStageToStep("flow_'.$id_flow.'","step'.$position.'",'.$is_blocking.');';
			}
			$nb_etapes_ref=count($etapes);
			if($nb_etapes_ref>0)
				$priorite=round($priorite/$nb_etapes_ref);
			
			$requete=requeteSql("select * from observe where id_tache=$id_tache_ref");
			if($requete['nb_lines']>0)
			{
				$observers=array();
				while($ligne = fetchRequest($requete['result']))
				{
					$observers[]=$ligne['id_worker'];
				}
			}
		}
		$projets=getProjectSelector(PROJECT_RUNNING);
		$workers=getWorkerSelector(WORKER_ACTIF);
		$workers_with_none=getWorkerSelector(WORKER_ACTIF,true);
		$tags=getTagSelector();
		$stages=getAllStageSelector();
		
		$fields[]=array("id_field"=>"expert_mode_switcher","label"=>getLocText('ltext_expert_mode'),"type"=>"checkbox",'value'=>$_SESSION['expert_mode'],"onchange"=>'switchExpertMode()');
		$fields[]=array("id_field"=>"id_projet","label"=>getLocText('ltext_task_project'),"type"=>"list","datas"=>$projets,"value"=>$id_projet);
		$fields[]=array("id_field"=>"nom_tache","label"=>getLocText('ltext_task_name'),"type"=>"text","validation"=>"not_empty","value"=>$nom_tache);
		$fields[]=array("id_field"=>"description","label"=>getLocText('ltext_task_description'),"type"=>"textarea","validation"=>"not_empty","value"=>$description);
		$fields[]=array("id_field"=>"priorite","label"=>getLocText('ltext_task_priority'),"type"=>"text","validation"=>"is_numeric","value"=>$priorite);
		$fields[]=array("id_field"=>"id_echeance","label"=>getLocText('ltext_task_deadline'),"type"=>"list","datas"=>getDeadlineSelector(),"value"=>$id_echeance,'expert'=>$_SESSION['expert_mode']);
		$fields[]=array("id_field"=>"id_milestone","label"=>getLocText('ltext_task_milestone'),"type"=>"list","datas"=>getMilestoneSelector(),"value"=>$id_milestone,'expert'=>$_SESSION['expert_mode']);
		
		foreach($etapes as $key=>$etape)
		{
			$sub_fields=array();
			$sub_fields[]=array("id_field"=>"id_worker","label"=>getLocText('ltext_task_member'),"type"=>"list","datas"=>$workers,"value"=>$etape['id_worker'],'onchange'=>'updateFormField();');
			$sub_fields[]=array("id_field"=>"etape_objectif","label"=>getLocText('ltext_task_add_stage_objective'),"type"=>"text","validation"=>"not_empty","value"=>$etape['objectif'],'onchange'=>'updateFormField();');
			$sub_fields[]=array("id_field"=>"estimation_duree","label"=>getLocText('ltext_task_add_stage_duration'),"type"=>"text","value"=>0,"validation"=>"is_numeric","title"=>getLocText('ltext_task_help_no_estimation'),"value"=>$etape['estimation_duree']);
			$sub_fields[]=array("id_field"=>"etape_priorite","label"=>getLocText('ltext_task_priority'),"type"=>"text","validation"=>"is_numeric","value"=>$etape['etape_priorite'],'expert'=>$_SESSION['expert_mode']);
			$sub_fields[]=array("id_field"=>"id_tag","label"=>getLocText('ltext_task_tag'),"type"=>"list","datas"=>$tags,"value"=>0,"title"=>getLocText('ltext_task_help_tag'),"value"=>$etape['id_tag'],'expert'=>$_SESSION['expert_mode']);
			$sub_fields[]=array("id_field"=>"dependance","label"=>getLocText('ltext_task_depends'),"type"=>"list","datas"=>$stages,"duplication"=>getLocText('ltext_task_add_dependence'),'expert'=>$_SESSION['expert_mode']);
			if(ENGINE_V2)
			{
				$fields[]=array("id_field"=>"etape","label"=>getLocText('ltext_task_stage'),"type"=>"group","duplication"=>getLocText('ltext_task_add_stage'),'extra'=>'flow_graph',"datas"=>$sub_fields);
			}
			else
			{
				$fields[]=array("id_field"=>"etape","label"=>getLocText('ltext_task_stage'),"type"=>"group","duplication"=>getLocText('ltext_task_add_stage'),"datas"=>$sub_fields);
			}
		}
		
		foreach($observers as $key=>$val)
		{
			$fields[]=array("id_field"=>"id_observer","label"=>getLocText('ltext_task_observer'),"type"=>"list","datas"=>$workers_with_none,"duplication"=>getLocText('ltext_task_add_observer'),'title'=>getLocText('ltext_task_help_observer'),'value'=>$val);
		}
		//$fields[]=array("id_field"=>"add_project_docs","label"=>"Fichier","type"=>"file");
		if(ENGINE_V2)
		{
			$fields[]=array("id_field"=>"flow_container","type"=>"flow_graph",'expert'=>$_SESSION['expert_mode']);
		}
		$options=array('submit_text'=>getLocText('ltext_task_add'),'validation'=>"check_presence-etape",'processing_fixed'=>true);
		$form=getBasicForm("add_task",$fields,$options);
		updatePage($form['html'],$form['js'].'setAjaxForm("add_task","post","add_task","Ajout de tâche");$("#expert_mode_switcher").on("ifToggled", function(event){switchExpertMode();});switchExpertMode();'.$move_stages.'fixFlowGraph();');		
	}
	elseif(isset($_GET['add_task']))
	{
		if(ENGINE_V2)
		{
			$_SESSION['last_task_project']=$_POST['id_projet'];
			$id_projet=chaineMysql($_POST['id_projet']);
			$id_auteur=$_SESSION['id_worker'];
			$nom_tache=chaineMysql($_POST['nom_tache']);
			
			$description=chaineMysql(nl2br($_POST['description']));
			if(isset($_POST['expert_mode_switcher']))
				$_SESSION['expert_mode']=true;
			else
				$_SESSION['expert_mode']=false;
			
			$priorite=chaineMysql($_POST['priorite']);
			$id_milestone=chaineMysql($_POST['id_milestone']);
			$id_echeance=chaineMysql($_POST['id_echeance']);
			
			$requete=requeteSql("select * from tache where nom_tache=$nom_tache and description=$description");
			if($requete['nb_lines']>0)
			{
				echo 'showDialog("'.getLocText('ltext_dialog_existing_task_title').'","'.getLocText('ltext_dialog_existing_task_message').'",false);';
			}
			else
			{
				$requete=requeteSql("insert into tache (id_projet,id_auteur,nom_tache,description,id_milestone,id_echeance) values ($id_projet,$id_auteur,$nom_tache,$description,$id_milestone,$id_echeance)");
				$id_tache=$requete['id_created'];
				addLog($id_auteur,$id_projet,$id_tache,0,LOG_NEW_TASK,$id_tache);
				
				$etapes=array();
				$observer_added=array();
				$positions=array();
				foreach($_POST as $key=>$val)
				{
					if(strpos($key,'id_worker')===0)
					{
						$id_etape=str_replace('id_worker','',$key);
						$etapes[$id_etape]['id_worker']=$val;
					}
					elseif(strpos($key,'etape_objectif')===0)
					{
						$id_etape=str_replace('etape_objectif','',$key);
						$etapes[$id_etape]['etape_objectif']=$val;
					}
					elseif(strpos($key,'etape_priorite')===0)
					{
						$id_etape=str_replace('etape_priorite','',$key);
						$etapes[$id_etape]['etape_priorite']=$val;
					}
					elseif(strpos($key,'estimation_duree')===0)
					{
						$id_etape=str_replace('estimation_duree','',$key);
						$etapes[$id_etape]['estimation_duree']=$val;
					}	
					elseif(strpos($key,'id_tag')===0)
					{
						$id_etape=str_replace('id_tag','',$key);
						$etapes[$id_etape]['id_tag']=$val;
					}	
					elseif(strpos($key,'dependance')===0)
					{
						$parts=explode('_',$key);
						$id_dependance=str_replace('dependance','',$parts[0]);
						$id_etape=str_replace('etape','',$parts[1]);
						$etapes[$id_etape]['dependances'][]=$val;
					}	
					elseif(strpos($key,'id_observer')===0)
					{
						$id_observer=$val;
						if(!in_array($id_observer,$observer_added))
						{
							requeteSql("INSERT INTO `observe`(`id_worker`, `id_tache`) VALUES ($id_observer,$id_tache)");
							$observer_added[]=$id_observer;
						}
					}
					elseif(strpos($key,'stage_ref_flow_')===0)
					{
						$id_flow=str_replace('stage_ref_flow_','',$key);
						$id_etape=str_replace('cell_field','',$val);
						$is_blocking=$_POST['is_blocking_flow_'.$id_flow];
						$sovereign=$_POST['sovereign_flow_'.$id_flow];
						$position=$_POST['priority_flow_'.$id_flow];
						if(!in_array($position,$positions))
							$positions[]=$position;
						$etapes[$id_etape]['position']=$position;
						$etapes[$id_etape]['is_blocking']=$is_blocking;
						$etapes[$id_etape]['sovereign']=$sovereign;
					}
				}
				
				sort($positions);
				foreach($etapes as $id_etape=>$val)
				{
					$old_position=$etapes[$id_etape]['position'];
					$new_position=array_search($val['position'], $positions)+1;
					if($old_position!=$new_position)
					{
						$etapes[$id_etape]['position']=$new_position;//fix gaps (empty steps)
						foreach($etapes as $k=>$v)
						{
							if($etapes[$k]['sovereign']==$old_position)
							{
								//echo "fixing soverign for $k : old sovereign $old_position new $new_position\n";
								if($etapes[$k]['position']+1==$new_position)//it was supposed to be sovereign but after gap fixing, it is just blocking
								{
									$etapes[$k]['sovereign']=0;
									$etapes[$k]['is_blocking']=1;
								}
								else
									$etapes[$k]['sovereign']=$new_position;
							}
						}
					}
				}
				foreach($etapes as $id_etape=>$val)
				{
					if($etapes[$id_etape]['sovereign']>0)
					{
						foreach($etapes as $k=>$v)
						{
							if($etapes[$k]['position']==$etapes[$id_etape]['sovereign'])
							{
								$etapes[$k]['internal_dependances'][]=$id_etape;
							}
						}
					}
				}
				
				$erreur_dependance='';
				$id_first_worker=0;
				$id_first_etape=0;
				foreach($etapes as $id_etape=>$etape)
				{
					$id_worker=chaineMysql($etape['id_worker']);
					$id_job=getWorkerJob($id_worker);
					$objectif=chaineMysql(nl2br($etape['etape_objectif']));
					$etape_priorite=chaineMysql($etape['etape_priorite']);
					if(isset($_POST['expert_mode_switcher']))
					{
						$priorite=$etape_priorite;
					}
					$estimation_duree=chaineMysql($etape['estimation_duree']);
					$id_tag=chaineMysql($etape['id_tag']);
					$position=chaineMysql($etape['position']);
					$is_blocking=chaineMysql($etape['is_blocking']);
					$requete=requeteSql("insert into etape (id_worker,id_tache,objectif,position,statut,duree,estimation_duree,id_tag,priorite,id_metier,is_blocking) values ($id_worker,$id_tache,$objectif,$position,".(STAGE_STANDBY).",0,$estimation_duree,$id_tag,$priorite,$id_job,$is_blocking)");
					$id_etape_created=$requete['id_created'];
					$etapes[$id_etape]['id_db']=$id_etape_created;
					if($id_first_worker==0)
					{
						$id_first_worker=$etape['id_worker'];
						$id_first_etape=$id_etape_created;
					}
					if(isset($etape['dependances']))
					{
						foreach($etape['dependances'] as $key=>$val)
						{
							if($val!=0)
							{
								if(noLegacyLoop($id_etape_created,$val))
									requeteSql("insert into depend_de (id_etape_mere,id_etape_fille) values ($val,$id_etape_created)");
								else
									$erreur_dependance.=str_replace('[X]',$val,getLocText('ltext_dialog_dependency_error_message')).'<br>';
								
							}
						}
					}
				}
				foreach($etapes as $id_etape=>$etape)
				{
					if(isset($etape['internal_dependances']))
					{
						foreach($etape['internal_dependances'] as $key=>$val)
						{
							if($val!=0)
							{
								$id_etape_created=$etapes[$id_etape]['id_db'];
								$id_etape_sovereign=$etapes[$val]['id_db'];
								if(noLegacyLoop($id_etape_created,$id_etape_sovereign))
									requeteSql("insert into depend_de (id_etape_mere,id_etape_fille) values ($id_etape_sovereign,$id_etape_created)");
								else
									$erreur_dependance.=str_replace('[X]',$id_etape_sovereign,getLocText('ltext_dialog_dependency_error_message')).'<br>';
								
							}
						}
					}
				}
				foreach($observer_added as $key=>$id_observer)
				{
					addNotification($id_observer,NOTIF_TASK_CREATED,$id_first_worker,$id_tache,$id_first_etape);
				}
				updateStageTask($id_tache);
				echo 'showDialog("'.getLocText('ltext_dialog_added_task_title').'","'.getLocText('ltext_dialog_added_task_message').'<br><a onclick=\'closeDialog();\' href=#taches/display/tache'.$id_tache.'/info0>'.getLocText('ltext_dialog_added_task_message2').'</a>",false);';
				if($erreur_dependance!='')
					echo 'showDialog("'.getLocText('ltext_dialog_dependency_error_title').'","'.$erreur_dependance.'",false);';
			}
		}
		else
		{
			$_SESSION['last_task_project']=$_POST['id_projet'];
			$id_projet=chaineMysql($_POST['id_projet']);
			$id_auteur=$_SESSION['id_worker'];
			$nom_tache=chaineMysql($_POST['nom_tache']);
			
			$description=chaineMysql(nl2br($_POST['description']));
			
			$priorite=chaineMysql($_POST['priorite']);
			
			$requete=requeteSql("select * from tache where nom_tache=$nom_tache and description=$description");
			if($requete['nb_lines']>0)
			{
				echo 'showDialog("'.getLocText('ltext_dialog_existing_task_title').'","'.getLocText('ltext_dialog_existing_task_message').'",false);';
			}
			else
			{
				$requete=requeteSql("insert into tache (id_projet,id_auteur,nom_tache,description) values ($id_projet,$id_auteur,$nom_tache,$description)");
				$id_tache=$requete['id_created'];
				addLog($id_auteur,$id_projet,$id_tache,0,LOG_NEW_TASK,$id_tache);
				
				$etapes=array();
				$observer_added=array();
				foreach($_POST as $key=>$val)
				{
					if(strpos($key,'id_worker')===0)
					{
						$id_etape=str_replace('id_worker','',$key);
						$etapes[$id_etape]['id_worker']=$val;
					}
					elseif(strpos($key,'etape_objectif')===0)
					{
						$id_etape=str_replace('etape_objectif','',$key);
						$etapes[$id_etape]['etape_objectif']=$val;
					}
					elseif(strpos($key,'estimation_duree')===0)
					{
						$id_etape=str_replace('estimation_duree','',$key);
						$etapes[$id_etape]['estimation_duree']=$val;
					}	
					elseif(strpos($key,'id_tag')===0)
					{
						$id_etape=str_replace('id_tag','',$key);
						$etapes[$id_etape]['id_tag']=$val;
					}	
					elseif(strpos($key,'dependance')===0)
					{
						$parts=explode('_',$key);
						$id_dependance=str_replace('dependance','',$parts[0]);
						$id_etape=str_replace('etape','',$parts[1]);
						$etapes[$id_etape]['dependances'][]=$val;
					}	
					elseif(strpos($key,'id_observer')===0)
					{
						$id_observer=$val;
						if(!in_array($id_observer,$observer_added))
						{
							requeteSql("INSERT INTO `observe`(`id_worker`, `id_tache`) VALUES ($id_observer,$id_tache)");
							$observer_added[]=$id_observer;
						}
					}	
				}
				
				$erreur_dependance='';
				$id_first_worker=0;
				$id_first_etape=0;
				foreach($etapes as $id_etape=>$etape)
				{
					$id_worker=chaineMysql($etape['id_worker']);
					$id_job=getWorkerJob($id_worker);
					$objectif=chaineMysql(nl2br($etape['etape_objectif']));
					$estimation_duree=chaineMysql($etape['estimation_duree']);
					$id_tag=chaineMysql($etape['id_tag']);
					$requete=requeteSql("insert into etape (id_worker,id_tache,objectif,position,statut,duree,estimation_duree,id_tag,priorite,id_metier) values ($id_worker,$id_tache,$objectif,$id_etape,".(STAGE_STANDBY).",0,$estimation_duree,$id_tag,$priorite,$id_job)");
					$id_etape=$requete['id_created'];
					if($id_first_worker==0)
					{
						$id_first_worker=$etape['id_worker'];
						$id_first_etape=$id_etape;
					}
					if(isset($etape['dependances']))
					{
						foreach($etape['dependances'] as $key=>$val)
						{
							if($val!=0)
							{
								if(noLegacyLoop($id_etape,$val))
									requeteSql("insert into depend_de (id_etape_mere,id_etape_fille) values ($val,$id_etape)");
								else
									$erreur_dependance.=str_replace('[X]',$val,getLocText('ltext_dialog_dependency_error_message')).'<br>';
								
							}
						}
					}
				}
				foreach($observer_added as $key=>$id_observer)
				{
					addNotification($id_observer,NOTIF_TASK_CREATED,$id_first_worker,$id_tache,$id_first_etape);
				}
				updateStageTask($id_tache);
				echo 'showDialog("'.getLocText('ltext_dialog_added_task_title').'","'.getLocText('ltext_dialog_added_task_message').'<br><a onclick=\'closeDialog();\' href=#taches/display/tache'.$id_tache.'/info0>'.getLocText('ltext_dialog_added_task_message2').'</a>",false);';
				if($erreur_dependance!='')
					echo 'showDialog("'.getLocText('ltext_dialog_dependency_error_title').'","'.$erreur_dependance.'",false);';
			}
		}
	}
	elseif(isset($_GET['get_add_member_form']))
	{
		$fields=array();
		$metiers=getJobSelector();
		$statut_worker=getWorkerStatutSelector();
		$languages=getLanguageSelector();
		if(USE_WINDOWS_LDAP)
		{
			$fields[]=array("id_field"=>"new_login","label"=>getLocText('ltext_team_name'),"type"=>"text","validation"=>"not_empty","title"=>'Cela doit correspondre au login Windows');
			$fields[]=array("id_field"=>"new_mdp","type"=>"hidden","value"=>"");
		}
		else
		{
			$fields[]=array("id_field"=>"new_login","label"=>getLocText('ltext_team_name'),"type"=>"text","validation"=>"not_empty");
			$fields[]=array("id_field"=>"new_mdp","label"=>getLocText('ltext_team_password'),"type"=>"password","validation"=>"not_empty");
		}
		if(USE_WINDOWS_EMAIL_INTERNAL_SERVER)
			$fields[]=array("id_field"=>"email","type"=>"hidden","value"=>"");
		else
			$fields[]=array("id_field"=>"email","label"=>getLocText('ltext_team_email'),"type"=>"text","validation"=>"is_email");
			
		$fields[]=array("id_field"=>"id_metier","label"=>getLocText('ltext_team_job'),"type"=>"list","datas"=>$metiers);
		$fields[]=array("id_field"=>"statut","label"=>getLocText('ltext_team_status'),"type"=>"list","datas"=>$statut_worker);
		$fields[]=array("id_field"=>"language","label"=>getLocText('ltext_team_language'),"type"=>"list","datas"=>$languages);
		
		//$fields[]=array("id_field"=>"add_project_docs","label"=>"Fichier","type"=>"file");
		$options=array('submit_text'=>getLocText('ltext_team_add'));
		$form=getBasicForm("add_member",$fields,$options);
		updatePage($form['html'],$form['js'].'setAjaxForm("add_member","post","add_member","Ajout de membre");');		
	}
	elseif(isset($_GET['add_member']))
	{
		$nom_worker=chaineMysql($_POST['new_login']);
		$id_metier=0;
		if(isset($_POST['id_metier']))
			$id_metier=chaineMysql($_POST['id_metier']);
		$statut_worker=chaineMysql($_POST['statut']);
		$language=chaineMysql($_POST['language']);
		$email=chaineMysql($_POST['email']);
		if($_POST['new_mdp']!='')
			$mdp=chaineMysql(crypt($_POST['new_mdp'],$_POST['new_mdp']));
		else
			$mdp=chaineMysql($_POST['new_mdp']);

		$requete=requeteSql("insert into worker (nom_worker,mdp,id_metier,statut_worker,actif,email,language) values ($nom_worker,$mdp,$id_metier,$statut_worker,1,$email,$language)");
		$id_worker=$requete['id_created'];
		addLog($_SESSION['id_worker'],0,0,0,LOG_NEW_USER,$id_worker);
		$requete=requeteSql("select * from worker");
		$precisions='';
		if($requete['nb_lines']==1)//on donne toutes les permissions au premier utilisateur
		{
			grantAllPermissions($id_worker);
			$precisions=getLocText('ltext_dialog_added_member_message2');
		}
		echo 'showDialog("'.getLocText('ltext_dialog_added_member_title').'","'.getLocText('ltext_dialog_added_member_message').' '.$precisions.'",false);';
	}
	elseif(isset($_GET['add_project']))
	{
		$nom_projet=chaineMysql($_POST['nom_projet']);
		$alias=chaineMysql($_POST['alias_projet']);
		$budget=chaineMysql($_POST['budget_projet']);
		$projet_date_start=dateMysql($_POST['date_start']);
		$projet_date_end=dateMysql($_POST['date_end']);
		$requete=requeteSql("insert into projet (nom_projet,alias,budget,projet_date_start,projet_date_end,statut_projet) values ($nom_projet,$alias,$budget,$projet_date_start,$projet_date_end,0)");
		$id_project=$requete['id_created'];
		addLog($_SESSION['id_worker'],$id_project,0,0,LOG_NEW_PROJECT,$id_project);
		echo 'showDialog("'.getLocText('ltext_dialog_added_project_title').'","'.getLocText('ltext_dialog_added_project_message').'",false);';
	}
	elseif(isset($_GET['edit_project']))
	{
		$id_project=$_GET['edit_project'];
		$nom_projet=chaineMysql($_POST["nom_projet$id_project"]);
		$alias=chaineMysql($_POST["alias_projet$id_project"]);
		$update_budget='';
		if(isset($_POST["budget_projet$id_project"]))
		{
			$budget=chaineMysql($_POST["budget_projet$id_project"]);
			$update_budget="budget=$budget,";
		}
		$projet_date_start=dateMysql($_POST["date_start$id_project"]);
		$projet_date_end=dateMysql($_POST["date_end$id_project"]);
		requeteSql("update projet set nom_projet=$nom_projet,alias=$alias, $update_budget projet_date_start=$projet_date_start,projet_date_end=$projet_date_end where id=$id_project");
		$res=getProjectInfo($id_project);
		//echo 'showDialog("Projet édité","Ce projet a bien été édité !",false);refreshPage();';
		updatePage($res['html'],$res['js'],'info0_projet'.$id_project);
	}
	elseif(isset($_GET['edit_worker']))
	{
		$id_worker=$_GET['edit_worker'];
		
		$nom_worker=chaineMysql($_POST["nom_worker$id_worker"]);
		$id_metier=chaineMysql($_POST["id_metier$id_worker"]);
		$statut_worker=chaineMysql($_POST["statut$id_worker"]);
		$pagestyle=chaineMysql($_POST["pagestyle$id_worker"]);
		$chat_color=chaineMysql($_POST["chat_color$id_worker"]);
		$email=chaineMysql($_POST["email$id_worker"]);
		$language=chaineMysql($_POST["language$id_worker"]);
		
		$update_pwd='';
		if(isset($_POST["mdp$id_worker"]))
		{
			$pwd=$_POST["mdp$id_worker"];
			if($pwd!='******')
			{
				$pwd=chaineMysql(crypt($pwd,$pwd));
				$update_pwd="mdp=$pwd,";
			}
		}
		requeteSql("update worker set $update_pwd nom_worker=$nom_worker,id_metier=$id_metier,statut_worker=$statut_worker,pagestyle=$pagestyle,email=$email,chat_color=$chat_color,language=$language where id=$id_worker");
		
		requeteSql("delete from avoir_droit where id_worker=$id_worker");
		$droits_added=array();
		foreach($_POST as $key=>$val)
		{
			if(strpos($key,"droit$id_worker")===0 && $val!=0)
			{
				if(!in_array($val,$droits_added))
				{
					$droits_added[]=$val;
					requeteSql("insert into avoir_droit (id_worker,droit) values ($id_worker,$val)");
				}
			}	
		}
		
		$update_css='';
		$update_language='';
		if($id_worker==$_SESSION['id_worker'])
		{
			$update_css='resetCssSheet('.$pagestyle.');';
			$update_language='initTranslationTable();';
			$_SESSION['pagestyle']=$_POST["pagestyle$id_worker"];
			$_SESSION['language_worker']=$_POST["language$id_worker"];
		}
		
		$res=getWorkerInfo($id_worker);
		updatePage($res['html'],$res['js'].$update_css.$update_language,'info0_worker'.$id_worker);
	}
	elseif(isset($_GET['edit_tache']))
	{
		$id_tache=$_GET['edit_tache'];
		
		$id_projet=chaineMysql($_POST["id_projet$id_tache"]);
		$nom_tache=chaineMysql($_POST["nom_tache$id_tache"]);
		$description=chaineMysql(nl2br($_POST["description_tache$id_tache"]));
		$id_auteur=chaineMysql($_POST["auteur_tache$id_tache"]);
		$id_milestone=chaineMysql($_POST["milestone_tache$id_tache"]);
		$id_tag=chaineMysql($_POST["tag_tache$id_tache"]);
		$id_echeance=chaineMysql($_POST["echeance_tache$id_tache"]);
		$color=($_POST["color_tache$id_tache"]);
		if(strtolower($color)=='ffffff')
			$color='';
		requeteSql("update tache set id_projet=$id_projet,nom_tache=$nom_tache,description=$description,id_auteur=$id_auteur,id_milestone=$id_milestone,id_tag=$id_tag,id_echeance=$id_echeance,color='$color' where id=$id_tache");
		
		requeteSql("delete from observe where id_tache=$id_tache");
		$observers_added=array();
		foreach($_POST as $key=>$val)
		{
			if(strpos($key,"id_observer$id_tache")===0 && $val!=0)
			{
				if(!in_array($val,$observers_added))
				{
					$observers_added[]=$val;
					requeteSql("INSERT INTO `observe`(`id_worker`, `id_tache`) VALUES ($val,$id_tache)");
				}
			}	
		}
		
		$res=getTaskInfo($id_tache);
		updatePage($res['html'],$res['js'],'info0_tache'.$id_tache);
	}
	elseif(isset($_GET['get_project_list']))
	{
		$type_projet=$_GET['get_project_list'];
		$projects=getProjects($type_projet);
		$active_project=str_replace('projet','',$_GET['active_project']);
		$active_info=str_replace('info','',$_GET['active_info']);
		if($active_info=="")
			$active_info=0;
		$res=getProjectList($projects,$active_project,$active_info);
		updatePage($res['html'],$res['js']);		
	}
	elseif(isset($_GET['get_task_list']))
	{
		$type_tache=$_GET['get_task_list'];
		$filter_workers=$_GET['filter_workers'];
		if($filter_workers=="")
			$filter_workers=$_SESSION['id_worker'];
		$filter_workers=explode(',',$filter_workers);
		$filter_projects=$_GET['filter_projects'];
		$tri='priorite desc';
		if(isset($_GET['tri']))
		{
			$tri=$_GET['tri'];
		}
		if($filter_projects=="")
		{
			$project_ids=getProjectIds(PROJECT_RUNNING);
			$filter_projects=implode(',',$project_ids);
		}
		$filter_projects=explode(',',$filter_projects);
		$active_task=str_replace('tache','',$_GET['active_task']);
		$active_info=str_replace('info','',$_GET['active_info']);
		$filter_tags='';
		if(isset($_GET['filter_tags']))
			$filter_tags=$_GET['filter_tags'];
		if($filter_tags=="")
		{
			$tag_ids=getTagIds();
			$tag_ids[]=0;
			$filter_tags=implode(',',$tag_ids);
		}
		if($filter_tags=='')
			$filter_tags=array();
		else
			$filter_tags=explode(',',$filter_tags);
			
		$filter_milestones='';
		if(isset($_GET['filter_milestones']))
			$filter_milestones=$_GET['filter_milestones'];
		if($filter_milestones=="")
		{
			$milestone_ids=getMilestoneIds();
			$milestone_ids[]=0;
			$filter_milestones=implode(',',$milestone_ids);
		}
		if($filter_milestones=='')
			$filter_milestones=array();
		else
			$filter_milestones=explode(',',$filter_milestones);
			
		$filter_deadlines='';
		if(isset($_GET['filter_deadlines']))
			$filter_deadlines=$_GET['filter_deadlines'];
		if($filter_deadlines=="")
		{
			$deadline_ids=getDeadlineIds();
			$deadline_ids[]=0;
			$filter_deadlines=implode(',',$deadline_ids);
		}
		if($filter_deadlines=='')
			$filter_deadlines=array();
		else
			$filter_deadlines=explode(',',$filter_deadlines);
		
		if($type_tache=='unique')
			$options=array('id_tache'=>$active_task,'workers'=>$filter_workers,'projects'=>$filter_projects,'tri'=>$tri);
		elseif($type_tache=='favorite')
			$options=array('favorite'=>true,'tri'=>$tri);
		else
			$options=array('statut'=>$type_tache,'workers'=>$filter_workers,'projects'=>$filter_projects,'tri'=>$tri,'tags'=>$filter_tags,'milestones'=>$filter_milestones,'deadlines'=>$filter_deadlines);
		
		$tasks=getTasks($options);
		if($active_info=="")
			$active_info=0;
		$res=getTaskList($tasks,$active_task,$active_info);
		$filters=getFilters($options);
		
		$state_tri_priorite='ui-state-default';
		$state_tri_date='ui-state-default';
		if($tri=='priorite desc')
			$state_tri_priorite='ui-state-active';
		else
			$state_tri_date='ui-state-active';
		/*$current_tri='	<ul id="icons_tri" class="icons ui-widget ui-helper-clearfix">
							<li class="'.$state_tri_priorite.' ui-corner-all" accept_tooltip="1" title="Tri par priorité" onclick="setTri(\'priorite desc\')"><span class="ui-icon ui-icon-star"></span></li>
							<li class="'.$state_tri_date.' ui-corner-all" accept_tooltip="1" title="Tri par date de dernière modification" onclick="setTri(\'date_derniere_modif desc\')"><span class="ui-icon ui-icon-clock"></span></li>
						</ul>';*/
		$current_tri="<ul id='icons_tri' class='icons ui-widget ui-helper-clearfix'>
							<li id='icon_tri_priorite' class='$state_tri_priorite ui-corner-all' accept_tooltip='1' title='".getLocText('ltext_sort_priority')."' onclick='setTri(0)'><span class='ui-icon ui-icon-star'></span></li>
							<li id='icon_tri_date' class='$state_tri_date ui-corner-all' accept_tooltip='1' title='".getLocText('ltext_sort_date')."' onclick='setTri(1)'><span class='ui-icon ui-icon-clock'></span></li>
						</ul>";
		$update_tri='$("#list_tri").html("'.($current_tri).'");';
		updatePage('<br>'.$res['html'],$res['js'].$update_tri."scrollToActiveItem('tache_list','".$_GET['active_task']."');");	
		updatePage($filters['html'],$filters['js'],'filtres');	
	}
	elseif(isset($_GET['update_stage_counts']))
	{
		$filter_workers=$_GET['filter_workers'];
		if($filter_workers=="")
			$filter_workers=$_SESSION['id_worker'];
		$filter_workers=explode(',',$filter_workers);
		$filter_projects=$_GET['filter_projects'];
		
		if($filter_projects=="")
		{
			$project_ids=getProjectIds(PROJECT_RUNNING);
			$filter_projects=implode(',',$project_ids);
		}
		$filter_projects=explode(',',$filter_projects);
		$filter_tags='';
		if(isset($_GET['filter_tags']))
			$filter_tags=$_GET['filter_tags'];
		if($filter_tags=="")
		{
			$tag_ids=getTagIds();
			$tag_ids[]=0;
			$filter_tags=implode(',',$tag_ids);
		}
		if($filter_tags=='')
			$filter_tags=array();
		else
			$filter_tags=explode(',',$filter_tags);
			
		$filter_milestones='';
		if(isset($_GET['filter_milestones']))
			$filter_milestones=$_GET['filter_milestones'];
		if($filter_milestones=="")
		{
			$milestone_ids=getMilestoneIds();
			$milestone_ids[]=0;
			$filter_milestones=implode(',',$milestone_ids);
		}
		if($filter_milestones=='')
			$filter_milestones=array();
		else
			$filter_milestones=explode(',',$filter_milestones);
		
		$filter_deadlines='';
		if(isset($_GET['filter_deadlines']))
			$filter_deadlines=$_GET['filter_deadlines'];
		if($filter_deadlines=="")
		{
			$deadline_ids=getDeadlineIds();
			$deadline_ids[]=0;
			$filter_deadlines=implode(',',$deadline_ids);
		}
		if($filter_deadlines=='')
			$filter_deadlines=array();
		else
			$filter_deadlines=explode(',',$filter_deadlines);
			
		$updates=array('todo'=>STAGE_TODO,'wip'=>STAGE_WIP,'pending'=>strval(STAGE_STANDBY),'complete'=>STAGE_DONE);
		//print_r($updates);
		foreach($updates as $id_html=>$statut)
		{
			$options=array('statut'=>$statut,'workers'=>$filter_workers,'projects'=>$filter_projects,'tags'=>$filter_tags,'milestones'=>$filter_milestones,'deadlines'=>$filter_deadlines);
			//print_r($options);
			$tasks=getTasks($options);
			$count=0;
			while($ligne = fetchRequest($tasks['result']))
			{
				$count+=$ligne['nb_etapes'];
			}
			echo '$("#amount_'.$id_html.'").html("'.$count.'");';
		}
	}
	elseif(isset($_GET['get_all_task_list']))
	{
		set_time_limit(0);
		$filter_statuts=$_GET['filter_statuts'];
		if($filter_statuts=="")
		{
			$standby=STAGE_STANDBY;
			$todo=STAGE_TODO;
			$wip=STAGE_WIP;
			$done=STAGE_DONE;
			$filter_statuts="$standby,$todo,$wip,$done";
		}
		$filter_statuts=explode(',',$filter_statuts);
		
		$filter_workers=$_GET['filter_workers'];
		if($filter_workers=="")
		{
			$worker_ids=getWorkerIds(WORKER_ACTIF);
			$filter_workers=implode(',',$worker_ids);
		}
		$filter_workers=explode(',',$filter_workers);
		
		$filter_projects=$_GET['filter_projects'];
		if($filter_projects=="")
		{
			$project_ids=getProjectIds(PROJECT_RUNNING);
			$filter_projects=implode(',',$project_ids);
		}
		$filter_projects=explode(',',$filter_projects);
		
		$filter_authors=$_GET['filter_authors'];
		if($filter_authors=="")
		{
			$worker_ids=getWorkerIds(WORKER_ACTIF);
			$filter_authors=implode(',',$worker_ids);
		}
		$filter_authors=explode(',',$filter_authors);
		$filter_tags='';
		if(isset($_GET['filter_tags']))
			$filter_tags=$_GET['filter_tags'];
		if($filter_tags=="")
		{
			$tag_ids=getTagIds();
			$tag_ids[]=0;
			$filter_tags=implode(',',$tag_ids);
		}
		if($filter_tags=='')
			$filter_tags=array();
		else
			$filter_tags=explode(',',$filter_tags);
			
		$filter_milestones='';
		if(isset($_GET['filter_milestones']))
			$filter_milestones=$_GET['filter_milestones'];
		if($filter_milestones=="")
		{
			$milestone_ids=getMilestoneIds();
			$milestone_ids[]=0;
			$filter_milestones=implode(',',$milestone_ids);
		}
		if($filter_milestones=='')
			$filter_milestones=array();
		else
			$filter_milestones=explode(',',$filter_milestones);
		
		$filter_deadlines='';
		if(isset($_GET['filter_deadlines']))
			$filter_deadlines=$_GET['filter_deadlines'];
		if($filter_deadlines=="")
		{
			$deadline_ids=getDeadlineIds();
			$deadline_ids[]=0;
			$filter_deadlines=implode(',',$deadline_ids);
		}
		if($filter_deadlines=='')
			$filter_deadlines=array();
		else
			$filter_deadlines=explode(',',$filter_deadlines);
			
		$options=array('statuts'=>$filter_statuts,'workers'=>$filter_workers,'projects'=>$filter_projects,'authors'=>$filter_authors,'tags'=>$filter_tags,'milestones'=>$filter_milestones,'deadlines'=>$filter_deadlines);
		$tasks=getTasks($options);
		
		$res=getAllTaskTable($tasks);
		$filters=getFilters($options,PROJECT_ALL);
		updatePage($res['html'],$res['js']);	
		updatePage($filters['html'],$filters['js'],'filtres');				
		
	}
	
	elseif(isset($_GET['get_member_list']))
	{
		$worker_activity=$_GET['get_member_list'];
		$workers=getWorkers($worker_activity);
		$active_worker=str_replace('worker','',$_GET['active_worker']);
		$active_info=str_replace('info','',$_GET['active_info']);
		if($active_info=="")
			$active_info=0;
		$res=getWorkerList($workers,$active_worker,$active_info);
		updatePage($res['html'],$res['js']);		
	}
	elseif(isset($_GET['get_chat_room']))
	{
		$id_room=$_GET['get_chat_room'];
		$chat_room=getChatRoom($id_room);
		updatePage($chat_room['html'],$chat_room['js']);	
		echo 'updateChatRoom('.$id_room.',1);';	
	}
	elseif(isset($_POST['add_chat_message']))
	{
		$id_room=$_POST['id_room'];
		$id_worker=$_SESSION['id_worker'];
		$message=chaineMysql($_POST['message']);
		requeteSql("insert into chat_message (id_room,id_worker,message,date_post) values ($id_room,$id_worker,$message,NOW())");
		updateChatRoom($id_room);		
	}
	elseif(isset($_GET['update_chat_room']))
	{
		$id_room=$_GET['update_chat_room'];
		$quick_load=$_GET['quick_load'];
		echo 'updateChatRoom('.$id_room.');';
		updateChatRoom($id_room,$quick_load);	
	}
	elseif(isset($_GET['send_chat_room_notification']))
	{
		$id_room=$_GET['send_chat_room_notification'];
		$id_dest=$_GET['id_dest'];
		$id_sender=$_SESSION['id_worker'];
		$add_notif=true;
		$requete=requeteSql("select * from notification where id_destinataire=$id_dest and param1=$id_sender and param4=$id_room and type_notif=".NOTIF_CHAT_ROOM." order by date_notif desc limit 1");
		if($requete['nb_lines']==1)
		{
			$ligne=$requete['first_line'];
			$last_notif=$ligne['date_notif'];
			$time_elapsed=time()-getTimeStamp($last_notif);
			if($time_elapsed<60*10)
				$add_notif=false;
		}
		if($add_notif)
			addNotification($id_dest,NOTIF_CHAT_ROOM,$id_sender,0,0,$id_room);
	}
	elseif(isset($_GET['switch_favorite']))
	{
		$id_tache=chaineMysql($_GET['id_tache']);
		$add=chaineMysql($_GET['add']);
		$id_worker=$_SESSION['id_worker'];
		if($add==1)
		{
			requeteSql("insert into avoir_favori (id_tache,id_worker) values ($id_tache,$id_worker)");
		}
		else
		{
			requeteSql("delete from avoir_favori where id_tache=$id_tache and id_worker=$id_worker");
		}
	}
	elseif(isset($_GET['get_map_list']))
	{
		$active_menu=$_GET['menu'];
		$res=getMapList($active_menu);
		updatePage($res['html'],$res['js']);		
	}
	elseif(isset($_GET['get_map']))
	{
		$active_map=substr($_GET['map'],4);
		$map_info=getMapInfo($active_map);
		updatePage($map_info,'','info0_'.$_GET['map']);		
	}
	elseif(isset($_GET['get_global_datas_list']))
	{
		$active_menu=$_GET['menu'];
		$res=getGlobalDatasList($active_menu);
		updatePage($res['html'],$res['js']);		
	}
	elseif(isset($_GET['get_global_datas_job_info0']))
	{
		$res=getJobDatas();
		updatePage($res['html'],$res['js'].'','info0_global_datas_job');	
	}
	elseif(isset($_GET['get_global_datas_job_category_info0']))
	{
		$res=getJobCategoryDatas();
		updatePage($res['html'],$res['js'].'','info0_global_datas_job_category');	
	}
	elseif(isset($_GET['get_global_datas_tag_info0']))
	{
		$res=getTagDatas();
		updatePage($res['html'],$res['js'].'','info0_global_datas_tag');	
	}
	elseif(isset($_GET['get_global_datas_budget_info0']))
	{
		$res=getBudgetDatas();
		updatePage($res['html'],$res['js'].'','info0_global_datas_budget');	
	}
	elseif(isset($_GET['get_global_datas_budget_info1']))
	{
		$res=getBudgetEvolutionDatas();
		updatePage($res['html'],$res['js'].'','info1_global_datas_budget');	
	}
	elseif(isset($_GET['get_operations_list']))
	{
		$active_menu=$_GET['menu'];
		$res=getOperationsList($active_menu);
		updatePage($res['html'],$res['js']);		
	}
	elseif(isset($_GET['get_operations_bdd_info0']))
	{
		$res=getBackupOperation();
		updatePage($res['html'],$res['js'].'','info0_operations_bdd');	
	}
	elseif(isset($_GET['get_operations_bdd_info1']))
	{
		$res=getRestoreOperation();
		updatePage($res['html'],$res['js'].'','info1_operations_bdd');	
	}
	elseif(isset($_GET['get_operations_errors_info0']))
	{
		$res=getStageAnalysis();
		updatePage($res['html'],$res['js'].'','info0_operations_errors');	
	}
	elseif(isset($_GET['get_operations_errors_info1']))
	{
		$res=getTaskAnalysis();
		updatePage($res['html'],$res['js'].'','info1_operations_errors');	
	}
	elseif(isset($_GET['get_operations_errors_info2']))
	{
		$res=getWorkAnalysis();
		updatePage($res['html'],$res['js'].'','info2_operations_errors');	
	}
	elseif(isset($_GET['get_operations_data_export_info0']))
	{
		$res=getWorkingDaysExport();
		updatePage($res['html'],$res['js'].'','info0_operations_data_export');	
	}
	elseif(isset($_GET['get_operations_data_export_info1']))
	{
		$res=getPlanningExport();
		updatePage($res['html'],$res['js'].'','info1_operations_data_export');	
	}
	elseif(isset($_GET['repair_stages']))
	{
		$res=getStageAnalysis(true);
		updatePage($res['html'],$res['js'].'','info0_operations_errors');	
	}
	elseif(isset($_GET['repair_tasks']))
	{
		$res=getTaskAnalysis(true);
		updatePage($res['html'],$res['js'].'','info1_operations_errors');	
	}
	elseif(isset($_GET['repair_work']))
	{
		$res=getWorkAnalysis(true);
		updatePage($res['html'],$res['js'].'','info2_operations_errors');	
	}
	elseif(isset($_GET['export_work']))
	{
		$res=getWorkingDaysExport(true);
		updatePage($res['html'],$res['js'].'','info0_operations_data_export');	
	}
	elseif(isset($_GET['export_planning']))
	{
		$res=getPlanningExport(true);
		updatePage($res['html'],$res['js'].'','info1_operations_data_export');	
	}
	
	elseif(isset($_GET['backup_bases']))
	{
		if(!(is_dir("backup/")))
			mkdir("backup/");
		set_time_limit(0);
		$today=date("j_m_y");
		$full_path="backup/backup_bases_$today.txt";
		$fp = @fopen($full_path, 'wb');
		if($fp!=false)
		{
			fwrite($fp, getBackupBase(NOM_BASE_COMMON));
			fclose($fp);
			updatePage('<div style="margin-top: 20px; padding: 0 .7em;" class="ui-state-highlight ui-corner-all"><p><span style="float: left; margin-right: .3em;" class="ui-icon ui-icon-info"></span>'.getLocText('ltext_menu_admin_operations_backup_result_ok').'<a href="'.$full_path.'" target="_blank">'.$full_path.'</a></p></div>','','info0_operations_bdd');	
		}
		else
			updatePage('<div style="margin-top: 20px; padding: 0 .7em;" class="ui-state-error ui-corner-all"><p><span style="float: left; margin-right: .3em;" class="ui-icon ui-icon-info"></span>'.getLocText('ltext_menu_admin_operations_backup_result_error').'</p></div>','','info0_operations_bdd');	
	}
	elseif(isset($_GET['show_progress']))
	{
		$process_name=$_GET['show_progress'];
		$progress=getProgress($process_name);
		$progress=@number_format($progress,3);
		updatePage('progress='.$progress.' %','','info1_operations_bdd');	
		echo 'trackProgress("'.$process_name.'");';
	}
	elseif(isset($_GET['test_progress']))
	{
		header('Connection: close');
		session_write_close();
		updateProgress('restore_base',0);
		
		for($i=0;$i<100;$i++)
			@getProjectPlanningDatas();
		updateProgress('restore_base',1);
		
		for($i=0;$i<100;$i++)
			@getProjectPlanningDatas();
		
		updateProgress('restore_base',2);
		
	}
	elseif(isset($_GET['restore_base']))
	{
		set_time_limit(0);
		if(isset($_GET['continue']))
		{
			$bases=array();
			$bases[0]['uploaded']=true;
			$bases[0]['full_path']=$_GET['file'];
			$line_start=$_GET['continue'];
			$requests_done=$_GET['requests_done'];
			$download_ok=true;
		}
		else
		{
			$bases=retrieveInputFile("backup");
			$line_start=0;
			$requests_done=0;
			$download_ok=false;
		}
		header('Connection: close');
		session_write_close();
		if(isset($bases[0]))
		{
			if($bases[0]['uploaded'])
			{
				$full_path=$bases[0]['full_path'];
				$handle = fopen($full_path, "r");
				$contents = fread($handle, filesize($full_path));
				$requetes=explode(";\r\n",$contents);
				$nb_requetes=0;
				$tot_requetes=sizeof($requetes);
				$nb_ajouts=0;
				$current_line=0;
				$process_complete=true;
				foreach($requetes as $key=>$val)
				{
					if($current_line>=$line_start)
					{
						if(strlen($val)>5)
						{
							$requete=requeteSql($val);
							$nb_requetes++;
							updateProgress('restore_base',100*($nb_requetes+$requests_done)/$tot_requetes);
							$nb_ajouts+=$requete['affected_lines'];
						}
					}
					$current_line++;
					if($nb_requetes>1000)
					{
						$process_complete=false;
						break;
					}
				}
				fclose($handle);
				if($process_complete)
				{
					unlink($full_path);
					$result=getLocText('ltext_menu_admin_operations_restore_ok');
					$result=str_replace('[X]',$nb_requetes+$requests_done,$result);
					$result=str_replace('[Y]',$nb_ajouts,$result);
					updatePage('<div style="margin-top: 20px; padding: 0 .7em;" class="ui-state-highlight ui-corner-all"><p><span style="float: left; margin-right: .3em;" class="ui-icon ui-icon-info"></span>'.$result.'</p></div>','stopTracking("restore_base");','info1_operations_bdd');	
				}
				else
				{
					echo 'continueRestoreBases("'.$full_path.'",'.$current_line.','.($nb_requetes+$requests_done).');';
				}
				$download_ok=true;
			}
		}
		if(!$download_ok)
			updatePage('<div style="margin-top: 20px; padding: 0 .7em;" class="ui-state-error ui-corner-all"><p><span style="float: left; margin-right: .3em;" class="ui-icon ui-icon-info"></span>'.getLocText('ltext_menu_admin_operations_restore_error').'</p></div>','stopTracking("restore_base");','info1_operations_bdd');	
	}
	elseif(isset($_GET['get_operations_global_edition_info0']))
	{
		$res=getStageTransfer();
		updatePage($res['html'],$res['js'].'','info0_operations_global_edition');	
	}
	elseif(isset($_GET['get_operations_global_edition_info1']))
	{
		$res=getProjectTransfer();
		updatePage($res['html'],$res['js'].'','info1_operations_global_edition');	
	}
	elseif(isset($_GET['get_operations_global_edition_info2']))
	{
		$res=getPriorityRedistribution();
		updatePage($res['html'],$res['js'].'','info2_operations_global_edition');	
	}
	elseif(isset($_GET['transfer_stage']))
	{
		$condition_projet='';
		$id_projet=$_POST['id_projet'];
		if($id_projet!='all')
			$condition_projet="and t.id_projet=$id_projet";
		$id_giver=$_POST['id_giver'];
		$id_receiver=$_POST['id_receiver'];
		$requete=requeteSql("update etape e, tache t set e.id_worker=$id_receiver where e.id_worker=$id_giver and e.id_tache=t.id and e.statut<>".STAGE_DONE." $condition_projet");
		$nb_modifications=$requete['affected_lines'];
		$requete=requeteSql("update tache t set id_auteur=$id_receiver where id_auteur=$id_giver $condition_projet");
		$nb_modifications+=$requete['affected_lines'];
		updatePage('<div style="margin-top: 20px; padding: 0 .7em;" class="ui-state-highlight ui-corner-all"><p><span style="float: left; margin-right: .3em;" class="ui-icon ui-icon-info"></span>'.str_replace('[X]',$nb_modifications,getLocText('ltext_edition_stage_result')).'</p></div>','','info0_operations_global_edition');	
	}
	elseif(isset($_GET['transfer_project']))
	{
		$condition_projet='';
		$id_projet_from=$_POST['id_projet_from'];
		$id_projet_to=$_POST['id_projet_to'];
		
		$requete=requeteSql("update etape e,tache t set t.id_projet=$id_projet_to where t.id_projet=$id_projet_from and e.id_tache=t.id and e.statut<>".STAGE_DONE);
		$nb_modifications=$requete['affected_lines'];
		requeteSql("update log l,tache t set l.id_projet=t.id_projet where l.id_tache=t.id");
		updatePage('<div style="margin-top: 20px; padding: 0 .7em;" class="ui-state-highlight ui-corner-all"><p><span style="float: left; margin-right: .3em;" class="ui-icon ui-icon-info"></span>'.str_replace('[X]',$nb_modifications,getLocText('ltext_edition_project_result')).'</p></div>','','info1_operations_global_edition');	
	}
	elseif(isset($_GET['redistribute_priorities']))
	{
		$id_projet=$_POST['id_projet'];
		$nb_modifications=redistributePriorities($id_projet);
		updatePage('<div style="margin-top: 20px; padding: 0 .7em;" class="ui-state-highlight ui-corner-all"><p><span style="float: left; margin-right: .3em;" class="ui-icon ui-icon-info"></span>'.str_replace('[X]',$nb_modifications,getLocText('ltext_edition_priority_result')).'</p></div>','','info2_operations_global_edition');	
	}
	elseif(isset($_GET['get_next_holidays']))
	{
		$res=getNextHolidaysTable();
		updatePage($res['html'],$res['js']);		
	}
	elseif(isset($_GET['get_team_overview']))
	{
		$res=getTeamOverview();
		updatePage($res['html'],$res['js']);		
	}
	elseif(isset($_GET['get_credits']))
	{
		$res=getCredits();
		updatePage($res['html'],$res['js']);		
	}
	elseif(isset($_GET['set_project_statut']))
	{
		$id_project=str_replace('projet','',$_GET['projet']);
		$new_statut=$_GET['set_project_statut'];
		requeteSql("update projet set statut_projet=$new_statut where id=$id_project");
		echo 'refreshPage();';
	}
	elseif(isset($_GET['set_worker_activity']))
	{
		$id_project=str_replace('worker','',$_GET['worker']);
		$new_statut=$_GET['set_worker_activity'];
		requeteSql("update worker set actif=$new_statut where id=$id_project");
		echo 'refreshPage();';
	}
	elseif(isset($_GET['set_stage_statut']))
	{
		if(ENGINE_V2)
		{
			$id_tache=str_replace('tache','',$_GET['tache']);
			$multi_tasks=explode(',',$_GET['multi']);
			//$multi_tasks=arem($multi_tasks,$id_tache);
			if(sizeof($multi_tasks)>0)
			{
				reset($multi_tasks);
				//echo '/*';print_r($multi_tasks);echo '*/';
				$id_tache=current($multi_tasks);
			}
			$new_statut=$_GET['set_stage_statut'];
			$search_statut='statut=-1';
			switch($new_statut)
			{
				case STAGE_TODO:$search_statut='statut='.STAGE_WIP;break;
				case STAGE_WIP:$search_statut='statut='.STAGE_TODO;break;
				case STAGE_DONE:$search_statut='(statut='.STAGE_TODO.' or statut='.STAGE_WIP.')';break;
			}
			$requete=requeteSql("select * from etape where id_tache=$id_tache and $search_statut and sleeping=0 and id_worker=".$_SESSION['id_worker']);
			if($requete['nb_lines']!=1)
				$requete=requeteSql("select * from etape where id_tache=$id_tache and $search_statut and sleeping=0");
			
			if($requete['nb_lines']==1)
			{
				$ligne=$requete['first_line'];
				$id_etape=$ligne['id'];
				updateStageStatut($id_etape,$new_statut);
				updateStageTask($id_tache);
				
				$multi_tasks=arem($multi_tasks,$id_tache);
				echo '$( "#tache'.$id_tache.'" ).effect( "drop", {direction:"right"} );';
				if(sizeof($multi_tasks)>0)
				{
					echo 'sendRequest("get","set_stage_statut='.$new_statut.'&tache='.$_GET['tache'].'&multi='.implode(',',$multi_tasks).'",REQUEST_HIDDEN,"Changement de statut");';
				}
				else
					echo 'updateStageCounts();';
			}
			elseif($requete['nb_lines']>1)
			{
				if(isset($_POST['change_statut_complex']))
				{
					foreach($_POST as $key=>$val)
					{
						if(strpos($key,'id_etape')===0)
						{
							$id_etape=str_replace('id_etape','',$key);
							updateStageStatut($id_etape,$new_statut);
						}
					}
					updateStageTask($id_tache);
					echo '$( "#tache'.$id_tache.'" ).effect( "drop", {direction:"right"} );';
					$multi_tasks=arem($multi_tasks,$id_tache);
					if(sizeof($multi_tasks)>0)
					{
						echo 'try{$( "#dialog-message").dialog( "close" );}catch(e){}sendRequest("get","set_stage_statut='.$new_statut.'&tache='.$_GET['tache'].'&multi='.implode(',',$multi_tasks).'",REQUEST_HIDDEN,"Changement de statut");';
					}
					else
						echo 'try{$( "#dialog-message").dialog( "close" );}catch(e){}updateStageCounts();';
				}
				else
				{
					echo "getDialog('change_statut_complex',$id_tache,$new_statut,'".$_GET['multi']."');";
				}
			}
			else
			{
				echo 'refreshPage();';
				echo 'showDialog("'.getLocText('ltext_dialog_operation_impossible').'","'.getLocText('ltext_dialog_change_status_impossible_message').'<br><a onclick=\'closeDialog();\' href=\'#taches/display/tache'.$id_tache.'/info2\'>'.getLocText('ltext_dialog_change_status_impossible_message2').'</a>",false);';
			}
		}
		else
		{
			$id_tache=str_replace('tache','',$_GET['tache']);
			$new_statut=$_GET['set_stage_statut'];
			if($new_statut==STAGE_TODO)
			{
				$requete=requeteSql("select * from etape where id_tache=$id_tache and statut=".STAGE_WIP." and sleeping=0");
			}
			elseif($new_statut==STAGE_WIP)
			{
				$requete=requeteSql("select * from etape where id_tache=$id_tache and statut=".STAGE_TODO." and sleeping=0");
			}
			elseif($new_statut==STAGE_DONE)
			{
				$requete=requeteSql("select * from etape where id_tache=$id_tache and (statut=".STAGE_TODO." or statut=".STAGE_WIP.") and sleeping=0");
			}
			else
			{
				$requete=requeteSql("select * from etape where id_tache=$id_tache and statut=-1 and sleeping=0");
			}
			
			
			if($requete['nb_lines']==1)
			{
				$ligne=$requete['first_line'];
				$id_etape=$ligne['id'];
				updateStageStatut($id_etape,$new_statut);
				updateStageTask($id_tache);
			}
			else
			{
				echo 'refreshPage();';
				echo 'showDialog("'.getLocText('ltext_dialog_operation_impossible').'","'.getLocText('ltext_dialog_change_status_impossible_message').'<br><a onclick=\'closeDialog();\' href=\'#taches/display/tache'.$id_tache.'/info2\'>'.getLocText('ltext_dialog_change_status_impossible_message2').'</a>",false);';
			}
		}
	}
	elseif(isset($_GET['set_stage_priorite']))
	{
		$id_etape=$_GET['id_etape'];
		$requete=requeteSql("select * from etape where id=$id_etape");
		$ligne=$requete['first_line'];
		$id_tache=$ligne['id_tache'];
		$new_priorite=$_GET['set_stage_priorite'];
		if($_GET['etape_only']==1)
		{
			if(ENGINE_V2)
			{
				$position=$ligne['position'];
				requeteSql("update etape set priorite=$new_priorite where id_tache=$id_tache and position=$position");
			}			
			else
				requeteSql("update etape set priorite=$new_priorite where id=$id_etape");
		}
		else
		{
			$multi_tasks=array();
			if($_GET['multi']!='')
				$multi_tasks=explode(',',$_GET['multi']);
			$multi_tasks[]=$id_tache;
			foreach($multi_tasks as $key=>$id_tache)
				requeteSql("update etape set priorite=$new_priorite where id_tache=$id_tache");
		}
		echo 'refreshPage();';
	}
	elseif(isset($_GET['set_stage_sleeping']))
	{
		$id_etape=$_GET['id_etape'];
		$sleeping=$_GET['set_stage_sleeping'];
		$change_ok=true;
		$requete=requeteSql("select * from etape where id=$id_etape");
		$ligne=$requete['first_line'];
		$id_tache=$ligne['id_tache'];
		if($sleeping==1)
		{
			$requete=requeteSql("select * from etape where id_tache=$id_tache");
			$nb_etapes=$requete['nb_lines'];
			$requete=requeteSql("select * from etape where id_tache=$id_tache and sleeping=1");
			$nb_etapes_endormies=$requete['nb_lines'];
			if($nb_etapes_endormies>=$nb_etapes-1)
			{
				$change_ok=false;
			}	
		}
		if($change_ok)
		{
			requeteSql("update etape set sleeping=$sleeping where id=$id_etape");
			updateStageTask($id_tache);
			echo 'refreshPage();';
		}
		else
		{
			echo 'showDialog("'.getLocText('ltext_dialog_operation_impossible').'","'.getLocText('ltext_dialog_sleeping_task_message').'",true);';
		}
	}
	elseif(isset($_GET['set_tache_color']))
	{
		$id_tache=$_GET['id_tache'];
		$color=$_GET['set_tache_color'];
		if(strtolower($color)=='ffffff')
			$color='';
		$multi_tasks=array();
		if($_GET['multi']!='')
			$multi_tasks=explode(',',$_GET['multi']);
		$multi_tasks[]=$id_tache;
		foreach($multi_tasks as $key=>$id_tache)
			requeteSql("update tache set color='$color' where id=$id_tache");	
		if(sizeof($multi_tasks)>1)
			echo 'refreshPage();';
	}
	elseif(isset($_GET['update_stage']))
	{
		$id_etape=$_GET['update_stage'];
		$new_position=$_GET['new_position'];
		$id_tache=$_GET['id_tache'];
		$requete=requeteSql("select * from etape where id=$id_etape");
		$ligne=$requete['first_line'];
		$old_position=$ligne['position'];
		if(ENGINE_V2)
		{
			$prev_position=$_GET['prev_position'];
			$next_position=$_GET['next_position'];
			if($prev_position==0)
			{
				$new_position=1;
				requeteSql("update etape set position=position+1 where id_tache=$id_tache");
				requeteSql("update etape set position=$new_position where id=$id_etape");
			}
			elseif($next_position==0)
			{
				$new_position=$prev_position+1;
				requeteSql("update etape set position=$new_position where id=$id_etape");
			}
			elseif($prev_position==$next_position)
			{
				requeteSql("update etape set position=$prev_position where id=$id_etape");
			}
			else
			{
				$new_position=$prev_position+1;
				requeteSql("update etape set position=position+1 where id_tache=$id_tache and position>=$new_position");
				requeteSql("update etape set position=$new_position where id=$id_etape");
			}
		}
		else
		{
			requeteSql("update etape set position=position-1 where id_tache=$id_tache and position>$old_position");
			requeteSql("update etape set position=position+1 where id_tache=$id_tache and position>=$new_position");
			requeteSql("update etape set position=$new_position where id=$id_etape");
		}
		
		if(ENGINE_V2)
		{
			$requete2=requeteSql("select * from etape where id_tache=$id_tache order by position");
			$positions=array();
			$etapes=array();
			while($ligne2 = fetchRequest($requete2['result']))
			{
				$id_etape=$ligne2['id'];
				$position_etape=$ligne2['position'];
				if(!in_array($position_etape,$positions))
					$positions[]=$position_etape;
				$etapes[$id_etape]['position']=$position_etape;
			}
			sort($positions);
			foreach($etapes as $id_etape=>$val)
			{
				$old_position=$etapes[$id_etape]['position'];
				$new_position=array_search($val['position'], $positions)+1;
				if($old_position!=$new_position)//fix gaps (empty steps)
				{
					$etapes[$id_etape]['position']=$new_position;
					requeteSql("update etape set position=$new_position where id=$id_etape");
				}
			}
		}
		
		$ancestors=getStageAncestors($id_etape);
		$need_delete_ancestors=false;
		foreach($ancestors['id_etape_meres'] as $k=>$v)
		{
			if(!noLegacyLoop($id_etape,$v))//une boucle de dépendance infinie est apparue suite au changement d'ordre des tâches
			{
				requeteSql("delete from depend_de where id_etape_fille=$id_etape and id_etape_mere=$v");
				$need_delete_ancestors=true;
			}
		}
		updateStageTask($id_tache);
		updateInfo();
		echo 'updateStageCounts();';
		if($need_delete_ancestors)
			echo 'showDialog("'.getLocText('ltext_dialog_delete_dependency_title').'","'.getLocText('ltext_dialog_delete_dependency_message').'",true);';
		//$res=getTaskFlow($id_tache);
		//updatePage($res['html'],$res['js'],'info2_tache'.$id_tache);	
		//echo 'refreshPage();';
	}
	elseif(isset($_GET['quick_fix_delay']))
	{
		$id_etape=$_GET['id_etape'];
		$requete=requeteSql("select * from etape e,tache t where t.id=e.id_tache and e.id=$id_etape");
		$ligne=$requete['first_line'];
		$duree=$ligne['duree'];
		$estimation_duree=$ligne['estimation_duree'];
		$id_projet=$ligne['id_projet'];
		$id_tache=$ligne['id_tache'];
		$histo=requeteSql("select * from histo_etape where id_etape=$id_etape and date_end='0000-00-00 00:00:00'");
		if($histo['nb_lines']==1)
		{
			$histo_ligne=$histo['first_line'];
			$duree+=getDateDiff(date("Y-m-d H:i:s"),$histo_ligne['date_start'])/3600;
		}
		if($duree>$estimation_duree)
		{
			$new_estimation=$duree+1;
			requeteSql("update etape set estimation_duree=$new_estimation where id=$id_etape");
			addLog($_SESSION['id_worker'],$id_projet,$id_tache,$id_etape,LOG_UPDATE_ESTIMATION,($new_estimation-$estimation_duree));
		}
	}
	elseif(isset($_GET['get_task_info0']))
	{
		$id_tache=str_replace('tache','',$_GET['tache']);
		$res=getTaskInfo($id_tache);
		updatePage($res['html'],$res['js'].'','info0_tache'.$id_tache);	
	}
	elseif(isset($_GET['get_task_info1']))
	{
		$id_tache=str_replace('tache','',$_GET['tache']);
		$res=getTaskCurrentStageInfo($id_tache);
		updatePage($res['html'],$res['js'],'info1_tache'.$id_tache);	
	}
	elseif(isset($_GET['get_task_info2']))
	{
		$id_tache=str_replace('tache','',$_GET['tache']);
		$res=getTaskFlow($id_tache);
		updatePage($res['html'],$res['js'],'info2_tache'.$id_tache);	
	}
	elseif(isset($_GET['get_task_info3']))
	{
		$id_tache=str_replace('tache','',$_GET['tache']);
		$res=getTaskFlow($id_tache,DISPLAY_GRAPH);
		updatePage($res['html'],$res['js'],'info3_tache'.$id_tache);	
	}
	elseif(isset($_GET['get_task_info4']))
	{
		$id_tache=str_replace('tache','',$_GET['tache']);
		$res=getTaskDocuments($id_tache);
		updatePage($res['html'],$res['js'],'info4_tache'.$id_tache);	
	}
	elseif(isset($_GET['get_task_info5']))
	{
		$id_tache=str_replace('tache','',$_GET['tache']);
		$res=getTaskComments($id_tache);
		updatePage($res['html'],$res['js'],'info5_tache'.$id_tache);	
	}
	elseif(isset($_GET['get_task_info6']))
	{
		$id_tache=str_replace('tache','',$_GET['tache']);
		$res=getTaskLog($id_tache);
		updatePage($res['html'],$res['js'],'info6_tache'.$id_tache);	
	}
	elseif(isset($_GET['get_task_info7']))
	{
		$id_tache=str_replace('tache','',$_GET['tache']);
		$res=getTaskRemoval($id_tache);
		updatePage($res['html'],$res['js'],'info7_tache'.$id_tache);	
	}
	
	elseif(isset($_GET['get_project_info0']))
	{
		$id_project=str_replace('projet','',$_GET['projet']);
		$res=getProjectInfo($id_project);
		updatePage($res['html'],$res['js'],'info0_projet'.$id_project);	
	}
	elseif(isset($_GET['get_project_info1']))
	{
		$id_project=str_replace('projet','',$_GET['projet']);
		$res=getProjectPeople($id_project);
		updatePage($res['html'],$res['js'],'info1_projet'.$id_project);		
	}
	elseif(isset($_GET['get_project_info2']))
	{
		$id_project=str_replace('projet','',$_GET['projet']);
		$res=getProjectMilestone($id_project);
		updatePage($res['html'],$res['js'],'info2_projet'.$id_project);		
	}
	elseif(isset($_GET['get_project_info3']))
	{
		$id_project=str_replace('projet','',$_GET['projet']);
		$res=getProjectRampUp($id_project);
		updatePage($res['html'],$res['js'],'info3_projet'.$id_project);		
	}
	elseif(isset($_GET['get_project_info4']))
	{
		$id_project=str_replace('projet','',$_GET['projet']);
		$res=getProjectBudget($id_project);
		updatePage($res['html'],$res['js'],'info4_projet'.$id_project);		
	}
	elseif(isset($_GET['get_project_info5']))
	{
		$id_project=str_replace('projet','',$_GET['projet']);
		$res=getProjectExternalCosts($id_project);
		updatePage($res['html'],$res['js'],'info5_projet'.$id_project);		
	}
	elseif(isset($_GET['get_project_info6']))
	{
		$id_project=str_replace('projet','',$_GET['projet']);
		$res=getTagDatas($id_project);
		updatePage($res['html'],$res['js'],'info6_projet'.$id_project);		
	}
	elseif(isset($_GET['get_project_info7']))
	{
		$id_project=str_replace('projet','',$_GET['projet']);
		$res=getProjectGraph($id_project);
		updatePage($res['html'],$res['js'],'info7_projet'.$id_project);		
	}
	elseif(isset($_GET['get_project_info8']))
	{
		$id_project=str_replace('projet','',$_GET['projet']);
		$res=getProjectDeadline($id_project);
		updatePage($res['html'],$res['js'],'info8_projet'.$id_project);		
	}
	elseif(isset($_GET['get_project_info9']))
	{
		$from=isset($_GET['from'])?$_GET['from']:'';
		$to=isset($_GET['to'])?$_GET['to']:'';
		$status=isset($_GET['status'])?$_GET['status']:-1;
		$id_project=str_replace('projet','',$_GET['projet']);
		$res=getProjectLog($id_project,$from,$to,$status);
		updatePage($res['html'],$res['js'],'info9_projet'.$id_project);		
	}
	elseif(isset($_GET['get_worker_info0']))
	{
		$id_worker=str_replace('worker','',$_GET['worker']);
		$res=getWorkerInfo($id_worker);
		updatePage($res['html'],$res['js'],'info0_worker'.$id_worker);	
	}
	elseif(isset($_GET['get_worker_info1']))
	{
		$id_worker=str_replace('worker','',$_GET['worker']);
		$res=getWorkerHolidays($id_worker);
		updatePage($res['html'],$res['js'],'info1_worker'.$id_worker);		
	}
	elseif(isset($_GET['get_worker_info2']))
	{
		$id_worker=str_replace('worker','',$_GET['worker']);
		$res=getWorkerProjects($id_worker);
		updatePage($res['html'],$res['js'],'info2_worker'.$id_worker);		
	}
	elseif(isset($_GET['get_worker_info3']))
	{
		$id_worker=str_replace('worker','',$_GET['worker']);
		$from=isset($_GET['from'])?$_GET['from']:'';
		$to=isset($_GET['to'])?$_GET['to']:'';
		$res=getWorkerStats($id_worker,$from,$to);
		updatePage($res['html'],$res['js'],'info3_worker'.$id_worker);		
	}
	elseif(isset($_GET['log_out']))
	{
		session_unset();
		echo 'check_notification=1;refreshPage();';
	}
	elseif(isset($_GET['save_dim']))
	{
		$content_page_width=$_GET['width'];
		$content_page_height=$_GET['height'];
		requeteSql("update worker set content_page_width=$content_page_width,content_page_height=$content_page_height where id=".$_SESSION['id_worker']);
		$_SESSION['content_page_width']=$content_page_width;
		$_SESSION['content_page_height']=$content_page_height;
	}
	elseif(isset($_GET['get_user_input']))
	{
		$global_action=$_GET['get_user_input'];
		if($global_action=='add_project_member')
		{	
			$fields=array();
			$workers=getWorkerSelector(true);
			$fields[]=array("id_field"=>"id_projet","type"=>"hidden","value"=>$_GET['val1']);
			$fields[]=array("id_field"=>"id_worker","label"=>getLocText('ltext_task_member'),"type"=>"list","datas"=>$workers);
			$fields[]=array("id_field"=>"date_start","label"=>getLocText('ltext_team_start'),"type"=>"date","validation"=>"valid_date");
			$fields[]=array("id_field"=>"date_end","label"=>getLocText('ltext_team_end'),"type"=>"date","validation"=>"valid_date");
			$options=array('submit_text'=>"");
			$form=getBasicForm("add_project_member",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("add_project_member","post","add_project_member","Ajout de membre au projet");','dialog-message');		
		}
		elseif($global_action=='edit_project_plage')
		{	
			$fields=array();
		
			$fields[]=array("id_field"=>"id_worker","type"=>"hidden","value"=>$_GET['val1']);
			$fields[]=array("id_field"=>"id_projet","type"=>"hidden","value"=>$_GET['val2']);
			$fields[]=array("id_field"=>"date_start","label"=>getLocText('ltext_team_start'),"type"=>"date","validation"=>"valid_date");
			$fields[]=array("id_field"=>"date_end","label"=>getLocText('ltext_team_end'),"type"=>"date","validation"=>"valid_date");
			$options=array('submit_text'=>"",'title_form'=>getLocText('ltext_project_people_edit_work_slot_desc'));
			$form=getBasicForm("edit_project_plage",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("edit_project_plage","post","edit_project_plage","Edition de plage");','dialog-message');		
		}
		elseif($global_action=='delete_project_plage')
		{	
			$fields=array();
		
			$fields[]=array("id_field"=>"id_worker","type"=>"hidden","value"=>$_GET['val1']);
			$fields[]=array("id_field"=>"id_projet","type"=>"hidden","value"=>$_GET['val2']);
			$options=array('submit_text'=>"",'title_form'=>getLocText('ltext_project_people_delete_work_slot_desc'));
			$form=getBasicForm("delete_project_plage",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("delete_project_plage","post","delete_project_plage","Suppression de plage");','dialog-message');		
		}
		elseif($global_action=='add_project_milestone')
		{	
			$fields=array();
			$fields[]=array("id_field"=>"id_projet","type"=>"hidden","value"=>$_GET['val1']);
			$fields[]=array("id_field"=>"nom_milestone","label"=>getLocText('ltext_project_milestone_name'),"type"=>"text","validation"=>"not_empty");
			$fields[]=array("id_field"=>"date_milestone","label"=>getLocText('ltext_project_milestone_date'),"type"=>"date","validation"=>"valid_date");
			$options=array('submit_text'=>"");
			$form=getBasicForm("add_project_milestone",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("add_project_milestone","post","add_project_milestone","Ajout de milestone au projet");','dialog-message');		
		}
		elseif($global_action=='edit_project_milestone')
		{	
			$fields=array();
			$id_milestone=$_GET['val1'];
			$requete=requeteSql("select * from milestone where id=$id_milestone");
			$ligne=$requete['first_line'];
			$fields[]=array("id_field"=>"id_milestone","type"=>"hidden","value"=>$_GET['val1']);
			$fields[]=array("id_field"=>"nom_milestone","label"=>getLocText('ltext_project_milestone_name'),"type"=>"text","validation"=>"not_empty","value"=>$ligne['nom_milestone']);
			$fields[]=array("id_field"=>"date_milestone","label"=>getLocText('ltext_project_milestone_date'),"type"=>"date","validation"=>"valid_date","value"=>dateHtml($ligne['date_milestone']));
			$fields[]=array("id_field"=>"is_sent","label"=>getLocText('ltext_project_milestone_sent'),"type"=>"checkbox","value"=>$ligne['is_sent']);
			$fields[]=array("id_field"=>"is_validated","label"=>getLocText('ltext_project_milestone_validated'),"type"=>"checkbox","value"=>$ligne['is_validated']);
			$fields[]=array("id_field"=>"is_paid","label"=>getLocText('ltext_project_milestone_paid'),"type"=>"checkbox","value"=>$ligne['is_paid']);
			$options=array('submit_text'=>"");
			$form=getBasicForm("edit_project_milestone",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("edit_project_milestone","post","edit_project_milestone","Edition de milestone");','dialog-message');		
		}
		elseif($global_action=='delete_project_milestone')
		{	
			$fields=array();
			$id_milestone=$_GET['val1'];
			$requete=requeteSql("select * from milestone where id=$id_milestone");
			$ligne=$requete['first_line'];
			$nom_milestone=$ligne['nom_milestone'];
			$fields[]=array("id_field"=>"id_milestone","type"=>"hidden","value"=>$_GET['val1']);
			$options=array('submit_text'=>"",'title_form'=>str_replace('[X]',$nom_milestone,getLocText('ltext_project_milestone_delete_desc')));
			$form=getBasicForm("delete_project_milestone",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("delete_project_milestone","post","delete_project_milestone","Suppression de milestone");','dialog-message');		
		}
		elseif($global_action=='add_project_echeance')
		{	
			$fields=array();
			$fields[]=array("id_field"=>"id_projet","type"=>"hidden","value"=>$_GET['val1']);
			$fields[]=array("id_field"=>"nom_echeance","label"=>getLocText('ltext_project_deadlines_name'),"type"=>"text","validation"=>"not_empty");
			$fields[]=array("id_field"=>"date_debut","label"=>getLocText('ltext_project_start'),"type"=>"date","validation"=>"valid_date");
			$fields[]=array("id_field"=>"date_echeance","label"=>getLocText('ltext_project_end'),"type"=>"date","validation"=>"valid_date");
			$options=array('submit_text'=>"");
			$form=getBasicForm("add_project_echeance",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("add_project_echeance","post","add_project_echeance","Ajout de echeance au projet");','dialog-message');		
		}
		elseif($global_action=='edit_project_echeance')
		{	
			$fields=array();
			$id_echeance=$_GET['val1'];
			$requete=requeteSql("select * from echeance where id=$id_echeance");
			$ligne=$requete['first_line'];
			$fields[]=array("id_field"=>"id_echeance","type"=>"hidden","value"=>$_GET['val1']);
			$fields[]=array("id_field"=>"nom_echeance","label"=>getLocText('ltext_project_deadlines_name'),"type"=>"text","validation"=>"not_empty","value"=>$ligne['nom_echeance']);
			$fields[]=array("id_field"=>"date_debut","label"=>getLocText('ltext_project_start'),"type"=>"date","validation"=>"valid_date","value"=>dateHtml($ligne['date_debut']));
			$fields[]=array("id_field"=>"date_echeance","label"=>getLocText('ltext_project_end'),"type"=>"date","validation"=>"valid_date","value"=>dateHtml($ligne['date_echeance']));
			$options=array('submit_text'=>"");
			$form=getBasicForm("edit_project_echeance",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("edit_project_echeance","post","edit_project_echeance","Edition de echeance");','dialog-message');		
		}
		elseif($global_action=='delete_project_echeance')
		{	
			$fields=array();
			$id_echeance=$_GET['val1'];
			$requete=requeteSql("select * from echeance where id=$id_echeance");
			$ligne=$requete['first_line'];
			$nom_echeance=$ligne['nom_echeance'];
			$fields[]=array("id_field"=>"id_echeance","type"=>"hidden","value"=>$_GET['val1']);
			$options=array('submit_text'=>"",'title_form'=>str_replace('[X]',$nom_echeance,getLocText('ltext_project_deadlines_delete_desc')));
			$form=getBasicForm("delete_project_echeance",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("delete_project_echeance","post","delete_project_echeance","Suppression de echeance");','dialog-message');		
		}
		elseif($global_action=='add_project_external_cost')
		{	
			$fields=array();
			$fields[]=array("id_field"=>"id_projet","type"=>"hidden","value"=>$_GET['val1']);
			$fields[]=array("id_field"=>"nom_cout","label"=>getLocText('ltext_project_external_costs_name'),"type"=>"text","validation"=>"not_empty");
			$fields[]=array("id_field"=>"valeur_cout","label"=>getLocText('ltext_project_external_costs_value'),"type"=>"text","validation"=>"is_numeric");
			$fields[]=array("id_field"=>"date_cout","label"=>getLocText('ltext_project_external_costs_date'),"type"=>"date","validation"=>"valid_date");
			$options=array('submit_text'=>"");
			$form=getBasicForm("add_project_external_cost",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("add_project_external_cost","post","add_project_external_cost","Ajout de coût externe au projet");','dialog-message');		
		}
		elseif($global_action=='edit_project_external_cost')
		{	
			$fields=array();
			$id_cout=$_GET['val1'];
			$requete=requeteSql("select * from cout_externe where id=$id_cout");
			$ligne=$requete['first_line'];
			$fields[]=array("id_field"=>"id_cout","type"=>"hidden","value"=>$_GET['val1']);
			$fields[]=array("id_field"=>"nom_cout","label"=>getLocText('ltext_project_external_costs_name'),"type"=>"text","validation"=>"not_empty","value"=>$ligne['nom_cout']);
			$fields[]=array("id_field"=>"valeur_cout","label"=>getLocText('ltext_project_external_costs_value'),"type"=>"text","validation"=>"is_numeric","value"=>$ligne['valeur_cout']);
			$fields[]=array("id_field"=>"date_cout","label"=>getLocText('ltext_project_external_costs_date'),"type"=>"date","validation"=>"valid_date","value"=>dateHtml($ligne['date_cout']));
			$options=array('submit_text'=>"");
			$form=getBasicForm("edit_project_external_cost",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("edit_project_external_cost","post","edit_project_external_cost","Edition de coût");','dialog-message');		
		}
		elseif($global_action=='delete_project_external_cost')
		{	
			$fields=array();
			$id_cout=$_GET['val1'];
			$requete=requeteSql("select * from cout_externe where id=$id_cout");
			$ligne=$requete['first_line'];
			$nom_cout=$ligne['nom_cout'];
			$fields[]=array("id_field"=>"id_cout","type"=>"hidden","value"=>$_GET['val1']);
			$options=array('submit_text'=>"",'title_form'=>str_replace('[X]',$nom_cout,getLocText('ltext_project_external_costs_delete_desc')));
			$form=getBasicForm("delete_project_external_cost",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("delete_project_external_cost","post","delete_project_external_cost","Suppression de coût");','dialog-message');		
		}
		elseif($global_action=='add_worker_holidays')
		{	
			$fields=array();
			$type_vac=getHolidayTypeSelector();
			$fields[]=array("id_field"=>"id_worker","type"=>"hidden","value"=>$_GET['val1']);
			$fields[]=array("id_field"=>"vac_date_start","label"=>getLocText('ltext_team_start'),"type"=>"date","validation"=>"valid_date");
			$fields[]=array("id_field"=>"vac_date_end","label"=>getLocText('ltext_team_end'),"type"=>"date","validation"=>"valid_date");
			$fields[]=array("id_field"=>"type_vac","label"=>getLocText('ltext_team_holidays_type'),"type"=>"list","datas"=>$type_vac);
			$options=array('submit_text'=>"");
			$form=getBasicForm("add_worker_holidays",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("add_worker_holidays","post","add_worker_holidays","Ajout de vacances");','dialog-message');		
		}
		elseif($global_action=='edit_worker_holidays')
		{	
			$fields=array();
			$id_vacances=$_GET['val1'];
			$requete=requeteSql("select * from vacances where id=$id_vacances");
			$ligne=$requete['first_line'];
			$type_vac=getHolidayTypeSelector();
			$fields[]=array("id_field"=>"id_vacances","type"=>"hidden","value"=>$_GET['val1']);
			$fields[]=array("id_field"=>"vac_date_start","label"=>getLocText('ltext_team_start'),"type"=>"date","validation"=>"valid_date","value"=>dateHtml($ligne['vac_date_start']));
			$fields[]=array("id_field"=>"vac_date_end","label"=>getLocText('ltext_team_end'),"type"=>"date","validation"=>"valid_date","value"=>dateHtml($ligne['vac_date_end']));
			$fields[]=array("id_field"=>"type_vac","label"=>getLocText('ltext_team_holidays_type'),"type"=>"list","datas"=>$type_vac,"value"=>$ligne['type_vac']);
			$options=array('submit_text'=>"");
			$form=getBasicForm("edit_worker_holidays",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("edit_worker_holidays","post","edit_worker_holidays","Edition de vacances");','dialog-message');		
		}
		elseif($global_action=='delete_worker_holidays')
		{	
			$fields=array();
			$id_milestone=$_GET['val1'];
			$fields[]=array("id_field"=>"id_vacances","type"=>"hidden","value"=>$_GET['val1']);
			$options=array('submit_text'=>"",'title_form'=>getLocText('ltext_team_holidays_delete_desc'));
			$form=getBasicForm("delete_worker_holidays",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("delete_worker_holidays","post","delete_worker_holidays","Suppression de vacances");','dialog-message');		
		}
		elseif($global_action=='add_task_document')
		{	
			$fields=array();
			$id_tache=$_GET['val1'];
			$etapes=getStageSelector($id_tache);
			$workers=getWorkerSelector(true);
			if(ENGINE_V2)
			{
				$current_stages=getTaskCurrentStage($id_tache);
				$current_stage=$current_stages[0];
			}
			else
				$current_stage=getTaskCurrentStage($id_tache);
			
			$fields[]=array("id_field"=>"id_tache","type"=>"hidden","value"=>$id_tache);
			$fields[]=array("id_field"=>"nom_doc","label"=>getLocText('ltext_task_document_name'),"type"=>"text","title"=>getLocText('ltext_task_document_missing_name'));
			$fields[]=array("id_field"=>"id_etape","label"=>getLocText('ltext_task_document_stage'),"type"=>"list","datas"=>$etapes,"value"=>$current_stage['id_etape']);
			$fields[]=array("id_field"=>"id_uploader","label"=>getLocText('ltext_task_document_upload_by'),"type"=>"list","datas"=>$workers,"value"=>$_SESSION['id_worker']);
			$fields[]=array("id_field"=>"docs","label"=>getLocText('ltext_task_document_file'),"type"=>"file");
			
			$options=array('submit_text'=>"");
			$form=getBasicForm("add_task_document",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("add_task_document","post","add_task_document","Ajout de document");','dialog-message');		
		}
		elseif($global_action=='edit_task_document')
		{	
			$fields=array();
			$id_doc=$_GET['val1'];
			$requete=requeteSql("select nom_doc,id_etape,id_uploader,id_tache from pj as p, etape as e where p.id=$id_doc and p.id_etape=e.id");
			$ligne=$requete['first_line'];
			$id_tache=$ligne['id_tache'];
			$etapes=getStageSelector($id_tache);
			$workers=getWorkerSelector(true);

			$fields[]=array("id_field"=>"id_doc","type"=>"hidden","value"=>$id_doc);
			$fields[]=array("id_field"=>"id_tache","type"=>"hidden","value"=>$id_tache);
			$fields[]=array("id_field"=>"nom_doc","label"=>getLocText('ltext_task_document_name'),"type"=>"text","title"=>getLocText('ltext_task_document_missing_name'),"value"=>$ligne['nom_doc']);
			$fields[]=array("id_field"=>"id_etape","label"=>getLocText('ltext_task_document_stage'),"type"=>"list","datas"=>$etapes,"value"=>$ligne['id_etape']);
			$fields[]=array("id_field"=>"id_uploader","label"=>getLocText('ltext_task_document_upload_by'),"type"=>"list","datas"=>$workers,"value"=>$_SESSION['id_worker'],"value"=>$ligne['id_uploader']);
			
			$options=array('submit_text'=>"");
			$form=getBasicForm("edit_task_document",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("edit_task_document","post","edit_task_document","Edition de document");','dialog-message');		
		}
		elseif($global_action=='delete_task_document')
		{	
			$fields=array();
			$id_doc=$_GET['val1'];
			$fields[]=array("id_field"=>"id_doc","type"=>"hidden","value"=>$_GET['val1']);
			$options=array('submit_text'=>"",'title_form'=>getLocText('ltext_task_delete_document_desc'));
			$form=getBasicForm("delete_task_document",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("delete_task_document","post","delete_task_document","Suppression de document");','dialog-message');		
		}
		elseif($global_action=='add_task_comment')
		{	
			$fields=array();
			$id_tache=$_GET['val1'];
			$etapes=getStageSelector($id_tache);
			$destinataires=getTaskPeopleSelector($id_tache);
			$id_destinataires=array();
			foreach($destinataires as $key=>$val)
				$id_destinataires[]=$val['option_value'];
			$destinataires=getWorkerSelector(true);
			if(ENGINE_V2)
			{
				$current_stages=getTaskCurrentStage($id_tache);
				$current_stage=$current_stages[0];
			}
			else
				$current_stage=getTaskCurrentStage($id_tache);
			$fields[]=array("id_field"=>"id_tache","type"=>"hidden","value"=>$id_tache);
			$fields[]=array("id_field"=>"commentaire_texte","label"=>getLocText('ltext_task_comment'),"type"=>"textarea","validation"=>"not_empty","autofocus"=>"1");
			$fields[]=array("id_field"=>"id_etape","label"=>getLocText('ltext_task_stage'),"type"=>"list","datas"=>$etapes,"value"=>$current_stage['id_etape']);
			$fields[]=array("id_field"=>"destinataires","label"=>getLocText('ltext_task_comment_warn'),"type"=>"list","datas"=>$destinataires,"multiple_choice"=>1,"values"=>$id_destinataires);
			
			$options=array('submit_text'=>"");
			$form=getBasicForm("add_task_comment",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("add_task_comment","post","add_task_comment","Ajout de commentaire");','dialog-message');		
		}
		elseif($global_action=='edit_task_comment')
		{	
			$fields=array();
			$id_comment=$_GET['val1'];
			$requete=requeteSql("select commentaire_texte,id_etape,id_writer,id_tache from commentaire as c, etape as e where c.id=$id_comment and c.id_etape=e.id");
			$ligne=$requete['first_line'];
			$id_tache=$ligne['id_tache'];
			$etapes=getStageSelector($id_tache);
			
			$fields[]=array("id_field"=>"id_comment","type"=>"hidden","value"=>$id_comment);
			$fields[]=array("id_field"=>"commentaire_texte","label"=>getLocText('ltext_task_comment'),"type"=>"textarea","validation"=>"not_empty","value"=>$ligne['commentaire_texte']);
			$fields[]=array("id_field"=>"id_etape","label"=>getLocText('ltext_task_stage'),"type"=>"list","datas"=>$etapes,"value"=>$ligne['id_etape']);
			
			$options=array('submit_text'=>"");
			$form=getBasicForm("edit_task_comment",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("edit_task_comment","post","edit_task_comment","Edition de commentaire");','dialog-message');		
		}
		elseif($global_action=='delete_task_comment')
		{	
			$fields=array();
			$id_doc=$_GET['val1'];
			$fields[]=array("id_field"=>"id_comment","type"=>"hidden","value"=>$_GET['val1']);
			$options=array('submit_text'=>"",'title_form'=>getLocText('ltext_task_delete_comment_desc'));
			$form=getBasicForm("delete_task_comment",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("delete_task_comment","post","delete_task_comment","Suppression de comment");','dialog-message');		
		}
		elseif($global_action=='add_job')
		{	
			$job_categories=getJobCategorySelector();
			$fields=array();
			$fields[]=array("id_field"=>"nom_metier","label"=>getLocText('ltext_team_job'),"type"=>"text","validation"=>"not_empty");
			$fields[]=array("id_field"=>"id_categorie","label"=>getLocText('ltext_job_category'),"type"=>"list","datas"=>$job_categories);
			
			$options=array('submit_text'=>"");
			$form=getBasicForm("add_job",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("add_job","post","add_job","Ajout de métier");','dialog-message');		
		}
		elseif($global_action=='edit_job')
		{	
			$fields=array();
			$id_metier=$_GET['val1'];
			$job_categories=getJobCategorySelector();
			$requete=requeteSql("select * from metier where id=$id_metier");
			$ligne=$requete['first_line'];
						
			$fields[]=array("id_field"=>"id_metier","type"=>"hidden","value"=>$id_metier);
			$fields[]=array("id_field"=>"nom_metier","label"=>getLocText('ltext_team_job'),"type"=>"text","validation"=>"not_empty","value"=>$ligne['nom_metier']);
			$fields[]=array("id_field"=>"id_categorie","label"=>getLocText('ltext_job_category'),"type"=>"list","datas"=>$job_categories,"value"=>$ligne['id_categorie']);
			
			$options=array('submit_text'=>"");
			$form=getBasicForm("edit_job",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("edit_job","post","edit_job","Edition de métier");','dialog-message');		
		}
		elseif($global_action=='delete_job')
		{	
			$fields=array();
			$id_metier=$_GET['val1'];
			$fields[]=array("id_field"=>"id_metier","type"=>"hidden","value"=>$id_metier);
			$requete=requeteSql("select * from worker where id_metier=$id_metier");
			$desc=getLocText('ltext_job_delete_desc');
			$desc=str_replace('[X]',$requete['nb_lines'],$desc);
			$options=array('submit_text'=>"",'title_form'=>$desc);
			$form=getBasicForm("delete_job",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("delete_job","post","delete_job","Suppression de métier");','dialog-message');		
		}
		elseif($global_action=='add_job_category')
		{	
			$fields=array();
			$fields[]=array("id_field"=>"nom_categorie","label"=>getLocText('ltext_job_category'),"type"=>"text","validation"=>"not_empty");
			
			$options=array('submit_text'=>"");
			$form=getBasicForm("add_job_category",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("add_job_category","post","add_job_category","Ajout de catégorie");','dialog-message');		
		}
		elseif($global_action=='edit_job_category')
		{	
			$fields=array();
			$id_categorie=$_GET['val1'];
			$requete=requeteSql("select * from categorie_metier where id=$id_categorie");
			$ligne=$requete['first_line'];
						
			$fields[]=array("id_field"=>"id_categorie","type"=>"hidden","value"=>$id_categorie);
			$fields[]=array("id_field"=>"nom_categorie","label"=>getLocText('ltext_job_category'),"type"=>"text","validation"=>"not_empty","value"=>$ligne['nom_categorie']);
			
			$options=array('submit_text'=>"");
			$form=getBasicForm("edit_job_category",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("edit_job_category","post","edit_job_category","Edition de catégorie");','dialog-message');		
		}
		elseif($global_action=='delete_job_category')
		{	
			$fields=array();
			$id_categorie=$_GET['val1'];
			$fields[]=array("id_field"=>"id_categorie","type"=>"hidden","value"=>$id_categorie);
			$requete=requeteSql("select * from metier where id_categorie=$id_categorie");
			$desc=getLocText('ltext_job_cat_delete_desc');
			$desc=str_replace('[X]',$requete['nb_lines'],$desc);
			$options=array('submit_text'=>"",'title_form'=>$desc);
			$form=getBasicForm("delete_job_category",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("delete_job_category","post","delete_job_category","Suppression de catégorie");','dialog-message');		
		}
		elseif($global_action=='add_tag')
		{	
			$fields=array();
			$id_projet=$_GET['val1'];
			$projets=getProjectSelector(PROJECT_RUNNING);
			$fields[]=array("id_field"=>"nom_tag","label"=>getLocText('ltext_project_tags_name'),"type"=>"text","validation"=>"not_empty");
			$fields[]=array("id_field"=>"id_projet","label"=>getLocText('ltext_task_project'),"type"=>"list","datas"=>$projets,"value"=>$id_projet);
			
			$options=array('submit_text'=>"");
			$form=getBasicForm("add_tag",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("add_tag","post","add_tag","Ajout de tag");','dialog-message');		
		}
		elseif($global_action=='edit_tag')
		{	
			$fields=array();
			$id_tag=$_GET['val1'];
			$projets=getProjectSelector(PROJECT_RUNNING);
			$requete=requeteSql("select * from tag where id=$id_tag");
			$ligne=$requete['first_line'];
						
			$fields[]=array("id_field"=>"id_tag","type"=>"hidden","value"=>$id_tag);
			$fields[]=array("id_field"=>"nom_tag","label"=>getLocText('ltext_project_tags_name'),"type"=>"text","validation"=>"not_empty","value"=>$ligne['nom_tag']);
			$fields[]=array("id_field"=>"id_projet","label"=>getLocText('ltext_task_project'),"type"=>"list","datas"=>$projets,"value"=>$ligne['id_projet']);
			
			$options=array('submit_text'=>"");
			$form=getBasicForm("edit_tag",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("edit_tag","post","edit_tag","Edition de tag");','dialog-message');		
		}
		elseif($global_action=='delete_tag')
		{	
			$fields=array();
			$id_tag=$_GET['val1'];
			$fields[]=array("id_field"=>"id_tag","type"=>"hidden","value"=>$_GET['val1']);
			$options=array('submit_text'=>"",'title_form'=>getLocText('ltext_project_tags_delete_desc'));
			$form=getBasicForm("delete_tag",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("delete_tag","post","delete_tag","Suppression de tag");','dialog-message');		
		}
		elseif($global_action=='apply_realtime_tag')
		{	
			$fields=array();
			$id_tag=$_GET['val1'];
			$fields[]=array("id_field"=>"id_tag","type"=>"hidden","value"=>$_GET['val1']);
			$options=array('submit_text'=>"",'title_form'=>getLocText('ltext_project_tags_apply_desc'));
			$form=getBasicForm("apply_realtime_tag",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("apply_realtime_tag","post","apply_realtime_tag","Suppression de tag");','dialog-message');		
		}
		elseif($global_action=='add_budget')
		{	
			$fields=array();
			$fields[]=array("id_field"=>"date_start","label"=>getLocText('ltext_manmonth_from'),"type"=>"date","validation"=>"valid_date");
			$fields[]=array("id_field"=>"cout","label"=>getLocText('ltext_manmonth_cost'),"type"=>"text","validation"=>"is_numeric");
			
			$options=array('submit_text'=>"");
			$form=getBasicForm("add_budget",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("add_budget","post","add_budget","Ajout de coût");','dialog-message');		
		}
		elseif($global_action=='edit_budget')
		{	
			$fields=array();
			$id_mois_homme=$_GET['val1'];
			$requete=requeteSql("select * from mois_homme where id=$id_mois_homme");
			$ligne=$requete['first_line'];
			
			$fields[]=array("id_field"=>"id_mois_homme","type"=>"hidden",'value'=>$id_mois_homme);			
			$fields[]=array("id_field"=>"date_start","label"=>getLocText('ltext_manmonth_from'),"type"=>"date","validation"=>"valid_date",'value'=>dateHtml($ligne['date_start']));
			$fields[]=array("id_field"=>"cout","label"=>getLocText('ltext_manmonth_cost'),"type"=>"text","validation"=>"is_numeric",'value'=>$ligne['cout']);
			
			$options=array('submit_text'=>"");
			$form=getBasicForm("edit_budget",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("edit_budget","post","edit_budget","Edition de coût");','dialog-message');		
		}
		elseif($global_action=='delete_budget')
		{	
			$fields=array();
			$id_mois_homme=$_GET['val1'];
			
			$fields[]=array("id_field"=>"id_mois_homme","type"=>"hidden",'value'=>$id_mois_homme);			

			$options=array('submit_text'=>"",'title_form'=>getLocText('ltext_manmonth_delete_desc'));
			$form=getBasicForm("delete_budget",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("delete_budget","post","delete_budget","Suppression de coût");','dialog-message');		
		}
		elseif($global_action=='add_task_stage')
		{	
			$fields=array();
			$id_tache=$_GET['val1'];
			if(ENGINE_V2)
			{
				$current_stages=getTaskCurrentStage($id_tache);
				$current_stage=$current_stages[0];
			}
			else
				$current_stage=getTaskCurrentStage($id_tache);
			$requete=requeteSql("select id_projet from tache where id=$id_tache");
			$ligne=$requete['first_line'];
			$workers=getWorkerSelector(true);
			$workers=getWorkerSelector(WORKER_ACTIF);
			$stages=getAllStageSelector();
			$tags=getTagSelector($ligne['id_projet']);
			$fields[]=array("id_field"=>"id_tache","type"=>"hidden","value"=>$_GET['val1']);
			$fields[]=array("id_field"=>"objectif","label"=>getLocText('ltext_task_add_stage_objective'),"type"=>"text","validation"=>"not_empty");
			$fields[]=array("id_field"=>"id_worker","label"=>getLocText('ltext_task_member'),"type"=>"list","datas"=>$workers,'value'=>$_SESSION['id_worker']);
			$fields[]=array("id_field"=>"estimation_duree","label"=>getLocText('ltext_task_add_stage_duration'),"type"=>"text","value"=>0,"validation"=>"is_numeric","title"=>getLocText('ltext_task_help_no_estimation'));
			$fields[]=array("id_field"=>"priorite","label"=>getLocText('ltext_task_priority'),"type"=>"text","value"=>$current_stage['priorite'],"validation"=>"is_numeric");
			$fields[]=array("id_field"=>"id_tag","label"=>getLocText('ltext_task_tag'),"type"=>"list","datas"=>$tags,"title"=>getLocText('ltext_task_help_tag'));
			$fields[]=array("id_field"=>"dependance","label"=>getLocText('ltext_task_depends'),"type"=>"list","datas"=>$stages,"duplication"=>getLocText('ltext_task_add_dependence'));
			$options=array('submit_text'=>"");
			$form=getBasicForm("add_task_stage",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("add_task_stage","post","add_task_stage","'.getLocText('ltext_task_add_stage').'");','dialog-message');		
		}
		elseif($global_action=='edit_task_stage')
		{	
			$fields=array();
			$id_etape=$_GET['val1'];
			$requete=requeteSql("select id_tache, objectif, id_worker, estimation_duree, e.id_tag, sleeping, id_projet, id_metier  from etape e, tache t where t.id=e.id_tache and e.id=$id_etape");
			$ligne=$requete['first_line'];
			$workers=getWorkerSelector(WORKER_ACTIF);
			$stages=getAllStageSelector();
			$tags=getTagSelector($ligne['id_projet']);
			$jobs=getJobSelector();
			$ancestors=getStageAncestors($id_etape);
			$can_edit_estimation=workerHasRight($_SESSION['id_worker'],DROIT_EDIT_ESTIMATION);
			$fields[]=array("id_field"=>"id_etape","type"=>"hidden","value"=>$_GET['val1']);
			$fields[]=array("id_field"=>"id_tache","type"=>"hidden","value"=>$ligne['id_tache']);
			$fields[]=array("id_field"=>"objectif","label"=>getLocText('ltext_task_add_stage_objective'),"type"=>"text","validation"=>"not_empty","value"=>$ligne['objectif']);
			$fields[]=array("id_field"=>"id_worker","label"=>getLocText('ltext_task_member'),"type"=>"list","datas"=>$workers,"value"=>$ligne['id_worker']);
			$fields[]=array("id_field"=>"id_metier","label"=>getLocText('ltext_team_job'),"type"=>"list","datas"=>$jobs,"value"=>$ligne['id_metier'],"title"=>getLocText('ltext_task_help_job'));
			$fields[]=array("id_field"=>"estimation_duree","label"=>getLocText('ltext_task_add_stage_duration'),"type"=>"text","value"=>$ligne['estimation_duree'],"validation"=>"is_numeric","title"=>getLocText('ltext_task_help_no_estimation'),'read_only'=>!$can_edit_estimation);
			$fields[]=array("id_field"=>"id_tag","label"=>getLocText('ltext_task_tag'),"type"=>"list","datas"=>$tags,"value"=>$ligne['id_tag'],"title"=>getLocText('ltext_task_help_tag'));
			$fields[]=array("id_field"=>"sleeping","label"=>getLocText('ltext_task_sleeping_stage'),"type"=>"checkbox","value"=>$ligne['sleeping'],"title"=>getLocText('ltext_task_help_sleep'));
			
			foreach($ancestors['id_etape_meres'] as $key=>$val)
			{
				$fields[]=array("id_field"=>"dependance","label"=>getLocText('ltext_task_depends'),"type"=>"list","datas"=>$stages,'value'=>$val,'group_field'=>true);
			}
			$fields[]=array("id_field"=>"dependance","label"=>getLocText('ltext_task_depends'),"type"=>"list","datas"=>$stages,"duplication"=>getLocText('ltext_task_add_dependence'));
			$options=array('submit_text'=>"");
			$form=getBasicForm("edit_task_stage",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("edit_task_stage","post","edit_task_stage","Edition d\'étape");','dialog-message');		
		}
		elseif($global_action=='delete_task_stage')
		{	
			$fields=array();
			$id_etape=$_GET['val1'];
			$requete=requeteSql("select * from etape where id=$id_etape");
			$ligne=$requete['first_line'];
			$objectif=$ligne['objectif'];
			$id_tache=$ligne['id_tache'];
			$fields[]=array("id_field"=>"id_etape","type"=>"hidden","value"=>$_GET['val1']);
			$fields[]=array("id_field"=>"id_tache","type"=>"hidden","value"=>$id_tache);
			$desc=str_replace('[X]',$objectif,getLocText('ltext_stage_delete_desc'));
			$options=array('submit_text'=>"",'title_form'=>$desc);
			$form=getBasicForm("delete_task_stage",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("delete_task_stage","post","delete_task_stage","Suppression d\'étape");','dialog-message');		
		}
		elseif($global_action=='delete_task')
		{	
			$fields=array();
			$id_tache=$_GET['val1'];
			$fields[]=array("id_field"=>"id_tache","type"=>"hidden","value"=>$_GET['val1']);
			$options=array('submit_text'=>"",'title_form'=>getLocText('ltext_task_delete_desc'));
			$form=getBasicForm("delete_task",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("delete_task","post","delete_task","Suppression de tâche");','dialog-message');		
		}
		elseif($global_action=='go_todo_task_stage')
		{	
			$fields=array();
			$id_etape=$_GET['val1'];
			$requete=requeteSql("select * from etape where id=$id_etape");
			$ligne=$requete['first_line'];
			$objectif=$ligne['objectif'];
			$id_tache=$ligne['id_tache'];
			$position=$ligne['position'];
			$fields[]=array("id_field"=>"id_etape","type"=>"hidden","value"=>$_GET['val1']);
			$fields[]=array("id_field"=>"id_tache","type"=>"hidden","value"=>$id_tache);
			$fields[]=array("id_field"=>"position","type"=>"hidden","value"=>$position);
			$desc=str_replace('[X]',$objectif,getLocText('ltext_current_stage_change_desc'));
			$options=array('submit_text'=>"",'title_form'=>$desc);
			$form=getBasicForm("go_todo_task_stage",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("go_todo_task_stage","post","go_todo_task_stage","Transformation d\' une étape en étape courante");','dialog-message');		
		}
		elseif($global_action=='attrib_projects')
		{	
			$fields=array();
			$ids_travaille=explode('-',$_GET['val1']);
			$projets=getProjectSelector(PROJECT_RUNNING);
			$fields[]=array("id_field"=>"ids_travaille","type"=>"hidden","value"=>$_GET['val1']);
			$fields[]=array("id_field"=>"id_projet","label"=>getLocText('ltext_filter_project'),"type"=>"list","datas"=>$projets,"duplication"=>getLocText('ltext_menu_project_add'));
			$options=array('submit_text'=>"");
			$form=getBasicForm("attrib_projects",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("attrib_projects","post","attrib_projects","Attribution de projets aux cases sélectionnées");','dialog-message');		
		}
		elseif($global_action=='send_to_sleep_stage')
		{	
			$fields=array();
			$id_etape=$_GET['val1'];
			$fields[]=array("id_field"=>"id_etape","type"=>"hidden","value"=>$_GET['val1']);
			$options=array('submit_text'=>"",'title_form'=>getLocText('ltext_task_set_sleep_stage_desc'));
			$form=getBasicForm("send_to_sleep_stage",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("send_to_sleep_stage","post","send_to_sleep_stage","Endormissement d\'étape");','dialog-message');		
		}
		elseif($global_action=='wake_up_stage')
		{	
			$fields=array();
			$id_etape=$_GET['val1'];
			$fields[]=array("id_field"=>"id_etape","type"=>"hidden","value"=>$_GET['val1']);
			$options=array('submit_text'=>"",'title_form'=>getLocText('ltext_task_set_awake_stage_desc'));
			$form=getBasicForm("wake_up_stage",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("wake_up_stage","post","wake_up_stage","Réveil d\'étape");','dialog-message');		
		}
		elseif($global_action=='change_statut_complex')
		{	
			$fields=array();
			$id_tache=$_GET['val1'];
			$new_statut=$_GET['val2'];
			$multi=$_GET['val3'];
			$search_statut='statut=-1';
			$title_form=getLocText('ltext_task_change_status_desc');
			switch($new_statut)
			{
				case STAGE_TODO:$search_statut='statut='.STAGE_WIP;$title_form=getLocText('ltext_task_change_status_todo_desc');break;
				case STAGE_WIP:$search_statut='statut='.STAGE_TODO;$title_form=getLocText('ltext_task_change_status_wip_desc');break;
				case STAGE_DONE:$search_statut='(statut='.STAGE_TODO.' or statut='.STAGE_WIP.')';$title_form=getLocText('ltext_task_change_status_done_desc');break;
			}
			$requete=requeteSql("select * from etape where id_tache=$id_tache and $search_statut and sleeping=0");
			$fields[]=array("id_field"=>"change_statut_complex","type"=>"hidden","value"=>"1");
			while($ligne = fetchRequest($requete['result']))
			{
				$id_etape=$ligne['id'];
				$objectif=$ligne['objectif'];
				$nom_worker=getWorkerName($ligne['id_worker']);
				$fields[]=array("id_field"=>"id_etape$id_etape","label"=>"$objectif ($nom_worker)","type"=>"checkbox","value"=>"0","title"=>getLocText('ltext_task_stage'));
			}
			$options=array('submit_text'=>"",'title_form'=>$title_form);
			$form=getBasicForm("change_statut_complex",$fields,$options);
			updatePage($form['html'],$form['js'].'setAjaxForm("change_statut_complex","post","set_stage_statut='.$new_statut.'&tache=tache'.$id_tache.'&multi='.$multi.'","Réveil d\'étape");','dialog-message');		
		}
		elseif($global_action=='display_deadline_details')
		{	
			$id_echeance=$_GET['val1'];
			$res=getDeadlineDetails($id_echeance);
			updatePage($res['html'],$res['js'],'dialog-message');		
		}
		elseif($global_action=='estimate_task')
		{	
			$id_tache=$_GET['val1'];
			$res=array();
			$res['html']='';
			$res['js']='';
			$options=array('without_workers'=>array());
			$planning=getProjectPlanningDatas($options);
			$etapes=$planning['etapes'];
			$requete=requeteSql("select * from etape where id_tache=$id_tache order by position");
			$max_timestamp=0;
			$max_end_date='';
			$res['html'].='<table id="estimation_tache'.$id_tache.'" class="display">
						<thead>
							<tr>
								<th>'.getLocText('ltext_task_objective').'</th>
								<th>'.getLocText('ltext_project_end').'</th>
							</tr>
						</thead>
						<tbody>';
			while($ligne = fetchRequest($requete['result']))
			{
				$id_etape=$ligne['id'];
				$objectif=$ligne['objectif'];
				$date_end=$etapes[$id_etape]['date_end'];
				$date_end_afx=dateHtml($date_end);
				$date_end_timestamp=getTimestamp($date_end);
				if($date_end_timestamp>$max_timestamp)
				{
					$max_timestamp=$date_end_timestamp;
					$max_end_date=$date_end_afx;
				}
				$res['html'].="<tr><td>$objectif</td><td>$date_end_afx</td></tr>";
			}
			$res['html'].='</tbody></table><div id="estimation_tache'.$id_tache.'_buttons" class="table_buttons"></div>';
			$result=getLocText('ltext_task_estimate_result');
			$result=str_replace('[X]',$max_end_date,$result);
			$res['html']=$result.'<br><br>'.$res['html'];
			$res['js'].='var my_table=$("#estimation_tache'.$id_tache.'").DataTable({buttons: ["excel", "pdf"],select: true,"colReorder": true,"bPaginate": false,"bInfo": false, "bFilter": false,"bSort":false});';
			$res['js'].='my_table.buttons().container().appendTo( $("#estimation_tache'.$id_tache.'_buttons") );';
			updatePage($res['html'],$res['js'],'dialog-message');		
		}
		
	}
	elseif(isset($_GET['add_project_member']))
	{
		$id_projet=($_POST['id_projet']);
		$id_worker=($_POST['id_worker']);
		$date_start=($_POST['date_start']);
		$date_end=($_POST['date_end']);
		updateProjectWorker($id_projet,$id_worker,$date_start,$date_end);
		addLog($_SESSION['id_worker'],$id_projet,0,0,LOG_ADD_PROJECT_MEMBER,$id_worker);
		updateInfo();
	}
	elseif(isset($_GET['edit_project_plage']))
	{
		$id_projet=($_POST['id_projet']);
		$id_worker=($_POST['id_worker']);
		$date_start=dateMysql($_POST['date_start']);
		$date_end=dateMysql($_POST['date_end']);
		$requete=requeteSql("select * from travaille where id_worker=$id_worker and id_projet=$id_projet");
		while($ligne = fetchRequest($requete['result']))
		{
			$id_travaille=$ligne['id'];
			$current_jour=$ligne['jour'];
			requeteSql("delete from travaille where id=$id_travaille");
			requeteSql("update travaille set part=part-1 where jour='$current_jour' and id_worker=$id_worker");
		}
		$date_start=($_POST['date_start']);
		$date_end=($_POST['date_end']);
		updateProjectWorker($id_projet,$id_worker,$date_start,$date_end);
		updateInfo();
	}
	elseif(isset($_GET['delete_project_plage']))
	{
		$id_projet=($_POST['id_projet']);
		$id_worker=($_POST['id_worker']);
		$requete=requeteSql("select * from travaille where id_worker=$id_worker and id_projet=$id_projet");
		while($ligne = fetchRequest($requete['result']))
		{
			$id_travaille=$ligne['id'];
			$current_jour=$ligne['jour'];
			requeteSql("delete from travaille where id=$id_travaille");
			requeteSql("update travaille set part=part-1 where jour='$current_jour' and id_worker=$id_worker");
		}
		updateInfo();
	}
	elseif(isset($_GET['add_project_milestone']))
	{
		$id_projet=chaineMysql($_POST['id_projet']);
		$nom_milestone=chaineMysql($_POST['nom_milestone']);
		$date_milestone=dateMysql($_POST['date_milestone']);
		requeteSql("insert into milestone (id_projet,nom_milestone,date_milestone,is_validated,is_paid) values ($id_projet,$nom_milestone,$date_milestone,0,0)");
		addLog($_SESSION['id_worker'],$id_projet,0,0,LOG_ADD_PROJECT_MILESTONE,0);
		updateInfo();
	}
	elseif(isset($_GET['edit_project_milestone']))
	{
		$id_milestone=chaineMysql($_POST['id_milestone']);
		$nom_milestone=chaineMysql($_POST['nom_milestone']);
		$date_milestone=dateMysql($_POST['date_milestone']);
		$is_sent=0;
		$is_validated=0;
		$is_paid=0;
		if(isset($_POST['is_validated']))
			$is_validated=1;
		if(isset($_POST['is_paid']))
			$is_paid=1;
		if(isset($_POST['is_sent']))
			$is_sent=1;
		requeteSql("update milestone set nom_milestone=$nom_milestone,date_milestone=$date_milestone,is_validated=$is_validated,is_paid=$is_paid,is_sent=$is_sent where id=$id_milestone");
		updateInfo();
	}
	elseif(isset($_GET['delete_project_milestone']))
	{
		$id_milestone=chaineMysql($_POST['id_milestone']);
		requeteSql("delete from milestone where id=$id_milestone");
		requeteSql("update tache set id_milestone=0 where id_milestone=$id_milestone");
		updateInfo();
	}
	elseif(isset($_GET['add_project_echeance']))
	{
		$id_projet=chaineMysql($_POST['id_projet']);
		$nom_echeance=chaineMysql($_POST['nom_echeance']);
		$date_debut=dateMysql($_POST['date_debut']);
		$date_echeance=dateMysql($_POST['date_echeance']);
		requeteSql("insert into echeance (id_projet,nom_echeance,date_debut,date_echeance) values ($id_projet,$nom_echeance,$date_debut,$date_echeance)");
		updateInfo();
	}
	elseif(isset($_GET['edit_project_echeance']))
	{
		$id_echeance=chaineMysql($_POST['id_echeance']);
		$nom_echeance=chaineMysql($_POST['nom_echeance']);
		$date_debut=dateMysql($_POST['date_debut']);
		$date_echeance=dateMysql($_POST['date_echeance']);
		requeteSql("update echeance set nom_echeance=$nom_echeance,date_echeance=$date_echeance,date_debut=$date_debut where id=$id_echeance");
		updateInfo();
	}
	elseif(isset($_GET['delete_project_echeance']))
	{
		$id_echeance=chaineMysql($_POST['id_echeance']);
		requeteSql("delete from echeance where id=$id_echeance");
		requeteSql("update tache set id_echeance=0 where id_echeance=$id_echeance");
		updateInfo();
	}
	elseif(isset($_GET['add_project_external_cost']))
	{
		$id_projet=chaineMysql($_POST['id_projet']);
		$nom_cout=chaineMysql($_POST['nom_cout']);
		$valeur_cout=chaineMysql($_POST['valeur_cout']);
		$date_cout=dateMysql($_POST['date_cout']);
		requeteSql("insert into cout_externe (id_projet,nom_cout,valeur_cout,date_cout) values ($id_projet,$nom_cout,$valeur_cout,$date_cout)");
		updateInfo();
	}
	elseif(isset($_GET['edit_project_external_cost']))
	{
		$id_cout=chaineMysql($_POST['id_cout']);
		$nom_cout=chaineMysql($_POST['nom_cout']);
		$valeur_cout=chaineMysql($_POST['valeur_cout']);
		$date_cout=dateMysql($_POST['date_cout']);
		
		requeteSql("update cout_externe set nom_cout=$nom_cout,valeur_cout=$valeur_cout,date_cout=$date_cout where id=$id_cout");
		updateInfo();
	}
	elseif(isset($_GET['delete_project_external_cost']))
	{
		$id_cout=chaineMysql($_POST['id_cout']);
		requeteSql("delete from cout_externe where id=$id_cout");
		updateInfo();
	}
	elseif(isset($_GET['add_worker_holidays']))
	{
		$id_worker=chaineMysql($_POST['id_worker']);
		$type_vac=chaineMysql($_POST['type_vac']);
		$vac_date_start=dateMysql($_POST['vac_date_start']);
		$vac_date_end=dateMysql($_POST['vac_date_end']);
		requeteSql("insert into vacances (id_worker,vac_date_start,vac_date_end,type_vac) values ($id_worker,$vac_date_start,$vac_date_end,$type_vac)");
		updateInfo();
	}
	elseif(isset($_GET['edit_worker_holidays']))
	{
		$id_vacances=chaineMysql($_POST['id_vacances']);
		$type_vac=chaineMysql($_POST['type_vac']);
		$vac_date_start=dateMysql($_POST['vac_date_start']);
		$vac_date_end=dateMysql($_POST['vac_date_end']);
		
		requeteSql("update vacances set vac_date_start=$vac_date_start,vac_date_end=$vac_date_end,type_vac=$type_vac where id=$id_vacances");
		updateInfo();
	}
	elseif(isset($_GET['delete_worker_holidays']))
	{
		$id_vacances=chaineMysql($_POST['id_vacances']);
		requeteSql("delete from vacances where id=$id_vacances");
		updateInfo();
	}
	elseif(isset($_GET['add_task_stage']))
	{
		$id_tache=chaineMysql($_POST['id_tache']);
		$objectif=chaineMysql(nl2br($_POST['objectif']));
		$id_worker=chaineMysql($_POST['id_worker']);
		$id_job=getWorkerJob($id_worker);
		$estimation_duree=chaineMysql($_POST['estimation_duree']);
		$priorite=chaineMysql($_POST['priorite']);
		$requete=requeteSql("select max(position) as max_position from etape where id_tache=$id_tache");
		$ligne=$requete['first_line'];
		$position=$ligne['max_position']+1;
		$requete=requeteSql("insert into etape (id_worker,id_tache,objectif,position,statut,duree,estimation_duree,id_tag,priorite,id_metier) values ($id_worker,$id_tache,$objectif,$position,0,0,$estimation_duree,0,$priorite,$id_job)");
		$id_etape=$requete['id_created'];
		$erreur_dependance="";
		foreach($_POST as $key=>$val)
		{
			if(strpos($key,'dependance')===0)
			{
				if($val!=0)
				{
					if(noLegacyLoop($id_etape,$val))
						requeteSql("insert into depend_de (id_etape_mere,id_etape_fille) values ($val,$id_etape)");
					else
						$erreur_dependance.=str_replace('[X]',$val,getLocText('ltext_dialog_delete_dependency_message')).'<br>';
					
				}
			}
		}
		addLog($_SESSION['id_worker'],0,$id_tache,$id_etape,LOG_ADD_STAGE,$id_etape);
		updateStageTask($id_tache);
		updateInfo();
		if($erreur_dependance!='')
			echo 'showDialog("'.getLocText('ltext_dialog_dependency_error_title').'","'.$erreur_dependance.'",false);';
	}
	elseif(isset($_GET['edit_task_stage']))
	{
		$id_etape=chaineMysql($_POST['id_etape']);
		$requete=requeteSql("select * from etape e,tache t where t.id=e.id_tache and e.id=$id_etape");
		$ligne=$requete['first_line'];
		$old_estimation=$ligne['estimation_duree'];
		$id_projet=$ligne['id_projet'];
		$id_tache=chaineMysql($_POST['id_tache']);
		$objectif=chaineMysql(nl2br($_POST['objectif']));
		$id_worker=chaineMysql($_POST['id_worker']);
		$id_job=chaineMysql($_POST['id_metier']);//getWorkerJob($id_worker);
		$id_tag=chaineMysql($_POST['id_tag']);
		$sleeping=0;
		if(isset($_POST['sleeping']))
			$sleeping=1;
		$estimation_duree=chaineMysql($_POST['estimation_duree']);
		if($estimation_duree!=$old_estimation)
			addLog($_SESSION['id_worker'],$id_projet,$id_tache,$id_etape,LOG_UPDATE_ESTIMATION,($estimation_duree-$old_estimation));
		requeteSql("update etape set objectif=$objectif,id_worker=$id_worker,estimation_duree=$estimation_duree,id_tag=$id_tag,sleeping=$sleeping,id_metier=$id_job where id=$id_etape");
		requeteSql("delete from depend_de where id_etape_fille=$id_etape");
		$erreur_dependance='';
		foreach($_POST as $key=>$val)
		{
			if(strpos($key,'dependance')===0 && $val!=0)
			{
				if(noLegacyLoop($id_etape,$val))
					requeteSql("insert into depend_de (id_etape_mere,id_etape_fille) values ($val,$id_etape)");
				else
					$erreur_dependance.=str_replace('[X]',$val,getLocText('ltext_dialog_delete_dependency_message')).'<br>';
			}	
		}
		
		updateStageTask($id_tache);
		updateInfo();
		if($erreur_dependance!='')
			echo 'showDialog("'.getLocText('ltext_dialog_dependency_error_title').'","'.$erreur_dependance.'",false);';
	}
	elseif(isset($_GET['delete_task_stage']))
	{
		$id_etape=chaineMysql($_POST['id_etape']);
		$id_tache=chaineMysql($_POST['id_tache']);
		$requete=requeteSql("select * from etape where id_tache=$id_tache");
		if($requete['nb_lines']>1)
		{
			deleteStage($id_etape);
			updateStageTask($id_tache);
			updateInfo();
		}
		else
		{
			updateInfo();
			echo 'showDialog("'.getLocText('ltext_dialog_operation_impossible').'","'.getLocText('ltext_dialog_delete_stage_error_message').'",false);';
		}
	}
	elseif(isset($_GET['delete_task']))
	{	
		$id_tache=chaineMysql($_POST['id_tache']);
		deleteTask($id_tache);
		echo 'try{$( "#dialog-message").dialog( "close" );}catch(e){}refreshPage();';
	}
	elseif(isset($_GET['input_user_drop']))
	{
		$file=file_get_contents('php://input');
		$headers=get_apache_headers();
		//print_r($headers);
		if(isset($headers['X-File-Stage']))
			$id_etape=$headers['X-File-Stage'];
		else
			$id_etape=$headers['X-FILE-STAGE'];
		if(isset($headers['X-File-Task']))
			$id_tache=$headers['X-File-Task'];
		else
			$id_tache=$headers['X-FILE-TASK'];
		
		$id_uploader=$_SESSION['id_worker'];
		if(isset($headers['X-File-Name']))
			$filename=cleanFilename(utf8_encode($headers['X-File-Name']));
		else
			$filename=cleanFilename(utf8_encode($headers['X-FILE-NAME']));
		if($id_tache>0)//task document
		{
			$path="uploaded/";
			$lien=getFreeFilename($path.$filename);
			$fileName=str_replace($path,"",$lien);
			$fp = fopen($lien, 'w');
			fwrite($fp, $file);
			fclose($fp);
			$nom_doc=chaineMysql($filename);
			$lien=chaineMysql($lien);
			requeteSql("insert into pj (id_etape,id_uploader,nom_doc,lien,date_upload) values ($id_etape,$id_uploader,$nom_doc,$lien,NOW())");
		}
		else //chat room
		{
			$path="uploaded/agora/";
			$lien=getFreeFilename($path.$filename);
			$fileName=str_replace($path,"",$lien);
			$fp = fopen($lien, 'w');
			fwrite($fp, $file);
			fclose($fp);
			$id_room=$id_etape;
			$id_worker=$id_uploader;
			$message='<i>'.getLocText("ltext_agora_share_file").'</i> <a href="'.$lien.'" target="_blank" download="'.$fileName.'">'.$fileName.'</a>';
			requeteSql("insert into chat_message (id_room,id_worker,message,date_post) values ($id_room,$id_worker,'$message',NOW())");
			updateChatRoom($id_room);	
		}
	}
	elseif(isset($_GET['add_task_document']))
	{
		$id_tache=chaineMysql($_POST['id_tache']);
		$nom_doc=chaineMysql($_POST['nom_doc']);
		$id_etape=chaineMysql($_POST['id_etape']);
		$id_uploader=chaineMysql($_POST['id_uploader']);
		$documents=retrieveInputFile("docs");
		$documents_not_uploaded="";
		foreach($documents as $key=>$val)
		{
			$uploaded=$val['uploaded'];
			$filename=$val['filename'];
			$full_path=$val['full_path'];
			if($uploaded===false)
			{
				$documents_not_uploaded.="$key<br>";
			}
			else
			{
				$lien=chaineMysql($full_path);
				if($_POST['nom_doc']=='')
					$nom_doc=chaineMysql($filename);
				requeteSql("insert into pj (id_etape,id_uploader,nom_doc,lien,date_upload) values ($id_etape,$id_uploader,$nom_doc,$lien,NOW())");
			}
		}
		
		updateInfo();
		
		if($documents_not_uploaded!="")
			echo 'showDialog("'.getLocText('ltext_dialog_download_file_impossible_title').'","'.getLocText('ltext_dialog_download_file_impossible_message').'<br>'.$documents_not_uploaded.'",false);';
		
		
	}
	elseif(isset($_GET['edit_task_document']))
	{
		$id_doc=chaineMysql($_POST['id_doc']);
		$id_tache=chaineMysql($_POST['id_tache']);
		$nom_doc=chaineMysql($_POST['nom_doc']);
		$id_etape=chaineMysql($_POST['id_etape']);
		$id_uploader=chaineMysql($_POST['id_uploader']);
		requeteSql("update pj set nom_doc=$nom_doc,id_etape=$id_etape,id_uploader=$id_uploader where id=$id_doc");
		updateInfo();
	}
	elseif(isset($_GET['delete_task_document']))
	{
		$id_doc=chaineMysql($_POST['id_doc']);
		$doc_deleted=deleteDocument($id_doc);
		updateInfo();
		if(!$doc_deleted)
			echo 'showDialog("'.getLocText('ltext_dialog_delete_file_impossible_title').'","'.getLocText('ltext_dialog_delete_file_impossible_message').'",false);';
	}
	elseif(isset($_GET['add_job']))
	{
		$nom_metier=chaineMysql($_POST['nom_metier']);
		$id_categorie=chaineMysql($_POST['id_categorie']);
		requeteSql("insert into metier (nom_metier,id_categorie) values ($nom_metier,$id_categorie)");
		updateInfo();
	}
	elseif(isset($_GET['edit_job']))
	{
		$id_metier=chaineMysql($_POST['id_metier']);
		$nom_metier=chaineMysql($_POST['nom_metier']);
		$id_categorie=chaineMysql($_POST['id_categorie']);
		
		requeteSql("update metier set nom_metier=$nom_metier,id_categorie=$id_categorie where id=$id_metier");
		updateInfo();
	}
	elseif(isset($_GET['delete_job']))
	{
		$id_metier=chaineMysql($_POST['id_metier']);
		
		requeteSql("update worker set id_metier=0 where id_metier=$id_metier");
		requeteSql("update etape set id_metier=0 where id_metier=$id_metier");
		requeteSql("delete from metier where id=$id_metier");
		updateInfo();
	}
	elseif(isset($_GET['add_job_category']))
	{
		$nom_categorie=chaineMysql($_POST['nom_categorie']);
		requeteSql("insert into categorie_metier (nom_categorie) values ($nom_categorie)");
		updateInfo();
	}
	elseif(isset($_GET['edit_job_category']))
	{
		$id_categorie=chaineMysql($_POST['id_categorie']);
		$nom_categorie=chaineMysql($_POST['nom_categorie']);
		
		requeteSql("update categorie_metier set nom_categorie=$nom_categorie where id=$id_categorie");
		updateInfo();
	}
	elseif(isset($_GET['delete_job_category']))
	{
		$id_categorie=chaineMysql($_POST['id_categorie']);
		
		requeteSql("update metier set id_categorie=0 where id_categorie=$id_categorie");
		requeteSql("delete from categorie_metier where id=$id_categorie");
		updateInfo();
	}
	elseif(isset($_GET['add_tag']))
	{
		$nom_tag=chaineMysql($_POST['nom_tag']);
		$id_projet=chaineMysql($_POST['id_projet']);
		requeteSql("insert into tag (id_projet,nom_tag) values ($id_projet,$nom_tag)");
		updateInfo();
	}
	elseif(isset($_GET['edit_tag']))
	{
		$id_tag=chaineMysql($_POST['id_tag']);
		$nom_tag=chaineMysql($_POST['nom_tag']);
		$id_projet=chaineMysql($_POST['id_projet']);
		requeteSql("update tag set nom_tag=$nom_tag,id_projet=$id_projet where id=$id_tag");
		updateInfo();
	}
	elseif(isset($_GET['delete_tag']))
	{
		$id_tag=chaineMysql($_POST['id_tag']);
		
		requeteSql("update etape set id_tag=0 where id_tag=$id_tag");
		requeteSql("delete from tag where id=$id_tag");
		updateInfo();
	}
	elseif(isset($_GET['apply_realtime_tag']))
	{
		$id_tag=chaineMysql($_POST['id_tag']);
		
		$etapes=requeteSql("select * from etape where id_tag=$id_tag");
		
		$temps_reel=array();
		$etapes_finies=0;
		
		while($etape = fetchRequest($etapes['result']))
		{
			$statut=$etape['statut'];
			if($statut==STAGE_DONE)
			{
				$etapes_finies++;
				$temps_reel[]=$etape['duree'];
			}
		}
		
		if($etapes_finies>0)
		{
			$moyenne_temps_reel=round(array_sum($temps_reel)/$etapes_finies,1);
			requeteSql("update etape set estimation_duree=$moyenne_temps_reel where id_tag=$id_tag and statut<>".STAGE_DONE);
		}
		updateInfo();
	}
	elseif(isset($_GET['add_budget']))
	{
		$cout=chaineMysql($_POST['cout']);
		$date_start=dateMysql($_POST['date_start']);
		requeteSql("insert into mois_homme (date_start,cout) values ($date_start,$cout)");
		updateInfo();
	}
	elseif(isset($_GET['edit_budget']))
	{
		$id_mois_homme=chaineMysql($_POST['id_mois_homme']);
		$cout=chaineMysql($_POST['cout']);
		$date_start=dateMysql($_POST['date_start']);
		
		requeteSql("update mois_homme set cout=$cout,date_start=$date_start where id=$id_mois_homme");
		updateInfo();
	}
	elseif(isset($_GET['delete_budget']))
	{
		$id_mois_homme=chaineMysql($_POST['id_mois_homme']);
		
		requeteSql("delete from mois_homme where id=$id_mois_homme");
		updateInfo();
	}
	elseif(isset($_GET['add_task_comment']))
	{
		$id_tache=chaineMysql($_POST['id_tache']);
		$commentaire_texte_afx=nl2br($_POST['commentaire_texte']);
		$commentaire_texte=chaineMysql(nl2br($_POST['commentaire_texte']));
		$id_etape=chaineMysql($_POST['id_etape']);
		$id_writer=$_SESSION['id_worker'];
		$requete=requeteSql("insert into commentaire (id_etape,id_writer,commentaire_texte,commentaire_date) values ($id_etape,$id_writer,$commentaire_texte,NOW())");
		$id_comment=$requete['id_created'];
		$requete=requeteSql("select nom_tache,objectif from etape e,tache t where t.id=e.id_tache and e.id=$id_etape");
		$ligne=$requete['first_line'];
		$nom_tache=$ligne['nom_tache'];
		$objectif=$ligne['objectif'];
		if(isset($_POST['destinataires']))
		{
			foreach($_POST['destinataires'] as $key=>$id_destinataire)
			{
				addNotification($id_destinataire,NOTIF_ADD_COMMENT,$id_writer,$id_tache,$id_etape,$id_comment);
			}
		}

		updateInfo();
	}
	elseif(isset($_GET['edit_task_comment']))
	{
		$id_comment=chaineMysql($_POST['id_comment']);
		$commentaire_texte=chaineMysql(nl2br($_POST['commentaire_texte']));
		$id_etape=chaineMysql($_POST['id_etape']);
		$id_writer=$_SESSION['id_worker'];
		requeteSql("update commentaire set id_etape=$id_etape,commentaire_texte=$commentaire_texte,id_writer=$id_writer where id=$id_comment");
		updateInfo();
	}
	elseif(isset($_GET['delete_task_comment']))
	{
		$id_comment=chaineMysql($_POST['id_comment']);
		requeteSql("delete from commentaire where id=$id_comment");
		updateInfo();
	}
	elseif(isset($_GET['edit_task_flow']))
	{
		if(ENGINE_V2)
		{
			$positions=array();
			$etapes=array();
			$id_tache=$_GET['edit_task_flow'];
			foreach($_POST as $key=>$val)
			{
				if(strpos($key,'stage_ref_flow_')===0)
				{
					$id_flow=str_replace('stage_ref_flow_','',$key);
					$id_etape=$val;
					$is_blocking=$_POST['is_blocking_flow_'.$id_flow];
					$sovereign=$_POST['sovereign_flow_'.$id_flow];
					$position=$_POST['priority_flow_'.$id_flow];
					if(!in_array($position,$positions))
						$positions[]=$position;
					$etapes[$id_etape]['position']=$position;
					$etapes[$id_etape]['is_blocking']=$is_blocking;
					$etapes[$id_etape]['sovereign']=$sovereign;
					//echo "etape $id_etape : position $position is_blocking $is_blocking sovereign $sovereign\n";
				}
			}
			
			sort($positions);
			foreach($etapes as $id_etape=>$val)
			{
				$old_position=$etapes[$id_etape]['position'];
				$new_position=array_search($val['position'], $positions)+1;
				if($old_position!=$new_position)
				{
					//echo "etape $id_etape : old_position $old_position new_position $new_position\n";
					$etapes[$id_etape]['position']=$new_position;//fix gaps (empty steps)
					foreach($etapes as $k=>$v)
					{
						if($etapes[$k]['sovereign']==$old_position)
						{
							//echo "fixing soverign for $k : old sovereign $old_position new $new_position\n";
							if($etapes[$k]['position']+1==$new_position)//it was supposed to be sovereign but after gap fixing, it is just blocking
							{
								$etapes[$k]['sovereign']=0;
								$etapes[$k]['is_blocking']=1;
							}
							else
								$etapes[$k]['sovereign']=$new_position;
						}
					}
				}
			}
			foreach($etapes as $id_etape=>$val)
			{
				if($etapes[$id_etape]['sovereign']>0)
				{
					foreach($etapes as $k=>$v)
					{
						if($etapes[$k]['position']==$etapes[$id_etape]['sovereign'])
						{
							//echo "etape $k : internal_dependances $id_etape\n";
							$etapes[$k]['internal_dependances'][]=$id_etape;
						}
					}
				}
			}
			
			foreach($etapes as $id_etape=>$etape)
			{
				$position=chaineMysql($etape['position']);
				$is_blocking=chaineMysql($etape['is_blocking']);
				//echo "updating $id_etape\n";
				requeteSql("update etape set position=$position,is_blocking=$is_blocking where id=$id_etape");
			}
			
			$erreur_dependance='';
			$requete=requeteSql("select d.id as id_dependance,id_etape_fille from depend_de d,etape e where e.id_tache=$id_tache and d.id_etape_mere=e.id");
			while($ligne = fetchRequest($requete['result']))
			{
				$id_etape_fille=$ligne['id_etape_fille'];
				$id_dependance=$ligne['id_dependance'];
				$etape_fille=requeteSql("select * from etape where id=$id_etape_fille");;
				$ligne_etape_fille=$etape_fille['first_line'];
				$id_tache_fille=$ligne_etape_fille['id_tache'];
				if($id_tache_fille==$id_tache)
				{
					requeteSql("delete from depend_de where id=$id_dependance");
				}
			}
			
			
			foreach($etapes as $id_etape=>$etape)
			{
				if(isset($etape['internal_dependances']))
				{
					foreach($etape['internal_dependances'] as $key=>$val)
					{
						if($val!=0)
						{
							$id_etape_created=$id_etape;
							$id_etape_sovereign=$val;
							$requete=requeteSql("select * from depend_de where id_etape_mere=$id_etape_sovereign and id_etape_fille=$id_etape_created");
							if(noLegacyLoop($id_etape_created,$id_etape_sovereign))
							{
								if($requete['nb_lines']==0)//the link doesn't exit already
									requeteSql("insert into depend_de (id_etape_mere,id_etape_fille) values ($id_etape_sovereign,$id_etape_created)");
							}
							else
							{
								$erreur_dependance.=str_replace('[X]',$id_etape_sovereign,getLocText('ltext_dialog_dependency_error_message')).'<br>';
								if($requete['nb_lines']>0)//the link doesn't exit already
									requeteSql("delete from depend_de where id_etape_mere=$id_etape_sovereign and id_etape_fille=$id_etape_created");
							}
							
						}
					}
				}
			}
			
			updateStageTask($id_tache);
			updateInfo();
			echo 'updateStageCounts();';
			if($erreur_dependance!='')
				echo 'showDialog("'.getLocText('ltext_dialog_dependency_error_title').'","'.$erreur_dependance.'",false);';
		}
	}
	elseif(isset($_GET['go_todo_task_stage']))
	{
		if(ENGINE_V2)
		{
			$id_etape_ref=chaineMysql($_POST['id_etape']);
			$position=chaineMysql($_POST['position']);
			$id_tache=chaineMysql($_POST['id_tache']);
			$requete=requeteSql("select * from etape where id_tache=$id_tache");
			while($ligne = fetchRequest($requete['result']))
			{
				$id_etape=$ligne['id'];
				$position_etape=$ligne['position'];
				$sleeping=$ligne['sleeping'];
				$is_blocking=$ligne['is_blocking'];
				$current_status=$ligne['statut'];
				if($sleeping==0)
				{
					if($position_etape<$position)
						updateStageStatut($id_etape,STAGE_DONE);
					if($id_etape==$id_etape_ref)
						updateStageStatut($id_etape,STAGE_TODO);
					/*elseif($position_etape==$position)
					{
						if($current_status!=STAGE_WIP)//case of non blocking stages
							updateStageStatut($id_etape,STAGE_TODO);
					}*/
				}
			}
			updateStageTask($id_tache);
			updateInfo();
			echo 'updateStageCounts();';
		}
		else
		{
			$id_etape=chaineMysql($_POST['id_etape']);
			$position=chaineMysql($_POST['position']);
			$id_tache=chaineMysql($_POST['id_tache']);
			$requete=requeteSql("select * from etape where id_tache=$id_tache");
			while($ligne = fetchRequest($requete['result']))
			{
				$id_etape=$ligne['id'];
				$position_etape=$ligne['position'];
				$sleeping=$ligne['sleeping'];
				if($sleeping==0)
				{
					if($position_etape<$position)
						updateStageStatut($id_etape,STAGE_DONE);
					elseif($position_etape==$position)
						updateStageStatut($id_etape,STAGE_TODO);
					else
						updateStageStatut($id_etape,STAGE_STANDBY);
				}
			}
			updateStageTask($id_tache);
			updateInfo();
		}
	}
	elseif(isset($_GET['get_project_planning']))
	{
		$without_workers=array();
		if(isset($_GET['without_workers']))
			$without_workers=explode('-',$_GET['without_workers']);
		$options=array('without_workers'=>$without_workers);
		$datas=getProjectPlanningDatas($options);
		$datas['planning_from'] = mktime(0, 0, 0, date("m")-1, date("d"),   date("Y"));
		$datas['planning_to'] = mktime(0, 0, 0, date("m")+1, date("d"),   date("Y"));
		if(isset($_GET['planning_from']))
			$datas['planning_from']=getTimestamp($_GET['planning_from']);
		if(isset($_GET['planning_to']))
			$datas['planning_to']=getTimestamp($_GET['planning_to']);
		$datas['page']='get_project_planning';
		$planning=getGanttPlanning($datas);
		updatePage($planning['html'],$planning['js']);		
	}
	elseif(isset($_GET['get_team_planning']))
	{
		$without_workers=array();
		if(isset($_GET['without_workers']))
			$without_workers=explode('-',$_GET['without_workers']);
		$options=array('without_workers'=>$without_workers);
		$datas=getTeamPlanningDatas($options);
		$datas['planning_from'] = mktime(0, 0, 0, date("m")-1, date("d"),   date("Y"));
		$datas['planning_to'] = mktime(0, 0, 0, date("m")+1, date("d"),   date("Y"));
		if(isset($_GET['planning_from']))
			$datas['planning_from']=getTimestamp($_GET['planning_from']);
		if(isset($_GET['planning_to']))
			$datas['planning_to']=getTimestamp($_GET['planning_to']);
		$datas['page']='get_team_planning';
		$planning=getGanttPlanning($datas);
		updatePage($planning['html'],$planning['js']);		
	}
	elseif(isset($_GET['get_notifications']))
	{
		$notifications=getNotifications();
		echo $notifications;
		echo 'check_notification=0;';
		setPresence($_SESSION['id_worker'],'site');		
	}
	elseif(isset($_GET['remove_notification']))
	{
		$id_notification=$_GET['remove_notification'];
		requeteSql("update notification set checked_notif=1 where id=$id_notification");
	}
	elseif(isset($_GET['attrib_projects']))
	{	
		$fields=array();
		$worker_jour=explode('_',$_POST['ids_travaille']);
		$workers=array();
		
		foreach($worker_jour as $key=>$val)
		{
			$parts=explode('d',$val);
			$id_worker=$parts[0];
			$jour=$parts[1];
			$requete=requeteSql("delete from travaille where id_worker=$id_worker and jour='$jour'");
			$workers[$id_worker][]=$jour;
		}
		foreach($_POST as $key=>$val)
		{
			if(strpos($key,'id_projet')===0 && $val!=0)
			{
				$id_projet=$val;
				foreach($workers as $id_worker=>$days)
				{
					foreach($days as $jour)
						updateProjectWorker($id_projet,$id_worker,$jour,$jour);
				}
			}
		}
		
		$options=array();
		$datas=getTeamPlanningDatas($options);
		$datas['planning_from'] = mktime(0, 0, 0, date("m")-1, date("d"),   date("Y"));
		$datas['planning_to'] = mktime(0, 0, 0, date("m")+1, date("d"),   date("Y"));
		if(isset($_GET['planning_from']))
			$datas['planning_from']=getTimestamp($_GET['planning_from']);
		if(isset($_GET['planning_to']))
			$datas['planning_to']=getTimestamp($_GET['planning_to']);
		$datas['page']='get_team_planning';
		$planning=getGanttPlanning($datas);
		updatePage($planning['html'],$planning['js'].'$( "#dialog-message").dialog( "close" );');	
	}
	elseif(isset($_GET['send_to_sleep_stage']))
	{
		$id_etape=$_POST['id_etape'];
		echo 'try{$( "#dialog-message").dialog( "close" );}catch(e){}setStageSleeping('.$id_etape.',1);';
	}
	elseif(isset($_GET['wake_up_stage']))
	{
		$id_etape=$_POST['id_etape'];
		echo 'try{$( "#dialog-message").dialog( "close" );}catch(e){}setStageSleeping('.$id_etape.',0);';
	}
	elseif(isset($_GET['get_delay']))
	{
		$workers=requeteSql("select * from worker where (statut_worker=".SALARIE." or statut_worker=".FREELANCE.")and actif=".WORKER_ACTIF);
		
		$last_week_time=time()-7*24*60*60;
		$cur_week=date('y-W');
		$last_week=date('y-W',$last_week_time);
		$last_last_week=date('y-W',$last_week_time-7*24*60*60);
		echo '<html><head><meta charset="utf-8"></head><body>';
		while($ligne = fetchRequest($workers['result']))
		{
			$id_worker=$ligne['id'];
			$nom_worker=$ligne['nom_worker'];
			echo "<br><br>-------------<br>$nom_worker<br><br>";
			$stats=getWorkerStats($id_worker);
			$weekly_delay=$stats['weekly_delay'];
			$weekly_advance=$stats['weekly_advance'];
			$weekly_delay_stages=$stats['weekly_delay_stages'];
			$weekly_advance_stages=$stats['weekly_advance_stages'];
		
			$cur_delay=@$weekly_delay[$cur_week];
			$cur_advance=@$weekly_advance[$cur_week];
			$cur_stages=@getDelayExplanations($weekly_delay_stages[$cur_week]);
			$cur_stages_advance=@getAdvanceExplanations($weekly_advance_stages[$cur_week]);
			
			$last_week_delay=@$weekly_delay[$last_week];
			$last_week_advance=@$weekly_advance[$last_week];
			$last_week_stages=@getDelayExplanations($weekly_delay_stages[$last_week]);
			$last_week_stages_advance=@getAdvanceExplanations($weekly_advance_stages[$last_week]);
			
			$last_last_week_delay=@$weekly_delay[$last_last_week];
			$last_last_week_advance=@$weekly_advance[$last_last_week];
			$last_last_week_stages=@getDelayExplanations($weekly_delay_stages[$last_last_week]);
			$last_last_week_stages_advance=@getAdvanceExplanations($weekly_advance_stages[$last_last_week]);
			echo '<table border="1">
				<tr><td>Semaine</td><td>Total</td><td>Retard</td><td>Etapes et commentaires</td><td>Avance</td><td>Etapes</td></tr>
				<tr><td>'.$cur_week.'</td><td>'.formatWorkDuration($cur_advance-$cur_delay).'</td><td>'.formatWorkDuration($cur_delay).'</td><td>'.$cur_stages.'</td><td>'.formatWorkDuration($cur_advance).'</td><td>'.$cur_stages_advance.'</td></tr>
				<tr><td>'.$last_week.'</td><td>'.formatWorkDuration($last_week_advance-$last_week_delay).'</td><td>'.formatWorkDuration($last_week_delay).'</td><td>'.$last_week_stages.'</td><td>'.formatWorkDuration($last_week_advance).'</td><td>'.$last_week_stages_advance.'</td></tr>
				<tr><td>'.$last_last_week.'</td><td>'.formatWorkDuration($last_last_week_advance-$last_last_week_delay).'</td><td>'.formatWorkDuration($last_last_week_delay).'</td><td>'.$last_last_week_stages.'</td><td>'.formatWorkDuration($last_last_week_advance).'</td><td>'.$last_last_week_stages_advance.'</td></tr>
				';
				
			echo '</table>';
		}
		
		$requete=requeteSql("select *,e.id as id_etape from tache t,etape e where t.id=e.id_tache and e.id_worker=7 and estimation_duree>0 and duree>estimation_duree+1 order by id_etape desc limit 100");
		$min_date='';
		$max_date='';
		$total_retard=0;
		$start_date=getTimeStamp('2014-06-23');
		while($ligne = fetchRequest($requete['result']))
		{
			$objectif=$ligne['objectif'];
			$id_tache=$ligne['id_tache'];
			$id_etape=$ligne['id_etape'];
			$nom_tache=$ligne['nom_tache'];
			$duree=$ligne['duree'];
			$estimation_duree=$ligne['estimation_duree'];
			$retard=$duree-$estimation_duree;
			
			$histo=requeteSql("select min(date_start) as min_date_start,max(date_end) as max_date_end from histo_etape where id_etape=$id_etape");
			$histo_ligne=$histo['first_line'];
			$min_date_start=getTimeStamp($histo_ligne['min_date_start']);
			$max_date_end=getTimeStamp($histo_ligne['max_date_end']);
			if($min_date_start>$start_date)
			{
				$total_retard+=$retard;
				$ratio_retard=number_format(($retard/$estimation_duree)*100,0);
				if($min_date=='')
				{
					$min_date=$min_date_start;
					$max_date=$max_date_end;
				}
				else
				{
					if($min_date_start<$min_date)
						$min_date=$min_date_start;
					if($max_date_end>$max_date)
						$max_date=$max_date_end;
				}
				echo 'Retard de '.$retard.' heures (+'.$ratio_retard.'%) sur la tâche <a href='.WEBSITE_ADDRESS.'#taches/display/tache'.$id_tache.'>'.$nom_tache.'</a> (objectif : '.$objectif.')<br>';
			}
		}
		echo '<br><br>Total retard = '.$total_retard;
		$min_date=date('d-m-Y',$min_date);
		$max_date=date('d-m-Y',$max_date);
		echo "<br><br>Période allant du $min_date au $max_date";
	}
	elseif(isset($_GET['get_advance']))
	{
		$workers=requeteSql("select * from worker where (statut_worker=".SALARIE." or statut_worker=".FREELANCE.")and actif=".WORKER_ACTIF);
		
		$last_week_time=time()-7*24*60*60;
		$cur_week=date('y-W');
		$last_week=date('y-W',$last_week_time);
		$last_last_week=date('y-W',$last_week_time-7*24*60*60);
		echo '<html><head><meta charset="utf-8"></head><body>';
		while($ligne = fetchRequest($workers['result']))
		{
			$id_worker=$ligne['id'];
			$nom_worker=$ligne['nom_worker'];
			echo "<br><br>-------------<br>$nom_worker<br><br>";
			$stats=getWorkerStats($id_worker);
			$weekly_advance=$stats['weekly_advance'];
			$weekly_advance_stages=$stats['weekly_advance_stages'];
			$cur_advance=@$weekly_advance[$cur_week];
			$cur_stages=@getAdvanceExplanations($weekly_advance_stages[$cur_week]);
			
			$last_week_advance=@$weekly_advance[$last_week];
			$last_week_stages=@getAdvanceExplanations($weekly_advance_stages[$last_week]);
			
			$last_last_week_advance=@$weekly_advance[$last_last_week];
			$last_last_week_stages=@getAdvanceExplanations($weekly_advance_stages[$last_last_week]);
			echo '<table border="1">
				<tr><td>Semaine</td><td>Avance</td><td>Etapes</td></tr>
				<tr><td>'.$cur_week.'</td><td>'.formatWorkDuration($cur_advance).'</td><td>'.$cur_stages.'</td></tr>
				<tr><td>'.$last_week.'</td><td>'.formatWorkDuration($last_week_advance).'</td><td>'.$last_week_stages.'</td></tr>
				<tr><td>'.$last_last_week.'</td><td>'.formatWorkDuration($last_last_week_advance).'</td><td>'.$last_last_week_stages.'</td></tr>
				';
				
			echo '</table>';
		}
	}
	elseif(isset($_GET['test_curl']))
	{
		$data = new Spreadsheet_Excel_Reader('SIB_Text.xls');
		$sheet=0;
		$current_line=3;
		$txt_line=0;
		$column_id=letterToInt('A');
		$column_en=letterToInt('J');
		$column_fr=letterToInt('N');

		$process_done=false;
		$empty_lines=0;
		$current_cutscene='';
		$cutscenes=array();
		$res='';
		
		$xml = new ExcelWriterXML;
		$xml->docAuthor('Xavier Marot');
		
		$xml->overwriteFile();
		$xml->showErrorSheet(false);

		$format = $xml->addStyle('MP_Project');
		//$format->fontBold();
		//$format->alignWraptext();
		//$format->fontSize(18);
		$format->bgColor('orange');
		
		$format = $xml->addStyle('MP_Header');
		$format->fontBold();
		$sheet = $xml->addSheet('Jours');
		$sheet->columnWidth( 1,200);
		//$xml->sendHeaders();
		
		set_time_limit(0);
		$tmp_folder='tmp/'.getWorkerName($_SESSION['id_worker']);
		if(!(is_dir("$tmp_folder/")))
			mkdir("$tmp_folder/");
		
		
		
		while(!$process_done)
		{
			$text_id=$data->value($current_line,$column_id,0);
			$text_en=$data->value($current_line,$column_en,0);
			$text_fr=$data->value($current_line,$column_fr,0);
			$text_en=str_replace("\n",'',$text_en);
			$text_en=str_replace("\r",'',$text_en);
			$text_fr=str_replace("\r",'',$text_fr);
			$text_fr=str_replace("\r",'',$text_fr);
			
			//if($current_line>500)
				//$process_done=true;
			if($text_en=='')
			{
				$empty_lines++;
				if($empty_lines>10)
					$process_done=true;
			}
			else
			{
				$sheet->writeString($current_line,1,$text_id);
				$sheet->writeString($current_line,2,$text_en);
				if($text_en==$text_fr && strlen($text_en)>15 && strlen($text_en)<300)
				{
					$str_en=urlencode($text_en);

					do
					{
						$url_ok=true;
						$res=@curl_get('http://translate.reference.com/translate?query='.$str_en.'&src=en&dst=fr');
						if($res===false || $res=='' || strpos($res,'Internal Server Error')===0)
						{
							$url_ok=false;
							sleep(1);
						}
						
					}while(!$url_ok);
					$pos_start=strpos($res,'<div id="trans" class="tap_mt">');
					$pos_end=strpos($res,'</div>',$pos_start+1);
					$res=substr($res,$pos_start,$pos_end-$pos_start);
					$res=str_replace("\n",'',$res);
					$res=str_replace("\r",'',$res);
					$str_fr=utf8_decode(strip_tags($res));
					$sheet->writeString($current_line,3,$str_fr,'MP_Project');
				}
				else
				{
					$str_fr=$text_fr;
					$sheet->writeString($current_line,3,$str_fr,'MP_Header');
				}
			}
			echo "$text_id - $text_en - $str_fr<br>";
			//$text3=mb_convert_encoding($data->value($current_line,$column_text3,$sheet), "UTF-8", mb_detect_encoding($data->value($current_line,$column_text3,$sheet), "UTF-8, ISO-8859-1, ISO-8859-15", true));
		
			
			$current_line++;
		}	
		
		$full_path=utf8_encode($tmp_folder."/Text_translated.xml");
		$xml->writeData($full_path);
		
		
		
	}
	elseif(isset($_GET['set_stage_job']))
	{
		$requete=requeteSql("select e.id as id_etape,w.id_metier as worker_metier from etape e,worker w where e.id_worker=w.id and e.id_metier=0");
		$nb_etape_affected=0;
		$start=time();
		$tot_etapes=$requete['nb_lines'];
		while($ligne = fetchRequest($requete['result']))
		{
			$id_etape=$ligne['id_etape'];
			$worker_metier=$ligne['worker_metier'];
			requeteSql("update etape set id_metier=$worker_metier where id=$id_etape");
			$nb_etape_affected++;
			if(time()-$start>20)
				break;
		}
		//echo "$nb_etape_affected etapes modifiees !<br>$tot_etapes etapes restantes.<script language='javascript'>document.location.href='executor.php?set_stage_job';</script>";
	}
	elseif(isset($_GET['test_xav']))
	{
		//requeteSql("update log l,tache t set l.id_projet=t.id_projet where l.id_tache=t.id");
		$sound_files=array();
		$tuto_cutscenes=array();
		//$tuto_cutscenes=array(1900,1901,1902,1903,1904,1905,1906,1907,1908,1909,1910,1911,1913,1484,1485,1202,1486,1487,1488,1299,1296,1503,1914,1915,1916,1495,1496,1497,1498,1499,1500,1501,1502,1917,1918,1919,1920,1504,1505,1506,1507,1508,1509,1510,1511,1512,1513,1514,1515,1921,1922,1923,1924,1925,1516,1931,1932,1933);
		$folder='tmp/xmarot/wav/';
		$nb_sounds=0;
		if (is_dir($folder)) 
		{
			if ($dh = opendir($folder)) 
			{
				while (($file = readdir($dh)) !== false) 
				{
					if($file!="." && $file!=".." && !is_dir($folder.$file))
					{
						$file=strtolower($file);
						$filename=str_replace('_uk.wav','',$file);
						
						echo "added:$filename<br>";
						$sound_files[]=$filename;	
						$nb_sounds++;					
					}
				}
				closedir($dh);
			}
		}
		$nb_sounds=sizeof($sound_files);
		$nb_sounds_added=0;
		$sounds_added=array();
		echo "$nb_sounds<br>";
		$folder='tmp/xmarot/cs/';
		if (is_dir($folder)) 
		{
			if ($dh = opendir($folder)) 
			{
				while (($file = readdir($dh)) !== false) 
				{
					if($file!="." && $file!=".." && !is_dir($folder.$file))
					{
						echo "$file<br>";
						$full_content=file_get_contents($folder.$file);
						$add_omega_music=false;
						$omega_music_added=false;
						if(strpos($full_content,'CHANGEMUSIC')===false && strpos($full_content,',32000')!==false)
						{
							$add_omega_music=true;
						}
						$cutscene_id=str_replace('cs_','',$file);
						$cutscene_id=str_replace('.txt','',$cutscene_id);
						$file_content='';
						$file_modified=false;
						$world_found=false;
						$allow_skip_found=false;
						$f=fopen($folder.$file,'r');
						while($line=fgets($f))
						{
							echo "$line<br>";
							if(strpos($line,'WORLD')===0)
							{
								$world_found=true;
								echo "world found<br>";
							}
							elseif(strpos($line,'ALLOWSKIP')===0)
							{
								$allow_skip_found=true;
								echo "allowskip found<br>";
							}
							elseif(strpos($line,'SHOWBUBBLE')===0)
							{
								if($world_found && $add_omega_music && !$omega_music_added)
								{
									echo "add_omega_music with $cutscene_id<br>";
									$file_modified=true;
									$omega_music_added=true;
									$file_content.='CHANGEMUSIC,13,1'.chr(13).chr(10);
								}
								if($world_found && !$allow_skip_found)
								{
									echo "check add allow with $cutscene_id<br>";
									$allow_skip_found=true;
									if(in_array($cutscene_id,$tuto_cutscenes))
									{
										echo "add allow with $cutscene_id<br>";
										$file_modified=true;
										$file_content.='ALLOWSKIP,0'.chr(13).chr(10);
									}
								}	
								$line_parts=explode(',',$line);
								if(sizeof($line_parts)==4)
								{
									$txt=strtolower($line_parts[1]);
									echo "check vo_$txt<br>";
									if(in_array("vo_$txt",$sound_files))
									{
										echo "vo found!!!<br>";
										$line_parts[]="vo_$txt";
										$nb_sounds_added++;
										$sounds_added[]="vo_$txt";
										$file_modified=true;
									}
								}
								$line=implode(',',$line_parts);
								$line=str_replace(chr(13),'',$line);
								$line=str_replace(chr(10),'',$line);
								$line=$line.chr(13).chr(10);
								//for($i=0;$i<strlen($line);$i++)
									//echo "$i:".$line[$i].":".ord($line[$i]).'<br>';
								echo "NEWLINE: $line<br>";
								
							}
							elseif(strpos($line,'ADDBUBBLETEXTS')!==false)
							{
								$line_parts=explode(',',$line);
								if(sizeof($line_parts)==2)
								{
									$txt=strtolower($line_parts[1]);
									$txt=str_replace(chr(13),'',$txt);
									$txt=str_replace(chr(10),'',$txt);
									echo "check vo_$txt<br>";
									if(in_array("vo_$txt",$sound_files))
									{
										echo "vo found!!!<br>";
										$line_parts[]="vo_$txt";
										$nb_sounds_added++;
										$sounds_added[]="vo_$txt";
										$file_modified=true;
									}
								}
								
								$line=implode(',',$line_parts);
								$line=str_replace(chr(13),'',$line);
								$line=str_replace(chr(10),'',$line);
								$line=$line.chr(13).chr(10);
								//for($i=0;$i<strlen($line);$i++)
									//echo "$i:".$line[$i].":".ord($line[$i]).'<br>';
								echo "NEWLINE: $line<br>";
								
							}
							$file_content.=$line;
						}
						fclose($f);
						if($file_modified)
						{
							$f=fopen($folder.$file,'w');
							fwrite($f,$file_content);
							fclose($f);
						}
					}
				}
				closedir($dh);
			}
		}
		echo "$nb_sounds_added sounds added!<br>";
		foreach($sound_files as $key=>$sound)
		{
			if(!in_array($sound,$sounds_added))
				echo "$sound not added<br>";
		}
		
		/*$data = new Spreadsheet_Excel_Reader('SIB_Worlds.xls');
		$import_complete=false;
		$current_sheet=0;
		$current_line=0;
		$current_column=0;
		$dbs=array();
		while(!$import_complete)
		{
			$nb_lines=@$data->rowcount($current_sheet);
			$nb_columns=@$data->colcount($current_sheet);
			if($nb_lines) //sheet exists
			{
				$nb_lines+=10;
				$nb_columns+=10;
				$db_found=false;
				$db_start_line=0;
				$db_start_column=0;
				$db_end_column=0;
				for($current_line=0;$current_line<$nb_lines;$current_line++) 
				{
					for($current_column=0;$current_column<$nb_columns;$current_column++)
					{
						$current_cell=$data->value($current_line,$current_column,$current_sheet);
						echo "$current_line - $current_column : $current_cell (db found?$db_found)<bR>";
					
						if(strpos($current_cell,'.db')!==false)
						{
							$db_found=true;
							$db_name=$current_cell;
							$db_start_line=$current_line;
							$db_start_column=$current_column;
						}
						if($db_found)
						{
							//echo "$current_line==$db_start_line && $current_cell=='' && $db_end_column==0";
							if($current_line==$db_start_line && $current_cell==='' && $db_end_column==0)//end of db definition reached
							{
								echo "end db column found!<bR>";
								$db_end_column=$current_column;
							}
							if($current_column==$db_start_column && $current_cell=='')//end of db lines
							{
								$db_end_line=$current_column;
								$db_found=false;
								$db_start_line=0;
								$db_start_column=0;
								$db_end_column=0;
							}
							//echo "$current_line>$db_start_line && $current_column<$db_end_column && $current_column>$db_start_column<br>";
							if($current_line>$db_start_line && $current_column<$db_end_column && $current_column>$db_start_column)
							{
								//echo "insert into array";
								$dbs[$db_name][$current_line-$db_start_line-1][$current_column-$db_start_column-1]=$current_cell;
							}
						}
					}
				}
			}
			else
			{
				$import_complete=true;
			}
			$current_sheet++;
		}
		
		foreach($dbs as $db=>$lines)
		{
			echo "DB $db<br>";
			echo "nb lines=".sizeof($lines).'<br>';
			echo "nb column=".sizeof($lines[0]).'<br>';
			foreach($lines as $line=>$columns)
			{
				echo "ligne $line<br>";
				foreach($columns as $column=>$value)
				{
					echo "colonne $column=>$value<br>";
				}
			}
		}
		print_r($dbs);*/
		
		/*$xml = new ExcelWriterXML;
		$xml->docAuthor('Robert F Greer');
		
		$xml->overwriteFile();
		$xml->showErrorSheet(false);

		$format = $xml->addStyle('StyleHeader');
		$format->fontBold();
		$format->alignRotate(45);
		$sheet = $xml->addSheet('My Sheet');

		$sheet->writeString(1,1,'Header','StyleHeader');
		$sheet->writeString(2,1,'Ttoto','StyleHeader');

		//$xml->sendHeaders();
		$xml->writeData("test.xml");
		exit(0);
		$requete=requeteSql("select MIN(jour) as min_jour, MAX(jour) as max_jour from travaille");
		$ligne=$requete['first_line'];
		$min_jour=getTimeStamp($ligne['min_jour']);
		$max_jour=getTimeStamp($ligne['max_jour'])+24*60*60;
		$un_jour=24*60*60;
		$timestamp_equiv=array();
		$tmp_folder='tmp/'.getWorkerName($_SESSION['id_worker']);
		@unlink($tmp_folder."/travaille.txt");
		$file_text=fopen($tmp_folder."/travaille.txt",'a');
		
		$date_line='';
		for($i=$min_jour;$i<$max_jour;$i+=$un_jour)
		{
			$timestamp_equiv[$i]=date("Y-m-d",$i);
			$date_line.=$timestamp_equiv[$i]."\t";
		}
		$requete=requeteSql("select * from travaille t,worker w,projet p where w.id=t.id_worker and t.id_projet=p.id order by nom_worker");
		$travaille=array();
		
		while($ligne = fetchRequest($requete['result']))
		{
			$nom_projet=$ligne['nom_projet'];
			$nom_worker=$ligne['nom_worker'];
			$jour=$ligne['jour'];
			
			$part=number_format(1/$ligne['part'],2);
			$travaille[$nom_projet][$nom_worker][$jour]=$part;
		}
		foreach($travaille as $nom_projet=>$detail_projet)
		{
			fwrite($file_text,"\r\n$nom_projet\r\n");
			fwrite($file_text,"Membre\t$date_line");
			
			fwrite($file_text,"\r\n\r\n");
			foreach($detail_projet as $nom_worker=>$detail_travaille)
			{
				fwrite($file_text,"$nom_worker\t");
				for($i=$min_jour;$i<$max_jour;$i+=$un_jour)
				{
					$jour=$timestamp_equiv[$i];
					$part=0;
					if(isset($travaille[$nom_projet][$nom_worker][$jour]))
					{
						$part=$travaille[$nom_projet][$nom_worker][$jour];
					}
					fwrite($file_text,"$part\t");
				}
				fwrite($file_text,"\r\n");
			}
		}
		fclose($file_text);
		//$params=array('to'=>array('xmarot@magicpockets.com'),'subject'=>'Test magic projects','message'=>'Test magic projects');
		//sendMail($params);*/
		/*$m = new MongoClient();
		$db = $m->testjohn;
		$collection = $db->bob;
		$document = array( "title" => "Calvin and Hobbes", "author" => "Bill Watterson" );
		//$collection->insert($document);
		$collection->findAndModify(array("title" => "Calvin and Hobbes"),array("title" => "Calvin and Hobbes 2"));
		$cursor = $collection->find();
		foreach ($cursor as $document) {
			var_dump($document);
		}*/
		
		
		
		/*$requete=requeteSql("select id_tache, MAX(date_log) as max_date_log from log group by id_tache");
		while($ligne = fetchRequest($requete['result']))
		{
			$id_tache=$ligne['id_tache'];
			$date_derniere_modif=$ligne['max_date_log'];
			requeteSql("update tache set date_derniere_modif='$date_derniere_modif' where id=$id_tache");
		}*/
		/*$requete=requeteSql("select * from commentaire where id_writer=6");
		while($ligne = fetchRequest($requete['result']))
		{
			$commentaire=$ligne['commentaire_texte'];
			echo "$commentaire<br>";
		}*/
		//echo base64_decode('aWQ9YjY0Jm1zZz1jbw==');
		//"ecb", "cbc", "cfb", "ofb", "nofb" or "stream".
		//$coded_str=base64_decode('ZzTEu0sYGFApXQdC5gOw/rIU2Ui+PrODBx/eQRbVcXNDa+oSm3ZP4/65WbfUZC/L');
		//echo mcrypt_decrypt(MCRYPT_DES,"12345678",$coded_str,"ecb");
		/*echo mcrypt_decrypt(MCRYPT_DES,"12345678",$coded_str,"cbc");
		echo mcrypt_decrypt(MCRYPT_DES,"12345678",$coded_str,"cfb");
		echo mcrypt_decrypt(MCRYPT_DES,"12345678",$coded_str,"ofb");
		echo mcrypt_decrypt(MCRYPT_DES,"12345678",$coded_str,"nofb");
		echo mcrypt_decrypt(MCRYPT_DES,"12345678",$coded_str,"ncfb");
		echo mcrypt_decrypt(MCRYPT_DES,"12345678",$coded_str,"ctr");*/
		
	}
	else
	{
	
		//addNotification(2,NOTIF_DELAY,2,3277,11595,10);
		/*set_time_limit(0);
		$monfichier=fopen('events.csv','r');
	
		while( !feof( $monfichier ) )
		{
			$ligne=fgets( $monfichier );
			$ligne=explode(',',$ligne);
			$ligne=implode('<br>',$ligne);
			//if(strpos($ligne,'date.timezone')===false)
				echo "$ligne<bR>";
			break;
		}*/
		/*$codes=array('NJ01','NJ02','NJ03','NJ04','NJ05','BP06','SP01','SP02','SP03','SP04','SP05','BP02','CY01','CY02','CY03','CY04','CY05','MR01','MR02','MR03','MR04','MR05','PS03','BP01','MU01','MU02','MU03','MU04','MU05','PS02','BP03','SH01','SH02','SH03','SH04','SH05','PS01','HW01','HW02','HW03','HW04','HW05','RB01','RB02','RB03','RB04','RB05','SY01','SY02','SY03','SY04','SY05','FA01','FA02','FA03','FA04','FA05','SF01','SF02','SF03','SF04','SF05','FI01','FI02','FI03','FI04','FI05','DF01','DF02','DF03','AP01','AP02','SK01','SK02','SK03','SK04','SK05','OG01','OG02','OG03','OG04','OG05','BZ01','BZ02','BZ03','BZ04','BZ05','MI01','MI02','MI03','MI04','MI05');
		$first_names=array('Hiro','Johnny','Socky','Silent','Samurai','Frost','Ace','Redzone','Tiberius','Xeno','Space','Major','Smokey','Katt','Gus','SWAT','Officer','Rotten','Hank','Vlad','Harry','Stanley','Franken','Captain','Manely','Sheldon','Bam','Sharky','Dino','Testy','Bucky','Knight','Uber','Finley','Ray','Jack','Doc','MC','Punky','Tami','Dean','Glen','Protecto','Scuttle','Al','Perfectimus','Rusty','Dublo','Tricky','Covert','Sneaky ','Undercover','King','Wizzy','Sir','Lavender','Scaly','Pauly','Becky','Donnie','Sammy','Gordie','Macho','Tightpants','Sally','Breaki','Cheese','Jack','Katie','Alex','Store','Mac','Young','Rusted','Cyber','Robo','Stealth','Pyro','Sludge','Spin','Magna','Omega','DJ','Elite','Bluezone','Twilight','TBD','Commander','Banana','Scuba','Haz','TBD');
		$last_names=array('Thunderbutt','Sweeps','Rockfoot','Shadow','Swordmaster','Ninja','Orbit','Ranger','Warpspeed','Mite','Stalker','Blazer','Burns','Burglar','Groucho','Cop','Kuffowitz','Walker','Hacksaw','Von Vein','Fangface','Screamer','Studz','Blockbeard','Chesthair','Davinci','Boozler','Chumbucket','Biter','Monkey','Blastoff','Rat','Woman','Fishsticker','Lightbeam','Wisecracker','Devio','Mogul','Crewster','Miami','Idol','Gothly','Servo','Bot','Beeback','Supreme','Nuggets','Sven','Tasha','Cobra','Steve','Barber','Barfer','Beardall','Axalot','Deathskirt','Scorcher','Pigskin','Backhand','Dribbles','Strikeout','Goonsky','Mike','Trooper','Smackdown','Smashian','Grater','Justice','Kantmiss','Awesome','Genius','Intosh','Deevy','Stumbler','Chief','Kuff','Shade','Techie','Hammer','Doctor','Minion','Blaster','Chill','Scourge','Battler','Assassin','TBD','Toughneck','Boomer','Spi','Matt','TBD');
		foreach($first_names as $key=>$first)
		{
			foreach($last_names as $k=>$name)
			{
				if($k!=$key)
					echo $codes[$key]."--".$codes[$k]."--"."$first $name<br>";
			}
		}*/
		/*echo translateNotification(MODE_NOTIF_SIMPLE,NOTIF_NEW_TASK,1,2,5,4).'<br>';
		echo translateNotification(MODE_NOTIF_COMPLEX,NOTIF_NEW_TASK,1,2,5,4).'<br>';
		echo translateNotification(MODE_NOTIF_SIMPLE,NOTIF_TASK_CREATED,1,2,5,4).'<br>';
		echo translateNotification(MODE_NOTIF_COMPLEX,NOTIF_TASK_CREATED,1,2,5,4).'<br>';
		echo translateNotification(MODE_NOTIF_SIMPLE,NOTIF_TASK_PAUSED,1,2,5,4).'<br>';
		echo translateNotification(MODE_NOTIF_COMPLEX,NOTIF_TASK_PAUSED,1,2,5,4).'<br>';
		echo translateNotification(MODE_NOTIF_SIMPLE,NOTIF_START_WORK,1,2,5,4).'<br>';
		echo translateNotification(MODE_NOTIF_COMPLEX,NOTIF_START_WORK,1,2,5,4).'<br>';
		echo translateNotification(MODE_NOTIF_SIMPLE,NOTIF_END_WORK,1,2,5,4).'<br>';
		echo translateNotification(MODE_NOTIF_COMPLEX,NOTIF_END_WORK,1,2,5,4).'<br>';
		echo translateNotification(MODE_NOTIF_SIMPLE,NOTIF_ADD_COMMENT,1,2,5,400000).'<br>';
		echo translateNotification(MODE_NOTIF_COMPLEX,NOTIF_ADD_COMMENT,1,2,5,400000).'<br>';
		echo translateNotification(MODE_NOTIF_SIMPLE,NOTIF_ADD_DOC,1,2,5,4).'<br>';
		echo translateNotification(MODE_NOTIF_COMPLEX,NOTIF_ADD_DOC,1,2,5,4).'<br>';
		echo translateNotification(MODE_NOTIF_SIMPLE,NOTIF_RESET_TASK,1,2,5,4).'<br>';
		echo translateNotification(MODE_NOTIF_COMPLEX,NOTIF_RESET_TASK,1,2,5,4).'<br>';
		echo translateNotification(MODE_NOTIF_SIMPLE,NOTIF_DELAY,1,2,5,4).'<br>';
		echo translateNotification(MODE_NOTIF_COMPLEX,NOTIF_DELAY,1,2,5,4).'<br>';
		echo translateNotification(MODE_NOTIF_SIMPLE,NOTIF_NO_CURRENT_TASK,1,2,5,4).'<br>';
		echo translateNotification(MODE_NOTIF_COMPLEX,NOTIF_CHAT_ROOM,1,2,5,4).'<br>';*/
		//addNotification(1,NOTIF_NO_CURRENT_TASK,16,3282,11651,2);
		
		
	}
	




?>