<?php

/* Mysql database changes
25/06/2014
ALTER TABLE `worker` ADD `content_page_width` SMALLINT UNSIGNED NOT NULL DEFAULT '0',
ADD `content_page_height` SMALLINT UNSIGNED NOT NULL DEFAULT '0';


02/07/2014
CREATE TABLE IF NOT EXISTS `observe` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `id_worker` int(11) NOT NULL,
  `id_tache` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `id_worker` (`id_worker`),
  KEY `id_tache` (`id_tache`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


19/09/2014
CREATE TABLE IF NOT EXISTS `chat_message` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `id_room` tinyint(4) NOT NULL,
  `id_worker` int(11) NOT NULL,
  `message` text NOT NULL,
  `date_post` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `id_room` (`id_room`),
  KEY `date_post` (`date_post`),
  KEY `id_worker` (`id_worker`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


06/10/2014
CREATE TABLE IF NOT EXISTS `est_present` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `id_worker` int(11) NOT NULL,
  `place` varchar(32) NOT NULL,
  `since` datetime NOT NULL,
  PRIMARY KEY (`id`),
   KEY `id_worker` (`id_worker`),
   KEY `place` (`place`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


10/10/2014
ALTER TABLE `worker` ADD `chat_color` VARCHAR( 6 ) NOT NULL DEFAULT '';


14/01/2015
CREATE TABLE IF NOT EXISTS `echeance` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `id_projet` int(11) NOT NULL,
  `nom_echeance` varchar(32) NOT NULL,
  `date_echeance` date NOT NULL,
  PRIMARY KEY (`id`),
  KEY `id_projet` (`id_projet`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

ALTER TABLE `tache` ADD `id_milestone` int(11) NOT NULL DEFAULT 0;
ALTER TABLE `tache` ADD `id_echeance` int(11) NOT NULL DEFAULT 0;
ALTER TABLE `tache` ADD `id_tag` int(11) NOT NULL DEFAULT 0;
ALTER TABLE `etape` ADD `id_metier` int(11) NOT NULL DEFAULT 0;

21/04/2015

ALTER TABLE `worker` ADD `language` TINYINT NOT NULL DEFAULT '0';

20/05/2015

ALTER TABLE `etape` ADD `is_blocking` TINYINT NOT NULL DEFAULT '1';

29/07/2015

ALTER TABLE `echeance` ADD `date_debut` DATE NOT NULL DEFAULT '0000-00-00' AFTER `nom_echeance`;


26/08/2015


CREATE TABLE IF NOT EXISTS `avoir_favori` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `id_worker` int(11) NOT NULL,
  `id_tache` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `id_worker` (`id_worker`,`id_tache`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
;

*/

/** DO NOT EDIT ANYTHING BELOW **/

define("SESSION_DEAD",				1);
define("SESSION_WRONG",				2);
define("SESSION_OK",				3);
define("SESSION_TEMP",				4);

define("PROJECT_RUNNING",			0);
define("PROJECT_CLOSED",			1);
define("PROJECT_ALL",				2);

define("STAGE_STANDBY",				0);
define("STAGE_TODO",				1);
define("STAGE_WIP",					2);
define("STAGE_DONE",				3);

define("LOG_NEW_TASK",				1);
define("LOG_NEW_STAGE",				2);
define("LOG_NEW_USER",				3);
define("LOG_NEW_PROJECT",			4);
define("LOG_ADD_PROJECT_MEMBER",	5);
define("LOG_ADD_PROJECT_MILESTONE",	6);
define("LOG_ADD_STAGE",				7);
define("LOG_UPDATE_STAGE_STATUT",	8);
define("LOG_UPDATE_ESTIMATION",		9);

define("NOTIF_NEW_TASK",			1);
define("NOTIF_START_WORK",			2);
define("NOTIF_END_WORK",			3);
define("NOTIF_ADD_COMMENT",			4);
define("NOTIF_ADD_DOC",				5);
define("NOTIF_RESET_TASK",			6);
define("NOTIF_NO_CURRENT_TASK",		7);
define("NOTIF_DELAY",				8);
define("NOTIF_TASK_CREATED",		9);
define("NOTIF_TASK_PAUSED",			10);
define("NOTIF_CHAT_ROOM",			11);

define("MODE_NOTIF_SIMPLE",			1);
define("MODE_NOTIF_COMPLEX",		2);

define("VAC_CONGES",				0);
define("VAC_MALADIE",				1);
define("VAC_FORMATION",				2);

define("UNDEFINED",			0);
define("SALARIE",			1);
define("STAGIAIRE",			2);
define("OWNER",				3);
define("CHERCHEUR",			4);
define("FREELANCE",			5);

define("DROIT_STANDARD",			0);
define("DROIT_EDIT_ESTIMATION",		1);
define("DROIT_SEE_BUDGET",			2);
define("DROIT_EDIT_ALL_WORKERS",	3);
define("DROIT_RESTORE_BASE",		4);
define("DROIT_REPAIR_BASE",			5);
define("DROIT_EDIT_RIGHTS",			6);
define("DROIT_MAN_MONTH",			7);
define("DROIT_GET_HOLIDAYS",		8);
define("DROIT_EDIT_REAL_TIME",		9);

define("WORKER_INACTIF",		0);
define("WORKER_ACTIF",			1);

define("LANG_EN",				0);
define("LANG_FR",				1);

define("DATE_DMY",				0);
define("DATE_MDY",				1);

define("ENGINE_V2",				true);

define("STEP_TODO",					0);
define("STEP_DONE",					1);
define("STEP_STANDBY",				2);

define("DISPLAY_LINEAR",			0);
define("DISPLAY_GRAPH",				1);

define("SALT_CRYPT",				'zB!958t"~!');


function checkSession()//function called to identify user using his windows login/password
{
	//if($_SESSION['id_worker']==1)
		//session_unset();
	$pagestyle='ui-lightness';
	$content_page_width=0;
	$content_page_height=0;
	if(!isset($_SESSION['id_worker']) || @$_SESSION['id_worker']==0)
	{
		$requete=requeteSql("select * from worker");
		if($requete['nb_lines']==0)
		{
			$_SESSION['id_worker']=0;
			return SESSION_TEMP;
		}
	}
	if(isset($_POST['login']))
	{
		$username=chaineMysql($_POST['login']);
		$pwd=(crypt($_POST['password'],$_POST['password']));
		$user_authentified=false;
		$existing_user=false;
		$id_worker=0;
		$worker_name=$_POST['login'];
		$requete=requeteSql("select * from worker where nom_worker=$username");
		if($requete['nb_lines']==1)//username exists in our database
		{
			$existing_user=true;
			$ligne=$requete['first_line'];
			$id_worker=$ligne['id'];
			$worker_name=$ligne['nom_worker'];
			$db_pwd=$ligne['mdp'];
			$pagestyle=$ligne['pagestyle'];
			$language=$ligne['language'];
			$content_page_width=$ligne['content_page_width'];
			$content_page_height=$ligne['content_page_height'];
			if($pagestyle=='')
				$pagestyle='ui-lightness';
			if($pwd==$db_pwd)//password fits
			{
				$user_authentified=true;
				$_SESSION['id_worker']=$id_worker;
				$_SESSION['language_worker']=$language;
			}
		}
		if(!$user_authentified && USE_WINDOWS_LDAP)//username doesn't exists in our database, or his password has changed
		{
			$ds = ldap_connect(LDAP_DOMAIN); 
			$filter = "(&(ObjectClass=user)(objectCategory=person))";
			
			$r = @ldap_bind($ds,$_POST['login'].'@'.LDAP_DOMAIN,$_POST['password']);
			if($r)//identification using AD is ok
			{
				$pwd=chaineMysql($pwd);
				if($existing_user)
				{
					requeteSql("update worker set mdp=$pwd where id=$id_worker");
				}
				else
				{
					$requete=requeteSql("insert into worker (nom_worker,mdp) values ($username,$pwd)");
					$id_worker=$requete['id_created'];
					addLog(0,0,0,0,LOG_NEW_USER,$id_worker);
				}
				$_SESSION['id_worker']=$id_worker;
				$user_authentified=true;
				
			}
			else
			{
				$_SESSION['id_worker']=0;
				$login_needed=true;
			}
		}
		elseif(!$user_authentified)
		{
			$_SESSION['id_worker']=0;
			$login_needed=true;
		}
		if($user_authentified)
		{
			if(isset($_POST['remember_me']))
			{
				setcookie('login', $_POST['login'], time() + 365*24*3600, null, null, false, true); // On écrit un cookie
				setcookie('mdp',magicCrypt($_POST['password']), time() + 365*24*3600, null, null, false, true); // On écrit un autre cookie...
				setcookie('remember',"1", time() + 365*24*3600, null, null, false, true); // On écrit un autre cookie...
			}
			else
			{
				setcookie('login', '', time() + 365*24*3600, null, null, false, true); // On écrit un cookie
				setcookie('mdp', '', time() + 365*24*3600, null, null, false, true); // On écrit un autre cookie...
				setcookie('remember','', time() + 365*24*3600, null, null, false, true); // On écrit un autre cookie...
			}
		}
	}
	
	if(!isset($_SESSION['id_worker']))
	{
		return SESSION_DEAD;
	}
	elseif($_SESSION['id_worker']==0)
	{
		return SESSION_WRONG;
	}
	if(isset($_POST['login']))
	{
		echo '$( "#dialog-message").dialog( "close" );';
		echo 'resetCssSheet("'.$pagestyle.'");';
		echo 'initTranslationTable();';
		echo '$( "#session_worker_name").html("'.$worker_name.'");';
		$_SESSION["worker_name$id_worker"]=$worker_name;
		if($content_page_width!=0)
		{
			echo "resetContentPageDim($content_page_width,$content_page_height);";
			$_SESSION['content_page_width']=$content_page_width;
			$_SESSION['content_page_height']=$content_page_height;
		}
		$_SESSION['pagestyle']=$pagestyle;
		if(!isset($_POST['posting_form']))
			echo 'check_notification=0;refreshPage();';
	}
	
	return SESSION_OK;

}

function magicCrypt($str)
{
	$str=cryptoJsAesEncrypt(SALT_CRYPT,$_POST['password']);
	$str=base64_encode($str);
	$str=strrev($str);
	$str=str_rot13($str);
	return $str;
}

function magicDecrypt($str)
{
	$str=str_rot13($str);
	$str=strrev($str);
	$str=base64_decode($str);
	$str=cryptoJsAesDecrypt(SALT_CRYPT,$str);
	return $str;
}


?>