

var requests=new Array();
var requests_complete=new Array();
var requests_description=new Array();
var requests_abort=new Array();
var request_next_id=0;

var REQUEST_ABORTABLE=0;
var REQUEST_CAN_BE_ABORTED=1;
var REQUEST_UNABORTABLE=2;
var REQUEST_HIDDEN=3;

var STAGE_STANDBY=0;
var STAGE_TODO=1;
var STAGE_WIP=2;
var STAGE_DONE=3;

var posting_form=0;

var ctrl_pressed=false;

function sendRequest(method,dataSent,abort_type,desc)
{
	var request_id=request_next_id;
	requests_complete[request_id]=false;
	requests_abort[request_id]=abort_type;
	requests_description[request_id]=desc;
	var jqxhr = $.ajax( 
		{
			type: method,
			url: "executor.php",
			data:dataSent
		})
		.done(function(data, textStatus, jqXHR)
		{
			requests_complete[request_id]=true;
			evalJs(data);
		})
		.fail(function(jqXHR, textStatus, errorThrown)
		{
			if(errorThrown!="abort")
				displayError("error:"+errorThrown+"\n"+"responseText:"+jqXHR.responseText);
		})
		.always(function(data, textStatus, jqXHR)
		{
			requests_complete[request_id]=true;
			requests[request_id]=0;
			requests_description[request_id]=0;
		});
	if(abort_type==REQUEST_CAN_BE_ABORTED || abort_type==REQUEST_ABORTABLE)
		requests[request_id]=jqxhr;
	else
		requests[request_id]=0;
	request_next_id=request_next_id+1;
}


function setAjaxForm(idForm,method,params,desc)
{
	var r_id=request_next_id;
	requests_description[r_id]=desc;
	request_next_id=request_next_id+1;
	var options = { 
        //target:        '#output1',   	  // target element(s) to be updated with server response 
        beforeSubmit:  function(formData, jqForm, options) {
			var form_ok=checkForm(formData, jqForm, options);
			if(form_ok)
			{
				var exec_on_submit=$("#"+idForm).attr('exec_on_submit');
				if(exec_on_submit!='' && exec_on_submit!='undefined')
					eval(exec_on_submit);
				return true;
			}
			return false;
		},		  // pre-submit callback 
        success:       function(responseText, statusText, xhr, $form) {
			requests_complete[r_id]=true;
			evalFormResponse(responseText, statusText, xhr, $form);
		},	  // post-submit callback 
		error:    function() { 
			requests_complete[r_id]=true;
		}, 
		uploadProgress:function(event, position, total, percentComplete) {
			monitorProgress(event, position, total, percentComplete, idForm);
		},
		request_id:r_id,
        // other available options: 
        url:       "executor.php?"+params,         // override for form's 'action' attribute 
        type:      method        // 'get' or 'post', override for form's 'method' attribute 
        //dataType:  null        // 'xml', 'script', or 'json' (expected server response type) 
        //clearForm: true        // clear all form fields after successful submit 
        //resetForm: true        // reset the form after successful submit 
 
        // $.ajax options can be used here too, for example: 
        //timeout:   3000 
    }; 
	 
	$('#'+idForm).ajaxForm(options); 
	redrawSelect();
	
}

var tracking_requests={};

function trackProgress(process_name)
{
	tracking_requests[process_name]=setTimeout(function(){sendRequest("get","show_progress="+process_name,REQUEST_ABORTABLE,"Tracking process");},2000);
}

function stopTracking(process_name)
{
	clearTimeout(tracking_requests[process_name]);
}

function startBackupBases()
{
	displayLoading('info0_operations_bdd');
	sendRequest("get","backup_bases",REQUEST_CAN_BE_ABORTED,"Création du backup de la base de données");
	
}

function continueRestoreBases(file,line,requests_done)
{
	sendRequest("get","restore_base&continue="+line+"&file="+file+"&requests_done="+requests_done,REQUEST_CAN_BE_ABORTED,"Restauration des bases (suite)");
}

function startStageRepair()
{
	displayLoading('info0_operations_errors');
	sendRequest("get","repair_stages",REQUEST_CAN_BE_ABORTED,"Réparation des étapes");
	
}

function startTaskRepair()
{
	displayLoading('info1_operations_errors');
	sendRequest("get","repair_tasks",REQUEST_CAN_BE_ABORTED,"Réparation des tâches");
	
}


function startWorkRepair()
{
	displayLoading('info2_operations_errors');
	sendRequest("get","repair_work",REQUEST_CAN_BE_ABORTED,"Réparation des jours travaillés");
	
}

function startExportWork()
{
	displayLoading('info0_operations_data_export');
	sendRequest("get","export_work",REQUEST_CAN_BE_ABORTED,"Export des jours travaillés");
}

function startExportPlanning()
{
	displayLoading('info1_operations_data_export');
	sendRequest("get","export_planning",REQUEST_CAN_BE_ABORTED,"Export du planning");
}

function refreshProjectLog(id_project,from,to,status)
{
	displayLoading('info9_projet'+id_project);
	sendRequest("get","get_project_info9&projet=projet"+id_project+"&from="+from+"&to="+to+"&status="+status,REQUEST_CAN_BE_ABORTED,"Log project");
}

function refreshWorkerLog(id_worker,from,to,status)
{
	displayLoading('info3_worker'+id_worker);
	sendRequest("get","get_worker_info3&worker=worker"+id_worker+"&from="+from+"&to="+to,REQUEST_CAN_BE_ABORTED,"Log worker");
}

function redrawSelect()
{
	$( "*[custom_select]" ).each(function (index,elem)
	{
		var options=new Array();
		options["width"]="200px";
		options["search_contains"]=true;
		$(this).chosen(options);
		$(this).on('chosen:showing_dropdown', function(evt, params) {
			//console.log("chosen:showing_dropdown")
			$(this).next("div").css("width","1000px");
			if($('#dialog-message').is(':visible') && $('#dialog-message').height()>0)
				$('#dialog-message').height($('#dialog-message').height()+100);
			else
			{
				//alert($(this).parents("div.ui-tabs-panel").attr('id'));
				$(this).parents("div.ui-tabs-panel").height($(this).parents("div.ui-tabs-panel").height()+100);
			}
		});
		$(this).on('chosen:hiding_dropdown', function(evt, params) {
			$(this).next("div").css("width","200px");
			if($('#dialog-message').is(':visible') && $('#dialog-message').height()>0)
				$('#dialog-message').height($('#dialog-message').height()-100);
			else
				$(this).parents("div.ui-tabs-panel").height($(this).parents("div.ui-tabs-panel").height()-100);
		});
	});
}

function redrawCheckbox(mode)
{
	if(mode=="multiselect")
		$(".custom_checkbox_multiselect").iCheck({checkboxClass: "icheckbox_flat-green", radioClass: "iradio_flat-green"});
	else
		$(".custom_checkbox").iCheck({checkboxClass: "icheckbox_flat-blue", radioClass: "iradio_flat-blue"});
}

function redrawInput()
{
	$("input").addClass("ui-widget ui-widget-content ui-corner-all");
}

var ltexts={};

function getLocText(label)
{
	if(ltexts[label])
		return ltexts[label];
	return '';
}

function refreshLocalizedTexts()
{
	$( "*[localized]" ).each(function (index,elem)
	{
		$(this).html(ltexts[this.id]);
	});
}

function initTranslationTable()
{
	$.ajax( {
			async:true,
			url: "executor.php?init_translation_table"
		} )
	.done(function(data, textStatus, jqXHR) {
		evalJs(data,0);
		refreshLocalizedTexts();
	})
	.fail(function() {
		displayError( "Impossible to init translation table" );
	})
	.always(function() {
	
	});	
}

function showDialog(dialog_title,text,is_blocking)
{
	$( "#dialog-message" ).html(text);
	var apparition={effect:"fade",duration:500};
	try{$( "#dialog-message" ).dialog( "destroy" );}catch(e){};
	$( "#dialog-message" ).dialog(
	{
		modal: is_blocking,
		title:dialog_title,
		draggable: true,
		width: 400,
		minHeight: 200,
		show: apparition,
		hide: apparition,
		buttons: 
		{
			Ok: function() 
			{
				$( this ).dialog( "close" );
			}
		}
	});
}

function closeDialog()
{
	$( "#dialog-message" ).dialog( "close" );
}

function getUserInput(global_action,params)
{
	if(!params['already_set'])
	{
		$( "#dialog-message" ).html('<br><br><br<br><br><br><br><br>');
		displayLoading("dialog-message");
	}
	var apparition={effect:"fade",duration:500};
	try{$( "#dialog-message" ).dialog( "destroy" );}catch(e){};
	$( "#dialog-message" ).dialog(
	{
		modal: params['is_blocking'],
		title:params['title'],
		show: apparition,
		hide: apparition,
		draggable: true,
		width: params['width'],
		height:'auto',
		closeOnEscape: true,
		drag: function( event, ui ) {
			$( "div[error_field]" ).each( function(index) {
				var field_name=$( this ).attr( "error_field" );
				setErrorMessagePosition(field_name);
			});
		},
		/*resizeStart:function( event, ui )
		{
			$( "#dialog-message"  ).dialog( "option", "height", '' );
		},*/
		close:function(event,ui)
		{
			removeErrorFields();
		}
	});
	
	if(params['form_id']!="")
		$( "#dialog-message").dialog( "option", "buttons", [ { icons: { primary: "ui-icon-check"}, text: params['ok_button_title'], click: function() { $('#'+params['form_id']).submit(); } },{ text: ltexts['ltext_cancel'], click: function() { $( this ).dialog( "close" ); } } ] );
	else
		$( "#dialog-message").dialog( "option", "buttons", [ { icons: { primary: "ui-icon-check"}, text: params['ok_button_title'], click: function() { $( this ).dialog( "close" ); } } ] );
	if(!params['already_set'])
		sendRequest("get","get_user_input="+global_action+"&val1="+params['val1']+"&val2="+params['val2']+"&val3="+params['val3'],REQUEST_ABORTABLE,"Création de la zone de saisie");
}

function getDialog(type_dialog,val1,val2,val3)
{
	var params=new Array();
	params['val1']=val1;
	params['val2']=val2;
	params['val3']=val3;
	params['already_set']=false;
	params['width']=400;
	if(type_dialog=="add_project_member")
	{
		params['title']=ltexts['ltext_project_people_add_work_slot_title'];
		params['form_id']="add_project_member";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_project_people_add_this_work_slot'];
		getUserInput("add_project_member",params);
	}
	else if(type_dialog=="edit_project_plage")
	{
		params['title']=ltexts['ltext_project_people_edit_work_slot_title'];
		params['form_id']="edit_project_plage";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_project_people_edit_this_work_slot'];
		getUserInput("edit_project_plage",params);
	}
	else if(type_dialog=="delete_project_plage")
	{
		params['title']=ltexts['ltext_project_people_delete_work_slot_title'];
		params['form_id']="delete_project_plage";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_project_people_delete_this_work_slot'];
		getUserInput("delete_project_plage",params);
	}
	else if(type_dialog=="add_project_milestone")
	{
		params['title']=ltexts['ltext_project_milestone_add_title'];
		params['form_id']="add_project_milestone";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_project_milestone_add_this'];
		getUserInput("add_project_milestone",params);
	}
	else if(type_dialog=="edit_project_milestone")
	{
		params['title']=ltexts['ltext_project_milestone_edit_title'];
		params['form_id']="edit_project_milestone";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_project_milestone_edit'];
		getUserInput("edit_project_milestone",params);
	}
	else if(type_dialog=="delete_project_milestone")
	{
		params['title']=ltexts['ltext_project_milestone_edit_title']
		params['form_id']="delete_project_milestone";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_project_milestone_delete'];
		getUserInput("delete_project_milestone",params);
	}
	else if(type_dialog=="add_project_echeance")
	{
		params['title']=ltexts['ltext_project_deadlines_add_title'];
		params['form_id']="add_project_echeance";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_project_deadlines_add'];
		getUserInput("add_project_echeance",params);
	}
	else if(type_dialog=="edit_project_echeance")
	{
		params['title']=ltexts['ltext_project_deadlines_edit_title'];
		params['form_id']="edit_project_echeance";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_project_deadlines_edit'];
		getUserInput("edit_project_echeance",params);
	}
	else if(type_dialog=="delete_project_echeance")
	{
		params['title']=ltexts['ltext_project_deadlines_delete_title'];
		params['form_id']="delete_project_echeance";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_project_deadlines_delete'];
		getUserInput("delete_project_echeance",params);
	}
	else if(type_dialog=="add_worker_holidays")
	{
		params['title']=ltexts['ltext_team_holidays_add_title'];
		params['form_id']="add_worker_holidays";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_team_holidays_add_this'];
		getUserInput("add_worker_holidays",params);
	}
	else if(type_dialog=="edit_worker_holidays")
	{
		params['title']=ltexts['ltext_team_holidays_edit_title'];
		params['form_id']="edit_worker_holidays";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_team_holidays_edit'];
		getUserInput("edit_worker_holidays",params);
	}
	else if(type_dialog=="delete_worker_holidays")
	{
		params['title']=ltexts['ltext_team_holidays_delete_title'];
		params['form_id']="delete_worker_holidays";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_team_holidays_delete'];
		getUserInput("delete_worker_holidays",params);
	}
	else if(type_dialog=="add_task_document")
	{
		params['title']=ltexts['ltext_task_add_document'];
		params['form_id']="add_task_document";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_task_add_this_document'];
		params['width']=600;
		getUserInput("add_task_document",params);
	}
	else if(type_dialog=="edit_task_document")
	{
		params['title']=ltexts['ltext_task_edit_document'];
		params['form_id']="edit_task_document";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_task_edit_this_document'];
		getUserInput("edit_task_document",params);
	}
	else if(type_dialog=="delete_task_document")
	{
		params['title']=ltexts['ltext_task_delete_document'];
		params['form_id']="delete_task_document";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_task_delete_this_document'];
		getUserInput("delete_task_document",params);
	}
	else if(type_dialog=="add_task_comment")
	{
		params['title']=ltexts['ltext_task_add_comment'];
		params['form_id']="add_task_comment";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_task_add_this_comment'];
		params['width']=600;
		getUserInput("add_task_comment",params);
	}
	else if(type_dialog=="edit_task_comment")
	{
		params['title']=ltexts['ltext_task_edit_comment'];
		params['form_id']="edit_task_comment";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_task_edit_this_comment'];
		getUserInput("edit_task_comment",params);
	}
	else if(type_dialog=="delete_task_comment")
	{
		params['title']=ltexts['ltext_task_delete_comment'];
		params['form_id']="delete_task_comment";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_task_delete_this_comment'];
		getUserInput("delete_task_comment",params);
	}
	else if(type_dialog=="add_task_stage")
	{
		params['title']=ltexts['ltext_task_add_stage'];
		params['form_id']="add_task_stage";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_task_add_this_stage'];
		params['width']=1000;
		getUserInput("add_task_stage",params);
	}
	else if(type_dialog=="edit_task_stage")
	{
		params['title']=ltexts['ltext_stage_edition'];
		params['form_id']="edit_task_stage";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_edit_this_stage'];
		params['width']=1000;
		getUserInput("edit_task_stage",params);
	}
	else if(type_dialog=="delete_task_stage")
	{
		params['title']=ltexts['ltext_stage_deletion'];
		params['form_id']="delete_task_stage";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_delete_this_stage'];
		getUserInput("delete_task_stage",params);
	}
	else if(type_dialog=="go_todo_task_stage")
	{
		params['title']=ltexts['ltext_current_stage_change'];
		params['form_id']="go_todo_task_stage";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_set_current_stage'];
		getUserInput("go_todo_task_stage",params);
	}
	else if(type_dialog=="identify_user")
	{
		params['title']=ltexts['ltext_team_identify'];
		params['form_id']="identify_user";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_team_identify_this'];
		params['already_set']=true;
		getUserInput("identify_user",params);
	}
	else if(type_dialog=="add_job")
	{
		params['title']=ltexts['ltext_job_add_title'];
		params['form_id']="add_job";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_job_add_this'];
		getUserInput("add_job",params);
	}
	else if(type_dialog=="edit_job")
	{
		params['title']=ltexts['ltext_job_edit_title'];
		params['form_id']="edit_job";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_job_edit'];
		getUserInput("edit_job",params);
	}
	else if(type_dialog=="delete_job")
	{
		params['title']=ltexts['ltext_job_delete_title'];
		params['form_id']="delete_job";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_job_delete'];
		getUserInput("delete_job",params);
	}
	else if(type_dialog=="add_job_category")
	{
		params['title']=ltexts['ltext_job_cat_add_title'];
		params['form_id']="add_job_category";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_job_cat_add_this'];
		getUserInput("add_job_category",params);
	}
	else if(type_dialog=="edit_job_category")
	{
		params['title']=ltexts['ltext_job_cat_edit_title'];
		params['form_id']="edit_job_category";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_job_cat_edit'];
		getUserInput("edit_job_category",params);
	}
	else if(type_dialog=="delete_job_category")
	{
		params['title']=ltexts['ltext_job_cat_delete_title'];
		params['form_id']="delete_job_category";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_job_cat_delete'];
		getUserInput("delete_job_category",params);
	}
	else if(type_dialog=="add_tag")
	{
		params['title']=ltexts['ltext_project_tags_add_title'];
		params['form_id']="add_tag";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_project_tags_add_this'];
		getUserInput("add_tag",params);
	}
	else if(type_dialog=="edit_tag")
	{
		params['title']=ltexts['ltext_project_tags_edit_title'];
		params['form_id']="edit_tag";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_project_tags_edit'];
		getUserInput("edit_tag",params);
	}
	else if(type_dialog=="delete_tag")
	{
		params['title']=ltexts['ltext_project_tags_delete_title'];
		params['form_id']="delete_tag";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_project_tags_delete'];
		getUserInput("delete_tag",params);
	}
	else if(type_dialog=="apply_realtime_tag")
	{
		params['title']=ltexts['ltext_project_tags_apply_title'];
		params['form_id']="apply_realtime_tag";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_project_tags_apply_this'];
		getUserInput("apply_realtime_tag",params);
	}
	else if(type_dialog=="add_budget")
	{
		params['title']=ltexts['ltext_manmonth_add_title'];
		params['form_id']="add_budget";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_manmonth_add_this'];
		getUserInput("add_budget",params);
	}
	else if(type_dialog=="edit_budget")
	{
		params['title']=ltexts['ltext_manmonth_edit_title'];
		params['form_id']="edit_budget";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_manmonth_edit'];
		getUserInput("edit_budget",params);
	}
	else if(type_dialog=="delete_budget")
	{
		params['title']=ltexts['ltext_manmonth_delete_title'];
		params['form_id']="delete_budget";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_manmonth_delete'];
		getUserInput("delete_budget",params);
	}
	else if(type_dialog=="delete_task")
	{
		params['title']=ltexts['ltext_task_deletion'];
		params['form_id']="delete_task";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_task_delete_this'];
		getUserInput("delete_task",params);

	}
	else if(type_dialog=="add_project_external_cost")
	{
		params['title']=ltexts['ltext_project_external_costs_add_title'];
		params['form_id']="add_project_external_cost";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_project_external_costs_add_this'];
		getUserInput("add_project_external_cost",params);
	}
	else if(type_dialog=="edit_project_external_cost")
	{
		params['title']=ltexts['ltext_project_external_costs_edit_title'];
		params['form_id']="edit_project_external_cost";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_project_external_costs_edit'];
		getUserInput("edit_project_external_cost",params);
	}
	else if(type_dialog=="delete_project_external_cost")
	{
		params['title']=ltexts['ltext_project_external_costs_delete_title'];
		params['form_id']="delete_project_external_cost";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_project_external_costs_delete'];
		getUserInput("delete_project_external_cost",params);
	}
	else if(type_dialog=="send_to_sleep_stage")
	{
		params['title']=ltexts['ltext_task_set_sleep_stage_title'];
		params['form_id']="send_to_sleep_stage";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_task_set_sleep_stage'];
		getUserInput("send_to_sleep_stage",params);
	}
	else if(type_dialog=="wake_up_stage")
	{
		params['title']=ltexts['ltext_task_set_awake_stage_title'];
		params['form_id']="wake_up_stage";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_task_set_awake_stage'];
		getUserInput("wake_up_stage",params);
	}
	else if(type_dialog=="change_statut_complex")
	{
		params['title']=ltexts['ltext_task_change_status_title'];
		params['form_id']="change_statut_complex";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_task_change_status_action'];
		getUserInput("change_statut_complex",params);
	}
	else if(type_dialog=="display_deadline_details")
	{
		params['title']=ltexts['ltext_project_deadlines_details_title'];
		params['form_id']="";
		params['is_blocking']=false;
		params['ok_button_title']='Ok';
		params['width']="90%";
		getUserInput("display_deadline_details",params);
	}
	else if(type_dialog=="estimate_task")
	{
		params['title']=ltexts['ltext_task_estimate_title'];
		params['form_id']="";
		params['is_blocking']=false;
		params['ok_button_title']='Ok';
		getUserInput("estimate_task",params);
	}
	else if(type_dialog=="attrib_projects")
	{
		params['title']=ltexts['ltext_team_distribution_add_title'];
		params['form_id']="attrib_projects";
		params['is_blocking']=true;
		params['ok_button_title']=ltexts['ltext_team_distribution_add_this'];
		params['val1']='';
		$.each(planning_items, function(index, value) {
			if(value==true)
			{
				params['val1']+=index+'_';
			}
		});
		
		params['val1']=params['val1'].substring(0,params['val1'].length-1);
		//alert(params['val1']);
		getUserInput("attrib_projects",params);
	}
}
 
 
 function checkForm(formData, jqForm, options, request_id) { 
    // formData is an array; here we use $.param to convert it to a string to display it 
    // but the form plugin does this for you automatically when it submits the data 
    var queryString = $.param(formData); 
	
    // jqForm is a jQuery object encapsulating the form element.  To access the 
    // DOM element for the form do this: 
    var formElement = jqForm[0]; 
	var nb_errors=0;
	removeErrorFields();
	for(i=0;i<jqForm.context.length;i++)
	{
		if(typeof(jqForm.context[i].attributes.validation)!="undefined")
		{
			var id_field=jqForm.context[i].attributes.id.value;
			var validation_type=jqForm.context[i].attributes.validation.value;
			if(validation_type=="not_empty")
			{
				nb_errors=nb_errors+checkEmptyField(id_field,ltexts['ltext_error_empty']);
			}
			else if(validation_type=="valid_date")
			{
				nb_errors=nb_errors+checkDateField(id_field,ltexts['ltext_error_date']);
			}
			else if(validation_type=="valid_date_us")
			{
				nb_errors=nb_errors+checkDateFieldUS(id_field,ltexts['ltext_error_date_us']);
			}
			else if(validation_type=="is_numeric")
			{
				nb_errors=nb_errors+checkNumericField(id_field,ltexts['ltext_error_number']);
			}
			else if(validation_type=="is_email")
			{
				nb_errors=nb_errors+checkEmailField(id_field,ltexts['ltext_error_email']);
			}
			else if(validation_type.indexOf("check_presence-")==0)
			{
				var check_item=validation_type.replace("check_presence-","");
				var error_message=ltexts['ltext_error_missing_element'].replace("[X]",check_item);
				nb_errors=nb_errors+checkExistField(id_field,jqForm,check_item,error_message);
			}
		}
	}
	/*if(formElement.id=="add_project")
	{
		//nb_errors=nb_errors+checkEmptyField("nom_projet","Ce champs ne doit pas être vide !");
		//nb_errors=nb_errors+checkEmptyField("alias_projet","Ce champs ne doit pas être vide !");
		nb_errors=nb_errors+checkDateField("date_start","La date doit être valide et avoir ce format : dd/mm/aaaa");
		nb_errors=nb_errors+checkDateField("date_end","La date doit être valide et avoir ce format : dd/mm/aaaa");
	}*/
 
    //alert('About to submit form '+formElement.id+': \n\n' + queryString); 
 
    // here we could return false to prevent the form from being submitted; 
    // returning anything other than false will allow the form submit to continue 
	if(nb_errors==0)
	{
		requests_complete[options.request_id]=false;
		requests_abort[options.request_id]=REQUEST_UNABORTABLE;
		$('#processing_'+formElement.id).show( "fade", 1000 );
		$('#'+formElement.id).addClass("ui-state-disabled");
		posting_form=1;
		return true; 
	}
	try
	{	
		$('#button_submit_'+formElement.id).pulsate({reach:100, color:'#ff0000',glow:true,repeat:1 });
		$('#submit_button_'+formElement.id).pulsate({reach:100, color:'#ff0000',glow:true,repeat:1 });
	}
	catch(e){}
	return false;
}

function checkExistField(field_name,form,check_item,error_msg)
{
	var missing_item=true;
	for(j=0;j<form.context.length;j++)
	{
		if(typeof(form.context[j].attributes.id)!="undefined")
		{
			var id_field=form.context[j].attributes.id.value;
			if(id_field.indexOf(check_item)==0)
			{
				missing_item=false;
				break;
			}
		}
	}
	
	if(missing_item)
	{
		raiseFormError(field_name,error_msg);
		return 1;
	}
	
	return 0;
} 

function removeErrorFields()
{
	$( "div[error_field]" ).remove();
}

function checkEmptyField(field_name,error_msg)
{
	var field=$('#'+field_name);
	if($('#'+field_name).val()=="")
	{
		raiseFormError(field_name,error_msg);
		return 1;
	}
	
	return 0;
}

function checkNumericField(field_name,error_msg)
{
	if($.isNumeric($('#'+field_name).val())==false)
	{
		raiseFormError(field_name,error_msg);
		return 1;
	}
	
	return 0;
}

function checkEmailField(field_name,error_msg){//check if an email is correctly formatted
	var filter = /^([\w-\.]+)@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.)|(([\w-]+\.)+))([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)$/;
    if (!filter.test($('#'+field_name).val())) 
	{
		raiseFormError(field_name,error_msg);
		return 1;
	}
	return 0;
}

function checkDateField(field_name,error_msg)//check if a date is correctly formatted
{
	var res="";
	if($('#'+field_name).val().length!=10)
	{
		raiseFormError(field_name,error_msg);
		return 1;
	}
	
	
	var jour=$('#'+field_name).val().charAt(0);
	jour=jour.concat($('#'+field_name).val().charAt(1));
	var mois=$('#'+field_name).val().charAt(3);
	mois=mois.concat($('#'+field_name).val().charAt(4));
	var annee=$('#'+field_name).val().charAt(6);
	annee=annee.concat($('#'+field_name).val().charAt(7));
	annee=annee.concat($('#'+field_name).val().charAt(8));
	annee=annee.concat($('#'+field_name).val().charAt(9));
	
		
	var split1=$('#'+field_name).val().charAt(2);
	var split2=$('#'+field_name).val().charAt(5);
	
	if(split1!="/" || split2!="/")
	{
		raiseFormError(field_name,error_msg);
		return 1;
	}
	if(annee<"2000" || annee>"2100" || isNaN(annee))
	{
		raiseFormError(field_name,error_msg);
		return 1;
	}
	if(isNaN(mois) || mois>"12" || mois<"01")
	{
		raiseFormError(field_name,error_msg);
		return 1;
	}
	if(isNaN(jour) || jour>"31" || jour<"01")
	{
		raiseFormError(field_name,error_msg);
		return 1;
	}
	
	return 0;
}

function checkDateFieldUS(field_name,error_msg)//check if a date is correctly formatted
{
	var res="";
	if($('#'+field_name).val().length!=10)
	{
		raiseFormError(field_name,error_msg);
		return 1;
	}
	
	
	var jour=$('#'+field_name).val().charAt(3);
	jour=jour.concat($('#'+field_name).val().charAt(4));
	var mois=$('#'+field_name).val().charAt(0);
	mois=mois.concat($('#'+field_name).val().charAt(1));
	var annee=$('#'+field_name).val().charAt(6);
	annee=annee.concat($('#'+field_name).val().charAt(7));
	annee=annee.concat($('#'+field_name).val().charAt(8));
	annee=annee.concat($('#'+field_name).val().charAt(9));
	
		
	var split1=$('#'+field_name).val().charAt(2);
	var split2=$('#'+field_name).val().charAt(5);
	
	if(split1!="/" || split2!="/")
	{
		raiseFormError(field_name,error_msg);
		return 1;
	}
	if(annee<"2000" || annee>"2100" || isNaN(annee))
	{
		raiseFormError(field_name,error_msg);
		return 1;
	}
	if(isNaN(mois) || mois>"12" || mois<"01")
	{
		raiseFormError(field_name,error_msg);
		return 1;
	}
	if(isNaN(jour) || jour>"31" || jour<"01")
	{
		raiseFormError(field_name,error_msg);
		return 1;
	}
	
	return 0;
}

function setDatePicker(field_name)
{
	$( "#"+field_name ).datepicker(/*{popup: true,}*/);
	$( "#"+field_name ).datepicker("show");
}

function raiseFormError(field_name,error_msg)
{
	if($('#'+field_name+'_error').length==0)
	{
		var positionning='';
		if(current_page=="#taches" && current_menu=="menu8" && $("#edit_"+ field_name).length>0)//very very very dirty hack for this particular page...
			positionning='left:100%;top:30%;';
		var error_box='<div id="'+field_name+'_error" error_field="'+field_name+'" class="ui-state-error ui-corner-all" style="width:500px;z-index:110;'+positionning+'position:absolute"><span style="float: left; margin-right: .3em;" class="ui-icon ui-icon-alert"></span>'+error_msg+'</div>';
		if(current_page=="#taches" && current_menu=="menu8")//very very very dirty hack for this particular page...
		{
			if($("#edit_"+ field_name).length==0)
			{
				$(error_box).appendTo( window.document.body);
				setErrorMessagePosition(field_name);
			}
			else
				$(error_box).appendTo( $("#edit_"+ field_name));
		}
		else
			$(error_box).appendTo(  $("#edit_"+ field_name));
	}
	//$('#'+field_name+'_error').html(error_msg);
	
	/*if(current_page=="#taches" && current_menu=="menu8")
		$('#tr_'+field_name).append('<td>'+error_box+'</td>');
	else*/
	if(current_page!="#taches" || current_menu!="menu8")//very very very dirty hack for this particular page...
		setErrorMessagePosition(field_name);
	var bounce={effect:"bounce",duration:1000}
	var highlight={effect:"highlight",duration:1000,queue:false,color:"red"}
	$('#'+field_name+'_error').effect( bounce);
	$('#'+field_name+'_error').effect( highlight);
	
}

function setErrorMessagePosition(field_name)
{
	$( '#'+field_name+'_error' ).position({
		my: "left",
		at: "right",
		of: '#'+field_name,
		collision:"none"
		});
}

function updateStagePosition(event,ui,id_table,page_part)
{
	var new_position=1;
	var drop_elem_id=ui.item.attr("id");
	var last_position=0;
	var prev_position=0;
	var next_position=-1;
	$('#'+id_table+' > tbody  > tr').each(function(index,element)
	{
		if(next_position==0)
		{
			next_position=parseInt($(this).attr('step_position'));
		}
		if(element.id==drop_elem_id)
		{
			prev_position=last_position;
			next_position=0;
		}
		last_position=parseInt($(this).attr('step_position'));
		
		//new_position=parseInt($(this).attr('step_position'))+1;
	});
	//console.log("prev position="+prev_position+" next_position="+next_position);
	//return true;
	
	$('#'+id_table+' > tbody  > tr').each(function(index,element)
	{
		if(element.id==drop_elem_id)
			return false;
		new_position=new_position+1;
		//new_position=parseInt($(this).attr('step_position'))+1;
	});
	displayLoading(page_part);
	sendRequest("get","update_stage="+drop_elem_id.replace("ligne_etape","")+"&prev_position="+prev_position+"&next_position="+next_position+"&new_position="+new_position+"&id_tache="+page_part.replace("info2_tache",''),REQUEST_CAN_BE_ABORTED,"Mise à jour de la position de l'étape");
}

var new_line=new Array();

function removeFormField(elem)
{
	var id_flow=$('#'+elem).attr('flow_id');
	if(id_flow)
	{
		$( "#stage_ref_flow_"+id_flow ).remove();
		$( "#is_blocking_flow_"+id_flow ).remove();
		$( "#sovereign_flow_"+id_flow ).remove();
		$( "#priority_flow_"+id_flow ).remove();
		task_flow.remove ('flow_'+id_flow);
		//console.log("remvoving "+'#flow_'+id_flow);
		task_flow.repaintEverything (true);
	}
	$('#'+elem).closest('tr').remove();
	/*var id_ref=$( "div[id_ref='flow_"+elem+"']" ).attr('id');
	if(id_ref)
	{
		task_flow.remove (id_ref);
		//console.log("remvoving "+'#'+id_ref);
		
		task_flow.repaintEverything (true);
	}*/
}

function addFormField(elem,html)
{
     // var newrow = $("<tr><td>"+(counter++)+"</td><td>"+(counter++)+"</td></tr>");
	$(elem).closest('tr').before(html);
	
	updateFormField();
	
		
		//alert((elementCount).length);
		/*var str="Visit Microsoft! Microsoft Microsoft Microsoft MicrosoftMicrosoftMicrosoft";
			var n=str.replace(/Microsoft /g,"W3Schools");
			alert(n);	*/	
       // newrow.each(addToRow);
	   //alert(html);
}

function updateFormField()
{
	var count=new Array();
	$( "*[group]" ).each(function (index,elem)
	{
		var attrib_id=$(this).attr("group");
		var field_to_update=attrib_id.search('NUM');
		if(field_to_update>=0)
		{
			if(!count[attrib_id])
				count[attrib_id]=1;
			var tr_parents=$( this ).parents( "tr" );
			var pere="";
			if(tr_parents.length==2 && $(this).attr("duplication")==1)
			{
				//console.log("sous duplicat trouvé : "+$(this).attr("id")+" père = "+$(tr_parents[1]).attr("id"));
				pere='_'+$(tr_parents[1]).attr("id").replace(/tr_field/g,'etape');
			}
			var new_id=attrib_id.replace(/NUM/g,count[attrib_id]);
			var old_id=$(this).attr("id");
			//replaceFlowId(old_id,new_id);
			$(this).attr("id",new_id+pere);
			$(this).attr("name",new_id+pere);
			
			var group_text=$(this).attr("group_text");
			var read_only=$(this).attr("read_only");
			
			if(group_text && !read_only)
			{
				$(this).attr("resizelabel","1");
				$(this).attr("resized_up","0");
				var new_content=group_text.replace(/NUM/g,count[attrib_id]);
				$(this).html('<ul class="icons ui-widget ui-helper-clearfix"   id="icons"><li  editlabel="1" onclick="removeFormField(\''+new_id+pere+'\');updateFormField();" title="'+ltexts['ltext_delete_this_item']+'" accept_tooltip="1" class="ui-state-default ui-corner-all"><span  class="ui-icon ui-icon-circle-close"></span></li><span style="vertical-align:middle">'+new_content+'</span></ul>');
			}
			
			count[attrib_id]=count[attrib_id]+1;
			//$("#bas_page").html($("#bas_page").html()+index+'-'+attrib_id+"->"+new_id+"<br>");
		}
	});
	
	/*$( "*[replace_name]" ).each(function (index,elem)
	{
		var replace_name=$(this).attr("replace_name");
		if(replace_name!="0")
		{
			var old_id=$(this).attr("id");
			//console.log(old_id+' will become '+replace_name);
			$(this).attr("id",replace_name);
			$(this).attr("name",replace_name);
			$(this).attr("replace_name","0");
		}
	});
	$( "*[replace_name_ref]" ).each(function (index,elem)
	{
		var replace_name=$(this).attr("replace_name_ref");
		if(replace_name!="0")
		{
			var old_id=$(this).attr("id");
			//console.log(old_id+' will become '+replace_name);
			$(this).attr("id_ref",replace_name);
			$(this).attr("replace_name","0");
		}
	});*/
	$( "*[flow_graph]" ).each(function (index,elem)
	{
		var stage_id=$(this).attr("id");
		var group_id=$(this).attr("group");
		group_id=group_id.replace(/NUM/g,"");
		var stage_num=stage_id.replace(group_id,'');
		var stage_to_add=$(this).attr("flow_graph");
		if(stage_to_add==1)
		{
			addFlowStage("flow_"+task_attrib_id,stage_id);
			$(this).attr("flow_id",task_attrib_id);
			task_attrib_id++;
			$(this).attr("flow_graph",0);
		}
		var worker=$("#id_worker"+stage_num).find('option:selected').text();
		var worker_parts=worker.split(' (');
		var worker_name=worker_parts[0];
		var objectif=$("#etape_objectif"+stage_num).val();
		//$("#flow_"+stage_id).html(worker_name+'<br>'+objectif);
		//$( "div[id_ref='flow_"+stage_id+"']" ).html(worker_name+'<br>'+objectif);
		$( "#flow_"+$(this).attr("flow_id") ).html(worker_name+'<br>'+objectif);
		$( "#stage_ref_flow_"+$(this).attr("flow_id") ).val(stage_id);
	});
	redrawSelect();
	redrawInput();
	switchExpertMode();
}
 
// post-submit callback 
function evalFormResponse(responseText, statusText, xhr, $form)  { 
    // for normal html responses, the first argument to the success callback 
    // is the XMLHttpRequest object's responseText property 
 
    // if the ajaxForm method was passed an Options Object with the dataType 
    // property set to 'xml' then the first argument to the success callback 
    // is the XMLHttpRequest object's responseXML property 
 
    // if the ajaxForm method was passed an Options Object with the dataType 
    // property set to 'json' then the first argument to the success callback 
    // is the json data object returned by the server 
	
	//if($form.context.id=="add_project")
	$('#processing_'+$form.context.id).hide( "fade", 1000 );
	$('#'+$form.context.id).removeClass("ui-state-disabled");
	evalJs(responseText);
	posting_form=0;
    //alert('status: ' + statusText + '\n\nresponseText: \n' + responseText + '\n\nThe output div should have already been updated with the responseText.'); 
} 

function monitorProgress(event, position, total, percentComplete, idForm) {
	$( "#progress_"+idForm ).progressbar({value: percentComplete});
	$( "#progressvalue_"+idForm ).html(percentComplete+"%");
}

var planning_items={};
var planning_item_clicked=false;

var notifications=new Array();
var notifications_bdd=new Array();
var count_notification=0;

function addNotification(message,id_bdd,date_notif)
{
	var notif_exists=false;
	//console.log("on veut ajouter la notification "+id_bdd);
	$( "div[notification]" ).each(function (index,elem){
		var notification_id=$(this).attr("notification");
		//console.log("notification trouvée : id "+notification_id);
		if(notification_id==id_bdd)
		{
			notif_exists=true;
			return false;
		}
	});
	if(!notif_exists)
	{
		$('#close_all_notifications').show("fade");
		notifications[count_notification]=$('<div id="notification'+count_notification+'" style="position:fixed;top:100px;z-index:200;right:-2px;width:300px;" title="'+date_notif+'" accept_tooltip="1" class="ui-widget ui-state-highlight ui-corner-all"><table><tr><td><ul class="icons ui-widget ui-helper-clearfix" id="icons"><li onclick="removeNotification('+count_notification+','+id_bdd+')" title="'+ltexts['ltext_notif_delete_this']+'" accept_tooltip="1" class="ui-state-default ui-corner-all"><span class="ui-icon ui-icon-circle-close"></span></li></ul></td><td><div style="word-wrap:break-word;width:250px;" class="small_text" id="notif_afx_'+id_bdd+'" notification="'+id_bdd+'" id_notif="'+count_notification+'">'+message+'</div></td></tr></table>	</div>').appendTo( window.document.body ).effect("slide",{direction:"right"});
		notifications_bdd[count_notification]=id_bdd;
		var add_height=notifications[count_notification].height();
		for(var i=0;i<count_notification;i++)
		{
			if(notifications[i])
				notifications[i].animate({top:"+="+(add_height)+"px"},500);
		}
		count_notification=count_notification+1;
	}
}

function removeNotification(id_notification,id_bdd)
{
	if(notifications[id_notification])
	{
		var remove_height=notifications[id_notification].height();
		$("#notif_afx_"+id_bdd).attr("notification",0);
		notifications[id_notification].effect("explode");
		notifications[id_notification]=false;
		sendRequest("get","remove_notification="+id_bdd,REQUEST_HIDDEN,"Récupération des notifications");
		for(var i=0;i<id_notification;i++)
		{
			if(notifications[i])
				notifications[i].animate({top:"-="+(remove_height)+"px"},500);
		}
		if(countNotifications()==0)
			$('#close_all_notifications').hide("fade");
	}
}

function removeAllNotifications()
{
	for(var i=0;i<count_notification;i++)
	{
		if(notifications[i])
			removeNotification(i,notifications_bdd[i]);
	}
}

function countNotifications()
{
	var res=0;
	for(var i=0;i<count_notification;i++)
	{
		if(notifications[i])
			res++;
	}
	return res;
}

function displayFilter(filter_name)
{
	var just_close=false;
	if($("#filter_zone_"+filter_name).is(':visible'))
		just_close=true;
	$(".filter").hide();
	if(!just_close)
	{
		$("#filter_zone_"+filter_name).show( "fade", 1000 );
		$("#filter"+filter_name).trigger('chosen:open');
		var filter_left=$("#filter_label_"+filter_name).position().left;
		var filter_top=$("#filter_label_"+filter_name).position().top;
		$( "#filter_zone_"+filter_name).css("left",filter_left+"px");
		$( "#filter_zone_"+filter_name).css("top",(filter_top+30)+"px");
		/*$( "#filter_zone_"+filter_name).position({
			my: "left",
			at: "bottom+30px",
			of: "#filter_label_"+filter_name,
			collision:"none"
			});*/
	}
	
	filter_end_update=0;
	filter_list_is_closed=1;
}

function updateFilter(filter_name)
{
	var old_filter=$("#filter_text_"+filter_name).html();
	var filter_select=$("#filter"+filter_name+ " option");
	var selected_items=new Array();
	var new_filter='';
	var tot_items=0;
	var amount_selected=0;
	filter_select.each(function () {
		var $this = $(this);
		tot_items++;
		if($(this).is(':selected'))
		{
			var selText = $this.text();
			selected_items.push(selText);
			new_filter=new_filter+selText+', ';
			amount_selected++;
		}
	});
	//var new_filter=selected_items.toString();
	new_filter=new_filter.substring(0,new_filter.length-2);
	if(new_filter.length>50)
		new_filter=new_filter.substring(0,50)+"...";
	if(amount_selected==tot_items)
	{
		new_filter='<span localized="1" id="ltext_filter_all_'+filter_name+'">'+ltexts['ltext_filter_all_'+filter_name]+'</span>';
	}
	else if(amount_selected==0)
	{
		var no_one='ltext_filter_no_one';
		new_filter=ltexts[no_one];
	}
	if(old_filter!=new_filter)
	{
		if(old_filter!="")
			$('#refresh_filters').pulsate({reach:50,pause:500,color:"#09f"});
		
		$("#filter_text_"+filter_name).html(new_filter);
		//console.log("update");
	}
	filter_end_update=1;
}

var filter_list_is_closed=0;
var filter_end_update=0;

function hideFilter()
{
	if(filter_list_is_closed==1 && filter_end_update==0)
	{
		$(".filter").hide();
		filter_list_is_closed=0;
	}
	filter_end_update=0;
}

function initFilter(filter_name)
{
	$("#filter"+filter_name).selectMultiple({
		selectableHeader: "<input type='text' class='search-input' autocomplete='off' onclick='event.stopPropagation();'>",
		afterInit: function(ms){
		var that = this,
			$selectableSearch = that.$selectableUl.prev(),
			selectableSearchString = '#'+that.$container.attr('id')+' .ms-elem-selectable';

		that.qs1 = $selectableSearch.quicksearch(selectableSearchString)
		.on('keydown', function(e){
		  if (e.which === 40){
			that.$selectableUl.focus();
			return false;
		  }
		});
		},
		afterSelect: function(values){
		this.qs1.cache();
		$(".ms-selected").addClass("ui-state-highlight");
		},
		afterDeselect: function(values){
		this.qs1.cache();
		$(".ms-elem-selectable").removeClass("ui-state-highlight");
		$(".ms-selected").addClass("ui-state-highlight");
		}
	});
}

var workers_out_planning=new Array();

function removeWorkerFromPlanning(checkbox)
{
	var id_worker=$(checkbox).val();
	if(!$(checkbox).is(':checked'))
	{
		workers_out_planning.push(id_worker);
	}
	else
	{
		workers_out_planning.splice( $.inArray(id_worker,workers_out_planning) ,1 );
	}
}

function switchExpertMode()
{
	if(!$("#expert_mode_switcher").is(':checked'))
	{
		$(".expert_only").hide();
		$("._jsPlumb_endpoint").hide();
	}
	else
	{
		$(".expert_only").show();
		$("._jsPlumb_endpoint").show();
	}
	if(task_flow!=0)
	{
		try{	//ugly stuff to force a refresh on jsPlumb that doesn't like to be hidden
			
			var step=addFlowStep();
			task_flow.remove (step.attr("id")); 
			//console.log("removing "+"#ligne_"+step);
			$("#ligne_"+step.attr("id")).remove();
			
		}catch(e){}
		task_flow.repaintEverything (true);
	}
}

function fixFlowGraph()
{
	$(".expert_only").show();
	$("._jsPlumb_endpoint").show();
	
	if(task_flow!=0)
	{
		try{	//ugly stuff to force a refresh on jsPlumb that doesn't like to be hidden
			
			var step=addFlowStep();
			task_flow.remove (step.attr("id")); 
			//console.log("removing "+"#ligne_"+step);
			$("#ligne_"+step.attr("id")).remove();
			
		}catch(e){}
		task_flow.repaintEverything (true);
	}
	switchExpertMode();
	//setTimeout(switchExpertMode,500);

}

function refreshPlanning(planning_type,planning_from,planning_to)
{
	var without_workers="";
	
	$.each(workers_out_planning, function(index, value) {
		
		without_workers+=value+'-';
		
	});
	displayLoading();
	sendRequest("get",planning_type+"&planning_from="+planning_from+"&planning_to="+planning_to+"&without_workers="+without_workers,REQUEST_ABORTABLE,"Récupération du planning général");	
}

function claimRefresh()
{
	$('#refresh_button').pulsate({reach:50,pause:500,color:"#09f"});
}

function fixDelay(elem,id_etape)
{
	var id_bdd=$(elem).parent("div").attr("notification");
	var id_notif=$(elem).parent("div").attr("id_notif");
	sendRequest("get","quick_fix_delay&id_etape="+id_etape,REQUEST_HIDDEN,"Quick fix delay");
	removeNotification(id_notif,id_bdd);
}

function updateTrField(field_id)
{
	var edit_field_height=$('#edit_'+field_id).height();
	var read_field_height=$('#readonly_'+field_id).height();
	var tr_height=Math.max(edit_field_height, read_field_height);
	$('#tr_'+field_id).height(tr_height+5);
}

function setCheckAll(elem_type,check)
{
	$( "#"+elem_type+" > option" ).each(function (index,elem){
		if(check==true)
		{
			$(this).prop('selected', 'selected');
		}
		else
		{
			$(this).prop('selected', '');
		}
	});
	 $("#"+elem_type).trigger('chosen:updated');
}

function switchChecked(elem)
{
	if($('input[name='+elem+']').prop('checked')==true)
	{
		$('input[name='+elem+']').prop('checked', '');
		$('#span_'+elem).removeClass("ui-state-focus");
		$('#span_'+elem).addClass("ui-state-default");
	}
	else
	{
		$('input[name='+elem+']').prop('checked', 'checked');
		$('#span_'+elem).removeClass("ui-state-default");
		$('#span_'+elem).addClass("ui-state-focus");
	}
}

/**here is the system that manages page navigation according to hashtag
On a page that only use http request and is never refreshed, the previous/forward function cannot work properly.
In order to emulate this behavior, I'm using hash tags: when you modify a hash tag, it is added to the page history.
So all you have to do is to detect these changes and according to them, make the http request you need.**/
	  

function popHandler_(e) {
  parent.pops && parent.pops.push(e);
  parent.events && parent.events.push('popstate');
  display_(e.state);
}

function hashChangeHandler_(e) {
  parent.hashChanges && parent.hashChanges.push(e);
  parent.events && parent.events.push('hashchange');
  display_(location.hash);
}
/**
 * Note: history back/forward don't behave like the browser controls in IE.
 * They always force a reload, even if they are just navigating a hash change.
 *
 * So it's impossile to test IE's history navigation behavior. This should
 * probably mean IE just fails all of these tests, but I'm putting in a cheat.
 * The hashchange_back_forward test verifies the specific behavior and fails
 * for IE as expected.
 */
 


function loadHandler_(e) {
  parent.loads && parent.loads.push(e);
  parent.events && parent.events.push('load');

  //display_(location.href);
}

var filter_workers="";
var filter_projects="";
var filter_authors="";
var filter_statuts="";
var filter_tags="";
var filter_task_tags="";
var filter_milestones="";
var filter_deadlines="";

var tri="priorite desc";

function setTri(new_tri)
{
	if(new_tri==0)
	{
		tri="priorite desc";
		$('#icon_tri_priorite').addClass('ui-state-active');
		$('#icon_tri_date').removeClass('ui-state-active');
	}
	else
	{
		tri="date_derniere_modif desc";
		$('#icon_tri_date').addClass('ui-state-active');
		$('#icon_tri_priorite').removeClass('ui-state-active');
	}
	setTimeout(function(){refreshPage();},100);
}

function cancelFilters()
{
	filter_workers="";
	filter_projects="";
	filter_authors="";
	filter_statuts="";
	filter_tags="";
	filter_task_tags="";
	filter_milestones="";
	filter_deadlines="";
	current_menu="";
	display_(window.location.hash);
}

function resetFilters()
{
	var workers=new Array();
	$( "#filterworker > option" ).each( 
		function(index) {
			if($(this).is(':selected'))
			{
				var field_value=$( this ).attr( "value" );
				workers.push(field_value);
			}
		});
	filter_workers=workers.toString();
	var projects=new Array();
	$( "#filterproject > option" ).each( 
		function(index) {
			if($(this).is(':selected'))
			{
				var field_value=$( this ).attr( "value" );
				projects.push(field_value);
			}
		});
	filter_projects=projects.toString();
	var authors=new Array();
	$( "#filterauthor > option" ).each( 
		function(index) {
			if($(this).is(':selected'))
			{
				var field_value=$( this ).attr( "value" );
				authors.push(field_value);
			}
		});
	filter_authors=authors.toString();
	var statuts=new Array();
	$( "#filterstatut > option" ).each( 
		function(index) {
			if($(this).is(':selected'))
			{
				var field_value=$( this ).attr( "value" );
				statuts.push(field_value);
			}
		});
	filter_statuts=statuts.toString();
	var tags=new Array();
	$( "#filtertag > option" ).each( 
		function(index) {
			if($(this).is(':selected'))
			{
				var field_value=$( this ).attr( "value" );
				tags.push(field_value);
			}
		});
	filter_tags=tags.toString();
	var task_tags=new Array();
	$( "#filtertask_tag > option" ).each( 
		function(index) {
			if($(this).is(':selected'))
			{
				var field_value=$( this ).attr( "value" );
				task_tags.push(field_value);
			}
		});
	filter_task_tags=task_tags.toString();
	var milestones=new Array();
	$( "#filtermilestone > option" ).each( 
		function(index) {
			if($(this).is(':selected'))
			{
				var field_value=$( this ).attr( "value" );
				milestones.push(field_value);
			}
		});
	filter_milestones=milestones.toString();
	var deadlines=new Array();
	$( "#filterdeadline > option" ).each( 
		function(index) {
			if($(this).is(':selected'))
			{
				var field_value=$( this ).attr( "value" );
				deadlines.push(field_value);
			}
		});
	filter_deadlines=deadlines.toString();
	current_menu="";
	display_(window.location.hash);
}

var current_page="";
var current_menu="";
var current_elem="";
var current_sub_elem="";

var current_loading=null;


function updatePage(content,js,page_part,ignore_error)
{
	//var loading_img=$("#"+page_part)[0].attributes.processing_img.value;
	var is_loading_img_visible=false;
	var loading_img=$("#"+page_part).attr("processing_img");
	if(loading_img)
	{
		if(current_loading)
			current_loading.stop();
		is_loading_img_visible=$("#"+loading_img).is(':visible');
	}
	if(is_loading_img_visible)
	{
		current_loading=$("#"+loading_img).hide(
			{
				duration:500,
				complete:function()
				{
					$("#"+page_part).html(content);
					//var current_date=new Date();
					//var start_time=current_date.getTime();
					evalJs(js,ignore_error);
					//current_date=new Date();
					//console.log("time elapsed="+(current_date.getTime()-start_time));
				}
			}
		);
	}
	else
	{
		$("#"+page_part).html(content);
		evalJs(js,ignore_error);
	}
	
	
}

function evalJs(js,ignore_error)
{
	try
	{
		eval(js);
	}
	catch(e)
	{
		if(!ignore_error)
		{
			displayError(e);
			displayError(js);
			throw(e);
		}
	}
}

function refreshPage()
{
	current_page="";
	current_menu="";
	current_elem="";
	current_sub_elem="";
	displayLoading();
	display_(window.location.hash);
}

function displayError(error_text)
{
	//alert(error_text);
	$('#bas_page').html($('#bas_page').html()+'<br>'+error_text);
	//var pulsate={effect:"pulsate",times:6};
	$('#bas_page').css("z-index:1000");
	//var highlight={effect:"highlight",duration:1000,queue:false,color:"red"};
	$("#bas_page").pulsate({reach:100, color:'#ff0000',glow:true,repeat:10 });
	//$('#bas_page').effect( pulsate);
	//$('#bas_page').effect( highlight);
	$(document.body).scrollTo("max",500);
}

var copy_task=0;

function copyTask(id_tache)
{
	copy_task=id_tache;
	document.location.href="#taches/menu8";
}

function display_(text) { //function called whenever the hash tag is changed, with the current adress in parameter. According to it, display the requested windows.
  try {
	//document.getElementById('debug').innerHTML += '<p>--' + text + '--</p>';
	
	if(text)
	{
		//showDialog("toto1",text,true);
		//showDialog("toto2",text,true);
		
		if(checkGoTo(text)==false)
		{
			return false;
		}
		//addNotification(text,0); 
		
		
		var menu_tree=window.location.hash.split("/");
		var page=menu_tree[0];
		var menu="";
		var elem="";
		var sub_elem="";
		if(menu_tree.length>1)
			menu=menu_tree[1];
		if(menu_tree.length>2)
			elem=menu_tree[2];
		if(menu_tree.length>3)
			sub_elem=menu_tree[3];
		removeErrorFields();
		if(page!=current_page)
		{
			if(page=="#taches")
			{
				$( "#menu_content").html("");
				
				addMenu("menu1",'<span localized="1" id="ltext_menu_task_pending">'+getLocText('ltext_menu_task_pending')+'</span><div id="amount_pending" class="amount_stage ui-state-default ui-corner-top ui-droppable small_text"></div>');
				addMenu("menu2",'<span localized="1" id="ltext_menu_task_todo">'+getLocText('ltext_menu_task_todo')+'</span><div id="amount_todo" class="amount_stage ui-state-default ui-corner-top ui-droppable small_text"></div>');
				addMenu("menu3",'<span localized="1" id="ltext_menu_task_wip">'+getLocText('ltext_menu_task_wip')+'</span><div id="amount_wip" class="amount_stage ui-state-default ui-corner-top ui-droppable small_text"></div>');
				
				
				addMenu("menu4",'<span localized="1" id="ltext_menu_task_complete">'+getLocText('ltext_menu_task_complete')+'</span><div id="amount_complete" class="amount_stage ui-state-default ui-corner-top ui-droppable small_text"></div>');
				addMenu("menu5",'<span localized="1" id="ltext_menu_task_all">'+getLocText('ltext_menu_task_all')+'</span>');
				addMenu("menu6",'<span localized="1" id="ltext_menu_task_favorite">'+getLocText('ltext_menu_task_favorite')+'</span>');
				addMenu("menu7",'<span localized="1" id="ltext_menu_task_search">'+getLocText('ltext_menu_task_search')+'</span>');
				addMenu("menu8",'<span localized="1" id="ltext_menu_add_task">'+getLocText('ltext_menu_add_task')+'</span>');
				
				refreshMenus('0');
				
				setDroppableMenu("menu3","start_task");
				setDroppableMenu("menu2","pause_task");
				setDroppableMenu("menu4","finish_task");
				setDroppableMenu("menu8","copy_task");
				
			}
			else if(page=="#projets")
			{
				$( "#menu_content").html("");
				
				addMenu("menu1",'<span localized="1" id="ltext_menu_project_wip">'+getLocText('ltext_menu_project_wip')+'</span>');
				addMenu("menu2",'<span localized="1" id="ltext_menu_project_complete">'+getLocText('ltext_menu_project_complete')+'</span>');
				addMenu("menu3",'<span localized="1" id="ltext_menu_project_planning">'+getLocText('ltext_menu_project_planning')+'</span>');
				addMenu("menu4",'<span localized="1" id="ltext_menu_project_weekly">'+getLocText('ltext_menu_project_weekly')+'</span>');
				addMenu("menu5",'<span localized="1" id="ltext_menu_project_add">'+getLocText('ltext_menu_project_add')+'</span>');
				
				setDroppableMenu("menu1","reopen_project");
				setDroppableMenu("menu2","close_project");
				
				
				refreshMenus('1');
				
			}
			else if(page=="#team")
			{
				$( "#menu_content").html("");
				
				addMenu("menu1",'<span localized="1" id="ltext_menu_team_active_members">'+getLocText('ltext_menu_team_active_members')+'</span>');
				addMenu("menu2",'<span localized="1" id="ltext_menu_team_old_members">'+getLocText('ltext_menu_team_old_members')+'</span>');
				addMenu("menu3",'<span localized="1" id="ltext_menu_team_holidays">'+getLocText('ltext_menu_team_holidays')+'</span>');
				addMenu("menu4",'<span localized="1" id="ltext_menu_team_distribution">'+getLocText('ltext_menu_team_distribution')+'</span>');
				addMenu("menu5",'<span localized="1" id="ltext_menu_team_overview">'+getLocText('ltext_menu_team_overview')+'</span>');
				addMenu("menu6",'<span localized="1" id="ltext_menu_team_add_member">'+getLocText('ltext_menu_team_add_member')+'</span>');
				
				setDroppableMenu("menu1","rehire_worker");
				setDroppableMenu("menu2","end_worker");
				
				refreshMenus('2');
			}
			else if(page=="#agora")
			{
				$( "#menu_content").html("");
				
				addMenu("menu1",'<span localized="1" id="ltext_menu_agora_room1">'+getLocText('ltext_menu_agora_room1')+'</span>');
				addMenu("menu2",'<span localized="1" id="ltext_menu_agora_room2">'+getLocText('ltext_menu_agora_room2')+'</span>');
				addMenu("menu3",'<span localized="1" id="ltext_menu_agora_room3">'+getLocText('ltext_menu_agora_room3')+'</span>');
				
				refreshMenus('5');
			}
			else if(page=="#admin")
			{
				$( "#menu_content").html("");
				
				addMenu("menu1",'<span localized="1" id="ltext_menu_admin_global_data">'+getLocText('ltext_menu_admin_global_data')+'</span>');
				addMenu("menu2",'<span localized="1" id="ltext_menu_admin_operations">'+getLocText('ltext_menu_admin_operations')+'</span>');
				addMenu("menu3",'<span localized="1" id="ltext_menu_admin_about">'+getLocText('ltext_menu_admin_about')+'</span>');
				
				refreshMenus('3');
			}
			else if(page=="#tools")
			{
				$( "#menu_content").html("");
				
				addMenu("menu1","Maps TM2");
				addMenu("menu2","Cutscenes TM2");
				addMenu("menu3","Cutscenes SMU");
				
				refreshMenus('4');
			}
		}
		
		var just_closing_a_menu=false;
		if(page==current_page && menu==current_menu && elem==current_elem && current_sub_elem!="" &&  sub_elem=='')
		{
			just_closing_a_menu=true;
		}
		if(!just_closing_a_menu)
		{
			if(page=="#taches")
			{
				var num_menu=menu.replace("menu", "");
				if(menu!=current_menu)
					selected_tasks=[];
				$( "#tabs").tabs({ active: (num_menu-1) });
				//$("#content_page").html(text);
				if(num_menu=="1" || num_menu=="2" || num_menu=="3" || num_menu=="4"|| num_menu=="5" || num_menu=="6")
				{
					var statut_tache=0;
					switch(num_menu)
					{
						case "1":statut_tache=STAGE_STANDBY;break;
						case "2":statut_tache=STAGE_TODO;break;
						case "3":statut_tache=STAGE_WIP;break;
						case "4":statut_tache=STAGE_DONE;break;
						case "5":statut_tache="all";break;
						case "6":statut_tache="favorite";break;
						default:displayError("Menu inconnu : "+num_menu);
					}
					
					if(current_menu!=menu || current_page!=page)
					{
						displayLoading();
						sendRequest("get","get_task_list="+statut_tache+"&active_task="+elem+"&active_info="+sub_elem+"&filter_workers="+filter_workers+"&filter_projects="+filter_projects+"&tri="+tri+"&filter_tags="+filter_tags+"&filter_task_tags="+filter_task_tags+"&filter_milestones="+filter_milestones+"&filter_deadlines="+filter_deadlines,REQUEST_ABORTABLE,"Récupération de la liste des tâches");
						updateStageCounts();
					}
					else if(elem!="")
					{
						scrollToActiveItem("tache_list",elem);
						
						if(sub_elem=="")
						{
							sub_elem="info0";
						}
						openActiveTab(elem,sub_elem);
						displayLoading(sub_elem+'_'+elem);
						sendRequest("get","get_task_"+sub_elem+"&tache="+elem,REQUEST_ABORTABLE,"Récupération des informations de la tâche");
						//setTimeout(function(){$('#content_page').scrollTo('+=200', { axis:'y' });},5000);
					}
				}
				else if(num_menu=="7")
				{
					if(current_menu!=menu || current_page!=page)
					{
						displayLoading();
						sendRequest("get","get_all_task_list&filter_workers="+filter_workers+"&filter_projects="+filter_projects+"&filter_authors="+filter_authors+"&filter_statuts="+filter_statuts+"&filter_tags="+filter_tags+"&filter_task_tags="+filter_task_tags+"&filter_milestones="+filter_milestones+"&filter_deadlines="+filter_deadlines,REQUEST_ABORTABLE,"Récupération de la liste des tâches");
					}
				}
				else if(num_menu=="8")
				{
					displayLoading();
					var add_create_parameters='';
					if(copy_task>0)
					{
						add_create_parameters='&copy_task='+copy_task;
						copy_task=0;
					}
					initTaskFlow();
					sendRequest("get","get_add_task_form"+add_create_parameters,REQUEST_ABORTABLE,"Récupération du formulaire d'ajout de tâches");
				}
				else if(menu=="display")
				{
					
					$( "#tabs").tabs({ active: 4 });
					displayLoading();
					sendRequest("get","get_task_list=unique&active_task="+elem+"&active_info="+sub_elem+"&filter_workers=&filter_projects=",REQUEST_ABORTABLE,"Récupération de la liste des tâches");
					
				}
				refreshMenus('0');
			}
			else if(page=="#projets")
			{
				
				var num_menu=menu.replace("menu", "");
				$( "#tabs").tabs({ active: (num_menu-1) });
				//$("#content_page").html(text);
				if(num_menu=="1" || num_menu=="2")
				{
					var type_projet=num_menu-1;
					if(current_menu!=menu || current_page!=page)
					{
						displayLoading();
						sendRequest("get","get_project_list="+type_projet+"&active_project="+elem+"&active_info="+sub_elem,REQUEST_ABORTABLE,"Récupération de la liste des projets");
					}
					else if(elem!="")
					{
						scrollToActiveItem("projet_list",elem);
						
						if(sub_elem=="")
						{
							sub_elem="info0";
						}
						
						openActiveTab(elem,sub_elem);
						displayLoading(sub_elem+'_'+elem);
						sendRequest("get","get_project_"+sub_elem+"&projet="+elem,REQUEST_ABORTABLE,"Récupération des informations du projet");
						
					}
					
				}
				else if(num_menu=="3")
				{
					$("#content_page").html('');
					displayLoading();
					sendRequest("get","get_project_planning",REQUEST_ABORTABLE,"Récupération du planning général");		
				}
				else if(num_menu=="4")
				{
					$("#content_page").html('');
					displayLoading();
					sendRequest("get","get_weekly_view",REQUEST_ABORTABLE,"Récupération du semainier");		
				}
				else if(num_menu=="5")
				{
					if(current_menu!=menu)
					{
						displayLoading();
						sendRequest("get","get_add_project_form",REQUEST_ABORTABLE,"Récupération du formulaire d'ajout de projet");
					}
					
				}
				
				
			}
			else if(page=="#team")
			{
				var num_menu=menu.replace("menu", "");
				$( "#tabs").tabs({ active: (num_menu-1) });
				//$("#content_page").html(text);
				if(num_menu=="1" || num_menu=="2")
				{
					var only_active_workers=1;
					if(num_menu=="2")
						only_active_workers=0;
					if(current_menu!=menu || current_page!=page)
					{
						displayLoading();
						sendRequest("get","get_member_list="+only_active_workers+"&active_worker="+elem+"&active_info="+sub_elem,REQUEST_ABORTABLE,"Récupération de la liste des membres");
					}
					else if(elem!="")
					{
						scrollToActiveItem("worker_list",elem);
						
						if(sub_elem=="")
						{
							sub_elem="info0";
						}
						
						openActiveTab(elem,sub_elem);
						displayLoading(sub_elem+'_'+elem);
						sendRequest("get","get_worker_"+sub_elem+"&worker="+elem,REQUEST_ABORTABLE,"Récupération des informations du membre");
						
					}
					
				}
				else if(num_menu=="3")
				{
					displayLoading();
					sendRequest("get","get_next_holidays",REQUEST_ABORTABLE,"Récupération des prochaines vacances");
				}
				else if(num_menu=="4")
				{
					displayLoading();
					sendRequest("get","get_team_planning",REQUEST_ABORTABLE,"Récupération du planning des équipes");
				}
				else if(num_menu=="5")
				{
					displayLoading();
					sendRequest("get","get_team_overview",REQUEST_ABORTABLE,"Récupération de la team overview");
				}
				else if(num_menu=="6")
				{
					displayLoading();
					sendRequest("get","get_add_member_form",REQUEST_ABORTABLE,"Récupération du formulaire d'ajout de membre");
				}
				
				
			}
			else if(page=="#agora")
			{
				var num_menu=menu.replace("menu", "");
				$( "#tabs").tabs({ active: (num_menu-1) });
				
				if(current_menu!=menu || current_page!=page)
				{
					displayLoading();
					sendRequest("get","get_chat_room="+num_menu,REQUEST_ABORTABLE,"Récupération de la chat room");
				}				
			}
			else if(page=="#admin")
			{
				var num_menu=menu.replace("menu", "");
				$( "#tabs").tabs({ active: (num_menu-1) });
				if(num_menu=="1")
				{
					if(current_menu!=menu || current_page!=page)
					{
						displayLoading();
						sendRequest("get","get_global_datas_list&menu="+elem,REQUEST_ABORTABLE,"Récupération de la liste des données globales");
					}
					else if(elem!="")
					{
						scrollToActiveItem("global_datas_list",elem);
						if(sub_elem=="")
						{
							sub_elem="info0";
						}
						
						openActiveTab(elem,sub_elem);
						displayLoading(sub_elem+'_'+elem);
						sendRequest("get","get_"+elem+"_"+sub_elem,REQUEST_ABORTABLE,"Récupération des informations des données globales");
						
					}
				}
				else if(num_menu=="2")
				{
					if(current_menu!=menu || current_page!=page)
					{
						displayLoading();
						sendRequest("get","get_operations_list&menu="+elem,REQUEST_ABORTABLE,"Récupération de la liste des opérations");
					}
					else if(elem!="")
					{
						scrollToActiveItem("operations_list",elem);
						
						if(sub_elem!="")
						{
							openActiveTab(elem,sub_elem);
							displayLoading(sub_elem+'_'+elem);
							sendRequest("get","get_"+elem+"_"+sub_elem,REQUEST_ABORTABLE,"Récupération des informations des opérations");
						}
					}
				}
				else if(num_menu=="3")
				{
					displayLoading();
					sendRequest("get","get_credits",REQUEST_ABORTABLE,"Récupération des crédits");
				}
			}
			else if(page=="#tools")
			{
				var num_menu=menu.replace("menu", "");
				$( "#tabs").tabs({ active: (num_menu-1) });
				if(num_menu=="1")
				{
					if(current_menu!=menu || current_page!=page)
					{
						displayLoading();
						sendRequest("get","get_map_list&menu="+elem,REQUEST_ABORTABLE,"Récupération de la liste des maps");
					}
					else if(elem!="")
					{
						scrollToActiveItem("map_list",elem);
						if(sub_elem=="")
						{
							sub_elem="info0";
						}
						
						openActiveTab(elem,sub_elem);
						displayLoading(sub_elem+'_'+elem);
						sendRequest("get","get_map&map="+elem,REQUEST_ABORTABLE,"Récupération des informations des maps");
						
					}
				}
				else if(num_menu=="2")
				{
					if(current_menu!=menu || current_page!=page)
					{
						displayLoading();
						sendRequest("get","get_cutscene_list&menu="+elem,REQUEST_ABORTABLE,"Récupération de la liste des cutscenes");
					}
					else if(elem!="")
					{
						scrollToActiveItem("cutscene_list",elem);
						
						if(sub_elem!="")
						{
							openActiveTab(elem,sub_elem);
							displayLoading(sub_elem+'_'+elem);
							sendRequest("get","get_cutscene_"+sub_elem,REQUEST_ABORTABLE,"Récupération des informations des cutscenes de TM2");
						}
					}
				}
				else if(num_menu=="3")
				{
					if(current_menu!=menu || current_page!=page)
					{
						displayLoading();
						sendRequest("get","get_cutscene_list_smu&menu="+elem,REQUEST_ABORTABLE,"Récupération de la liste des cutscenes de SMU");
					}
					
				}
			}
			
			if(page=="#taches" && menu!="menu8" && menu!="menu6" && menu!="display")
			{
				if(!$("#filtres").is(':visible'))
					$( "#filtres").toggle("fade");
			}
			else
			{
				if($("#filtres").is(':visible'))
					$( "#filtres").toggle("fade");
			}
			
			if(page=="#agora")
				document.title="Agora";
			else
				document.title="Magic Projects";
		}
		
		current_page=page;
		current_menu=menu;
		current_elem=elem;
		current_sub_elem=sub_elem;
		
	}
  } catch(e) {
	displayError(e);
	throw(e);
  }
}

function goToPage(event,nom_page)
{
	//alert(window.location.hash);
	
	if(checkGoTo('#'+nom_page)==true)
	{
		var default_menu="menu1";
		if(nom_page=="taches")
			default_menu="menu3";
		document.location.href='#'+nom_page+"/"+default_menu;
		return true;
	}
	event.stopPropagation();
	return false;
}

function goToMenu(event,nom_menu)
{
	//alert(window.location.hash);
	
	if(checkGoTo('#'+nom_menu)==true)
	{
		if(nom_menu=="menu7" && current_page=="#taches")
		{
			filter_workers='';
			filter_projects='';
			filter_authors='';
			filter_status='';
		}
		
		var menu_tree=window.location.hash.split("/");
		if(current_page!=menu_tree[0] || current_menu!=nom_menu)
		{
			var location=menu_tree[0]+'/'+nom_menu;
			document.location.href=location;
			return true;
		}
	}
	event.stopPropagation();
	return false;
}

function scrollToActiveItem(list_name,elem)
{
	//setTimeout(function(){console.log('tabs '+elem+ ' refresh');$( '#tabs'+elem).tabs( "option", "heightStyle", "auto" );$('#tabs'+elem).tabs( 'refresh' );},2000);
	var widget= $( "#"+list_name ).accordion( "widget" );
	var active = $( "#"+list_name ).accordion( "option", "active" );
	var childs=widget.children("h3");
	//console.log(childs.length);
	for(i=0;i<childs.length;i++)
	{	
		//console.log(elem+"-"+childs[i].id+"-"+i+"-"+active);
		if(elem==childs[i].id && i!=active)
		{
			$( "#"+list_name ).accordion({ active: false });
			setTimeout(function(){$('.content_page').scrollTo('#'+elem,1000,{onAfter:function(){$( "#"+list_name ).accordion( "option", "active", i );}});/*console.log("scroll to "+elem);*/},500);
			//setTimeout(function(){$('#content_page').scrollTo('#'+elem,2000);console.log("scrollto");},500);
			//setTimeout(function(){$('#content_page').scrollTo('+=200', { axis:'y' });alert("scrollto");},5000);
			break;
		}
	}
}

function openActiveTab(elem,sub_elem)
{
	var num_sub_elem=sub_elem.replace("info", "");
	var active = $( "#tabs"+elem ).tabs( "option", "active" );
	if(active!=num_sub_elem)
	{
		$( "#tabs"+elem).tabs({ active: (num_sub_elem) });
		$( "#tabs"+elem ).tabs("refresh");
	}
}

function setPageElement(elem_id)
{
	var menu_tree=window.location.hash.split("/");
	var location='';
	if(current_elem==elem_id && current_menu!="display")//on ferme le panneau dans ce cas
		location=menu_tree[0]+'/'+menu_tree[1];
	else
		location=menu_tree[0]+'/'+menu_tree[1]+'/'+elem_id+'/info0';
	document.location.href=location;
}

function setPageSubElement(elem_id)
{
	var menu_tree=window.location.hash.split("/");
	var location=menu_tree[0]+'/'+menu_tree[1]+'/'+menu_tree[2]+'/'+elem_id;
	document.location.href=location;
}

function checkGoTo(nom_page)
{
	for(i=0;i<requests.length;i++)
	{
		if(requests_complete[i]==false)
		{
			if(requests_abort[i]==REQUEST_UNABORTABLE)
			{
				var message=ltexts['ltext_request_unabortable'].replace('[X]',requests_description[i]);
				showDialog(ltexts['ltext_request_unabortable_title'],message,false);
				try
				{
					$(nom_page).removeClass("ui-tabs-active ui-state-active");
					$(current_menu).addClass("ui-tabs-active ui-state-active");
				}catch(e){}
				return false;
			}
			else if(requests_abort[i]==REQUEST_CAN_BE_ABORTED)
			{
				var message=ltexts['ltext_request_can_be_aborted'].replace('[X]',requests_description[i]);
				var abort_request=confirm(message);
				if(abort_request)
				{
					requests[i].abort();
					requests_complete[i]=true;
				}
				else
				{
					try
					{
						$(nom_page).removeClass("ui-tabs-active ui-state-active");
						$(current_menu).addClass("ui-tabs-active ui-state-active");
					}catch(e){}
					return false;
				}
			}
			else if(requests_abort[i]!=REQUEST_HIDDEN)
			{
				requests[i].abort();
				requests_complete[i]=true;
			}
		}
	}
	return true;
}

function displayLoading(page_part)
{
	if(!page_part)
		page_part="content_page";
	$('#'+page_part).wrapInner('<div id="content_disabled"></div>');
	$('#content_disabled').addClass("ui-state-disabled");
	$('#'+page_part).prepend('<div id="loading_img" style="position:fixed;z-index:55;width:80%;height:80%;">	<div style="position:relative;left:40px;top:20px;"><img src="img/spinner.gif"><br></div></div>');
	//$('#content_page').html('<img id="loading_img" src="img/spinner.gif">');
}

function refreshMenus(main_menu_selected)
{
	$( "#tabs" ).tabs("refresh");
	//$( "#tabs" ).tabs( "option", "show", { effect: "blind", duration: 800 } );
	setCheckedValue(document.forms['form_main_menu'].elements['radio'],main_menu_selected);
	$( "#main_menu_buttons" ).buttonset("refresh");
}

function addMenu(menu_id,menu_name)
{
	$( "#menu_content").html($( "#menu_content").html()+'<li id="'+menu_id+'" onclick="goToMenu(event,\''+menu_id+'\')"><toto></toto><a href="#content_page" ><textmenu>'+menu_name+'</textmenu></a></li>');
	
}

function setDroppableMenu(menu_id,drop_action)
{
	$( "#"+menu_id ).droppable({
		activeClass: "menu_droppable_activate",
		hoverClass:"menu_droppable_over",
		tolerance: "pointer",
		accept:".draggable_task",
		over: function( event, ui ) {
			//$( this ).addClass("menu_droppable_over");
		},
		out: function( event, ui ) {
			//$( this ).removeClass("menu_droppable_over");
		},
		drop: function(event, ui) {
			event.stopPropagation();
			event.preventDefault();
			var drop_id=ui.draggable[0].id;
			$( "#"+drop_id ).draggable( "option", "revert", false );
			var accordeon='#projet_list';
			if(current_page=="#taches")
			{
				accordeon='#tache_list';
			}
			else if(current_page=="#team")
			{
				accordeon='#worker_list';
			}
			$(accordeon).accordion({ active: false });
			
			var pulsate_color='#0000ff';
			if(drop_action=="close_project")
			{
				$( "#"+drop_id ).effect( "drop", {direction:"right"} );
				sendRequest("get","set_project_statut=1&projet="+drop_id,REQUEST_CAN_BE_ABORTED,"Changement de statut d'un projet");
			}
			else if(drop_action=="reopen_project")
			{
				$( "#"+drop_id ).effect( "drop", {direction:"right"} );
				sendRequest("get","set_project_statut=0&projet="+drop_id,REQUEST_CAN_BE_ABORTED,"Changement de statut d'un projet");
			}
			else if(drop_action=="end_worker")
			{
				$( "#"+drop_id ).effect( "drop", {direction:"right"} );
				sendRequest("get","set_worker_activity=0&worker="+drop_id,REQUEST_CAN_BE_ABORTED,"Changement de statut d'un membre");
			}
			else if(drop_action=="rehire_worker")
			{
				$( "#"+drop_id ).effect( "drop", {direction:"right"} );
				sendRequest("get","set_worker_activity=1&worker="+drop_id,REQUEST_CAN_BE_ABORTED,"Changement de statut d'un membre");
			}
			else if(drop_action=="start_task")
			{
				sendRequest("get","set_stage_statut="+STAGE_WIP+"&tache="+drop_id+"&multi="+selected_tasks.toString(),REQUEST_HIDDEN,"Changement de statut d'une tâche");
			}
			else if(drop_action=="pause_task")
			{
				sendRequest("get","set_stage_statut="+STAGE_TODO+"&tache="+drop_id+"&multi="+selected_tasks.toString(),REQUEST_HIDDEN,"Changement de statut d'une tâche");
			}
			else if(drop_action=="finish_task")
			{
				sendRequest("get","set_stage_statut="+STAGE_DONE+"&tache="+drop_id+"&multi="+selected_tasks.toString(),REQUEST_HIDDEN,"Changement de statut d'une tâche");
				pulsate_color='#00ff00';
			}
			else if(drop_action=="copy_task")
			{
				$( "#"+drop_id ).effect( "drop", {direction:"right"} );
				var id_tache=drop_id.replace('tache','');
				copyTask(id_tache);
			}
			setTimeout(function(){$( "#"+menu_id).pulsate({reach:50, color:pulsate_color,glow:true,repeat:1 });},200);
		}
	});
}

function setDroppableItem(item_id)
{
	$( "#"+item_id ).droppable({
		activeClass: "item_droppable_activate",
		hoverClass:"item_droppable_over",
		tolerance: "pointer",
		accept:".draggable_task",
		
		drop: function(event, ui) {
			var drop_id=ui.draggable[0].id;
			var drop_y=$("#"+drop_id).offset().top;
			var menu1_y=$("#menu1").offset().top;
			if(drop_y>menu1_y)//dirty fix pour éviter qu'une tâche qu'on droppe sur les menus "tâche en cours..." soit aussi positionnée sur une tâche parce que l'on a fait défilé l'ascenseur et qu'elles sont derrières ce menu (et du coup, le programme croit que l'on veut aussi changer sa priorité)
			{
				$( "#"+drop_id ).draggable( "option", "revert", false );
				$( "#"+drop_id ).effect( "drop", {direction:"right"} );
				var id_current_etape=ui.draggable.attr("id_current_etape");
				var new_priorite=parseInt($("#"+item_id ).attr("priorite"))+1;
				setStagePriority(id_current_etape,new_priorite);
			}
		}
		
	});
}

function execOnEnter(elem,code)//when enter key is pressed on the elem, code is performed
{
	$("#"+elem).keypress(function(e) {
		if (e.which == 13) {
			eval(code);
		}
		});
}

function updateStageCounts()
{
	sendRequest("get","update_stage_counts&filter_workers="+filter_workers+"&filter_projects="+filter_projects+"&filter_tags="+filter_tags+"&filter_task_tags="+filter_task_tags+"&filter_milestones="+filter_milestones+"&filter_deadlines="+filter_deadlines,REQUEST_HIDDEN,"Mise à jour des compteurs d'étapes");
}

var selected_tasks=[];

function setMultiSelection(id_tache)
{
	var index_tache=selected_tasks.indexOf(id_tache);
	if(index_tache>=0)
	{
		selected_tasks.splice(index_tache,1);
		$("#tache"+id_tache).removeClass("ui-state-highlight");
	}
	else
	{
		$("#tache"+id_tache).addClass("ui-state-highlight");
		selected_tasks.push(id_tache);
	}
	//console.log(selected_tasks);
}

function getSelectedTasks(id_tache)
{
	var res="";
	var index_tache=selected_tasks.indexOf(id_tache);
	if(index_tache<0)
		selected_tasks.push(id_tache);
	var i=0;
	for(i=0;i<selected_tasks.length;i++)
	{
		var tache=$("#tache"+selected_tasks[i]).attr("shortname");
		res+="<div class='ui-widget ui-state-default ui-corner-all' style='min-width:50px;min-height:50px;padding:5px;text-align:center;z-index:1000'>"+tache+"</div>"
	}
	res='<div>'+res+'</div>';
	//console.log(res);
	return $(res).appendTo('body');
}

function handleCurrentTask(id_tache)
{
	var checkbox=$("#multiselect_tache"+id_tache);
	if(!checkbox.is(':checked'))
	{
		var index_tache=selected_tasks.indexOf(id_tache);
		if(index_tache>=0)
			selected_tasks.splice(index_tache,1);
	}
	//console.log(selected_tasks);
}

function addChatMessage(id_room)
{
	var message=encodeURIComponent($("#chat_room_input_"+id_room).val());
	$("#chat_room_input_"+id_room).val("");
	sendRequest("post","add_chat_message=1&id_room="+id_room+"&message="+message,REQUEST_CAN_BE_ABORTED,"Ajout d'un message dans le forum");
}

function updateChatRoom(id_room,quick_load)
{
	var timeout=5000;
	if(quick_load)
		timeout=1000;
	else
		quick_load=0;
	if(current_page=="#agora" && current_menu=="menu"+id_room)
		setTimeout(function(){sendRequest("get","update_chat_room="+id_room+"&quick_load="+quick_load,REQUEST_HIDDEN,"Update du forum");},timeout);
}

function addChatNotification(author,message)
{
	if(window_has_focus==0)
	{
		//alert(html_entity_decode(message));
		var title=ltexts['ltext_notif_chat'].replace('[X]',author);
		var myNotification = new Notify(title, {
			body: strip_tags(html_entity_decode(message,'ENT_QUOTES')),
			notifyShow: onNotifyShow,
			notifyClose: onNotifyClose,
			notifyClick: onNotifyClick,
			icon:'img/info_done.png',
			tag:'chat',
			timeout:60,
		});
		myNotification.show();
	}
}

function onNotifyShow() {
	//console.log('notification was shown!');
}

function onNotifyClose() {
	//console.log('notification was closed!');
	stop_blinking=1;
}

function onNotifyClick() {
	//console.log('notification was clicked!');
	stop_blinking=1;
}


function updatePeopleRoom(id_room,id_worker,nom_worker,new_color)
{
	if(current_page=="#agora" && current_menu=="menu"+id_room)
	{
		if($( "#worker"+id_worker).length==0)
		{
			$("#chat_room_people_"+id_room).append('<div class="ui-widget" style="float:left;margin-right:5px;"><span accept_tooltip="1" title="'+ltexts['ltext_agora_invite']+'" id="worker'+id_worker+'" class="ui-corner-all small_text fauxlien" is_bouncing="0" onclick="sendChatRoomNotification(this,'+id_worker+','+id_room+');" style="padding-left:2px;padding-right:2px;background-color:white;border:1px solid grey;">'+nom_worker+'</span></div>');
		}
		$( "#worker"+id_worker).animate({color:new_color},1500);
	}
}

function addTextToMessage(id_room,txt)
{
	var current_val=$("#chat_room_input_"+id_room).val();
	$("#chat_room_input_"+id_room).val(current_val+txt);
}

function sendChatRoomNotification(button,id_dest,id_room)
{
	var is_bouncing=$(button).attr("is_bouncing");
	if(is_bouncing==0)
	{
		$(button).attr("is_bouncing",1);
		$(button).effect("highlight");
		$($(button).parent()).effect("bounce",function(){$(button).attr("is_bouncing",0);});
		sendRequest("get","send_chat_room_notification="+id_room+"&id_dest="+id_dest,REQUEST_ABORTABLE,"Envoi de notification");
	}
	
}

var blink_amount=10;
var is_blinking=0;
var stop_blinking=0;

function blink()
{
	if(document.title=="Agora")
		document.title="--------------";
	else
		document.title="Agora";
	blink_amount--;
	if(current_page=="#agora" && stop_blinking==0 && (blink_amount>0 || window_has_focus==0))
		setTimeout(function(){blink();},500);
	else
	{
		if(current_page=="#agora")
			document.title="Agora";
		else
			document.title="Magic Projects";
		is_blinking=0;
		stop_blinking=0;
	}
}

function startBlinking()
{
	if(is_blinking==0)
	{
		blink_amount=10;
		is_blinking=1;
		blink();
	}
	else
		blink_amount=10;
}

function setStagePriority(id_etape,new_priorite,etape_only)
{
	sendRequest("get","set_stage_priorite="+new_priorite+"&id_etape="+id_etape+"&etape_only="+etape_only+"&multi="+selected_tasks.toString(),REQUEST_CAN_BE_ABORTED,"Changement de priorité d'une étape");
}

function setStageSleeping(id_etape,go_to_sleep)
{
	sendRequest("get","set_stage_sleeping="+go_to_sleep+"&id_etape="+id_etape,REQUEST_CAN_BE_ABORTED,"Changement de statut endormi d'une étape");
}

function setColorTask(id_tache,new_color)
{
	if(new_color)
	{
		sendRequest("get","set_tache_color="+new_color+"&id_tache="+id_tache+"&multi="+selected_tasks.toString(),REQUEST_CAN_BE_ABORTED,"Changement de couleur d'une tâche");
	}
}

function editStage(id_stage)
{
	//console.log("editStage");
	if(dragging_stage==0)
		getDialog('edit_task_stage',id_stage);
}

// set the radio button with the given value as being checked
// do nothing if there are no radio buttons
// if the given value does not exist, all the radio buttons
// are reset to unchecked
function setCheckedValue(radioObj, newValue) {
	if(!radioObj)
		return;
	var radioLength = radioObj.length;
	if(radioLength == undefined) {
		radioObj.checked = (radioObj.value == newValue.toString());
		return;
	}
	for(var i = 0; i < radioLength; i++) {
		radioObj[i].checked = false;
		$(radioObj[i]).removeClass( "ui-state-focus" );
		if(radioObj[i].value == newValue.toString()) {
			radioObj[i].checked = true;
		}
	}
}

function initHashHandler()
{
	hashChangeHandler_({});
	if (window.addEventListener) {
	  window.addEventListener('popstate', popHandler_, false);
	} else if (window.attachEvent) {
	  window.attachEvent('onpopstate', popHandler_);
	}

	if (window.addEventListener) {
	  window.addEventListener('load', loadHandler_, false);
	} else if (window.attachEvent) {
	  window.attachEvent('onload', loadHandler_);
	}

	window.onhashchange = hashChangeHandler_;

}

function initDropZone(id_tache,id_etape)	
{
	$('#drop_zone'+id_tache)
		.on('drop', function(event){onDropElement(event,id_tache,id_etape);})
		.on('dragstart', function(event){})
		.on('dragenter', function(event){onDragEnter(event,id_tache,id_etape);})
		.on('dragover', function(event){})
		.on('dragleave', function(event){onDragLeave(event,id_tache,id_etape);});
	/*$('#drop_zone'+id_tache).on('drop', onDropElement);	
	$('#drop_zone'+id_tache).on('dragenter', function(event){onDragEnter(event,id_tache,id_etape);});
	$('#drop_zone'+id_tache).on('dragleave', function(event){onDragLeave(event,id_tache,id_etape);});
	$('#drop_zone'+id_tache).on('drop', function(event){onDragLeave(event,id_tache,id_etape);});*/
	/*var drop_zone_id='#drop_zone'+id_tache;
	$(drop_zone_id).filedrop({
		url: "executor.php?input_user_drop",
		paramname: 'files',
		maxFiles: 5,
		dragOver: function () {
			$(drop_zone_id).css('background', 'blue');
		},
		dragLeave: function () {
			$(drop_zone_id).css('background', 'gray');
		},
		drop: function () {
			$(drop_zone_id).css('background', 'gray');
		},
		afterAll: function () {
			$(drop_zone_id).html('The file(s) have been uploaded successfully!');
		},
		uploadFinished: function (i, file, response, time) {
			$('#uploadResult').append('<li>' + file.name + '</li>');
		}
			});*/
}

function onDragEnter(event,id_tache,id_etape) {
	
	//if(event.dataTransfer.getData("Text")=="" || typeof(event.dataTransfer.getData("Text"))=="undefined")
	{
		//alert("on drag over");
		$('#drop_zone'+id_tache).css('background-color', 'lightblue');
	}
}

function onDragLeave(event,id_tache,id_etape) {
	
	//if(event.dataTransfer.getData("Text")=="" || typeof(event.dataTransfer.getData("Text"))=="undefined")
	{
		//alert("on drag over");
		$('#drop_zone'+id_tache).css('background-color', 'transparent');
	}
}

function onDropElement(event,id_tache,id_etape) {
		event.preventDefault(); 
		$('#progress_zone'+id_tache).html("");
        onDragLeave(event,id_tache,id_etape);
        onFilesSelected(event.dataTransfer.files,id_tache,id_etape);
}

var uploading_files=0;//amount of files that are currently being uploaded
var id_files=0;

function onFilesSelected(files,id_tache,id_etape) {//function used to start the upload process for each file dropped.
	
	for (var i=0; i<files.length; i++) {
		var reader = new FileReader();
		reader.readAsDataURL(files[i]);
		uploadFile(files[i],id_tache,id_etape);
		uploading_files++;
		id_files++;
	}
}


function uploadFile(file,id_tache,id_etape) {//upload a file dropped by a user. It sends a request to executor.php with raw datas and creates a callback to know when the upload is done.
        var xhr = new XMLHttpRequest();
		var id_file=id_files;
        //on s'abonne à l'événement progress pour savoir où en est l'upload
		$('#progress_zone'+id_tache).html($('#progress_zone'+id_tache).html()+'<tr><td>'+file.name+'</td><td><div id="uploadfile'+id_file+'"></td></tr>');
		$('#tabstache'+id_tache).tabs( "refresh" );
		//$('#uploadfile'+id_file).progressbar({value: 0,max:100});
        xhr.upload.addEventListener("progress",  function(e){onUploadProgress(e,file.name,id_tache,id_file);}, false);
        xhr.open("POST", "executor.php?input_user_drop", true);
		
        // on s'abonne à tout changement de statut pour détecter
        // une erreur, ou la fin de l'upload
        xhr.onreadystatechange = function()
		 {
			if (xhr.readyState == 4) /* 4 : état "complete" */
			{
				
			   if (xhr.status == 200) /* 200 : code HTTP pour OK */
			   {
					/*
					Traitement de la réponse.
					On évalue le javascript affiché par la page executor.php
					*/
					/*eval(xmlhttp.responseText);
					processRunning--;
					displayProcessRunning();*/
					//$( "#uploadfile"+id_file).progressbar("value",100);
					$( "#uploadfile"+id_file).html("100 %");
					uploading_files--;
					
					if(uploading_files<=0)
					{
						
						//displayProjectDocuments(current_project,-1,-1,file.name);
						uploading_files=0;
						if(id_tache>0)
							display_(window.location.hash);
					}				  
			   }
			}
		 }

        xhr.setRequestHeader("Content-Type", "multipart/form-data");
        xhr.setRequestHeader("charset", "utf-8");
		//we add here parameters that will be used in executor.php (filename, project id...)
        xhr.setRequestHeader("X-File-Name", file.name);
        xhr.setRequestHeader("X-File-Size", file.size);
        xhr.setRequestHeader("X-File-Type", file.type);
		xhr.setRequestHeader("X-File-Stage", id_etape);
		xhr.setRequestHeader("X-File-Task", id_tache);

        xhr.send(file);
}


function onUploadProgress(event,filename,id_tache,id_file) {//callback which is called during the upload of a dropped file. Display progress.
	var percentComplete=0;
	if (event.lengthComputable) {
		percentComplete = Math.round((event.loaded / event.total) * 100);
	}
	
	try
	{
		//$( "#uploadfile"+id_file).progressbar("value",percentComplete);
		$( "#uploadfile"+id_file).html(percentComplete+ '%');
	}
	catch(e){}
}

var check_notification=0;

function onUpdate()
{
	//console.log("on update !");
	if(check_notification==0)
	{
		sendRequest("get","get_notifications",REQUEST_HIDDEN,"Récupération des notifications");
		check_notification=1;
	}
	setTimeout(onUpdate,60000);
}

function resetCssSheet(new_style)
{
	$("#pagestyle").attr('href', "css/"+new_style+"/jquery-ui-1.10.3.custom.css");
}



function initDrop()
{
	$('#dropZone').filedrop({
		url: '/Home/UploadFiles',
		paramname: 'files',
		maxFiles: 5,
		dragOver: function () {
			$('#dropZone').css('background', 'blue');
		},
		dragLeave: function () {
			$('#dropZone').css('background', 'gray');
		},
		drop: function () {
			$('#dropZone').css('background', 'gray');
		},
		afterAll: function () {
			$('#dropZone').html('The file(s) have been uploaded successfully!');
		},
		uploadFinished: function (i, file, response, time) {
			$('#uploadResult').append('<li>' + file.name + '</li>');
		}
	});
}

var mouse_held=0;
var start_x=-1;
var start_y=-1;
var initial_width=-1;
var initial_height=-1;
var window_has_focus=1;

function initListeners()
{
	$( window ).mousedown(function() {
		mouse_held=1;
		//console.log("held");
	});
	
	$( window ).mouseup(function() {
		mouse_held=0;
		if(start_x!=-1)
		{
			//console.log("save dim");
			var current_width=$(zone_scalable_width).width();
			var current_height=$(zone_scalable_height).height();
			sendRequest("get","save_dim&width="+current_width+"&height="+current_height,REQUEST_HIDDEN,"Sauvegarde des dimensions");
		}
		start_x=-1;
		start_y=-1;
		$( window ).unbind( "mousemove" );
		$("#content_page_scalable_zone").css("background-color","#eeeeee");
		$( window ).enableSelection();
		//console.log("unheld");
	});
	
	$(window).focus(function() {
        window_has_focus=1;
    });

    $(window).blur(function() {
        window_has_focus=0;
    });
}

var zone_scalable_width=".menu_page";
var zone_scalable_height=".content_page";

function initScalableZone()
{
	//console.log("init scalable");
	
	$( window ).bind( "mousemove",function( event ) {
		if(mouse_held==1)
		{
			if(start_x==-1)
			{
				start_x=event.pageX;
				start_y=event.pageY;
				initial_width=$(zone_scalable_width).width();
				initial_height=$(zone_scalable_height).height();
				$( window ).disableSelection();
				$("#content_page_scalable_zone").css("background-color","#ff0000");
			}
			var diff_x=start_x-event.pageX;
			var diff_y=start_y-event.pageY;
			var new_width=initial_width-diff_x;
			var new_height=initial_height-diff_y;
			resetContentPageDim(new_width,new_height);
			
			//var pageCoords = "( " + event.pageX + ", " + event.pageY + " )";
			//var clientCoords = "( " + event.clientX + ", " + event.clientY + " )";
			//console.log(pageCoords);
		}
		
	});
}



function resetContentPageDim(new_width,new_height)
{
	$(zone_scalable_width).width(new_width);
	$(zone_scalable_height).height(new_height);
}

function showEditFields(no_resize)
{
	$('*[readonlyfield]').css('position','absolute');
	$('*[editfield]').css('position','absolute');
	$('*[editfield]').css('top','0px');
	if(!no_resize)
	{
		if($("*[resizelabel]").attr('resized_up')==0)
		{
			$("*[resizelabel]").animate({width: "+=50px"});
			$("*[resizeheight]").animate({height: "30px"});
			$("*[resizelabel]").attr('resized_up',1);
		}
	}
	$('*[readonlyfield]').hide( 'fade', 1000,function(){$('*[readonlyfield]').css('position','');} );
	$('*[editfield]').show( 'fade', 1000,function(){$('*[editfield]').css('position','');$('*[editlabel]').css('display','');} );
}

function hideEditFields()
{
	$('*[readonlyfield]').css('position','absolute');
	$('*[editfield]').css('position','absolute');
	$('*[editlabel]').css('display','none');
	$("*[resizeheight]").animate({height: "0px"});
	if($("*[resizelabel]").attr('resized_up')==1)
	{
		$("*[resizelabel]").animate({width: "-=49px"});
		$("*[resizelabel]").attr('resized_up',0);
	}
	$('*[readonlyfield]').show( 'fade', 1000,function(){$('*[readonlyfield]').css('position','');} );
	$('*[editfield]').hide( 'fade', 1000,function(){
		$('*[editfield]').css('position','');
		
	
	} );
}

function logOut()
{
	sendRequest("get","log_out",REQUEST_HIDDEN,"Déconnexion");
}

function switchFavorite(event,id_tache)
{
	var elem="#favorite_"+id_tache;
	var add=0;
	if($(elem).hasClass("ui-state-default"))
	{
		$(elem).removeClass("ui-state-default");
		$(elem).addClass("ui-state-error");
		add=1;
	}
	else
	{
		$(elem).addClass("ui-state-default");
		$(elem).removeClass("ui-state-error");
	}
	sendRequest("get","switch_favorite&id_tache="+id_tache+"&add="+add,REQUEST_HIDDEN,"Switch favorite");
	event.stopPropagation();
}

function showColorPicker(elem,id_tache,default_color)
{
	$(elem).ColorPicker({
		onChange: function (hsb, hex, rgb) {
			$('#color_'+id_tache).css('backgroundColor', '#' + hex);
		},
		onBeforeShow: function () {
			$('#color_'+id_tache).addClass('task_color');
			$(elem).ColorPickerSetColor(default_color);
			$( window ).disableSelection();
		},
		onHide:function(colpkr){
			var new_color=rgbToHex($('#color_'+id_tache).css('backgroundColor'));
			if(new_color)
				setColorTask(id_tache,new_color);
			else
				$('#color_'+id_tache).removeClass('task_color');
			$( window ).enableSelection();
		}
	}).ColorPickerShow();

}

function createCookie(name,value,days) {
	if (days) {
		var date = new Date();
		date.setTime(date.getTime()+(days*24*60*60*1000));
		var expires = "; expires="+date.toGMTString();
	}
	else var expires = "";
	document.cookie = name+"="+value+expires+"; path=/";
}

function readCookie(name) {
	var nameEQ = name + "=";
	var ca = document.cookie.split(';');
	for(var i=0;i < ca.length;i++) {
		var c = ca[i];
		while (c.charAt(0)==' ') c = c.substring(1,c.length);
		if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
	}
	return null;
}

function eraseCookie(name) {
	createCookie(name,"",-1);
}

function checkCookie()
{
	var test_cookie="test_cookie";
	createCookie(test_cookie,1,1);
	var cookie_ok=readCookie(test_cookie);
	if(!cookie_ok)
	{
		alert("Votre navigateur n'accepte pas les cookies ! Vous devez les accepter pour utiliser Magic Projects.");
		return false;
	}
	return true;
	
}


function rgbToHex(rgb) {
	try
	{
	  /*var rgbvals = /rgb\((.+),(.+),(.+)\)/i.exec(rgb);
	  var rval = parseInt(rgbvals[1]);
	  var gval = parseInt(rgbvals[2]);
	  var bval = parseInt(rgbvals[3]);
	  return (
		rval.toString(16) +
		gval.toString(16) +
		bval.toString(16)
	  ).toUpperCase();*/
	  if (rgb.substr(0, 1) === "#") {
        return rgb.substr(1);
    }
    var nums = /(.*?)rgb\((\d+),\s*(\d+),\s*(\d+)\)/i.exec(rgb),
        r = parseInt(nums[2], 10).toString(16),
        g = parseInt(nums[3], 10).toString(16),
        b = parseInt(nums[4], 10).toString(16);
    return (
        (r.length == 1 ? "0"+ r : r) +
        (g.length == 1 ? "0"+ g : g) +
        (b.length == 1 ? "0"+ b : b)
    );
	}catch(e){}
	return null;
}


function strip_tags (input, allowed) {
  // http://kevin.vanzonneveld.net
  // +   original by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  // +   improved by: Luke Godfrey
  // +      input by: Pul
  // +   bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  // +   bugfixed by: Onno Marsman
  // +      input by: Alex
  // +   bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  // +      input by: Marc Palau
  // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  // +      input by: Brett Zamir (http://brett-zamir.me)
  // +   bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  // +   bugfixed by: Eric Nagel
  // +      input by: Bobby Drake
  // +   bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  // +   bugfixed by: Tomasz Wesolowski
  // +      input by: Evertjan Garretsen
  // +    revised by: Rafał Kukawski (http://blog.kukawski.pl/)
  // *     example 1: strip_tags('<p>Kevin</p> <br /><b>van</b> <i>Zonneveld</i>', '<i><b>');
  // *     returns 1: 'Kevin <b>van</b> <i>Zonneveld</i>'
  // *     example 2: strip_tags('<p>Kevin <img src="someimage.png" onmouseover="someFunction()">van <i>Zonneveld</i></p>', '<p>');
  // *     returns 2: '<p>Kevin van Zonneveld</p>'
  // *     example 3: strip_tags("<a href='http://kevin.vanzonneveld.net'>Kevin van Zonneveld</a>", "<a>");
  // *     returns 3: '<a href='http://kevin.vanzonneveld.net'>Kevin van Zonneveld</a>'
  // *     example 4: strip_tags('1 < 5 5 > 1');
  // *     returns 4: '1 < 5 5 > 1'
  // *     example 5: strip_tags('1 <br/> 1');
  // *     returns 5: '1  1'
  // *     example 6: strip_tags('1 <br/> 1', '<br>');
  // *     returns 6: '1  1'
  // *     example 7: strip_tags('1 <br/> 1', '<br><br/>');
  // *     returns 7: '1 <br/> 1'
  allowed = (((allowed || "") + "").toLowerCase().match(/<[a-z][a-z0-9]*>/g) || []).join(''); // making sure the allowed arg is a string containing only tags in lowercase (<a><b><c>)
  var tags = /<\/?([a-z][a-z0-9]*)\b[^>]*>/gi,
    commentsAndPhpTags = /<!--[\s\S]*?-->|<\?(?:php)?[\s\S]*?\?>/gi;
  return input.replace(commentsAndPhpTags, '').replace(tags, function ($0, $1) {
    return allowed.indexOf('<' + $1.toLowerCase() + '>') > -1 ? $0 : '';
  });
}


function html_entity_decode(string, quote_style) {
  //  discuss at: http://phpjs.org/functions/html_entity_decode/
  // original by: john (http://www.jd-tech.net)
  //    input by: ger
  //    input by: Ratheous
  //    input by: Nick Kolosov (http://sammy.ru)
  // improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  // improved by: marc andreu
  //  revised by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  //  revised by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  // bugfixed by: Onno Marsman
  // bugfixed by: Brett Zamir (http://brett-zamir.me)
  // bugfixed by: Fox
  //  depends on: get_html_translation_table
  //   example 1: html_entity_decode('Kevin &amp; van Zonneveld');
  //   returns 1: 'Kevin & van Zonneveld'
  //   example 2: html_entity_decode('&amp;lt;');
  //   returns 2: '&lt;'

  var hash_map = {},
    symbol = '',
    tmp_str = '',
    entity = '';
  tmp_str = string.toString();

  if (false === (hash_map = this.get_html_translation_table('HTML_ENTITIES', quote_style))) {
    return false;
  }

  // fix &amp; problem
  // http://phpjs.org/functions/get_html_translation_table:416#comment_97660
  delete(hash_map['&']);
  hash_map['&'] = '&amp;';

  for (symbol in hash_map) {
    entity = hash_map[symbol];
    tmp_str = tmp_str.split(entity)
      .join(symbol);
  }
  tmp_str = tmp_str.split('&#039;')
    .join("'");
tmp_str = tmp_str.split('&#39;')
    .join("'");
	
	tmp_str = tmp_str.split('&#34;')
    .join('"');
	
	tmp_str = tmp_str.split('&#034;')
    .join('"');

  return tmp_str;
}


function get_html_translation_table(table, quote_style) {
  //  discuss at: http://phpjs.org/functions/get_html_translation_table/
  // original by: Philip Peterson
  //  revised by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  // bugfixed by: noname
  // bugfixed by: Alex
  // bugfixed by: Marco
  // bugfixed by: madipta
  // bugfixed by: Brett Zamir (http://brett-zamir.me)
  // bugfixed by: T.Wild
  // improved by: KELAN
  // improved by: Brett Zamir (http://brett-zamir.me)
  //    input by: Frank Forte
  //    input by: Ratheous
  //        note: It has been decided that we're not going to add global
  //        note: dependencies to php.js, meaning the constants are not
  //        note: real constants, but strings instead. Integers are also supported if someone
  //        note: chooses to create the constants themselves.
  //   example 1: get_html_translation_table('HTML_SPECIALCHARS');
  //   returns 1: {'"': '&quot;', '&': '&amp;', '<': '&lt;', '>': '&gt;'}

  var entities = {},
    hash_map = {},
    decimal;
  var constMappingTable = {},
    constMappingQuoteStyle = {};
  var useTable = {},
    useQuoteStyle = {};

  // Translate arguments
  constMappingTable[0] = 'HTML_SPECIALCHARS';
  constMappingTable[1] = 'HTML_ENTITIES';
  constMappingQuoteStyle[0] = 'ENT_NOQUOTES';
  constMappingQuoteStyle[2] = 'ENT_COMPAT';
  constMappingQuoteStyle[3] = 'ENT_QUOTES';

  useTable = !isNaN(table) ? constMappingTable[table] : table ? table.toUpperCase() : 'HTML_SPECIALCHARS';
  useQuoteStyle = !isNaN(quote_style) ? constMappingQuoteStyle[quote_style] : quote_style ? quote_style.toUpperCase() :
    'ENT_COMPAT';

  if (useTable !== 'HTML_SPECIALCHARS' && useTable !== 'HTML_ENTITIES') {
    throw new Error('Table: ' + useTable + ' not supported');
    // return false;
  }

  entities['38'] = '&amp;';
  if (useTable === 'HTML_ENTITIES') {
    entities['160'] = '&nbsp;';
    entities['161'] = '&iexcl;';
    entities['162'] = '&cent;';
    entities['163'] = '&pound;';
    entities['164'] = '&curren;';
    entities['165'] = '&yen;';
    entities['166'] = '&brvbar;';
    entities['167'] = '&sect;';
    entities['168'] = '&uml;';
    entities['169'] = '&copy;';
    entities['170'] = '&ordf;';
    entities['171'] = '&laquo;';
    entities['172'] = '&not;';
    entities['173'] = '&shy;';
    entities['174'] = '&reg;';
    entities['175'] = '&macr;';
    entities['176'] = '&deg;';
    entities['177'] = '&plusmn;';
    entities['178'] = '&sup2;';
    entities['179'] = '&sup3;';
    entities['180'] = '&acute;';
    entities['181'] = '&micro;';
    entities['182'] = '&para;';
    entities['183'] = '&middot;';
    entities['184'] = '&cedil;';
    entities['185'] = '&sup1;';
    entities['186'] = '&ordm;';
    entities['187'] = '&raquo;';
    entities['188'] = '&frac14;';
    entities['189'] = '&frac12;';
    entities['190'] = '&frac34;';
    entities['191'] = '&iquest;';
    entities['192'] = '&Agrave;';
    entities['193'] = '&Aacute;';
    entities['194'] = '&Acirc;';
    entities['195'] = '&Atilde;';
    entities['196'] = '&Auml;';
    entities['197'] = '&Aring;';
    entities['198'] = '&AElig;';
    entities['199'] = '&Ccedil;';
    entities['200'] = '&Egrave;';
    entities['201'] = '&Eacute;';
    entities['202'] = '&Ecirc;';
    entities['203'] = '&Euml;';
    entities['204'] = '&Igrave;';
    entities['205'] = '&Iacute;';
    entities['206'] = '&Icirc;';
    entities['207'] = '&Iuml;';
    entities['208'] = '&ETH;';
    entities['209'] = '&Ntilde;';
    entities['210'] = '&Ograve;';
    entities['211'] = '&Oacute;';
    entities['212'] = '&Ocirc;';
    entities['213'] = '&Otilde;';
    entities['214'] = '&Ouml;';
    entities['215'] = '&times;';
    entities['216'] = '&Oslash;';
    entities['217'] = '&Ugrave;';
    entities['218'] = '&Uacute;';
    entities['219'] = '&Ucirc;';
    entities['220'] = '&Uuml;';
    entities['221'] = '&Yacute;';
    entities['222'] = '&THORN;';
    entities['223'] = '&szlig;';
    entities['224'] = '&agrave;';
    entities['225'] = '&aacute;';
    entities['226'] = '&acirc;';
    entities['227'] = '&atilde;';
    entities['228'] = '&auml;';
    entities['229'] = '&aring;';
    entities['230'] = '&aelig;';
    entities['231'] = '&ccedil;';
    entities['232'] = '&egrave;';
    entities['233'] = '&eacute;';
    entities['234'] = '&ecirc;';
    entities['235'] = '&euml;';
    entities['236'] = '&igrave;';
    entities['237'] = '&iacute;';
    entities['238'] = '&icirc;';
    entities['239'] = '&iuml;';
    entities['240'] = '&eth;';
    entities['241'] = '&ntilde;';
    entities['242'] = '&ograve;';
    entities['243'] = '&oacute;';
    entities['244'] = '&ocirc;';
    entities['245'] = '&otilde;';
    entities['246'] = '&ouml;';
    entities['247'] = '&divide;';
    entities['248'] = '&oslash;';
    entities['249'] = '&ugrave;';
    entities['250'] = '&uacute;';
    entities['251'] = '&ucirc;';
    entities['252'] = '&uuml;';
    entities['253'] = '&yacute;';
    entities['254'] = '&thorn;';
    entities['255'] = '&yuml;';
  }

  if (useQuoteStyle !== 'ENT_NOQUOTES') {
    entities['34'] = '&quot;';
  }
  if (useQuoteStyle === 'ENT_QUOTES') {
    entities['39'] = '&#39;';
  }
  entities['60'] = '&lt;';
  entities['62'] = '&gt;';

  // ascii decimals to real symbols
  for (decimal in entities) {
    if (entities.hasOwnProperty(decimal)) {
      hash_map[String.fromCharCode(decimal)] = entities[decimal];
    }
  }

  return hash_map;
}


var task_flow =0;
var task_attrib_id =1;
var stepEndpointOptions =0;
var stageEndpointOptions=0;
var endpoints={};
var dragging_stage=0;

jsPlumb.ready(function() {
	initTaskFlow();
});

function removeFlowContainerExcept(flow_container_id)
{
	$( ".flow_container" ).each(function (index,elem)
	{
		var flow_id=$(this).attr("id");
		if(flow_container_id!=flow_id)
			$(this).remove();
	});
}

function initTaskFlow()
{
	if(task_flow!=0)	
		task_flow.reset();
	
	task_attrib_id =1;
	task_flow = jsPlumb.getInstance(
	{ 
	ConnectionOverlays: [
		[ "Arrow", { location: 1 } ],

	]});
	task_flow.setContainer($("#task_flow"));
	
	task_flow.importDefaults({
	  Connector : [ "Straight", { gap: 5, stub:0} ],
	  Anchors : [ "TopCenter", "BottomCenter" ],
	   paintStyle:{ strokeStyle:"blue", lineWidth:10 },
		hoverPaintStyle:{ strokeStyle:"#00cbef" },
		endpointStyle:{ fillStyle:"blue", outlineColor:"black", outlineWidth:1 },
		endpointHoverStyles:[ 
			{ fillStyle:"red" }, 
			{ fillStyle:"yellow" } 
		]
	});
	
	task_flow.bind("beforeDrop", function(params) {
		var source=params['sourceId'];
		var source_level=parseInt($('#'+source).attr('stage_level'));
		var target=params['targetId'];
		var target_level=parseInt($('#'+target).attr('step_level'));
		//console.log("testing source level "+source_level+ " target level "+target_level);
		if(source_level>=target_level)
		{
			return false;
		}
		if(source_level==target_level-1)
		{
			$('#is_blocking_'+source).val("1");
			$('#sovereign_'+source).val("0");
		}
		else
		{
			$('#is_blocking_'+source).val("0");
			$('#sovereign_'+source).val(target_level);
		}
		//console.log("attaching "+source+" to "+target);
		return true;
	});
	
	task_flow.bind("beforeDetach", function(params) {
		
		var source=params['sourceId'];
		if($('#is_blocking_'+source).length==0)
			source=params['suspendedElement'].id;
		$('#is_blocking_'+source).val("0");
		$('#sovereign_'+source).val("0");
		//console.log("detaching "+source);
		return true;
	});
	
	/*task_flow.bind("beforeDrag", function(params) {
		
		var source=params['sourceId'];
		//console.log("dragging "+source);
		return true;
	});*/
	
	task_flow.bind("connection", function(info,originalEvent) {
		if(originalEvent)
		{
			//console.log("drag and drop connection !");
			var new_connection=info['connection'];
			new_connection.setPaintStyle({ 
				strokeStyle:"blue", lineWidth:5,
				
			});
			
			new_connection.setHoverPaintStyle({ 
				strokeStyle:"#00cbef", 
				
			});
		}
	});
	
	stepEndpointOptions = {
		endpoint:"Dot",
	  //paintStyle:{ width:25, height:21, fillStyle:'#666' },
	  isSource:false,
	  //connectorStyle : { strokeStyle:"#666" },
	  isTarget:true,
	  endpointHoverStyle:{ strokeStyle:"#00cbef" },
	   maxConnections:-1,
	};
	
	stageEndpointOptions = {
	  endpoint:"Rectangle",
	  //paintStyle:{ width:25, height:21, fillStyle:'#666' },
	  isSource:true,
	  maxConnections:1,
	 // connectorStyle : { strokeStyle:"#666" },
	  isTarget:false,
	
	};
	//console.log('task_flow initialized');
}

function addFlowStage(flow_id,stage_id)
{
	var new_step=addFlowStep();
	var step_level=new_step.attr('step_level');
	var new_stage='<input type="hidden" id="stage_ref_'+flow_id+'" name="stage_ref_'+flow_id+'" value="'+stage_id+'"><input type="hidden" id="priority_'+flow_id+'" name="priority_'+flow_id+'" value="'+step_level+'"><input type="hidden" id="is_blocking_'+flow_id+'" name="is_blocking_'+flow_id+'" value="1"><input type="hidden" id="sovereign_'+flow_id+'" name="sovereign_'+flow_id+'" value="0"><div id="'+flow_id+'" stage_level="'+step_level+'" class="stage ui-widget ui-state-highlight ui-corner-all"></div>';
	new_step.append(new_stage);
	$("#"+flow_id).draggable(
		{
			revert: true,
			zIndex: 100,
			opacity: 0.75,
			drag: function( event, ui ) {
				task_flow.repaintEverything (true);
				
			},
			start: function( event, ui ) {
				dragging_stage=1;
			},
			stop: function( event, ui ) {
				dragging_stage=0;
				task_flow.repaintEverything (true);
				
			}
		}
	);
	task_flow.detachAllConnections(flow_id);
	endpoints[flow_id]=task_flow.addEndpoint(flow_id, { 
	  anchor:"Bottom",
	  connectionsDetachable:true, 
	  
	}, stageEndpointOptions); 
	task_flow.repaintEverything (true);
	
	
}

function moveStageToStep(stage_id,step_id,is_blocking)
{
	var drop_id=stage_id;
	var step_level=$("#"+step_id).attr('step_level');
	$("#"+step_id).append($( "#"+drop_id ));
	/*$( "#"+drop_id ).draggable( "option", "revert", false );
	$( "#"+drop_id ).draggable( "destroy" );
	$( "#"+drop_id ).attr("style","");*/
	$( "#"+drop_id ).attr("stage_level",step_level);
	$( "#priority_"+drop_id ).val(step_level);
	task_flow.detachAllConnections(drop_id);
	endpoints[drop_id]=task_flow.addEndpoint(drop_id, { 
	  anchor:"Bottom",
	  connectionsDetachable:true, 
	}, stageEndpointOptions);
	var step_level=step_id.replace('step','');
	var next_step_id='step'+(parseInt(step_level)+1);
	//console.log("linking "+drop_id+" to "+next_step_id);
	var connection=0;
	if(is_blocking)
	{
		connection=task_flow.connect({
		  source:drop_id, 
		  target:next_step_id,
		  gap:10,
		  anchors:["Bottom", "Top" ],
		  paintStyle:{ strokeStyle:"blue", lineWidth:5 },
		  hoverPaintStyle:{ strokeStyle:"#00cbef" },  
	  
	  /*hoverPaintStyle:{ outlineColor:"black", outlineWidth:1 },*/
	 
	  
		});
	}
	if(connection)
	{
		$( "#is_blocking_"+drop_id ).val("1");
		$( "#sovereign_"+drop_id ).val("0");
	}
	else
	{
		$( "#is_blocking_"+drop_id ).val("0");
		$( "#sovereign_"+drop_id ).val("0");
	}
	task_flow.repaintEverything (true);
	/*$("#"+drop_id).draggable(
		{
			revert: true,
			zIndex: 100,
			opacity: 0.75,
			drag: function( event, ui ) {
				task_flow.repaintEverything (true);
			},
			start: function( event, ui ) {
				dragging_stage=1;
			},
			stop: function( event, ui ) {
				dragging_stage=0;
				task_flow.repaintEverything (true);
			}
		}
	);*/
}

function addFlowStep()
{
	var step_level=0;
	$( "*[step_level]" ).each(function (index,elem)
	{
		step_level=$(this).attr("step_level");
		//console.log("reading "+step_level);
	});
	step_level++;
	var step_id='step'+step_level;
	var new_step='<tr id="ligne_'+step_id+'"><td id="'+step_id+'" step_level="'+step_level+'" class="ui-widget ui-widget-content ui-corner-all" style="position:relative;height:50px;min-width:150px;"><div class="ui-widget ui-state-default ui-corner-all" style="position:absolute;top:-15px;left:-20px;">'+ltexts['ltext_task_step']+' '+step_level+'</div></td></tr>';
	//console.log("new step:"+new_step);
	$('#table_step > tbody:last').append(new_step);
	$("#"+step_id).droppable(
		{ 
			hoverClass: "drop_flow",					
			drop: function(event, ui) 
			{
				var drop_id=ui.draggable[0].id;
				var step_level=$("#"+step_id).attr('step_level');
				$("#"+step_id).append($( "#"+drop_id ));
				$( "#"+drop_id ).draggable( "option", "revert", false );
				$( "#"+drop_id ).draggable( "destroy" );
				$( "#"+drop_id ).attr("style","");
				$( "#"+drop_id ).attr("stage_level",step_level);
				$( "#priority_"+drop_id ).val(step_level);
				task_flow.detachAllConnections(drop_id);
				endpoints[drop_id]=task_flow.addEndpoint(drop_id, { 
				  anchor:"Bottom",
				  connectionsDetachable:true, 
				}, stageEndpointOptions);
				var step_level=step_id.replace('step','');
				var next_step_id='step'+(parseInt(step_level)+1);
				//console.log("linking "+drop_id+" to "+next_step_id);
				var connection=task_flow.connect({
				  source:drop_id, 
				  target:next_step_id,
				  gap:10,
				  anchors:["Bottom", "Top" ],
				  paintStyle:{ strokeStyle:"blue", lineWidth:5 },
				  hoverPaintStyle:{ strokeStyle:"#00cbef" },
				  
				  
				  /*hoverPaintStyle:{ outlineColor:"black", outlineWidth:1 },*/
				 
				  
				});
				if(connection)
				{
					$( "#is_blocking_"+drop_id ).val("1");
					$( "#sovereign_"+drop_id ).val("0");
				}
				else
				{
					$( "#is_blocking_"+drop_id ).val("0");
					$( "#sovereign_"+drop_id ).val("0");
				}
				task_flow.repaintEverything (true);
				$("#"+drop_id).draggable(
					{
						revert: true,
						zIndex: 100,
						opacity: 0.75,
						drag: function( event, ui ) {
							task_flow.repaintEverything (true);
						},
						start: function( event, ui ) {
							dragging_stage=1;
						},
						stop: function( event, ui ) {
							dragging_stage=0;
							task_flow.repaintEverything (true);
						}
					}
				);
			}
		}
	);
	endpoints[step_id]=task_flow.addEndpoint(step_id, { 
	  anchor:"Top",
	  connectionsDetachable:false, 
	  
	}, stepEndpointOptions); 
	$( "*[stage_level]" ).each(function (index,elem)
	{
		var parent_stage_id=$(this).attr("id");
		var parent_stage_level=$(this).attr("stage_level");
		if(parent_stage_level==step_level-1)
		{
			var connection=task_flow.connect({
			  source:parent_stage_id, 
			  target:step_id,
			  gap:10,
			  anchors:["Bottom", "Top" ],
			  paintStyle:{ strokeStyle:"blue", lineWidth:5 },
			   hoverPaintStyle:{ strokeStyle:"#00cbef" },
			 /* hoverPaintStyle:{ outlineColor:"black", outlineWidth:1 },*/
			  
			});
			if(connection)
			{
				$( "#"+parent_stage_id ).val("1");
				$( "#"+parent_stage_id ).val("0");
			}
			else
			{
				$( "#"+parent_stage_id ).val("0");
				$( "#"+parent_stage_id ).val("0");
			}
		}
	});
	
	return $('#'+step_id);

}

function createStageIntoStep(step,stage_id,text,is_blocking,color,target_step)
{
	var flow_id="flow_"+task_attrib_id;
	task_attrib_id++;
	var step_level=step.attr("step_level");
	var sovereign=target_step;
	if(is_blocking==1)
		sovereign=0;
	var new_stage='<input type="hidden" id="stage_ref_'+flow_id+'" name="stage_ref_'+flow_id+'" value="'+stage_id+'"><input type="hidden" id="priority_'+flow_id+'" name="priority_'+flow_id+'" value="'+step_level+'"><input type="hidden" id="is_blocking_'+flow_id+'" name="is_blocking_'+flow_id+'" value="'+is_blocking+'"><input type="hidden" id="sovereign_'+flow_id+'" name="sovereign_'+flow_id+'" value="'+sovereign+'"><div id="'+flow_id+'" stage_level="'+step_level+'" class="stage ui-widget ui-state-highlight ui-corner-all">'+text+'</div>';
	step.append(new_stage);
	$("#"+flow_id).draggable(
		{
			revert: true,
			zIndex: 100,
			opacity: 0.75,
			drag: function( event, ui ) {
				task_flow.repaintEverything (true);
			},
			start: function( event, ui ) {
				dragging_stage=1;
			},
			stop: function( event, ui ) {
				dragging_stage=0;
				task_flow.repaintEverything (true);
				//console.log("stop dragging");
				
			}
		}
	);
	task_flow.detachAllConnections(flow_id);
	endpoints[flow_id]=task_flow.addEndpoint(flow_id, { 
	  anchor:"Bottom",
	  connectionsDetachable:true, 
	  
	}, stageEndpointOptions); 
	if(target_step>0)
	{
		var next_step_id='step'+target_step;
		try
		{
			var connection=task_flow.connect({
			  source:flow_id, 
			  target:next_step_id,
			  gap:10,
			  anchors:["Bottom", "Top" ],
			  /*hoverPaintStyle:{ outlineColor:"black", outlineWidth:1 },*/
			 paintStyle:{
				strokeStyle:color,
				/*gradient:{
				  stops:[[0,'green'], [1,'red']]
				},*/
				lineWidth:5
			},
			hoverPaintStyle:{ strokeStyle:"#00cbef" },
			  
			});
			green[connection.id]=0;
		}catch(e)
		{
			//console.log('cannot link '+flow_id+' to '+next_step_id);
		}
		//animateFlow(connection);
			
	}
	task_flow.repaintEverything (true);
	

}

var green={};

function animateFlow(connection)
{
	connection.setPaintStyle({ 
			strokeStyle:'green',
			gradient:{
			  stops:[[0,'green'],[green[connection.id],'red'],[1,'red']]
			},
			lineWidth:15
		});
	green[connection.id]=green[connection.id]+0.1;
	if(green[connection.id]<1)
		setTimeout(function(){animateFlow(connection);},500);
	task_flow.repaintEverything (true);
	//console.log("animate "+connection.id+ " green "+green[connection.id]);
}

jQuery.extend( jQuery.fn.dataTableExt.oSort, {
    "date-euro-pre": function ( a ) {
        if ($.trim(a) != '') {
			
            var frDatea = $.trim(a).replace('(','').replace(')','').replace('h',':').split(' ');
            var frTimea = frDatea[1].split(':');
            var frDatea2 = frDatea[0].split('/');
			
            var x = (frDatea2[2] + frDatea2[1] + frDatea2[0] + frTimea[0] + frTimea[1]) * 1;
        } else {
            var x = 10000000000000; // = l'an 1000 ...
        }
         
        return x;
    },
 
    "date-euro-asc": function ( a, b ) {
        return a - b;
    },
 
    "date-euro-desc": function ( a, b ) {
        return b - a;
    }
} );

jQuery.extend( jQuery.fn.dataTableExt.oSort, {
    "date-us-pre": function ( a ) {
        if ($.trim(a) != '') {
			
            var frDatea = $.trim(a).replace('(','').replace(')','').replace('h',':').split(' ');
            var frTimea = frDatea[1].split(':');
            var frDatea2 = frDatea[0].split('/');
			
            var x = (frDatea2[2] + frDatea2[0] + frDatea2[1] + frTimea[0] + frTimea[1]) * 1;
        } else {
            var x = 10000000000000; // = l'an 1000 ...
        }
         
        return x;
    },
 
    "date-us-asc": function ( a, b ) {
        return a - b;
    },
 
    "date-us-desc": function ( a, b ) {
        return b - a;
    }
} );

jQuery.extend( jQuery.fn.dataTableExt.oSort, {
    "int-in-link-pre": function ( a ) {
        if ($.trim(a) != '') {
			var value=strip_tags (a, '');
            var x = value;
        } else {
            var x = 10000000000000; // = l'an 1000 ...
        }
         
        return x;
    },
 
    "int-in-link-asc": function ( a, b ) {
        return a - b;
    },
 
    "int-in-link-desc": function ( a, b ) {
        return b - a;
    }
} );

jQuery.extend( jQuery.fn.dataTableExt.oSort, {
    "date-uk-pre": function ( a ) {
        var ukDatea = a.split('/');
        return (ukDatea[2] + ukDatea[1]+ ukDatea[0]) * 1;
    },
 
    "date-uk-asc": function ( a, b ) {
        return ((a < b) ? -1 : ((a > b) ? 1 : 0));
    },
 
    "date-uk-desc": function ( a, b ) {
        return ((a < b) ? 1 : ((a > b) ? -1 : 0));
    }
} );

jQuery.extend( jQuery.fn.dataTableExt.oSort, {
    "date-us-small-pre": function ( a ) {
        var ukDatea = a.split('/');
        return (ukDatea[2] + ukDatea[0]+ ukDatea[1]) * 1;
    },
 
    "date-us-small-asc": function ( a, b ) {
        return ((a < b) ? -1 : ((a > b) ? 1 : 0));
    },
 
    "date-us-small-desc": function ( a, b ) {
        return ((a < b) ? 1 : ((a > b) ? -1 : 0));
    }
} );
