<?php


$errors_on_script_end=true;
register_shutdown_function('onScriptEnd');

function protectString($str)
{
	$str=str_replace('"','\"',$str);
	$str=str_replace("'","\'",$str);
	$str=str_replace("\n",'',$str);
	$str=str_replace("\r",'',$str);
	return $str;
}

function getDateDiff($date_end,$date_start,$step=60)
{
	$start=getTimeStamp($date_start);
	$end=getTimeStamp($date_end);
	$res=0;
	for($current_time=$start;$current_time<$end;$current_time+=$step)
	{
		$day=date('D',$current_time);
		$jour = date("d", $current_time);
		$mois = date("m", $current_time);
		$current_hour=date("H",$current_time);
		if($current_hour>=WORK_HOUR_DAY_END || $day=='Sat' || $day=='Sun' ||
			($jour == 1 && $mois == 11) ||
			($jour == 11 && $mois == 11) ||
			($jour == 25 && $mois == 12) ||
			($jour == 1 && $mois == 1) ||
			($jour == 1 && $mois == 5) ||
			($jour == 8 && $mois == 5) 
			)
			$current_time=mktime(WORK_HOUR_DAY_START, 0, 0, date("m",$current_time)  , date("d",$current_time)+1, date("Y",$current_time));
		elseif($current_hour<WORK_HOUR_LUNCH_START || $current_hour>=WORK_HOUR_LUNCH_END)
			$res+=$step;
	}
	return $res;
}

function addDateDuration($date_start,$duration)
{
    $res=getTimeStamp($date_start);
    $duration=$duration*60*60;
    //return $res+$duration;
    $added_duration=0;
    $step=60*60;
    while($added_duration<$duration)
    {
        $day=date('D',$res);
       
        if($day=='Sat' || $day=='Sun')
        {
            $res=mktime(WORK_HOUR_DAY_START, 0, 0, date("m",$res)  , date("d",$res)+1, date("Y",$res));
        }
        else
        {
            $current_hour=date("H",$res);
            if($current_hour<WORK_HOUR_DAY_START)
                $res=mktime(WORK_HOUR_DAY_START, 0, 0, date("m",$res)  , date("d",$res), date("Y",$res));
            elseif($current_hour<WORK_HOUR_DAY_END && ($current_hour<WORK_HOUR_LUNCH_START || $current_hour>=WORK_HOUR_LUNCH_END) )
            {
                $res+=$step;
                $added_duration+=$step;
               
            }
            elseif($current_hour>=WORK_HOUR_DAY_END)
                $res=mktime(WORK_HOUR_DAY_START, 0, 0, date("m",$res)  , date("d",$res)+1, date("Y",$res));
            else
                $res=mktime(WORK_HOUR_LUNCH_END, 0, 0, date("m",$res)  , date("d",$res), date("Y",$res));
           
        }
       
    }
   
    return $res;
}

function getTimeUntilEOW($start_date)
{
    $date_start=date('Y-m-d H:i:s',$start_date);
    //echo "start = $date_start<br>";
    $week=date('W',$start_date);
    $res=0;
    do
    {
        $res+=0.1;
        $new_date=addDateDuration($date_start,$res);
        //echo date('Y-m-d H:i:s',$new_date).'<br>';
        $new_week=date('W',$new_date);
    }while($new_week==$week);
    return $res;
}

function retrieveInputFile($fieldBaseName)//retrieve any files uploaded with their field starting with $fieldBaseName
{
	$documents=array();
	//$path=getUploadFolder();
	$path="uploaded/";
	//writeOnLog("exec.txt","retrieveInputFile");
	foreach($_FILES as $key=>$val)
	{
		//writeOnLog("exec.txt",$val["name"]);
		if(strpos($key,$fieldBaseName)===0)
		{
			if($val["name"]!="")
			{
				$fileName=cleanFilename($val["name"]);
				$lien=getFreeFilename("$path$fileName");
				$fileName=str_replace($path,"",$lien);
				$uploadOK=recupFichier($key,$path,$fileName);
				$documents[]=array('full_path'=>$lien,'filename'=>$fileName,'uploaded'=>$uploadOK);
			}
		}
	}
	return $documents;
}

function recupFichier($nomChamp,$cheminRelatif,$newName){//function called after a file upload: move the uploaded file to a selected folder
	if($_FILES[$nomChamp]["tmp_name"]!=""){//une fichier a été donné
		$temp = $_FILES[$nomChamp]["tmp_name"];//fichier temporaire
		$nomFichier=$_FILES[$nomChamp]["name"];// nom du fichier
		$savefile=$cheminRelatif.$newName;
		if(move_uploaded_file($temp, $savefile) && filesize($savefile)>0){//le déplacement du fichier s'est correctement effectué
			return true;
		}
	}
	return false;
}

function removeAccents($str)
{
	$accents = array('À','Á','Â','Ã','Ä','Å','Ç','È','É','Ê','Ë','Ì','Í','Î','Ï','Ò','Ó','Ô','Õ','Ö','Ù','Ú','Û','Ü','Ý','à','á','â','ã','ä','å','ç','è','é','ê','ë','ì','í','î','ï','ð','ò','ó','ô','õ','ö','ù','ú','û','ü','ý','ÿ','Ñ','ñ');
	$no_accents = array('A','A','A','A','A','A','C','E','E','E','E','I','I','I','I','O','O','O','O','O','U','U','U','U','Y','a','a','a','a','a','a','c','e','e','e','e','i','i','i','i','o','o','o','o','o','o','u','u','u','u','y','y','N','n');
	return str_replace($accents, $no_accents , $str);
}

function removeUselessWords($str)
{
	$mots = array('/\bà\b/i','/\bdans\b/i','/\bpar\b/i','/\bpour\b/i','/\ben\b/i','/\bvers\b/i','/\bavec\b/i','/\bde\b/i',
	'/\bsans\b/i','/\bsous\b/i','/\bsur\b/i','/\bje\b/i','/\btu\b/i','/\bil\b/i','/\bon\b/i','/\belle\b/i','/\bnous\b/i','/\bvous\b/i',
	'/\bils\b/i','/\blui\b/i','/\bmon\b/i','/\bton\b/i','/\bson\b/i','/\bma\b/i','/\bta\b/i','/\bsa\b/i','/\bnotre\b/i',
	'/\bvotre\b/i','/\bleur\b/i','/\bleurs\b/i','/\beux\b/i','/\bun\b/i','/\bune\b/i','/\bd\b/i','/\bdes\b/i','/\ble\b/i','/\bla\b/i','/\bles\b/i',
	'/\bmais\b/i','/\bou\b/i','/\bet\b/i','/\bdonc\b/i','/\bor\b/i','/\bni\b/i','/\bcar\b/i','/\boù\b/i',
	'/\bce\b/i','/\bça\b/i','/\bces\b/i','/\bqui\b/i','/\bque\b/i','/\bquoi\b/i','/\bdont\b/i','/\btout\b/i','/\btous\b/i','/\btoutes\b/i','/\btoute\b/i','/\bparce\b/i',
	'/\btant\b/i','/\bavant\b/i','/\baprès\b/i','/\bpendant\b/i','/\btandis\b/i','/\bsi\b/i','/\bau\b/i','/\baux\b/i','/\bmoment\b/i',
	'/\bai\b/i','/\bas\b/i','/\bavons\b/i','/\bavez\b/i','/\bont\b/i','/\bsuis\b/i','/\bes\b/i','/\best\b/i','/\bsommes\b/i','/\bêtes\b/i','/\bsont\b/i');
	return preg_replace($mots, "" , $str);
}

function cleanFilename($basename)
{
	$basename=removeAccents($basename);
	$basename=strtolower($basename);
	$basename=str_replace('"','_',$basename);
	$basename=str_replace(" ",'_',$basename);
	$basename=str_replace("'",'_',$basename);
	$basename=str_replace(":",'_',$basename);
	$basename=str_replace("/",'_',$basename);
	$basename=str_replace("\\",'_',$basename);
	$basename=str_replace("*",'_',$basename);
	$basename=str_replace("?",'_',$basename);
	$basename=str_replace("<",'_',$basename);
	$basename=str_replace(">",'_',$basename);
	$basename=str_replace("|",'_',$basename);
	$basename=str_replace("²",'_',$basename);
	$basename=str_replace("#",'_',$basename);
	
	return $basename;
}

function getFreeFilename($filename)//return a filename that is not already used
{
	if(file_exists($filename))
	{
		$fileparts=explode(".",$filename);
		$extension="";
		if(sizeof($fileparts)>1)
			$extension=".".$fileparts[sizeof($fileparts)-1];
		$filenamebase=str_replace("$extension","",$filename);
		$i=1;
		$filename="$filenamebase-$i$extension";
		while(file_exists($filename))
		{
			$i++;
			$filename="$filenamebase-$i$extension";
		}
	}
	return $filename;
}

function getBasicForm($id_form,$fields,$form_options)
{
	$res=array();
	$res['html']="";
	$res['js']="";
	$submit_text="Valider";
	$readonly=false;
	$editonly=true;
	$readedit=false;
	if(isset($form_options['edition']))
	{
		$readonly=false;
		$editonly=false;
		$readedit=false;
		if($form_options['edition']=='edit_only')
			$editonly=true;
		elseif($form_options['edition']=='read_only')
			$readonly=true;
		else
			$readedit=true;
	}
	if(isset($form_options['submit_text']))
		$submit_text=$form_options['submit_text'];
	$on_submit='';
	if(isset($form_options['on_submit']))
		$on_submit=$form_options['on_submit'];
	$edit_visibily='style=""';
	$read_visibily='style="display:none"';
	if($editonly==false || $readonly==true)
	{
		$edit_visibily='style="display:none"';
		$read_visibily='style=""';
	}
	$img_processing_position='absolute';
	if(isset($form_options['processing_fixed']))
		$img_processing_position='fixed';
	$res['html'].='	<div id="processing_'.$id_form.'" style="position:'.$img_processing_position.';z-index:5;width:90%;height:80%;display:none">
				<div style="position:relative;left:40px;top:20px;">
					<img src="img/spinner.gif"><br>
					<div style="position:relative;"><div id="progressvalue_'.$id_form.'" style="position:absolute;z-index:100;text-align:center;width:200px;"></div><div id="progress_'.$id_form.'" style="position:absolute;width:200px;"></div></div>
				</div>
			</div>';
			
	$show_edit="showEditFields();";
	$hide_edit="hideEditFields();";
	if(isset($form_options['title_form']))
		$res['html'].=$form_options['title_form'].'<br>';
	$res['html'].='<form id="'.$id_form.'" enctype="multipart/form-data" exec_on_submit="'.$on_submit.'">
				<table class="basic_table" >
				<tbody id="body'.$id_form.'">';
				
	$extra_fields='';
	foreach($fields as $key=>$field)
	{
		$field_id=$field['id_field'];
		$field_name="";
		if(isset($field['label']))
			$field_name=$field['label'];
		$field_value="";
		if(isset($field['value']))
			$field_value=protectString($field['value']);
		
		if($field['type']=='hidden')
		{
			$res['html'].='<input type="hidden" id="'.$field_id.'" name="'.$field_id.'" value="'.$field_value.'">';
		}
		elseif($field['type']=='flow_graph')
		{
			$expert_only='';
			if(isset($field['expert']))
			{
				if($field['expert']==false)
					$expert_only='style="display:none;position:relative;" class="expert_only"';
				else
					$expert_only='style="position:relative;" class="expert_only"';
			}
			$extra_fields.='<div '.$expert_only.'>
								<div id="task_flow'.$id_form.'" class="flow_container" style="position:relative;">
									<table id="table_step" style="border-collapse:separate; border-spacing:2em;">
										<tbody>
										</tbody>
									</table>
									<ul id="icons" class="icons ui-widget ui-helper-clearfix"><li class="ui-state-default ui-corner-all" title="'.getLocText('ltext_task_add_step').'" accept_tooltip="1" onclick="addFlowStep();">
												<span  class="ui-icon ui-icon-circle-plus"></span></li></ul><br>
								</div>
							</div><br>';
		}
		else
		{
			$full_line="";
			if($field['type']=='group')
			{
				$field_editable='';
				$field_extra='';
				if(@$field['read_only']==true)
					$field_editable='read_only="1"';
				if(@$field['extra']=='flow_graph')
					$field_editable='flow_graph="1"';
				$full_line.='		<tr height="30px" id="tr_fieldNUM" group="tr_fieldNUM" '.$field_extra.'>
								<td id="cell_fieldNUM" class="ui-widget ui-state-default ui-corner-all" group="cell_fieldNUM" group_text="'.$field_name.' NUM" '.$field_editable.' class="title_cell"></td>
								<td class="value_cell">
										<table>';
				$part_origin=array();
				$part_replace=array();
				
				foreach($field['datas'] as $k=>$sub_field)
				{
					$field_id=$sub_field['id_field'];
					$sub_field['group_field']=true;
					$field_name="";
					$cell_properties='';
					if(isset($sub_field['label']))
						$field_name=$sub_field['label'];
					if(isset($sub_field['duplication']))
					{
						$cell_properties='id="cell_'.$field_id.'NUM" group="cell_'.$field_id.'NUM" group_text="'.$field_name.'"';
					}
					
					$expert_only='';
					if(isset($sub_field['expert']))
					{
						if($sub_field['expert']==false)
							$expert_only='style="display:none" class="expert_only"';
						else
							$expert_only='style="" class="expert_only"';
					}
					$input_field=getInputField($sub_field);
					$sub_line='	<tr id="tr_'.$field_id.'" height="30px" '.$expert_only.'>
								<td class="ui-widget ui-state-highlight ui-corner-all" '.$cell_properties.'>'.$field_name.'</td>
								<td class="value_cell" style="display: block; position: relative;bottom:-2px;width:600px">
									<div id="readonly_'.$field_id.'" readonlyfield="1" group="readonly_'.$field_id.'NUM" '.$read_visibily.'>'.$input_field['display'].'</div>
									<div id="edit_'.$field_id.'" editfield="1" group="edit_'.$field_id.'NUM" '.$edit_visibily.'>';
					
					$res['js'].="updateTrField('$field_id');".$input_field['js'];
					
					$sub_line.=$input_field['input'];
					$sub_line.='					
										
									</div>
								</td>
							</tr>';
					$full_line.=$sub_line;
					
					if(isset($sub_field['duplication']))
					{
						$res['js'].="new_line['".$sub_field['id_field']."']='".($sub_line)."';";
						$full_line.='			<tr '.$expert_only.'>
								<td colspan="3"><ul id="icons" class="icons ui-widget ui-helper-clearfix">
												<li class="ui-state-default ui-corner-all" title="'.$sub_field['duplication'].'" accept_tooltip="1" onclick="addFormField(this,new_line.'.$sub_field['id_field'].');">
												<span class="ui-icon ui-icon-circle-plus"></span>
												</li>
												</ul>
									</td>
								<td></td>
								<td></td>
							</tr>';
					}
					
				}
				$full_line.='					
										</table>
								</td>
							</tr>';
				$res['html'].=$full_line;
				$res['js'].="updateFormField();";
				
				
			}
			else
			{
				$cell_properties='';
				$field_editable='';
				if(@$field['read_only']==true)
					$field_editable='read_only="1"';
				if(isset($field['duplication']) || isset($field['group_field']))
				{
					$field['group_field']=true;
					$cell_properties='id="cell_'.$field_id.'NUM" group="cell_'.$field_id.'NUM" '.$field_editable.' group_text="'.$field_name.' NUM"';
				}
				$input_field=getInputField($field);
				$expert_only='';
				if(isset($field['expert']))
				{
					if($field['expert']==false)
						$expert_only='style="display:none" class="expert_only"';
					else
						$expert_only='style="" class="expert_only"';
				}
				$full_line.='		<tr id="tr_'.$field_id.'" height="30px" '.$expert_only.'>
							<td class="ui-widget ui-state-default ui-corner-all" '.$cell_properties.'>'.$field_name.'</td>
							<td class="value_cell" style="display: block; position: relative;bottom:-2px;width:600px;">
									
									<div id="readonly_'.$field_id.'" readonlyfield="1" '.$read_visibily.'>'.$input_field['display'].'</div>
									<div id="edit_'.$field_id.'" editfield="1" '.$edit_visibily.'>';
				$res['js'].="updateTrField('$field_id');".$input_field['js'];
				$full_line.=$input_field['input'];
				$full_line.='				</div>
							</td>
						</tr>';
				$res['html'].=$full_line;
			}
			
			if(isset($field['duplication']))
			{
				$expert_only='';
				if(isset($field['expert']))
				{
					if($field['expert']==false)
						$expert_only='style="display:none" class="expert_only"';
					else
						$expert_only='style="" class="expert_only"';
				}
				$res['js'].="new_line['".$field['id_field']."']='".($full_line)."';";

				$res['js'].="updateFormField(); $('#body$id_form').sortable({containment: 'parent', handle: '.ui-widget' ,stop: function( event, ui ) {	updateFormField();}});";
				$edit_visibily_no_absolute=str_replace('position:absolute','',$edit_visibily);
				if(@$field['read_only']==false)
				{
					$res['html'].='			<tr '.$expert_only.'>
							<td colspan="3" height="0px" resizeheight="1"><ul id="icons" class="icons ui-widget ui-helper-clearfix" editlabel="1" '.$edit_visibily_no_absolute.'>
											<li class="ui-state-default ui-corner-all" title="'.$field['duplication'].'" accept_tooltip="1" onclick="addFormField(this,new_line[\''.$field['id_field'].'\']);'.'showEditFields(true);'.'">
											<span  class="ui-icon ui-icon-circle-plus"></span>
											</li>
											</ul>
								</td>
							<td></td>
							<td></td>
						</tr>';
				}
			}
		}
		
		
	}
	
	if(!$editonly)
		$res['js'].=$hide_edit;
	if($editonly==false && $readonly==false)
	{
		$submit='<br><div style="position:absolute">
					<span id="submit_'.$id_form.'" style="display:none"><button id="button_submit_'.$id_form.'" type="submit">'.$submit_text.'</button></span>
					<span id="cancel_'.$id_form.'" style="display:none"><button id="button_cancel_'.$id_form.'" type="button" onclick="removeErrorFields();$(\'#submit_'.$id_form.'\').hide( \'fade\', 1000 );$(\'#cancel_'.$id_form.'\').hide( \'fade\', 1000 );$(\'#edit_'.$id_form.'\').show( \'fade\', 1000 );'.$hide_edit.'">'.getLocText('ltext_cancel').'</button></span>
				</div>
				<div style="position:absolute">
					<span id="edit_'.$id_form.'"><button id="button_edit_'.$id_form.'" type="button" onclick="$(\'#submit_'.$id_form.'\').show( \'fade\', 1000 );$(\'#cancel_'.$id_form.'\').show( \'fade\', 1000 );$(\'#edit_'.$id_form.'\').hide( \'fade\', 1000 );'.$show_edit.'">'.getLocText('ltext_edit').'</button></span>
				</div><br>';
		$res['js'].='$( "#button_submit_'.$id_form.'" ).button({ icons: { primary: "ui-icon-check"}});$( "#button_cancel_'.$id_form.'" ).button();$( "#button_edit_'.$id_form.'" ).button();';
	}
	elseif($readonly==false)
	{
		$form_validation="";
		if(isset($form_options['validation']))
			$form_validation=$form_options['validation'];
		$submit='<button type="submit" id="submit_button_'.$id_form.'" validation="'.$form_validation.'">'.$submit_text.'</button>';
		$res['js'].='$( "#submit_button_'.$id_form.'" ).button({ icons: { primary: "ui-icon-check"}});';
	}
	else
		$submit='';
	if($extra_fields!='')
	{
		$extra_fields.=$submit;
		$submit='';
	}
	if($readonly==false)
		$res['js'].='redrawInput();redrawCheckbox();';
	if($submit_text!="")
		$res['html'].='			<tr>
							<td>'.$submit.'</td>
							<td></td>
							<td></td>
						</tr>';
	$res['html'].='		</tbody>
				</table>'.$extra_fields.'
			</form>';
	return $res;
}

function getInputField($field)
{
	$res=array();
	$res['input']="";
	$res['display']="";
	$res['js']="";
	$field_id=$field['id_field'];
	$field_name="";
	$onchange='';
	
	if(isset($field['onchange']))
		$onchange='onchange="'.$field['onchange'].'"';
	if(isset($field['label']))
		$field_name=$field['label'];
	$field_title="";
	if(isset($field['title']))
		$field_title='title="'.protectString($field['title']).'"';
	$field_value="";
	if(isset($field['value']))
		$field_value=protectString($field['value']);
	$field_values=array();
	if(isset($field['values']))
		$field_values=$field['values'];
	$field_validation="";
	if(isset($field['validation']))
	{
		$field_validation=$field['validation'];
		if($field_validation=='valid_date' && DATE_FORMAT==DATE_MDY)
			$field_validation='valid_date_us';
	}
	$field_type="text";
	if($field['type']=='file')
		$field_type="file";
	if($field['type']=='password')
		$field_type="password";
	elseif($field['type']=='checkbox')
		$field_type="checkbox";
	$options="";
	if($field['type']=='date')
		$options='onclick="setDatePicker(this.id);"';
	$group="";
	if(isset($field['group_field']))
		$group='group="'.$field_id.'NUM"';
	$autofocus='';
	if(isset($field['autofocus']))
		$autofocus='autofocus="autofocus"';
	$duplication='';
	if(isset($field['duplication']))
		$duplication='duplication="1"';
	
	$input="";
	$display="";
	if($field['type']=='list')
	{
		$datas=$field['datas'];
		$multiple='';
		$all_no_one='';
		if(isset($field['multiple_choice']))
		{
			$multiple='multiple="1"';
			$all_no_one='<span class="fauxlien ui-widget ui-state-default ui-corner-all" onclick="setCheckAll(\''.$field_id.'\',true)">'.getLocText('ltext_filter_all').'</span>&nbsp;<span class="fauxlien ui-widget ui-state-default ui-corner-all" onclick="setCheckAll(\''.$field_id.'\',false)">'.getLocText('ltext_filter_no_one').'</span>&nbsp;';
			$field_id=$field_id.'[]';
			
		}
		$input.='				<div onmousedown="event.stopPropagation();event.preventDefault(); " accept_tooltip="1" '.$field_title.' >'.$all_no_one.'<select id="'.str_replace('[]','',$field_id).'" '.$group.' name="'.$field_id.'" '.$multiple.' custom_select="1" '.$duplication.' '.$onchange.'>';
		foreach($datas as $key=>$value)
		{
			$selected="";
			$option_value=$value['option_value'];
			$option_name=$value['option_name'];
			if($option_value==$field_value)
			{
				$selected='selected="selected"';
				$display.=$option_name;
			}
			if(in_array($option_value,$field_values))
			{
				$selected='selected="selected"';
				$display.="$option_name ";
			}
			$input.='				<option value="'.$option_value.'" '.$selected.'>'.$option_name.'</option>';
		}
		$input.='				</select></div>';
		//$res['js'].='$("#'.$field_id.'").chosen();';
	}
	elseif($field['type']=='textarea')
	{
		
		$input.='				<textarea id="'.$field_id.'" '.$group.' rows="6" cols="70" name="'.$field_id.'" accept_tooltip="1" onmouseup="updateTrField(\''.$field_id.'\');" validation="'.$field_validation.'" '.$field_title.' '.$autofocus.' '.$duplication.' '.$onchange.'>'.br2nl($field_value).'</textarea>';
		$display=$field_value;
	}
	elseif($field['type']=='color')
	{
		$value='value="'.$field_value.'"';
		$input.='				<input type="'.$field_type.'" style="display:none" id="'.$field_id.'" '.$group.' name="'.$field_id.'" '.$value.' '.$options.' accept_tooltip="1" validation="'.$field_validation.'" '.$field_title.' '.$autofocus.' '.$duplication.' '.$onchange.'>';
		$input.='<div id="colorSelector'.$field_id.'" class="colorSelector"><div style="background-color: #'.$field_value.';"></div></div>';
		$res['js'].='$("#colorSelector'.$field_id.'").ColorPicker({color: "#'.$field_value.'",
						onShow: function (colpkr) {
							$(colpkr).fadeIn(500);
							return false;
						},
						onHide: function (colpkr) {
							$(colpkr).fadeOut(500);
							return false;
						},
						onChange: function (hsb, hex, rgb) {
							$("#colorSelector'.$field_id.' div").css("backgroundColor", "#" + hex);
							$("#'.$field_id.'").val(hex);
						}});';
		$display='<div class="task_color"  style="width:20px;height:20px;background-color:#'.$field_value.'"></div>';
	}
	
	else
	{
		$custom_checkbox='';
		if($field['type']=='checkbox')
		{
			$custom_checkbox='class="custom_checkbox"';
			$value="";
			if($field_value=="1")
				$value='checked="checked"';
				
		}
		else
			$value='value="'.$field_value.'"';
		$input.='				<input type="'.$field_type.'" '.$custom_checkbox.' id="'.$field_id.'" '.$group.' name="'.$field_id.'" '.$value.' '.$options.' accept_tooltip="1" validation="'.$field_validation.'" '.$field_title.' '.$autofocus.' '.$duplication.' '.$onchange.'>';
		
		$display=$field_value;
	}
	$res['input']=$input;
	$res['display']=$display;
	
	if(@$field['read_only']==true)
		$res['input']='<span style="display:none">'.$input.'</span>'.$display;
	
	return $res;
}

function getList($base_name,$items)
{
	$res=array();
	$res['html']="";
	$res['js']="";
	$tri='	<div style="position:absolute;top:-25px" id="list_tri">
				
			</div>';
	$list='<div style="position:relative">'.$tri.'<div id="'.$base_name.'_list">';
	$num_item=-1;
	$count=0;
	$displayed_items=array();
	$js="";
	$active_item=0;
	foreach($items as $key=>$item)
	{
		$id_item=$item['id'];
		$item_name=$item['name'];
		$shortname=$item_name;
		if(isset($item['shortname']))
			$shortname=$item['shortname'];
		$shortname=str_replace('"','&#34;',$shortname);
		$shortname=str_replace("'",'&#39;',$shortname);
		$displayed_items[]=array('id'=>$id_item,'name'=>$shortname);
		if(($item['active']))
		{
			$num_item=$count;
			$active_item=$id_item;
		}
		$count++;
		
		
		$additionnal_info="";	
		if(isset($item['additionnal_info']))
			$additionnal_info=$item['additionnal_info'];
		$list.='<h3 id="'.$base_name.$id_item.'" '.$additionnal_info.' shortname="'.$shortname.'" class="draggable_task" onclick="setPageElement(\''.$base_name.$id_item.'\')">'.$item_name.'</h3>
				<div>';
		
		if(isset($item['sub_items']))
		{
			$sub_items=$item['sub_items'];
			$sub_tab_menu='';
			$sub_tab_content='';
			$sub_tab_id=0;
			foreach($sub_items as $k=>$sub_item)
			{
				$sub_item_name=$sub_item['name'];
				$sub_item_content=$sub_item['html'];
				$js.=$sub_item['js'];
				$sub_tab_menu.='<li><a href="#info'.$sub_tab_id.'_'.$base_name.$id_item.'" onclick="setPageSubElement(\'info'.$sub_tab_id.'\');return false;"><span>'.$sub_item_name.'</span></a></li>';
				$sub_tab_content.='<div id="info'.$sub_tab_id.'_'.$base_name.$id_item.'" processing_img="processing_edit_'.$base_name.$id_item.'">
								'.$sub_item_content.'
								</div>';
				$sub_tab_id++;
			}
			$list.='	<div id="tabs'.$base_name.$id_item.'">
							<div  class="tabs-min">
							<ul>';
			$list.=$sub_tab_menu;
			$list.='		</ul>
							</div>';
			$list.=$sub_tab_content;
			$list.='	</div>';
							
		}
		$list.='</div>';
		$js.='var apparition={effect:"fade",duration:500};$( "#tabs'.$base_name.$id_item.'" ).tabs({ active: ('.($item['active_sub_item']).'),heightStyle:"content",show:apparition });';
		
	}
	$list.='</div></div>';
	$js.='$( "#'.$base_name.'_list" ).accordion({ collapsible: true,active:false,heightStyle: "content" });';
	if($num_item>-1)
		$js.='$( "#'.$base_name.'_list" ).accordion( "option", "active", '.$num_item.' );$("#content_page").scrollTo("#'.$base_name.$active_item.'");';
	
	foreach($displayed_items as $key=>$val)
	{
		$id=$val['id'];
		$name=$val['name'];
		if($base_name=='tache')
			$js.='setDroppableItem("'.$base_name.$id.'");$( "#'.$base_name.$id.'" ).draggable({ distance:20,revert: true,zIndex: 100,opacity: 0.75,scroll: true,cursorAt: { left: 5 },stop:function(){handleCurrentTask("'.$id.'");},helper: function(){return getSelectedTasks("'.$id.'");}});';
		else
			$js.='$( "#'.$base_name.$id.'" ).draggable({ distance:20,revert: true,zIndex: 100,opacity: 0.75,scroll: true,cursorAt: { left: 5 },helper: function(){return $("<div class=\'ui-widget ui-state-default ui-corner-all\' style=\'min-width:50px;min-height:50px;padding:5px;text-align:center;z-index:100\'>'.$name.'</div>").appendTo("body");}});';
	}
	$res['html']=$list;
	$res['js']=$js;
	return $res;
}

function getProjectList($projects,$active_project=0,$active_info=0)
{
	$items=array();
	while($ligne = fetchRequest($projects['result']))
	{
		$id_projet=$ligne['id'];
		$alias=($ligne['alias']);
		
		$project_info=array();
		$project_info['html']='';
		$project_info['js']='';
		
		$project_people=array();
		$project_people['html']='';
		$project_people['js']='';
		
		$project_milestone=array();
		$project_milestone['html']='';
		$project_milestone['js']='';
		
		$project_rampup=array();
		$project_rampup['html']='';
		$project_rampup['js']='';
		
		$project_budget=array();
		$project_budget['html']='';
		$project_budget['js']='';
		
		$project_cout_externe=array();
		$project_cout_externe['html']='';
		$project_cout_externe['js']='';
		
		$project_tags=array();
		$project_tags['html']='';
		$project_tags['js']='';
		
		$project_graph=array();
		$project_graph['html']='';
		$project_graph['js']='';
		
		$project_deadline=array();
		$project_deadline['html']='';
		$project_deadline['js']='';
		
		$project_log=array();
		$project_log['html']='';
		$project_log['js']='';
		
		if($id_projet==$active_project)
		{
			switch($active_info)
			{
				case 0:$project_info=getProjectInfo($id_projet);break;
				case 1:$project_people=getProjectPeople($id_projet);break;
				case 2:$project_milestone=getProjectMilestone($id_projet);break;
				case 3:$project_rampup=getProjectRampUp($id_projet);break;
				case 4:$project_budget=getProjectBudget($id_projet);break;
				case 5:$project_cout_externe=getProjectExternalCosts($id_projet);break;
				case 6:$project_tags=getTagDatas($id_projet);break;
				case 7:$project_graph=getProjectGraph($id_projet);break;
				case 8:$project_deadline=getProjectDeadline($id_projet);break;
				case 9:$project_log=getProjectLog($id_projet);break;
			}
		}
		
			
		$sub_items=array();
		$sub_items[]=array('name'=>getLocText('ltext_project_general'),'html'=>$project_info['html'],'js'=>$project_info['js']);
		$sub_items[]=array('name'=>getLocText('ltext_project_people'),'html'=>$project_people['html'],'js'=>$project_people['js']);
		$sub_items[]=array('name'=>getLocText('ltext_project_milestones'),'html'=>$project_milestone['html'],'js'=>$project_milestone['js']);
		$sub_items[]=array('name'=>getLocText('ltext_project_ramp_up'),'html'=>$project_rampup['html'],'js'=>$project_rampup['js']);
		$sub_items[]=array('name'=>getLocText('ltext_project_budget_evolution'),'html'=>$project_budget['html'],'js'=>$project_budget['js']);
		$sub_items[]=array('name'=>getLocText('ltext_project_external_costs'),'html'=>$project_cout_externe['html'],'js'=>$project_cout_externe['js']);
		$sub_items[]=array('name'=>getLocText('ltext_project_tags'),'html'=>$project_tags['html'],'js'=>$project_tags['js']);
		$sub_items[]=array('name'=>getLocText('ltext_project_progression'),'html'=>$project_graph['html'],'js'=>$project_graph['js']);
		$sub_items[]=array('name'=>getLocText('ltext_project_deadlines'),'html'=>$project_deadline['html'],'js'=>$project_deadline['js']);
		$sub_items[]=array('name'=>getLocText('ltext_project_log'),'html'=>$project_log['html'],'js'=>$project_log['js']);
		$items[]=array('id'=>$id_projet,'name'=>$alias,'sub_items'=>$sub_items,'active'=>($id_projet==$active_project),'active_sub_item'=>$active_info);
	}
	return getList('projet',$items);
}

function getGlobalDatasList($active_menu)
{
	$items=array();
	$can_edit_manmonths=workerHasRight($_SESSION['id_worker'],DROIT_MAN_MONTH);
	
	$jobs=getJobDatas();
	$sub_items=array();
	$sub_items[]=array('name'=>getLocText('ltext_menu_admin_global_data_list'),'html'=>$jobs['html'],'js'=>$jobs['js']);
	$items[]=array('id'=>'_job','name'=>getLocText('ltext_menu_admin_global_data_jobs'),'sub_items'=>$sub_items,'active'=>($active_menu=='global_datas_job'),'active_sub_item'=>0);
	
	$job_categories=getJobCategoryDatas();
	$sub_items=array();
	$sub_items[]=array('name'=>getLocText('ltext_menu_admin_global_data_list'),'html'=>$job_categories['html'],'js'=>$job_categories['js']);
	$items[]=array('id'=>'_job_category','name'=>getLocText('ltext_menu_admin_global_data_categories'),'sub_items'=>$sub_items,'active'=>($active_menu=='global_datas_job_categories'),'active_sub_item'=>0);
	
	$tags=getTagDatas();
	$sub_items=array();
	$sub_items[]=array('name'=>getLocText('ltext_menu_admin_global_data_list'),'html'=>$tags['html'],'js'=>$tags['js']);
	$items[]=array('id'=>'_tag','name'=>getLocText('ltext_menu_admin_global_data_tags'),'sub_items'=>$sub_items,'active'=>($active_menu=='global_datas_tag'),'active_sub_item'=>0);
	
	if($can_edit_manmonths)
	{
		$budget=getBudgetDatas();
		$budget_evolution=getBudgetEvolutionDatas();
		$sub_items=array();
		$sub_items[]=array('name'=>getLocText('ltext_menu_admin_global_data_list'),'html'=>$budget['html'],'js'=>$budget['js']);
		$sub_items[]=array('name'=>getLocText('ltext_menu_admin_global_data_evolution'),'html'=>$budget_evolution['html'],'js'=>$budget_evolution['js']);
		$items[]=array('id'=>'_budget','name'=>getLocText('ltext_menu_admin_global_data_man_month'),'sub_items'=>$sub_items,'active'=>($active_menu=='global_datas_budget'),'active_sub_item'=>0);
	}
	return getList('global_datas',$items);
}

function getBackupOperation()
{
	$res=array();
	$res['html']="";
	$res['js']="";
	$res['html'].=getLocText('ltext_menu_admin_operations_backup_confirm').'<br><button type="button" id="backup_button" onclick="startBackupBases();">'.getLocText('ltext_menu_admin_operations_backup_generate').'</button>';
	$res['js'].='$("#backup_button").button();';
	return $res;
}

function getRestoreOperation()
{
	$res=array();
	$res['html']="";
	$res['js']="";
	$can_restore_base=workerHasRight($_SESSION['id_worker'],DROIT_RESTORE_BASE);
	if(!$can_restore_base)
	{
		$res['html']='	<div style="margin-top: 20px; padding: 0 .7em;" class="ui-state-highlight ui-corner-all">
							<p><span style="float: left; margin-right: .3em;" class="ui-icon ui-icon-info"></span>
							Opération impossible !</p>
						</div>';
		return $res;
	}
	$fields=array();
	$fields[]=array("id_field"=>"backup","label"=>getLocText('ltext_menu_admin_operations_restore_file'),"type"=>"file");
	
	$options=array('submit_text'=>getLocText('ltext_menu_admin_operations_restore_start'),'on_submit'=>"trackProgress('restore_base');");
	$form=getBasicForm("restore_base",$fields,$options);
	$res['html'].=$form['html'];
	$res['js'].=$form['js'].'setAjaxForm("restore_base","post","restore_base","Restauration de base");';
	return $res;
}

function getOperationsList($active_menu)
{
	$items=array();
	if($active_menu=='operations_bdd')
	{
		$backup=getBackupOperation();
		$restore=getRestoreOperation();
	}
	
	$sub_items[]=array('name'=>getLocText('ltext_menu_admin_operations_backup'),'html'=>@$backup['html'],'js'=>@$backup['js']);
	$sub_items[]=array('name'=>getLocText('ltext_menu_admin_operations_restore'),'html'=>@$restore['html'],'js'=>@$restore['js']);
	$items[]=array('id'=>'_bdd','name'=>getLocText('ltext_menu_admin_operations_db'),'sub_items'=>$sub_items,'active'=>$active_menu=='operations_bdd','active_sub_item'=>0);
	
	$sub_items=array();
	if($active_menu=='operations_errors')
	{
		$stages=getStageAnalysis();
		$tasks=getTaskAnalysis();
		$working_days=getWorkAnalysis();
	}
	$sub_items[]=array('name'=>getLocText('ltext_data_stages'),'html'=>@$stages['html'],'js'=>@$stages['js']);
	$sub_items[]=array('name'=>getLocText('ltext_page_task'),'html'=>@$tasks['html'],'js'=>@$tasks['js']);
	$sub_items[]=array('name'=>getLocText('ltext_data_days'),'html'=>@$working_days['html'],'js'=>@$working_days['js']);
	$items[]=array('id'=>'_errors','name'=>getLocText('ltext_menu_admin_operations_analysis'),'sub_items'=>$sub_items,'active'=>$active_menu=='operations_errors','active_sub_item'=>0);
	
	$sub_items=array();
	if($active_menu=='operations_global_edition')
	{
		$stage_transfer=getStageTransfer();
		$priority_redistribution=getPriorityRedistribution();
		$project_transfer=getProjectTransfer();
	}
	$sub_items[]=array('name'=>getLocText('ltext_edition_stage'),'html'=>@$stage_transfer['html'],'js'=>@$stage_transfer['js']);
	$sub_items[]=array('name'=>getLocText('ltext_edition_project'),'html'=>@$project_transfer['html'],'js'=>@$project_transfer['js']);
	$sub_items[]=array('name'=>getLocText('ltext_edition_priority'),'html'=>@$stage_transfer['html'],'js'=>@$stage_transfer['js']);
	$items[]=array('id'=>'_global_edition','name'=>getLocText('ltext_menu_admin_operations_global'),'sub_items'=>$sub_items,'active'=>$active_menu=='operations_global_edition','active_sub_item'=>0);
	
	$sub_items=array();
	if($active_menu=='get_operations_data_export')
	{
		$export_working_days=getWorkingDaysExport();
		$export_planning=getPlanningExport();
	}
	$sub_items[]=array('name'=>getLocText('ltext_export_days'),'html'=>@$export_working_days['html'],'js'=>@$export_working_days['js']);
	$sub_items[]=array('name'=>getLocText('ltext_export_planning'),'html'=>@$export_planning['html'],'js'=>@$export_planning['js']);
	$items[]=array('id'=>'_data_export','name'=>getLocText('ltext_menu_admin_operations_export'),'sub_items'=>$sub_items,'active'=>$active_menu=='operations_data_export','active_sub_item'=>0);
	
	$sub_items=array();
	if($active_menu=='get_operations_update_magic_projects')
	{
		$update_magic_projects=getMagicProjectsUpdate();
		
	}
	$sub_items[]=array('name'=>getLocText('ltext_update_magic_projects'),'html'=>@$update_magic_projects['html'],'js'=>@$update_magic_projects['js']);
	$items[]=array('id'=>'_update_magic_projects','name'=>getLocText('ltext_menu_admin_operations_update_magic_projects'),'sub_items'=>$sub_items,'active'=>$active_menu=='operations_update_magic_projects','active_sub_item'=>0);
	
	return getList('operations',$items);
}

function getMagicProjectsUpdate()
{
	$res=array();
	$res['html']="";
	$res['js']="";
	$update=@curl_get('http://xmarot.com/magic_projects/get_patch.php?version='.MAGIC_PROJECTS_VERSION);
	if($update===false || $update=='' || strpos($update,'Internal Server Error')===0)
	{
		$update="An issue was encountered (see below). Please try again later or contact Xavier Marot (xmarot@gmail.com).<br><br><br>$res";
	}
	$res['html']=$update;
	return $res;
}

function getTaskList($tasks,$active_task=0,$active_info=0)
{
	$requete=requeteSql("select * from avoir_favori where id_worker=".$_SESSION['id_worker']);
	$favorite_tasks=array();
	while($ligne = fetchRequest($requete['result']))
	{
		$id_tache=$ligne['id_tache'];
		$favorite_tasks[]=$id_tache;
	}
	$items=array();
	$font_size='60';
	$favorite_icon='<span class="ui-icon ui-icon-flag" style="left:0"></span>';
	if($_SESSION['pagestyle']=='Bootstrap')
		$font_size='80';
	elseif($_SESSION['pagestyle']=='Absolution') //dirty fix related to Absolution css
		$favorite_icon='<span style=" background-repeat: no-repeat;  display: block; overflow: hidden;   text-indent: -99999px;width:16px;height:16px;background-position: -16px -112px;background-image: url(\'css/Absolution/images/ui-icons_222222_256x240.png\');left: 0;"></span>';
	while($ligne = fetchRequest($tasks['result']))
	{
		$id_tache=$ligne['id_tache'];
		$nom_tache=($ligne['nom_tache']);
		$desc_tache=cutString($ligne['description'],5);
		$color=$ligne['color'];
		$id_etape_first=$ligne['id_etape_first'];
		$priorite_etape_first=$ligne['priorite_etape_first'];
		$task_completion=getTaskState($id_tache);
		if(ENGINE_V2)
		{
			$current_stages=getTaskCurrentStage($id_tache);
			$current_stage=$current_stages[0];
			$details='';
			$details_class='ui-state-highlight ui-corner-all';
			$task_complete=true;
			$owners=array();
			$stage_names=array();
			$time_spent=array();
			$delays=array();
			$show_delay=false;
			foreach($current_stages as $key=>$stage)
			{
				if($stage['statut']!=STAGE_DONE)
					$task_complete=false;
				$owners[]=getWorkerName($stage['id_worker']);
				$stage_names[]=$stage['objectif'];
				$time_spent[]=formatWorkDuration($stage['duree']);
				$retard=$stage['duree']-$stage['estimation_duree'];
				if($retard>0)
				{
					$delays[]='<div class="ui-state-error">'.formatWorkDuration($retard).'</div>';
					$show_delay=true;
				}
				else
					$delays[]='';
			}
			if($task_complete)
			{
				$details.='<font color="green">'.getLocText('ltext_task_completed').'</font>';
			}
			else
			{
				$details.='<div class="tache_detail"><table><tr><td>'.getLocText('ltext_task_owned').'</td><td>'.implode('</td><td>',$owners).'</td></tr>';
				$details.='		  <tr><td>'.getLocText('ltext_task_current_step2').'</td><td>'.implode('</td><td>',$stage_names).'</td></tr>';
				$details.='		  <tr><td>'.getLocText('ltext_task_time_spent2').'</td><td>'.implode('</td><td>',$time_spent).'</td></tr>';
				if($show_delay)
					$details.='		  <tr><td>'.getLocText('ltext_task_delay2').'</td><td>'.implode('</td><td>',$delays).'</td></tr>';
				$details.='</table></div>';
			}
		}
		else
		{
			$current_stage=getTaskCurrentStage($id_tache);
			$details='';
			$img_details='<img src="img/info.png">';
			$details_class='ui-state-highlight ui-corner-all';
			
			if($current_stage['statut']==STAGE_DONE)
			{
				$details.='<font color="green">'.getLocText('ltext_task_completed').'</font>';
				$img_details='<img src="img/info_done.png">';
			}
			else
			{
				$owner=str_replace('[X]',getWorkerName($current_stage['id_worker']),getLocText('ltext_task_owner'));
				$details.=$owner.'<br>'.getLocText('ltext_task_current_step').$current_stage['objectif']."<br>";
				$details.=getLocText('ltext_task_time_spent').formatWorkDuration($current_stage['duree']).'<br>';
				$retard=$current_stage['duree']-$current_stage['estimation_duree'];
				if($retard>0)
				{
					$img_details='<img src="img/warning.png">';
					$details_class='ui-state-error ui-corner-all';
					$details.=getLocText('ltext_task_delay').formatWorkDuration($retard).'<br>';
				}
			}
		}
		
		
		$select_priority=getSelectStagePriority($id_etape_first,$priorite_etape_first);
		
		
		$task_info=array();
		$task_info['html']='';
		$task_info['js']='';
		
		$task_flow=array();
		$task_flow['html']='';
		$task_flow['js']='';
		
		$task_flow_graph=array();
		$task_flow_graph['html']='';
		$task_flow_graph['js']='';
		
		$task_current_stage=array();
		$task_current_stage['html']='';
		$task_current_stage['js']='';
		
		$task_documents=array();
		$task_documents['html']='';
		$task_documents['js']='';
		
		$task_comments=array();
		$task_comments['html']='';
		$task_comments['js']='';
		
		$task_logs=array();
		$task_logs['html']='';
		$task_logs['js']='';
		
		$task_removal=array();
		$task_removal['html']='';
		$task_removal['js']='';
		
		if($id_tache==$active_task)
		{
			switch($active_info)
			{
				case 0:$task_info=getTaskInfo($id_tache);break;
				case 1:$task_current_stage=getTaskCurrentStageInfo($id_tache);break;
				case 2:$task_flow=getTaskFlow($id_tache);break;
				case 3:$task_flow_graph=getTaskFlow($id_tache,DISPLAY_GRAPH);break;
				case 4:$task_documents=getTaskDocuments($id_tache);break;
				case 5:$task_comments=getTaskComments($id_tache);break;
				case 6:$task_logs=getTaskLog($id_tache);break;
				case 7:$task_removal=getTaskRemoval($id_tache);break;
			}
		}
		
		$additionnal_info='id_current_etape="'.$id_etape_first.'" priorite="'.$priorite_etape_first.'"';
		
		$requete=requeteSql("select * from pj p, etape e where p.id_etape=e.id and e.id_tache=$id_tache");
		$nb_docs=$requete['nb_lines'];
		$img_pj='';
		if($nb_docs>0)
			$img_pj='<div style="position:relative"><div style="position:absolute;top:30px;left:25px;border:1px solid black;border-radius:40px;color:white;background-color:red;min-width:20px;text-align:center" class="small_text">'.$nb_docs.'</div><img src="img/pj.png"></div>';
		
		$requete=requeteSql("select * from commentaire c, etape e where c.id_etape=e.id and e.id_tache=$id_tache");
		$nb_comments=$requete['nb_lines'];
	
		$sub_items=array();
		$sub_items[]=array('name'=>getLocText('ltext_task_general'),'html'=>$task_info['html'],'js'=>$task_info['js']);
		$sub_items[]=array('name'=>getLocText('ltext_task_current'),'html'=>$task_current_stage['html'],'js'=>$task_current_stage['js']);
		$sub_items[]=array('name'=>getLocText('ltext_task_stages'),'html'=>$task_flow['html'],'js'=>$task_flow['js']);
		$sub_items[]=array('name'=>getLocText('ltext_task_flow'),'html'=>$task_flow_graph['html'],'js'=>$task_flow_graph['js']);
		$sub_items[]=array('name'=>str_replace('[X]',$nb_docs,getLocText('ltext_task_documents')),'html'=>$task_documents['html'],'js'=>$task_documents['js']);
		$sub_items[]=array('name'=>str_replace('[X]',$nb_comments,getLocText('ltext_task_comments')),'html'=>$task_comments['html'],'js'=>$task_comments['js']);
		$sub_items[]=array('name'=>getLocText('ltext_task_history'),'html'=>$task_logs['html'],'js'=>$task_logs['js']);
		$sub_items[]=array('name'=>getLocText('ltext_task_delete'),'html'=>$task_removal['html'],'js'=>$task_removal['js']);
		
		$class_color='';
		if($color!='')
			$class_color='task_color';
		$favorite='ui-state-default';
		if(in_array($id_tache,$favorite_tasks))
			$favorite='ui-state-error';
		$items[]=array('id'=>$id_tache,'shortname'=>$nom_tache,'name'=>'<item2></item2><div style="position:absolute;top:6px;right:35px"><div  id="favorite_'.$id_tache.'" onclick="switchFavorite(event,'.$id_tache.');" class="'.$favorite.' ui-corner-all" style="min-height:16px;min-width:16px;">'.$favorite_icon.'</div></div><div style="position:absolute;top:5px;right:10px"><input id="multiselect_tache'.$id_tache.'" class="custom_checkbox_multiselect" type="checkbox" value="'.$id_tache.'" ></div><table><tr><td width="70px"><div id="color_'.$id_tache.'" onclick="showColorPicker(this,\''.$id_tache.'\',\''.$color.'\');event.preventDefault();event.stopPropagation();" class="'.$class_color.'" style="position:absolute;z-index:5;left:-25px;width:20px;height:20px;background-color:#'.$color.';"></div>['.getProjectName($current_stage['id_projet']).']</td><td width="200px">'.$nom_tache.'</td><td width="500px"><div style="font-size:'.$font_size.'%;color:black;word-wrap:break-word;width:500px">'.$desc_tache.'</div></td><td>'.$select_priority.'</td><td><div class="'.$details_class.'" style="font-size:'.$font_size.'%;word-wrap:break-word;"><i>'.$details.'</i></div></td><td><div title="'.str_replace('[X]',$nb_docs,getLocText('ltext_task_attached_documents')).'" accept_tooltip="1">'.$img_pj.'</div></td><td>'.$task_completion.'%</td></tr></table>','sub_items'=>$sub_items,'active'=>($id_tache==$active_task),'active_sub_item'=>$active_info,'additionnal_info'=>$additionnal_info);
	}
	$res=getList('tache',$items);
	$res['js'].='redrawCheckbox("multiselect");$(".custom_checkbox_multiselect").on("ifToggled", function(event){
						 setMultiSelection($(this).val());
						});';
	return $res;
}

function cutString($str,$nb_lines)
{
	$res='';
	$str_parts=explode('<br />',$str);
	$i=0;
	for($i=0;$i<sizeof($str_parts) && $i<$nb_lines;$i++)
	{
		$res.=$str_parts[$i].'<br />';
	}
	if($i!=sizeof($str_parts))
		$res.='<i>['.getLocText('ltext_task_read_more').']</i>';
	return $res;
}

function getAllTaskTable($tasks)
{
	$res=array();
	$res['html']="";
	$res['js']="";
	$res['html'].='<div style="width:80%"><table id="all_tasks" class="display">
						<thead>
							<tr>
								<th>'.getLocText('ltext_task').'</th>
								<th>'.getLocText('ltext_task_description').'</th>
								<th>'.getLocText('ltext_task_current').'</th>
								<th>'.getLocText('ltext_task_assigned').'</th>
								<th>'.getLocText('ltext_task_status').'</th>
								<th>'.getLocText('ltext_task_author').'</th>
								<th>'.getLocText('ltext_task_last_modification').'</th>
							</tr>
						</thead>
						<tbody>';
	
	while($ligne = fetchRequest($tasks['result']))
	{
		$id_tache=$ligne['id_tache'];
		$nom_tache=($ligne['nom_tache']);
		$desc_tache=($ligne['description']);
		$id_etape_first=$ligne['id_etape_first'];
		$priorite_etape_first=$ligne['priorite_etape_first'];
		if(ENGINE_V2)
		{
			$current_stages=getTaskCurrentStage($id_tache);
			$current_stage=$current_stages[0];
		}
		else
			$current_stage=getTaskCurrentStage($id_tache);
		$current_owner=getWorkerName($current_stage['id_worker']);
		$auteur=getWorkerName($ligne['id_auteur']);
		$current_objective=$current_stage['objectif'];
		$date_derniere_modif=dateHtml($ligne['date_derniere_modif']);
		$details='';
		$img_statut="";
		switch($current_stage['statut'])
		{
			case STAGE_TODO:$img_statut='<div style="display:none">'.getLocText('ltext_menu_task_todo').'</div><img alt="test" src="img/todo.png">';break;
			case STAGE_STANDBY:$img_statut='<div style="display:none">'.getLocText('ltext_menu_task_pending').'</div><img alt="test" src="img/wait.png">';break;
			case STAGE_WIP:$img_statut='<div style="display:none">'.getLocText('ltext_menu_task_wip').'</div><img alt="test" src="img/wip.png">';break;
			case STAGE_DONE:$img_statut='<div style="display:none">'.getLocText('ltext_menu_task_complete').'</div><img alt="test" src="img/check.png">';break;
		}
		
		$res['html'].='
							<tr>
								<td><a href="#taches/display/tache'.$id_tache.'">'.$nom_tache.'</a></td>
								<td>'.$desc_tache.'</td>
								<td>'.$current_objective.'</td>
								<td>'.$current_owner.'</td>
								<td>'.$img_statut.'</td>
								<td>'.$auteur.'</td>
								<td>'.$date_derniere_modif.'</td>
							</tr>';
	}
	$res['html'].='		</tbody>
					</table><div id="all_tasks_buttons" class="table_buttons"></div></div>';
	$date_sort='date-euro';
	if(DATE_FORMAT==DATE_MDY)
	{
		$date_sort='date-us';
	}
	$res['js'].='var my_table=$("#all_tasks").DataTable({buttons: ["excel", "pdf"],select: true,"colReorder": true,"aoColumnDefs": [{ "sSortDataType": "dom-text","sType": "'.$date_sort.'", "aTargets": [ 6 ] } ]});';
	$res['js'].='my_table.buttons().container().appendTo( $("#all_tasks_buttons") );';
	
	return $res;
}

function getWorkerList($workers,$active_worker=0,$active_info=0)
{
	$items=array();
	while($ligne = fetchRequest($workers['result']))
	{
		$id_worker=$ligne['id'];
		$nom_worker=$ligne['nom_worker'];
		
		$worker_info=array();
		$worker_info['html']='';
		$worker_info['js']='';
		
		$worker_holidays=array();
		$worker_holidays['html']='';
		$worker_holidays['js']='';
		
		$worker_projects=array();
		$worker_projects['html']='';
		$worker_projects['js']='';
		
		$worker_stats=array();
		$worker_stats['html']='';
		$worker_stats['js']='';
		
	
		if($id_worker==$active_worker)
		{
			switch($active_info)
			{
				case 0:$worker_info=getWorkerInfo($id_worker);break;
				case 1:$worker_holidays=getWorkerHolidays($id_worker);break;
				case 2:$worker_projects=getWorkerProjects($id_worker);break;
				case 3:$worker_stats=getWorkerStats($id_worker);break;
			}
		}
		
		$sub_items=array();
		$sub_items[]=array('name'=>'<span localized="1" id="ltext_team_general">'.getLocText('ltext_team_general').'</span>','html'=>$worker_info['html'],'js'=>$worker_info['js']);
		$sub_items[]=array('name'=>'<span localized="1" id="ltext_team_holidays">'.getLocText('ltext_team_holidays').'</span>','html'=>$worker_holidays['html'],'js'=>$worker_holidays['js']);
		$sub_items[]=array('name'=>getLocText('ltext_team_projects'),'html'=>$worker_projects['html'],'js'=>$worker_projects['js']);
		$sub_items[]=array('name'=>getLocText('ltext_team_stats'),'html'=>$worker_stats['html'],'js'=>$worker_stats['js']);
		$items[]=array('id'=>$id_worker,'name'=>$nom_worker,'sub_items'=>$sub_items,'active'=>($id_worker==$active_worker),'active_sub_item'=>$active_info);
	}
	return getList('worker',$items);
}

function updatePage($html,$js,$page_part="content_page",$ignore_error=0)
{
	$html=protectString($html);
	$js=protectString($js);
	echo 'updatePage("'.$html.'","'.$js.'","'.$page_part.'",'.$ignore_error.');';
}

function updateInfo()
{
	echo 'try{$( "#dialog-message").dialog( "close" );}catch(e){}display_(window.location.hash);';
}



function getSelectStagePriority($id_etape,$current_priority,$will_only_update_stage=0)
{
	$res='';
	$res.='<select onclick="event.stopPropagation();event.preventDefault();" onchange="setStagePriority('.$id_etape.',this.value,'.$will_only_update_stage.');">';
	for($i=0;$i<100;$i++)
	{
		$selected='';
		if($i==$current_priority)
			$selected='selected="selected"';
		$res.='<option value="'.$i.'" '.$selected.'>'.$i.'</option>';
	}
	$res.='</select>';
	return $res;
}

function getWorkerStatutSelector()
{
	$res=array();
	$res[]=array('option_name'=>getLocText('ltext_team_jobs_undefined'),'option_value'=>UNDEFINED);
	$res[]=array('option_name'=>getLocText('ltext_team_jobs_salary'),'option_value'=>SALARIE);
	$res[]=array('option_name'=>getLocText('ltext_team_jobs_trainee'),'option_value'=>STAGIAIRE);
	$res[]=array('option_name'=>getLocText('ltext_team_jobs_owner'),'option_value'=>OWNER);
	$res[]=array('option_name'=>getLocText('ltext_team_jobs_salary_out_budget'),'option_value'=>CHERCHEUR);
	$res[]=array('option_name'=>getLocText('ltext_team_jobs_freelance'),'option_value'=>FREELANCE);
	return $res;
}

function getRightSelector()
{
	$res=array();
	$res[]=array('option_name'=>getLocText('ltext_team_rights_standard'),'option_value'=>DROIT_STANDARD);
	$res[]=array('option_name'=>getLocText('ltext_team_rights_estimation'),'option_value'=>DROIT_EDIT_ESTIMATION);
	$res[]=array('option_name'=>getLocText('ltext_team_rights_budget'),'option_value'=>DROIT_SEE_BUDGET);
	$res[]=array('option_name'=>getLocText('ltext_team_rights_edition'),'option_value'=>DROIT_EDIT_ALL_WORKERS);
	$res[]=array('option_name'=>getLocText('ltext_team_rights_restore'),'option_value'=>DROIT_RESTORE_BASE);
	$res[]=array('option_name'=>getLocText('ltext_team_rights_repair'),'option_value'=>DROIT_REPAIR_BASE);
	$res[]=array('option_name'=>getLocText('ltext_team_rights_right'),'option_value'=>DROIT_EDIT_RIGHTS);
	$res[]=array('option_name'=>getLocText('ltext_team_rights_man_month'),'option_value'=>DROIT_MAN_MONTH);
	$res[]=array('option_name'=>getLocText('ltext_team_rights_get_holidays'),'option_value'=>DROIT_GET_HOLIDAYS);
	$res[]=array('option_name'=>getLocText('ltext_team_rights_real_time'),'option_value'=>DROIT_EDIT_REAL_TIME);
	return $res;
}

function getHolidayTypeSelector()
{
	$res=array();
	$res[]=array('option_name'=>getHolidayType(VAC_CONGES),'option_value'=>VAC_CONGES);
	$res[]=array('option_name'=>getHolidayType(VAC_MALADIE),'option_value'=>VAC_MALADIE);
	$res[]=array('option_name'=>getHolidayType(VAC_FORMATION),'option_value'=>VAC_FORMATION);
	return $res;
}

function getLanguageSelector()
{
	$res=array();
	$res[]=array('option_name'=>getLocText('ltext_english'),'option_value'=>LANG_EN);
	$res[]=array('option_name'=>getLocText('ltext_french'),'option_value'=>LANG_FR);
	return $res;
}

function getStageStatusSelector()
{
	$res=array();
	$res[]=array('option_name'=>getLocText('ltext_menu_task_all'),'option_value'=>-1);
	$res[]=array('option_name'=>getLocText('ltext_menu_task_todo'),'option_value'=>STAGE_TODO);
	$res[]=array('option_name'=>getLocText('ltext_menu_task_wip'),'option_value'=>STAGE_WIP);
	$res[]=array('option_name'=>getLocText('ltext_menu_task_pending'),'option_value'=>STAGE_STANDBY);
	$res[]=array('option_name'=>getLocText('ltext_menu_task_complete'),'option_value'=>STAGE_DONE);
	return $res;
}

function getCredits()
{
	$res=array();
	$res['html']="";
	$res['js']='var scroll=$(".content_page").scrollTo("max",40000,{easing:"easeInSine",onAfter:function(){$("#thank_you").effect("puff",{pertcent:100000},3000);}});$(window).on( "mousedown DOMMouseScroll mousewheel", function(){scroll.stop();} );';
	
	$res['html'].='<center><div class="ui-state-active ui-corner-all" style="width:500px"><h1>Magic Projects (version '.MAGIC_PROJECTS_VERSION.')</h1></div>';
	$res['html'].='<br><br><br><br><div class="ui-state-highlight ui-corner-all" style="width:500px"><h1>Designed and developed by</h1></div>';
	$res['html'].='<h2><a target="_blank" href="http://xmarot.com">Xavier Marot</a></h2><br><br><br>';
	
	$res['html'].='<div class="ui-state-highlight ui-corner-all" style="width:500px"><h1>External Javascript libraries</h1></div>';
	$res['html'].='<h2><a target="_blank" href="http://jquery.com/">JQuery<a></h2>';
	$res['html'].='<h2><a target="_blank" href="http://jqueryui.com/">JQuery UI</a></h2>';
	$res['html'].='<h2><a target="_blank" href="http://jquery.malsup.com/form/">jQuery Form Plugin</a></h2>';
	$res['html'].='<h2><a target="_blank" href="http://demos.flesler.com/jquery/scrollTo/">jQuery.scrollTo</a></h2>';
	$res['html'].='<h2><a target="_blank" href="https://www.filamentgroup.com/lab/update-to-jquery-visualize-accessible-charts-with-html5-from-designing-with.html">Visualize</a></h2>';
	$res['html'].='<h2><a target="_blank" href="http://taitems.github.io/jQuery.Gantt/">jQuery.Gantt</a></h2>';
	$res['html'].='<h2><a target="_blank" href="https://github.com/weixiyen/jquery-filedrop">jQuery filedrop plugin</a></h2>';
	$res['html'].='<h2><a target="_blank" href="http://kilianvalkhof.com/jquerypulsate/">jQuery.pulsate</a></h2>';
	$res['html'].='<h2><a target="_blank" href="https://harvesthq.github.io/chosen/">Chosen</a></h2>';
	$res['html'].='<h2><a target="_blank" href="http://www.eyecon.ro/colorpicker/">Color Picker</a></h2>';
	$res['html'].='<h2><a target="_blank" href="http://ionden.com/a/plugins/ion.sound/en.html">Ion.Sound</a></h2>';
	$res['html'].='<h2><a target="_blank" href="http://notifyjs.com/">Notify.js</a></h2>';
	$res['html'].='<h2><a target="_blank" href="http://fronteed.com/iCheck/">iCheck</a></h2>';
	$res['html'].='<h2><a target="_blank" href="https://jsplumbtoolkit.com/">jsplumb</a></h2>';
	$res['html'].='<h2><a target="_blank" href="http://touchpunch.furf.com/">jQuery UI Touch Punch</a></h2>';
	$res['html'].='<h2><a target="_blank" href="https://github.com/riklomas/quicksearch">quicksearch</a></h2>';
	$res['html'].='<h2><a target="_blank" href="http://krazedkrish.com/select-multiple/#home">select-multiple</a></h2><br>';
	
	$res['html'].='<div class="ui-state-highlight ui-corner-all" style="width:500px"><h1>External PHP libraries</h1></div>';
	$res['html'].='<h2><a target="_blank" href="https://github.com/PHPMailer/PHPMailer">PHPMailer</a></h2>';
	$res['html'].='<h2><a target="_blank" href="http://excelwriterxml.sourceforge.net/">ExcelWriterXML</a></h2>';
	$res['html'].='<h2><a target="_blank" href="https://github.com/brainfoolong/cryptojs-aes-php">cryptojs-aes-php</a></h2><br>';
	
	$res['html'].='<div class="ui-state-highlight ui-corner-all" style="width:500px"><h1>External CSS styles</h1></div>';
	$res['html'].='<h2><a target="_blank" href="http://jqueryui.com/themeroller/">jQuery UI ThemeRoller</a></h2>';
	$res['html'].='<h2><a target="_blank" href="https://jquery-ui-bootstrap.github.io/jquery-ui-bootstrap/">Bootstrap</a></h2>';
	$res['html'].='<h2><a target="_blank" href="https://github.com/taitems/Aristo-jQuery-UI-Theme">Aristo</a></h2>';
	$res['html'].='<h2><a target="_blank" href="https://github.com/MichaelVdheeren/Absolution">Absolution</a></h2><br>';
	
	$res['html'].='<div class="ui-state-highlight ui-corner-all" style="width:500px"><h1>Special thanks</h1></div>';
	$res['html'].='<h2><a target="_blank" href="http://www.magicpockets.com/">Magic Pockets</a></h2><br>';
	
	$res['html'].='<div class="ui-state-highlight ui-corner-all" style="width:500px"><h1>License</h1></div>';
	$res['html'].='<h2><a target="_blank" href="https://tldrlegal.com/license/mit-license#fulltext"><p>The MIT License (MIT)</p></a><br><br><br><br><br><br><br><br><br>
			<p>Copyright © 2016 Xavier Marot</p>
			<p>Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:</p>
			<p>The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.</p>
			<p>THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.</p></h2><br><br><br><br><br><br><br><br><br><br><br><br>';
	
	$res['html'].='<div id="thank_you" style="position:absolute;margin-left:40%;margin-right:40%;width:320px;"><h1>Thank you for playing! :-)</h1></div><br><br><br><br><br></center>';
	return $res;
}

function getPageStyleSelector()
{
	$res=array();
	clearstatcache();
	$folder='css/';
	if (is_dir($folder)) 
	{
		if ($dh = opendir($folder)) 
		{
			while (($file = readdir($dh)) !== false) 
			{
				if($file!="." && $file!=".." && is_dir($folder.$file))
				{
					if(file_exists($folder.$file.'/jquery-ui-1.10.3.custom.css'))
						$res[]=array('option_name'=>$file,'option_value'=>$file);
				}
			}
			closedir($dh);
		}
	}
	sortArrayWithKeys($res,'option_name');
	return $res;
}

function getWorkableDays($month,$year)
{
	if(DATE_FORMAT==DATE_MDY)
		$start_time=getTimeStamp("$month/01/$year");
	else
		$start_time=getTimeStamp("01/$month/$year");
	$res=0;
	for($day=$start_time;date('n',$day)==$month;$day+=24*60*60)
	{
		$jour=date('D',$day);
		if($jour!='Sat' && $jour!='Sun')
		{
			$res++;
		}
	}
	return $res;
}

function formatWorkDuration($work_time)
{
	$res="";
	$days=0;
	$negative=false;
	if($work_time<0)
	{
		$negative=true;
		$work_time=abs($work_time);
	}
	if($work_time>DAILY_WORKING_HOURS)
		$days=floor($work_time/DAILY_WORKING_HOURS);
	$hours=floor($work_time)-DAILY_WORKING_HOURS*$days;
	$minutes=floor(($work_time-floor($work_time))*60);
	if($days>0)
		$res.=$days.getLocText('ltext_day').' ';
	if($hours>0)
		$res.=$hours.getLocText('ltext_hour').' ';
	if($minutes>0)
		$res.=$minutes.getLocText('ltext_minute').' ';
	$res=substr($res, 0, -1);
	if($negative)
		$res="-$res";
	return $res;
}

function br2nl($string)
{
	return str_replace('<br />',"\\r\\n", $string);
    return preg_replace('/\<br(\s*)?\/?\>/i', "\n", $string);
}

function sendMail($params)
{
	if(USE_CUSTOM_EMAIL)
	{
		$mail = new PHPMailer;
		if(EMAIL_IS_SMTP)
			$mail->isSMTP();                                      // Set mailer to use SMTP
		$mail->Host = EMAIL_HOST;  // Specify main and backup server
		$mail->SMTPAuth = EMAIL_SMTP_AUTH;                               // Enable SMTP authentication
		$mail->Username = EMAIL_USERNAME;                            // SMTP username
		$mail->Password = EMAIL_PASSWORD;                           // SMTP password
		$mail->SMTPSecure = EMAIL_SMTP_SECURE;                            // Enable encryption, 'ssl' also accepted

		$mail->From = EMAIL_FROM;
		$mail->FromName = EMAIL_FROM_NAME;
		foreach($params['to'] as $key=>$destinataire)
			$mail->addAddress($destinataire);  // Add a recipient


		$mail->isHTML(true);                                  // Set email format to HTML

		$mail->Subject = utf8_decode($params['subject']);
		$mail->Body    = '<html><head><meta charset="utf-8"></head><body>'.utf8_decode($params['message']).'</body></html>';
		$mail->AltBody = $params['message'];

		if(!$mail->send()) {
			echo 'Message could not be sent.';
			echo 'Mailer Error: ' . $mail->ErrorInfo;
			return false;
		}

		return true;
	}
	else
	{
		$headers  = 'MIME-Version: 1.0' . "\r\n";
		$headers .= 'Content-type: text/html; charset=utf-8' . "\r\n";
		$headers .= 'From: '.EMAIL_FROM_NAME.' <'.EMAIL_FROM.'>' . "\r\n";
		$message='<html><head><meta charset="utf-8"></head><body>'.utf8_decode($params['message']).'</body></html>';
		$mail_sent=true;
		foreach($params['to'] as $key=>$destinataire)
		{
			$mail_sent=mail($destinataire,$params['subject'],$message,$headers);
		}
		return $mail_sent;
	}
}

function onScriptEnd()
{
	/*global $errors_on_script_end;
	if($errors_on_script_end)
		echo 'alert("Le script ne s\'est pas terminé correctement...")';
	else
		echo 'alert("Le script s\'est terminé correctement...")';
	*/
}

function getBackupBase($base_name)//backup function that returns sql instruction to re-create database
{
	$requete=requeteSql("show tables from $base_name");
	$res="";
	while($ligne = fetchRequest($requete['result']))
	{
		$res.=getBackupTable($ligne["Tables_in_$base_name"]);
	}
	return $res;
}

function getBackupTable($table_name)
{
	$requete=requeteSql("show columns from $table_name");
	$res="\nDROP TABLE IF EXISTS `$table_name`;\r\n
	CREATE TABLE `$table_name` (\r\n";
	$fields=array();
	$primary_key="";
	$keys=array();
	while($ligne = fetchRequest($requete['result']))
	{
		$field=$ligne['Field'];
		$type=$ligne['Type'];
		($ligne['Null']=="YES")?$is_null="":$is_null="NOT NULL";
		($ligne['Default']===NULL)?$default="":$default="DEFAULT ".chaineMysql($ligne['Default']);
		$extra=$ligne['Extra'];
		$fields[]=$field;
		if($ligne['Key']=="PRI")
			$primary_key=$field;
		elseif($ligne['Key']=="MUL")
			$keys[]=$field;
		
		$res.="`$field` $type $is_null $default $extra,\r\n";
	}
	if($primary_key!="")
		$res.="PRIMARY KEY (`$primary_key`)";
	if(sizeof($keys)>0)
		$res.=",";
	$res.="\r\n";
	foreach($keys as $key=>$val)
	{
		$res.="KEY `$val` (`$val`)";
		if($key!=sizeof($keys)-1)
			$res.=",";
		$res.="\r\n";
	}
	$res.=")ENGINE=InnoDB  DEFAULT CHARSET=utf8;\r\n\r\n";
	$field_chaine=implode(",",$fields);
	$requete=requeteSql("select $field_chaine from $table_name");
	while($ligne = fetchRequest($requete['result']))
	{
		$ligne=array_map("chaineMysql",$ligne);
		$valeurs=implode(",",$ligne);
		$res.="\tinsert into $table_name ($field_chaine) values ($valeurs);\r\n";
	}
	return $res;

} 

function cmpStringInArray($array1,$array2)
{
	foreach($GLOBALS["key"] as $key=>$val)
	{
		if($array1[$val]!=$array2[$val])
			return strcmp($array1[$val], $array2[$val]);
	}
	return strcmp($array1[$GLOBALS["key"][0]], $array2[$GLOBALS["key"][0]]);
}

function sortArrayWithKeys(&$my_array)
{
	$numargs = func_num_args();
	$arg_list = func_get_args();
	$GLOBALS["key"]=array();
	for ($i = 1; $i < $numargs; $i++)
		$GLOBALS["key"][]=$arg_list[$i];
	usort($my_array, "cmpStringInArray");
}

function arem($array,$value)
{
    $holding=array();
    foreach($array as $k => $v){
        if($value!=$v){
            $holding[$k]=$v;
        }
    }   
    return $holding;
}

function testValue($var,$val)
{
	if(isset($val))
	{
		return ($val==$val);
	}
	return false;
}

function debugXav()
{
	if($_SESSION['id_worker']==1)
		return true;
	return false;
}

function writeOnLog($filename,$text)
{
	$jour = date('d')."-".date('m')."-".date('Y');
	//$auteur=getUserName($_SESSION['id_user']);
	//$auteur=$_SESSION['id_user'];
	$auteur="";
	$path_log='log/';
	$lockname=$path_log."$filename-LOCK";
	getLock($lockname);
	$log = fopen($path_log."$filename", "a+");  // On ouvre le log
	fwrite($log,"$jour\t$auteur\t\t\t$text\n");
	fclose($log);
	releaseLock($lockname);
}

function getLock($lockName)
{
	$enterTime = time();
	while(file_exists($lockName))
	{
		sleep(1);
		$info=@stat($lockName);
		if($info)
		{
			if(time()-$info["mtime"]>600)
				@unlink($lockName);
		}
		clearstatcache();
	}
	$fpl = fopen($lockName, "w"); 
	fwrite($fpl, "locked");
}

function releaseLock($lockName)
{
	@fclose($lockName); 
	@unlink($lockName); 
}

function updateProgress($process_name,$new_progress)
{
	$path='tmp/'.getWorkerName($_SESSION['id_worker']).'/';
	if(!(is_dir($path)))
		mkdir($path);
	$file=fopen($path.$process_name.'.txt','w');
	fwrite($file,$new_progress);
	fclose($file);
}

function getProgress($process_name)
{
	$path='tmp/'.getWorkerName($_SESSION['id_worker']).'/';
	$progress=@file_get_contents($path.$process_name.'.txt');
	return $progress;
}

function formatChatMessage($brut_text)
{
	$in=array('`((?:http?|ftp?|https)://\S+[[:alnum:]]/?)`si','`((?<!//)(www\.\S+[[:alnum:]]/?))`si');
    $out=array("<a href='$1'  target='_blank'>$1</a> ","<a href='http://$1' target='_blank'>$1</a>");
	
	$brut_text=preg_replace($in,$out,$brut_text);
	
	if(strpos($brut_text,"[no_smiley]")===false)
	{
		$brut_text=str_replace(':)',"<img src='img/smileys/icon_smile.gif'>",$brut_text);
		$brut_text=str_replace(';)',"<img src='img/smileys/icon_wink.gif'>",$brut_text);
		$brut_text=str_replace(':D',"<img src='img/smileys/icon_biggrin.png'>",$brut_text);
		$brut_text=str_replace(':roll:',"<img src='img/smileys/icon_rolleyes.gif'>",$brut_text);
		$brut_text=str_replace(':oops:',"<img src='img/smileys/icon_redface.gif'>",$brut_text);
		$brut_text=str_replace(':shock:',"<img src='img/smileys/icon_eek.gif'>",$brut_text);
		$brut_text=str_replace(':lol:',"<img src='img/smileys/icon_lol.gif'>",$brut_text);
		$brut_text=str_replace(':x',"<img src='img/smileys/icon_mad.gif'>",$brut_text);
		$brut_text=str_replace('&gt;&lt;',"<img src='img/smileys/icon_mad.gif'>",$brut_text);
		$brut_text=str_replace(':(',"<img src='img/smileys/icon_sad.gif'>",$brut_text);
		$brut_text=str_replace(':?:',"<img src='img/smileys/icon_question.gif'>",$brut_text);
		$brut_text=str_replace(':cry:',"<img src='img/smileys/icon_cry.gif'>",$brut_text);
		$brut_text=str_replace(':p',"<img src='img/smileys/icon_razz.gif'>",$brut_text);
		$brut_text=str_replace(':twisted:',"<img src='img/smileys/icon_twisted.gif'>",$brut_text);
		$brut_text=str_replace(':sunny:',"<img src='img/smileys/icon_sunny.png'>",$brut_text);
		$brut_text=str_replace(':tired:',"<img src='img/smileys/icon_break.gif'>",$brut_text);
		$brut_text=str_replace(':scratch:',"<img src='img/smileys/icon_scratch.png'>",$brut_text);
		$brut_text=str_replace(':out:',"<img src='img/smileys/icon_out.gif'>",$brut_text);
		$brut_text=str_replace(':love:',"<img src='img/smileys/icon_kiss.gif'>",$brut_text);
		$brut_text=str_replace(':goodboy:',"<img src='img/smileys/icon_goodboy.gif'>",$brut_text);
		$brut_text=str_replace(':hate1:',"<img src='img/smileys/icon_hate1.gif'>",$brut_text);
		$brut_text=str_replace(':hate2:',"<img src='img/smileys/icon_hate2.gif'>",$brut_text);
		$brut_text=str_replace(':hate3:',"<img src='img/smileys/icon_hate3.gif'>",$brut_text);
		$brut_text=str_replace(':hate4:',"<img src='img/smileys/icon_hate4.gif'>",$brut_text);
		$brut_text=str_replace(':hate5:',"<img src='img/smileys/icon_hate5.gif'>",$brut_text);
		$brut_text=str_replace(':hate6:',"<img src='img/smileys/icon_hate6.gif'>",$brut_text);
		$brut_text=str_replace(':hate7:',"<img src='img/smileys/icon_hate7.gif'>",$brut_text);
		$brut_text=str_replace(':hate8:',"<img src='img/smileys/icon_hate8.gif'>",$brut_text);
		$brut_text=str_replace(':hate9:',"<img src='img/smileys/icon_hate9.gif'>",$brut_text);
		$brut_text=str_replace(':hate10:',"<img src='img/smileys/icon_hate10.gif'>",$brut_text);
		$brut_text=str_replace(':hate11:',"<img src='img/smileys/icon_hate11.gif'>",$brut_text);
	}
	
	$brut_text=str_replace("	",'<br>',$brut_text);
	$brut_text=str_replace('[no_smiley]',"",$brut_text);
	$brut_text=str_replace('[diese]',"#",$brut_text);
	$brut_text=str_replace('[et]',"&",$brut_text);
	$brut_text=str_replace('[nl]',"<br>",$brut_text);
	$brut_text=str_replace('[plus]',"+",$brut_text);
	$brut_text=str_replace('[tab]',"&nbsp;&nbsp;&nbsp;&nbsp;",$brut_text);
	return $brut_text;
}


function letterToInt($letter)
{
	$res=(ord($letter)-65)+1;
	return $res;
}

function getMapList($active_map)
{
	$items=array();
	$map_list[]='map_tm2_proto';
	$map_list[]='map_tm2_sewer_00';
	$map_list[]='map_tm2_sewer_00_quest';
	$map_list[]='map_tm2_sewer_01';
	$map_list[]='map_tm2_sewer_01_quest';
	$map_list[]='map_tm2_sewer_03';
	$map_list[]='map_tm2_sewer_03_quest';
	$map_list[]='map_tm2_street_00';
	$map_list[]='map_tm2_street_01';
	$map_list[]='map_tm2_street_01_quest';
	$map_list[]='map_tm2_street_05';
	$map_list[]='map_tm2_street_05_quest';
	$map_list[]='map_tm2_subway_00';
	$map_list[]='map_tm2_subway_01';
	$map_list[]='map_tm2_subway_01_quest';
	$map_list[]='map_tm2_lab_00';
	$map_list[]='map_tm2_lab_00_quest';
	$map_list[]='map_tm2_lab_03';
	$map_list[]='map_tm2_lab_03_quest_a';
	$map_list[]='map_tm2_lab_03_quest_b';
	$map_list[]='map_tm2_bridge_02';
	$map_list[]='map_tm2_splinter';
	$map_list[]='map_tm2_ratking';
	$map_list[]='map_tm2_slash';
	$map_list[]='map_tm2_shredder';
	foreach($map_list as $key=>$map)
	{
		$map_info['html']='';
		$map_info['js']='';
		if($map==$active_map)
		{
			$map_info['html']=getMapInfo($map);
		}
		
		$sub_items=array();
		$sub_items[]=array('name'=>'Logic check','html'=>$map_info['html'],'js'=>$map_info['js']);
		$items[]=array('id'=>$map,'name'=>$map,'sub_items'=>$sub_items,'active'=>($map==$active_map),'active_sub_item'=>0);
	}
	return getList('map_',$items);
}

function getMapInfo($map)
{
	$res='';
	$error='';
	system('smbget -r -w MAGICPOCKETS.CORP -u xmarot -p Valenciennes2007 smb://atlas/projects/tm2/todo/files/TM2_CS.xls >log/command.txt');
	system('smbget -r -w MAGICPOCKETS.CORP -u xmarot -p Valenciennes2007 smb://atlas/projects/tm2/todo/'.$map.'/cmd3.txt >log/command.txt');
	system('smbget -r -w MAGICPOCKETS.CORP -u xmarot -p Valenciennes2007 smb://atlas/projects/tm2/todo/'.$map.'/'.$map.'.txt >log/command.txt');
	
	$tmp_folder='tmp/'.getWorkerName($_SESSION['id_worker']);
	@mkdir($tmp_folder);
	@rename('TM2_CS.xls',$tmp_folder.'/TM2_CS.xls');
	@rename('cmd3.txt',$tmp_folder.'/cmd3.txt');
	@rename($map.'.txt',$tmp_folder.'/'.$map.'.txt');
	
	$data = new Spreadsheet_Excel_Reader($tmp_folder.'/TM2_CS.xls');
	$sheet=0;
	switch($map)
	{
		case 'map_tm2_lab_00':			$sheet=0;break;
		case 'map_tm2_lab_00_quest':	$sheet=1;break;
		case 'map_tm2_lab_03':			$sheet=2;break;
		case 'map_tm2_lab_03_quest_a':	$sheet=3;break;
		case 'map_tm2_lab_03_quest_b':	$sheet=4;break;
		case 'map_tm2_sewer_00':		$sheet=5;break;
		case 'map_tm2_sewer_00_quest':	$sheet=6;break;
		case 'map_tm2_sewer_01':		$sheet=7;break;
		case 'map_tm2_sewer_01_quest':	$sheet=8;break;
		case 'map_tm2_sewer_03':		$sheet=9;break;
		case 'map_tm2_sewer_03_quest':	$sheet=10;break;
		case 'map_tm2_street_00':		$sheet=11;break;
		case 'map_tm2_street_01':		$sheet=12;break;
		case 'map_tm2_street_01_quest':	$sheet=13;break;
		case 'map_tm2_street_05':		$sheet=14;break;
		case 'map_tm2_street_05_quest':	$sheet=15;break;
		case 'map_tm2_subway_00':		$sheet=16;break;
		case 'map_tm2_subway_01':		$sheet=17;break;
		case 'map_tm2_subway_01_quest':	$sheet=18;break;
		case 'map_tm2_bridge_02':		$sheet=19;break;
		case 'map_tm2_splinter':		$sheet=20;break;		
		case 'map_tm2_ratking':			$sheet=21;break;		
		case 'map_tm2_slash':			$sheet=22;break;		
		case 'map_tm2_shredder':		$sheet=23;break;		
		case 'map_tm2_proto':			$sheet=24;break;		
		default:$error.="L'onglet de ce niveau dans la base des cutscenes n'a pas été renseigné : prévenir Xavier !<br>";
	}
	$current_row=3;
	$column_cutscene=3;
	$column_token_id=4;
	$column_token_value=5;
	$column_token_goout_id=6;
	$column_token_goout_value=7;
	$column_token_goout_action=8;
	$logics=array();
	while($data->value($current_row,$column_cutscene,$sheet)!='EOF')
	{
		$logic_name=$data->value($current_row,$column_cutscene,$sheet)." (ligne $current_row)";
		$token_id=$data->value($current_row,$column_token_id,$sheet);
		$token_value=$data->value($current_row,$column_token_value,$sheet);
		$token_goout_id=$data->value($current_row,$column_token_goout_id,$sheet);
		$token_goout_value=$data->value($current_row,$column_token_goout_value,$sheet);
		$token_goout_action=$data->value($current_row,$column_token_goout_action,$sheet);
		if($token_id>0)
		{
			$logics[$logic_name]['ishandled_ttoken_id']=$token_id;
			$logics[$logic_name]['ishandled_ttoken_val']=$token_value;
		}
		if($token_goout_id>0)
		{
			$logics[$logic_name]['goout_stoken_id']=$token_goout_id;
			$logics[$logic_name]['goout_stoken_val']=$token_goout_value;
			$logics[$logic_name]['goout_stoken_action']=$token_goout_action;
		}
		$current_row++;
	}
	
	$file=@fopen($tmp_folder.'/cmd3.txt','r');
	$logics_def=array();
	if ($file)
	{
		/*Tant que l'on est pas à la fin du fichier*/
		$logic_name='';
		while (!feof($file))
		{
			/*On lit la ligne courante*/
			$buffer = fgets($file);
			if($logic_name!='' && $buffer!='')
			{
				$def_line=explode("\t",$buffer);
				$logics_def[$logic_name][]=str_replace(' ','',$def_line[0]);
				//$res.=$def_line[0].'<br>';
			}
			if(strpos($buffer,':')===3)
			{
				$logic_name=substr($buffer,0,3);
				//$res.="$logic_name<br>";
			}
			
			/*On l'affiche*/
			
		}
		/*On ferme le fichier*/
		fclose($file);
	}
	else
	{
		$res='Impossible d\'ouvrir le fichier cmd3';
		return $res;
	}
	
	$file=@fopen($tmp_folder.'/'.$map.'.txt','r');
	
	$zones=array();
	if ($file)
	{
		/*Tant que l'on est pas à la fin du fichier*/
		$zones_found=false;
		while (!feof($file))
		{
			/*On lit la ligne courante*/
			$buffer = fgets($file);
			if(strpos($buffer,'zones')===0)
				$zones_found=true;
			elseif(strpos($buffer,'walls')===0)
				$zones_found=false;
			$buffer_parts=explode(',',$buffer);
			if(sizeof($buffer_parts)==3 && $zones_found)
			{
				//$res.="zone trouvée : ".$buffer_parts[0].','.$buffer_parts[1].','.$buffer_parts[2].'<br>';
				//$res.="$buffer<br>";
				if(strlen($buffer_parts[0])<4)
				{
					$buffer_parts[0]=intval($buffer_parts[0]);
					$buffer_parts[1]=intval($buffer_parts[1]);
					$buffer_parts[2]=intval($buffer_parts[2]);
					//$res.='-'.$buffer_parts[2].'-<br>';
					if(strlen($buffer_parts[0])<4 && strlen($buffer_parts[1])<4 && strlen($buffer_parts[2])<4)
					{
						//$res.="$buffer<br>";
						$zone_type=$buffer_parts[1];
						$zone_ordre=$buffer_parts[2];
						//$res.="zone trouvée : ".$buffer_parts[1].','.$buffer_parts[2].'<br>';
						if(isset($zones[$zone_type][$zone_ordre]))
						{
							$res.="Warning: zone $zone_type,$zone_ordre en doublon !<bR>";
							$error.="Warning: zone $zone_type,$zone_ordre en doublon !<bR>";
						}
						$zones[$zone_type][$zone_ordre]=$buffer_parts[0];
					}
				}
			}
			elseif(strpos($buffer,'logic:')===0)
			{
				//$res.="$buffer<br>";
				$logic_name=substr($buffer,6,strpos($buffer,',datatype:')-6);
				$logic_type=substr($logic_name,0,3);
				$datas=substr($buffer,strpos($buffer,',datas:')+7);
				$datas=explode(',',$datas);
				$logics[$logic_name]=array();
				array_pop ( $datas );
				foreach($datas as $key=>&$val)
				{
					$val=substr($val,0,strpos($val,'['));
					//$res.=$logics_def[$logic_type][$key].": $val<br>";
					if(isset($logics[$logic_name]) && isset($logics_def[$logic_type][$key]))
						$logics[$logic_name][$logics_def[$logic_type][$key]]=$val;
					else
					{
						$res.="logics[logicname:$logic_name][logics_def[logictype:$logic_type][key:$key]] non défini !<bR>";
						$error.="logics[logicname:$logic_name][logics_def[logictype:$logic_type][key:$key]] non défini !<bR>";
					}
				}
			}
			/*On l'affiche*/
			
		}
		/*On ferme le fichier*/
		fclose($file);
		$total_ennemies=array();
		$ennemies=array();
		$packs=array();
		$talent_blocker=array();
		foreach($logics as $name=>$params)
		{
			if(isset($params['gdef']))
			{
				$gdef=$params['gdef'];
				if(isset($params['level']))
				{
					$level=$params['level'];
					@$total_ennemies[$gdef]++;
					@$ennemies[$gdef][$level]++;
				}
				else
					$error.="Le logic $name a un paramètre gdef mais pas de paramètre level : très étrange !!!<br>";
			}
			if(isset($params['turtletype']))
			{
				$turtletype=$params['turtletype'];
				@$talent_blocker[$turtletype]++;
			}
			if(isset($params['packid']))
			{
				$packid=$params['packid'];
				$container='unknown';
				if(isset($params['typeprops']))
					$container='props';
				elseif(isset($params['typecontainer']))
				{
					if($params['typecontainer']==0)
						$container='small chest';
					else
						$container='big chest';
				}
				@$packs[$container][$packid]++;
			}
			if(@$params['ishandled_ttoken_id']>0 && @$params['ishandled_ttoken_val']>0)//le logic dépend d'un token
			{
				$token_id=$params['ishandled_ttoken_id'];
				$token_val=$params['ishandled_ttoken_val'];
				
				$res.="La gestion du logic $name dépend du token $token_id qui doit prendre la valeur $token_val.<br>";
				$token_check=checkToken($token_id,$token_val,$logics);
				$res.=$token_check['details'];
				if($token_check['result']==false)
				{
					$res.="Ce logic ne sera jamais activé !<br>";
					$error.="La gestion du logic $name dépend du token $token_id qui doit prendre la valeur $token_val.<br>";
					$error.=$token_check['details']."Ce logic ne sera jamais activé !<br>";
				}
			}
			if(@$params['swapdefstate_ttoken_id']>0 && @$params['swapdefstate_ttoken_val']>0)//le logic dépend d'un token
			{
				$token_id=$params['swapdefstate_ttoken_id'];
				$token_val=$params['swapdefstate_ttoken_val'];
				
				$res.="Le changement d'état du logic $name dépend du token $token_id qui doit prendre la valeur $token_val.<br>";
				$token_check=checkToken($token_id,$token_val,$logics);
				$res.=$token_check['details'];
				if($token_check['result']==false)
				{
					$res.="Ce logic ne sera jamais activé !<br>";
					$error.="Le changement d'état du logic $name dépend du token $token_id qui doit prendre la valeur $token_val.<br>";
					$error.=$token_check['details']."Ce logic ne sera jamais activé !<br>";
				}
			}
			if(@$params['ishandled_ttoken_id']>0 && @$params['ishandled_ttoken_val']==0)//le logic dépend d'un token
			{
				$token_id=$params['ishandled_ttoken_id'];
				$token_val=$params['ishandled_ttoken_val'];
				$res.="La gestion du logic $name dépend du token $token_id qui doit prendre la valeur $token_val : cela sera donc vrai au lancement de la map !<br>";
				$error.="La gestion du logic $name dépend du token $token_id qui doit prendre la valeur $token_val : cela sera donc vrai au lancement de la map !<br>";
			}
			if(@$params['swapdefstate_ttoken_id']>0 && @$params['swapdefstate_ttoken_val']==0)//le logic dépend d'un token
			{
				$token_id=$params['swapdefstate_ttoken_id'];
				$token_val=$params['swapdefstate_ttoken_val'];$res.="Le changement d'état du logic $name dépend du token $token_id qui doit prendre la valeur $token_val : cela sera donc vrai au lancement de la map !<br>";
				$error.="Le changement d'état du logic $name dépend du token $token_id qui doit prendre la valeur $token_val : cela sera donc vrai au lancement de la map !<br>";
			}
			if(@$params['wareapolyid']>0 || @$params['fareapolyid']>0 || @$params['areapolyid']>0)//le logic dépend d'une zone
			{
				$zone_type1=@$params['wareapolyid'];
				$zone_ordre1=@$params['wareapolyordre'];
				$zone_type2=@$params['fareapolyid'];
				$zone_ordre2=@$params['fareapolyordre'];
				$zone_type3=@$params['areapolyid'];
				$zone_ordre3=@$params['areapolyordre'];
				if($zone_type1>0)
				{
					$res.="Le logic $name dépend de la zone de réveil $zone_type1,$zone_ordre1<br>";
					if(isset($zones[$zone_type1][$zone_ordre1]))
						$res.="La zone existe !<br>";
					else
					{
						$res.="La zone est absente !<br>";
						$error.="Le logic $name dépend de la zone de réveil $zone_type1,$zone_ordre1<br>";
						$error.="La zone est absente !<br>";
					}
				}
				if($zone_type2>0)
				{
					$res.="Le logic $name dépend de la zone de combat $zone_type2,$zone_ordre2<br>";
					if(isset($zones[$zone_type2][$zone_ordre2]))
						$res.="La zone existe !<br>";
					else
					{
						$res.="La zone est absente !<br>";
						$error.="Le logic $name dépend de la zone de réveil $zone_type1,$zone_ordre1<br>";
						$error.="La zone est absente !<br>";
					}
				}
				if($zone_type3>0)
				{
					$res.="Le logic $name dépend de la zone $zone_type3,$zone_ordre3<br>";
					if(isset($zones[$zone_type3][$zone_ordre3]))
						$res.="La zone existe !<br>";
					else
					{
						$res.="La zone est absente !<br>";
						$error.="Le logic $name dépend de la zone de réveil $zone_type1,$zone_ordre1<br>";
						$error.="La zone est absente !<br>";
					}
				}
			}
		}
	}
	else
	{
		$res='Impossible d\'ouvrir le fichier map '.$map.'.txt';
		return $res;
	}
	$stats='<table border="1">';
	foreach($total_ennemies as $key=>$val)
	{
		$ennemy_name=getEnemyType($key);
		$stats.="<tr><td>$ennemy_name</td><td>$val</td></tr>";
	}
	$stats.='</table><br><table border="1">';
	$stats.="<tr><td>Nom</td><td>Niveau</td><td>Nombre</td></tr>";
	foreach($ennemies as $key=>$val)
	{
		$ennemy_name=getEnemyType($key);
		foreach($val as $k=>$v)
			$stats.="<tr><td>$ennemy_name</td><td>$k</td><td>$v</td></tr>";
	}
	$stats.='</table>';
	$stats.='<br><table border="1">';
	$stats.="<tr><td>Container</td><td>Pack id</td><td>Nombre</td></tr>";
	foreach($packs as $container=>$pack)
	{
		foreach($pack as $packid=>$amount)
			$stats.="<tr><td>$container</td><td>$packid</td><td>$amount</td></tr>";
	}
	$stats.='</table>';
	$stats.="<br><table border='1'><tr><td>Turtle ID</td><td>Nombre</td></tr>";
	foreach($talent_blocker as $turle_id=>$amount)
	{
		$stats.="<tr><td>$turle_id</td><td>$amount</td></tr>";
	}
	$stats.='</table>';
	return "Stats : <br>$stats<hr>erreur:<br>$error<br><hr>details:<br>$res";
}

function getEnemyType($type)
{
	switch($type)
	{
		case 0: return "Foot Warrior 1";
		case 1: return "Foot Trooper 1";
		case 2: return "Ripper";
		case 3: return "Propagator";
		case 4: return "Wrecker";
		case 5: return "Gnawer";
		case 6: return "Foot Warrior 2";
		case 7: return "Mutant Warrior 1";
		case 8: return "Splinter";
		case 9: return "Drone";
		case 10: return "Drone Heal";
		case 11: return "Drone Shield";
		case 12: return "Foot Trooper 2";
		case 13: return "Foot Sentry";
		case 14: return "Baxter Sentry";
		case 15: return "Mouser";
		case 16: return "Bomber";
		case 17: return "Mutant Trooper 1";
		case 18: return "Foot Healer";
		case 19: return "Foot Warrior 2 Without Shield";
		case 20: return "Mutant Warrior 2";
		case 21: return "Mutant Warrior 2 Without Shield";
		default:return "type inconnu : $type";
	}

}


function checkToken($token_id,$token_val,$logics)
{
	$increased_value=0;
	$token_ok=false;
	$res='';
	$increased_values=array();
	$new_values=array();
	foreach($logics as $n=>$p)
	{
		if(@$p['ondie_stoken_id']==$token_id || @$p['onaction_stoken_id']==$token_id)
		{
			$increased_value++;
			$increased_values[]=1;
			$res.="Le logic $n incrémente la valeur du token $token_id à $increased_value<br>";
			if($increased_value==$token_val)
			{
				$res.="Logic ok!<br>";
				$token_ok=true;
				break;
			}
		}
		if(@$p['goin_stoken_id']==$token_id)
		{
			$new_value=$increased_value;
			switch($p['goin_stoken_action'])
			{
				case 0:$new_value=$p['goin_stoken_val'];break;
				case 2:$increased_value+=2;$new_value=$increased_value;break;
			}
			$new_values[]=$new_value;
			$res.="Le logic $n change la valeur du token $token_id à $new_value<br>";
			if($new_value==$token_val)
			{
				$res.="Logic ok!<br>";
				$token_ok=true;
				break;
			}
		}
		if(@$p['goout_stoken_id']==$token_id)
		{
			$new_value=$increased_value;
			switch($p['goout_stoken_action'])
			{
				case 0:$new_value=$p['goout_stoken_val'];break;
				case 2:$increased_value+=2;$new_value=$increased_value;break;
			}
			$new_values[]=$new_value;
			$res.="Le logic $n change la valeur du token $token_id à $new_value<br>";
			if($new_value==$token_val)
			{
				$res.="Logic ok!<br>";
				$token_ok=true;
				break;
			}
		}
	}
	if($token_ok==false)
	{
		$res.="Essai de combinaisons<br>";
		foreach($new_values as $new_value)
		{
			$test_value=$new_value;
			foreach($increased_values as $increase)
			{
				$test_value+=$increase;
				if($test_value==$token_val)
				{
					$res.="Logic ok!<br>";
					$token_ok=true;
					break;
				}
			}
			if($token_ok)
				break;
		}
	}
	return array('result'=>$token_ok,'details'=>$res);
}

function getMoodVO($current_character,$mood)
{
	$vo_file='';
	$character='';
	if($mood=='')
		return '';
	switch($current_character)
	{
		case 0:$character='leo';break;
		case 1:$character='raph';break;
		case 2:$character='donnie';break;
		case 3:$character='mikey';break;
		case 4:$character='april';break;
		case 5:$character='baxter';break;
		case 6:$character='splinter';break;
		case 7:$character='ratking';break;
		case 8:$character='splinter';break;
		default:
			if($mood=='Alarm')$vo_file='snd_vo_ba_Alarm_00';
			elseif($mood=='Radio')$vo_file='snd_vo_ba_radio_turning_on_00';
			elseif($mood=='Civil')$vo_file='vo_ba_civilian_thanks_00';
			elseif($mood=='Phone')$vo_file='snd_vo_phone';
			elseif($mood=='Rumble')$vo_file='snd_vo_rumble';
			elseif($mood=='Door')$vo_file='snd_vo_Sliding_door';
			if($vo_file=='')
				return '';
			else
				return ",$vo_file";
	}
	switch($mood)
	{
		case 'Bring it On':$vo_file='vo_ba_'.$character.'_bring_00';break;
		case 'Here they come / be Ready':$vo_file='vo_ba_'.$character.'_ready_00';break;
		case 'I picked up something useful/look at this':$vo_file='vo_ba_'.$character.'_look_00';break;
		case 'whew!':$vo_file='vo_ba_'.$character.'_whew_00';break;
		case 'Thank you':$vo_file='vo_ba_'.$character.'_thanks_00';break;
		case 'Attacking hard (variations)':$vo_file='vo_ba_'.$character.'_attackhard_00';break;
		case 'Listen up':$vo_file='vo_ba_'.$character.'_listen_00';break;
		case 'uh-oh':$vo_file='vo_ba_'.$character.'_uhoh_00';break;
		case 'Take em':$vo_file='vo_ba_'.$character.'_takeem_00';break;
		case 'We can do it.':$vo_file='vo_ba_'.$character.'_candoit_00';break;
		case 'Great Work.':$vo_file='vo_ba_'.$character.'_greatwork_00';break;
		case 'I have an idea.':$vo_file='vo_ba_'.$character.'_idea_00';break;
		case 'Good idea!':$vo_file='vo_ba_'.$character.'_goodidea_00';break;
		case 'Bad idea!':$vo_file='vo_ba_'.$character.'_badidea_00';break;
		case 'I\'m worried!':$vo_file='vo_ba_'.$character.'_worry_00';break;
		case 'That was great!':$vo_file='vo_ba_'.$character.'_great_00';break;
		case 'That was really difficult.':$vo_file='vo_ba_'.$character.'_difficult_00';break;
		case 'No problem.':$vo_file='vo_ba_'.$character.'_noproblem_00';break;
		case 'No way!':$vo_file='vo_ba_'.$character.'_noway_00';break;
		case 'I\'m telling you some information.':$vo_file='vo_ba_'.$character.'_info_00';break;
		case 'I\'m hurt':$vo_file='vo_ba_'.$character.'_hurt_00';break;
		default:return "erreur: mood $mood non trouvé !";
	}
	return ",$vo_file";

}

function curl_get($url, array $get = NULL, array $options = array())
{   
    $defaults = array(
        CURLOPT_URL => $url. (strpos($url, '?') === FALSE ? '?' : ''). http_build_query($get),
        CURLOPT_HEADER => 0,
        CURLOPT_RETURNTRANSFER => TRUE,
        CURLOPT_TIMEOUT => 4
    );
   
    $ch = curl_init();
	
    curl_setopt_array($ch, ($options + $defaults));
    if( ! $result = curl_exec($ch))
    {
        //trigger_error(curl_error($ch));
		return false;
    }
    curl_close($ch);
    return $result;
} 


function get_apache_headers()
{
	if(!function_exists("apache_request_headers"))
	{
		$arh = array();
		$rx_http = '/\AHTTP_/';
		foreach($_SERVER as $key => $val) {
		if( preg_match($rx_http, $key) ) {
		  $arh_key = preg_replace($rx_http, '', $key);
		  $rx_matches = array();
		  // do some nasty string manipulations to restore the original letter case
		  // this should work in most cases
		  $rx_matches = explode('_', $arh_key);
		  if( count($rx_matches) > 0 and strlen($arh_key) > 2 ) {
			foreach($rx_matches as $ak_key => $ak_val) $rx_matches[$ak_key] = ucfirst($ak_val);
			$arh_key = implode('-', $rx_matches);
		  }
		  $arh[$arh_key] = $val;
		}
		}
		return( $arh );
	}
	else
		return apache_request_headers();
}


?>